// JSB.require('utils');
// JSB.require('base64')
/** @return {dynamicController} */
const getDynamicController = ()=>self


var dynamicController = JSB.defineClass('dynamicController : UIViewController <NSURLConnectionDelegate>', {
  viewDidLoad: function() {
    try {
    let self = getDynamicController()
    self.init()
    self.custom = false;
    self.customMode = "None"
    self.funcResponse = ""
    self.dynamic = true;
    self.pinned = false;
    self.shouldCopy = false
    self.shouldComment = false
    self.selectedText = '';
    self.searchedText = '';
    self.isLoading = false;
    self.toolbarOn = true;
    // self.currentFrame = self.view.frame
    self.history = []
    self.inputHeight = 35
    self.title = "main"
    self.moveDate = Date.now()
    self.color = [true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true]
    } catch (error) {
      showHUD("Error in viewDidLoad: "+error)
    }
  },
  viewWillAppear: function(animated) {
  },
  viewWillDisappear: function(animated) {
  },
  viewWillLayoutSubviews: function() {
    if (self.onAnimate) {
      return
    }
    let studyFrame = MNUtil.studyView.frame
    if (self.lastFrame.x+self.lastFrame.width > studyFrame.width) {
      self.lastFrame.x = studyFrame.width-300
    }
    if (self.lastFrame.y+self.lastFrame.height > studyFrame.height) {
      self.lastFrame.y = studyFrame.height-200
    }
    self.view.frame = self.lastFrame
    self.aiButton.frame = MNUtil.genFrame(0, 0, 40, 40)
    self.closeButton.frame = MNUtil.genFrame(5, 5, 35, 35)
    self.sendButton.frame = MNUtil.genFrame(260, 5, 35, 35)
    self.OCREnhanced.frame = MNUtil.genFrame(260, 160, 35, 35)
    self.visionButton.frame = MNUtil.genFrame(260, 120, 35, 35)
    self.systemButton.frame = MNUtil.genFrame(260, 80, 35, 35)
    self.promptInput.frame = MNUtil.genFrame(45, 5, 210, self.inputHeight)
    self.scrollview.frame = MNUtil.genFrame(0, 40, 300, 160)
  },
  onMoveGesture:function (gesture) {
    self.pinned = true;
    let location = chatAIUtils.getNewLoc(gesture)
    let frame = self.view.frame
    // self.view.frame = MNUtil.genFrame(location.x,location.y,frame.width,frame.height)
    // self.currentFrame  = self.view.frame
    // self.custom = false;
    // if (gesture.state === 3) {
    //   MNUtil.studyView.bringSubviewToFront(self.view)
    // }


    // let locationToMN = gesture.locationInView(MNUtil.studyView)
    // if (!self.locationToButton && (Date.now() - self.moveDate) > 100) {
    //   let translation = gesture.translationInView(MNUtil.studyView)
    //   let locationToBrowser = gesture.locationInView(self.view)
    //   let locationToButton = gesture.locationInView(gesture.view)
    //   let buttonFrame = gesture.view.frame
    //   let newY = locationToButton.y-translation.y 
    //   let newX = locationToButton.x-translation.x
    //   if (gesture.state !== 3 && (newY<buttonFrame.height+5 && newY>-5 && newX<buttonFrame.width+5 && newX>-5 && Math.abs(translation.y)<20 && Math.abs(translation.x)<20)) {
    //     self.locationToBrowser = {x:locationToBrowser.x-translation.x,y:locationToBrowser.y-translation.y}
    //     self.locationToButton = {x:newX,y:newY}
    //   }
    //   // if ((newY<buttonFrame.height && newY>0 && newX<buttonFrame.width && newX>0 && Math.abs(translation.y)<20 && Math.abs(translation.x)<20) || !self.locationToBrowser) {

    //   // }
    // }
    // self.moveDate = Date.now()
    // let location = {x:locationToMN.x - self.locationToBrowser.x,y:locationToMN.y -self.locationToBrowser.y}
    // let location = {x:locationToMN.x - self.locationToButton.x-gesture.view.frame.x,y:locationToMN.y -self.locationToButton.y-gesture.view.frame.y}

    // let frame = self.view.frame
    let studyFrame = MNUtil.studyView.bounds
    let y = location.y
    if (y<=0) { y = 0 }
    if (y>=studyFrame.height-200) { y = studyFrame.height-200 }
    let x = location.x
    if (x<=0) { x = 0 }
    if (x>=studyFrame.width-300) { x = studyFrame.width-300 }
    self.view.frame = MNUtil.genFrame(x,y,frame.width,frame.height)
    self.lastFrame  = self.view.frame
  },
  openInput:async function () {
    let self = getDynamicController()
    self.onClick = true
    let studyFrame = MNUtil.studyView.frame
    if (self.lastFrame.x + 300 > studyFrame.width) {
      self.lastFrame.x = studyFrame.width-300
    }
    if (self.lastFrame.y + 200 > studyFrame.height) {
      self.lastFrame.y = studyFrame.width-200
    }
    self.lastFrame.width = 300
    self.lastFrame.height = 200
    self.aiButton.hidden = true
    self.setLayout(self.lastFrame)
  },
  closeInput:async function () {
    let self = getDynamicController()
    self.onClick = true
    self.pinned = false;
    self.lastFrame.width = 40
    self.lastFrame.height = 40
    self.setLayout(self.lastFrame)
    self.view.hidden = true
    self.aiButton.hidden = false
    chatAIUtils.OCREnhancedMode = false
    chatAIUtils.visionMode = false
  },
  toggleOCREnhanceMode:async function (params) {
    if (typeof ocrNetwork === 'undefined') {
      MNUtil.showHUD("Install 'MN OCR' first")
      return undefined
    }
    chatAIUtils.OCREnhancedMode = !chatAIUtils.OCREnhancedMode
    if (chatAIUtils.OCREnhancedMode) {
      self.OCREnhanced.backgroundColor = MNUtil.hexColorAlpha("#e06c75",0.8)
    }else{
      self.OCREnhanced.backgroundColor = MNUtil.hexColorAlpha("#c0bfbf",0.8)
    }
  },
  toggleVisionMode:async function (params) {
    chatAIUtils.visionMode = !chatAIUtils.visionMode
    if (chatAIUtils.visionMode) {
      self.visionButton.backgroundColor = MNUtil.hexColorAlpha("#e06c75",0.8)
    }else{
      self.visionButton.backgroundColor = MNUtil.hexColorAlpha("#c0bfbf",0.8)
    }
  },
  toggleNoSystemMode:async function (params) {
    chatAIUtils.noSystemMode = !chatAIUtils.noSystemMode
    if (chatAIUtils.noSystemMode) {
      MNUtil.showHUD("Clear System Message")
      self.systemButton.backgroundColor = MNUtil.hexColorAlpha("#e06c75",0.8)
    }else{
      self.systemButton.backgroundColor = MNUtil.hexColorAlpha("#c0bfbf",0.8)
    }
  },
  askWithPrompt: async function () {
  try {
    if (!chatAIUtils.checkCouldAsk()) {
      return
    }
    let self = getDynamicController();
    if (chatAIUtils.visionMode) {
      // MNUtil.showHUD("Vision")
      let imageData
      if (chatAIUtils.currentNoteId) {
        imageData = MNNote.getImageFromNote(MNNote.new(chatAIUtils.currentNoteId))
      }else{
        imageData = MNUtil.getDocImage(true,true)
      }
      let question = chatAIUtils.genUserMessage(self.promptInput.text, imageData)
      chatAIUtils.notifyController.askByVision(question)
      return
    }
    if (chatAIUtils.noSystemMode) {
      let userInput = self.promptInput.text
      let question = [{role: "user", content: userInput}]
      chatAIUtils.notifyController.askByDynamic(question)
      chatAIUtils.notifyController.currentPrompt = "Dynamic"
      // chatAIUtils.notifyController.onChat = false
      // MNUtil.showHUD("No System Message")
      return
    }
    if (chatAIUtils.currentNoteId) {
      self.askWithPromptOnNote(chatAIUtils.currentNoteId)
      return
    }else{
      self.askWithPromptOnText()
      return
    }
  } catch (error) {
    chatAIUtils.addErrorLog(error, "askWithPrompt")
  }
  },
  onResizeGesture:function (gesture) {
    if (self.notifyTimer) {self.notifyTimer.invalidate()}
    if (self.notifyLoc === 0) {
      self.custom = false;
      self.dynamic = false;
      self.customMode = "none"
      let baseframe = gesture.view.frame
      let locationToBrowser = gesture.locationInView(self.view)
      let frame = self.view.frame
      let height = locationToBrowser.y+baseframe.height*0.5
      if (height <= 100) {
        height = 100
      }
      //  self.view.frame = {x:frame.x,y:frame.y,width:frame.width+translationX,height:frame.height+translationY}
      self.view.frame = {x:50,y:50,width:400,height:height}
      self.currentFrame  = self.view.frame
    }else{
      self.custom = false;
      self.dynamic = false;
      self.customMode = "none"
      let baseframe = gesture.view.frame
      let locationToBrowser = gesture.locationInView(self.view)
      let frame = self.view.frame
      let height = locationToBrowser.y+baseframe.height*0.5
      if (height <= 120) {
        height = 120
      }
      //  self.view.frame = {x:frame.x,y:frame.y,width:frame.width+translationX,height:frame.height+translationY}
      self.view.frame = {x:frame.x,y:50,width:400,height:height}
      self.currentFrame  = self.view.frame
    }

  },
  textViewDidBeginEditing:function (textview) {
    // showHUD("begin")
    self.notifyTimer.invalidate()
  },
  onPromptButton:async function (sender) {
  try {
    if (!chatAIUtils.checkCouldAsk()) {
      return
    }
    // if (chatAIUtils.visionMode) {
    //   MNUtil.showHUD("Unavailable for vision mode")
    //   return
    // }
    let self = getDynamicController()
    let userInput = self.promptInput.text
    let title = sender.id
    let text = chatAIUtils.currentSelection
    chatAIUtils.notifyController.noteid = chatAIUtils.currentNoteId
    chatAIUtils.notifyController.text = text
    chatAIUtils.notifyController.currentPrompt = title
    let question = await chatAIUtils.chatController.getQuestion(title,userInput)
    
    // if (chatAIUtils.currentNoteId) {
    //   question = await chatAIUtils.chatController.getQuestionOnNote(chatAIUtils.currentNoteId,title)
    // }else{
    //   question = await chatAIUtils.chatController.getQuestionOnText(title)
    // }
    if (!question) {
      return
    }
    chatAIUtils.notifyController.query = text
    // MNUtil.copyJSON(question)
    // MNUtil.showHUD(title)
    chatAIUtils.notifyController.ask(question,title)
    } catch (error) {
    chatAIUtils.addErrorLog(error, "onPromptButton")
  }
  },
  /**
   * 
   * @param {UITextView} textview 
   */
  textViewDidChange:async function (textview) {
    let self = getDynamicController();
    let frame = self.view.frame
    let size = textview.sizeThatFits({width:210,height:1000})
    if (size.height < 35) {
      size.height = 35
    }
    if (size.height > 190) {
      size.height = 190
    }
    self.inputHeight = size.height
    self.promptInput.frame = MNUtil.genFrame(45, 5, 210, size.height)
    // MNUtil.showHUD("change:"+JSON.stringify(size))
    // MNUtil.genFrame(45, 5, 210, 35)
    if (/\n\n$/.test(textview.text) && textview.text.trim()) {
      if (chatAIUtils.notifyController.connection) {
        MNUtil.showHUD("Wait...")
        return
      }
      let text = textview.text.trim()
      self.promptInput.text = text
      let size = self.promptInput.sizeThatFits({width:210,height:1000})
      if (size.height < 35) {
        size.height = 35
      }
      if (size.height > 190) {
        size.height = 190
      }
      self.inputHeight = size.height
      self.promptInput.frame = MNUtil.genFrame(45, 5, 210, size.height)
      if (chatAIUtils.currentNoteId) {
        self.askWithPromptOnNote(chatAIUtils.currentNoteId)
        return
      }else if (chatAIUtils.currentSelection) {
        self.askWithPromptOnText()
        return
      }else{
        let userInput = text
        let question = [{role: "user", content: userInput}]
        chatAIUtils.notifyController.askByDynamic(question)
        chatAIUtils.notifyController.currentPrompt = "Dynamic"
        MNUtil.showHUD("No System Message")
        return
      }
    }
  },
});
/**
 * @this {dynamicController}
 */
dynamicController.prototype.init = function () {
  this.highlightColor = UIColor.blendedColor(MNUtil.hexColorAlpha("#2c4d81",0.8),
    chatAIUtils.app.defaultTextColor,
    0.8
  );
  if (this.firstFrame) {
    this.view.frame = this.firstFrame
  }else{
    this.view.frame = MNUtil.genFrame(50, 50, 40, 40)
  }

    this.lastFrame = this.view.frame;
    this.view.layer.shadowOffset = {width: 0, height: 0};
    this.view.layer.shadowRadius = 15;
    this.view.layer.shadowOpacity = 0.5;
    this.view.layer.shadowColor = UIColor.colorWithWhiteAlpha(0.5, 1);
    this.view.layer.cornerRadius = 11
    this.view.layer.borderColor = MNUtil.hexColorAlpha("#9bb2d6",0.8)
    this.view.layer.borderWidth = 0
    this.view.backgroundColor = MNUtil.hexColorAlpha("#e4eeff",0.55)

    this.scrollview = UIScrollView.new()
    this.view.addSubview(this.scrollview)
    this.scrollview.hidden = true
    this.scrollview.delegate = this
    this.scrollview.bounces = true
    this.scrollview.opacity = 1.0
    this.scrollview.alwaysBounceVertical = true
    this.scrollview.layer.cornerRadius = 8
    this.scrollview.backgroundColor = MNUtil.hexColorAlpha("#c0bfbf",0)
  this.reloadImage = MNUtil.getImage(chatAIConfig.mainPath + `/reload.png`)
  this.stopImage = MNUtil.getImage(chatAIConfig.mainPath + `/stop.png`)
  this.bigbangImage = MNUtil.getImage(chatAIConfig.mainPath + `/bigbang.png`)
  this.copyImage = MNUtil.getImage(chatAIConfig.mainPath + `/copy.png`)
  this.titleImage = MNUtil.getImage(chatAIConfig.mainPath + `/title.png`)
  this.tagImage = MNUtil.getImage(chatAIConfig.mainPath + `/tag.png`)
  this.commentImage = MNUtil.getImage(chatAIConfig.mainPath + `/comment.png`)
  this.aiImage = MNUtil.getImage(chatAIConfig.mainPath + `/ai.png`, 3)
  this.aiLinkImage = MNUtil.getImage(chatAIConfig.mainPath + `/aiLink.png`)
  this.chatImage = MNUtil.getImage(chatAIConfig.mainPath + `/chat.png`)
  this.sendImage = MNUtil.getImage(chatAIConfig.mainPath + `/send.png`)
  this.lockImage = MNUtil.getImage(chatAIConfig.mainPath + `/lock.png`)
  this.unlockImage = MNUtil.getImage(chatAIConfig.mainPath + `/unlock.png`)
  this.ocrImage = MNUtil.getImage(chatAIConfig.mainPath + `/ocr.png`)
  this.visionImage = MNUtil.getImage(chatAIConfig.mainPath + `/vision.png`,1.5)
  this.eraserImage = MNUtil.getImage(chatAIConfig.mainPath + `/eraser.png`)

  this.aiButton = this.createButton("openInput:")
  this.aiButton.setImageForState(this.aiImage,0)
  this.aiButton.hidden = false
  this.aiButton.frame = MNUtil.genFrame(0, 0, 40, 40)
  this.aiButton.backgroundColor =  MNUtil.hexColorAlpha("#ffffff",0)

  this.closeButton = this.createButton("closeInput:")
  this.closeButton.setImageForState(this.stopImage,0)
  this.closeButton.hidden = true
  this.closeButton.backgroundColor =  MNUtil.hexColorAlpha("#e06c75",0.8)

  this.sendButton = this.createButton("askWithPrompt:")
  this.sendButton.setImageForState(this.sendImage,0)
  this.sendButton.hidden = true
  this.sendButton.backgroundColor =  MNUtil.hexColorAlpha("#e06c75",0.8)
  this.promptInput = this.creatTextView("view","#89a6d5",0.8)
  this.promptInput.hidden = true

  this.OCREnhanced = this.createButton("toggleOCREnhanceMode:")
  this.OCREnhanced.setImageForState(this.ocrImage,0)
  this.OCREnhanced.hidden = true
  this.OCREnhanced.backgroundColor =  MNUtil.hexColorAlpha("#c0bfbf",0.8)

  this.visionButton = this.createButton("toggleVisionMode:")
  this.visionButton.setImageForState(this.visionImage,0)
  this.visionButton.hidden = true
  this.visionButton.backgroundColor =  MNUtil.hexColorAlpha("#c0bfbf",0.8)

  this.systemButton = this.createButton("toggleNoSystemMode:")
  this.systemButton.setImageForState(this.eraserImage,0)
  this.systemButton.hidden = true
  this.systemButton.backgroundColor =  MNUtil.hexColorAlpha("#c0bfbf",0.8)

  this.moveGesture = new UIPanGestureRecognizer(this,"onMoveGesture:")
  this.closeButton.addGestureRecognizer(this.moveGesture)
  this.moveGesture.view.hidden = false
  this.moveGesture.addTargetAction(this,"onMoveGesture:")
  this.moveGesture1 = new UIPanGestureRecognizer(this,"onMoveGesture:")
  this.sendButton.addGestureRecognizer(this.moveGesture1)
  this.moveGesture1.view.hidden = false
  this.moveGesture1.addTargetAction(this,"onMoveGesture:")
}

dynamicController.prototype.createButton = function (targetAction,superview,) {
  /** @type {UIButton} */
  let button = UIButton.buttonWithType(0);
  button.autoresizingMask = (1 << 0 | 1 << 3);
  button.setTitleColorForState(UIColor.whiteColor(),0);
  button.setTitleColorForState(this.highlightColor, 1);
  button.backgroundColor =  MNUtil.hexColorAlpha("#89a6d5",1.0)
  // button.backgroundColor = hexColorAlpha("#4769a0",1.0)
  button.layer.cornerRadius = 8;
  button.layer.masksToBounds = true;
  button.titleLabel.font = UIFont.systemFontOfSize(16);
  if (targetAction) {
    button.addTargetActionForControlEvents(this, targetAction, 1 << 6);
  }
  if (superview) {
    this[superview].addSubview(button)
  }else{
    this.view.addSubview(button);
  }
  return button
}

/**
 * @this {dynamicController}
 */
dynamicController.prototype.setLayout = async function (frame) {
  MNUtil.studyView.bringSubviewToFront(this.view)
  // this.view.frame = frame
  if (frame.width === 40) {
    this.closeButton.hidden = true
    this.sendButton.hidden = true
    this.OCREnhanced.hidden = true
    this.visionButton.hidden = true
    this.systemButton.hidden = true
    this.promptInput.hidden = true
    this.scrollview.hidden = true
    this.aiButton.hidden = !(this.lastFrame.width === 40)
  }
  this.lastFrame = frame
  await this.animateTo()
  if (frame.width === 40) {
    this.closeButton.hidden = true
    this.sendButton.hidden = true
    this.OCREnhanced.hidden = true
    this.visionButton.hidden = true
    this.systemButton.hidden = true
    this.promptInput.hidden = true
    this.scrollview.hidden = true
    this.aiButton.hidden = false
  }else{
    this.closeButton.hidden = false
    this.sendButton.hidden = false
    this.OCREnhanced.hidden = false
    this.visionButton.hidden = false
    this.systemButton.hidden = false
    this.promptInput.hidden = false
    this.scrollview.hidden = false
    if (chatAIUtils.OCREnhancedMode) {
      this.OCREnhanced.backgroundColor = MNUtil.hexColorAlpha("#e06c75",0.8)
    }else{
      this.OCREnhanced.backgroundColor = MNUtil.hexColorAlpha("#c0bfbf",0.8)
    }
    if (chatAIUtils.visionMode) {
      this.visionButton.backgroundColor = MNUtil.hexColorAlpha("#e06c75",0.8)
    }else{
      this.visionButton.backgroundColor = MNUtil.hexColorAlpha("#c0bfbf",0.8)
    }
    if (chatAIUtils.noSystemMode) {
      this.systemButton.backgroundColor = MNUtil.hexColorAlpha("#e06c75",0.8)
    }else{
      this.systemButton.backgroundColor = MNUtil.hexColorAlpha("#c0bfbf",0.8)
    }
    try {
      this.setButtonText(chatAIConfig.config.promptNames)
    } catch (error) {
      showHUD("Error in setLayout: "+error)
    }
  }
  return
}
/**
 * @this {dynamicController}
 */
dynamicController.prototype.openInput = function () {
  this.onClick = true
  let studyFrame = MNUtil.studyView.frame
  if (this.lastFrame.x + 300 > studyFrame.width) {
    this.lastFrame.x = studyFrame.width-300
  }
  if (this.lastFrame.y + 200 > studyFrame.height) {
    this.lastFrame.y = studyFrame.width-200
  }
  this.lastFrame.width = 300
  this.lastFrame.height = 200
  this.aiButton.hidden = true
  this.setLayout(this.lastFrame)
  // if (!chatAIUtils.currentNoteId && !chatAIUtils.currentSelection) {
  //   chatAIUtils.noSystemMode = true
  //   if (chatAIUtils.noSystemMode) {
  //     this.systemButton.backgroundColor = MNUtil.hexColorAlpha("#e06c75",0.8)
  //   }else{
  //     this.systemButton.backgroundColor = MNUtil.hexColorAlpha("#c0bfbf",0.8)
  //   }
  // }
}
/**
 * @this {dynamicController}
 * @returns {UITextView}
 */
dynamicController.prototype.creatTextView = function (superview="view",color="#e4eeff",alpha=0.9) {
  /** @type {UITextView} */
  let view = UITextView.new()
  view.font = UIFont.systemFontOfSize(15);
  view.layer.cornerRadius = 8
  view.backgroundColor = MNUtil.hexColorAlpha(color,alpha)
  view.textColor = UIColor.blackColor()
  view.delegate = this
  view.bounces = true
  this[superview].addSubview(view)
  return view
}


/**
 * @this {dynamicController}
 */
dynamicController.prototype.setButtonText = function (names) {
    this.words = names
    // MNUtil.copyJSON(names)
    names.map((word,index)=>{
      if (!this["nameButton"+index]) {
        this["nameButton"+index] = this.createButton("onPromptButton:","scrollview")
        // this.createButton("nameButton"+index,"onPromptButton:","scrollview")
        this["nameButton"+index].titleLabel.font = UIFont.systemFontOfSize(16);
      }
      this["nameButton"+index].hidden = false
      this["nameButton"+index].setTitleForState(chatAIConfig.prompts[word].title,0) 
      this["nameButton"+index].id = word
      this["nameButton"+index].backgroundColor = MNUtil.hexColorAlpha("#7093cb",0.7);
      this["nameButton"+index].isSelected = false
    })
    this.refreshLayout()
}

/**
 * @this {dynamicController}
 */
dynamicController.prototype.refreshLayout = function () {
    var viewFrame = this.scrollview.bounds;
    var xLeft     = 0
    let initX = 10
    let initY = 10
    let initL = 0
    this.locs = [];
    this.words.map((word,index)=>{
      let title = chatAIConfig.prompts[word].title
      let width = chatAIUtils.strCode(title.replaceAll(" ",""))*9+15
      if (xLeft+initX+width > viewFrame.width-15) {
        initX = 10
        initY = initY+40
        initL = initL+1
      }
      this["nameButton"+index].frame = {  x: xLeft+initX,  y: initY,  width: width,  height: 30,};
      this.locs.push({
        x:xLeft+initX,
        y:initY,
        l:initL,
        i:index
      })
      initX = initX+width+10
    })
    if (this.lastLength && this.lastLength>this.words.length) {
      for (let index = this.words.length; index < this.lastLength; index++) {
        this["nameButton"+index].hidden = true
      }
    }
    this.lastLength = this.words.length
    this.scrollview.contentSize= {width:viewFrame.width,height:initY+40}
  
}

/**
 * @this {dynamicController}
 */
dynamicController.prototype.getItemFromNoteByOrder = function (note) {
    let order = chatAIConfig.getConfig("searchOrder")
    let text
    for (let index = 0; index < order.length; index++) {
      const element = order[index];
      switch (element) {
        case 1:
          if (note.noteTitle && note.noteTitle !== "") {
            text = note.noteTitle
          }
          break;
        case 2:
          if (note.excerptText && note.excerptText !== "" && (!note.excerptPic || note.textFirst)) {
            text = note.excerptText
          }
          break;
        case 3:
          let commentText
          let comment = note.comments.find(comment=>{
            switch (comment.type) {
              case "TextNote":
                if (/^marginnote\dapp:\/\//.test(comment.text)) {
                  return false
                }else{
                  commentText = comment.text
                  return true
                }
              case "HtmlNote":
                commentText = comment.text
                return true
              case "LinkNote":
                if (comment.q_hpic && !note.textFirst) {
                  return false
                }else{
                  commentText = comment.q_htext
                  return true
                }
              default:
                return false
            }
          })
          if (commentText && commentText.length) {
            text = commentText
          }
          break;
        default:
          break;
      }
      if (text) {
        return text
      }
    }
  return ""
  }
/**
 * @this {dynamicController}
 */
dynamicController.prototype.getImageForOCR = function (noteId,userChoice,prompt) {
  //用户没手动开启，自然为false
  if (!userChoice) {
    return undefined
  }
  // if (noteId) {
  //   let note = MNUtil.getNoteById(noteId)
  // }
  let contextHasOCR = prompt.context.includes("{{textOCR}}")
  let systemHasOCR = prompt.system && prompt.system.includes("{{textOCR}}")
  let contextHasContext = prompt.context.includes("{{context}}")
  let systemHasContext = prompt.system && prompt.system.includes("{{context}}")

  if (contextHasOCR || systemHasOCR) {
    return undefined
  }
  if (!contextHasContext && !systemHasContext) {
    return undefined
  }

  let image = MNUtil.currentDocController.imageFromSelection()
  if (!image) {
      image = MNUtil.currentDocController.imageFromFocusNote()
  }
  return image


}

/**
 * @this {dynamicController}
 */
dynamicController.prototype.askWithPromptOnText = async function () {
  try {
  let userInput = this.promptInput.text
  let dynamicPrompt = chatAIConfig.dynamicPrompt
  let system = dynamicPrompt.text
  let systemMessage = await chatAIUtils.chatController.getTextVarInfo(system)
  let question = [{role:"system",content:systemMessage},{role: "user", content: userInput}]
  chatAIUtils.notifyController.askByDynamic(question)
  chatAIUtils.notifyController.currentPrompt = "Dynamic"
  chatAIUtils.notifyController.noteid = undefined
    } catch (error) {
    MNUtil.showHUD(error)
  }
}

/**
 * @this {dynamicController}
 */
dynamicController.prototype.askWithPromptOnNote = async function (noteid) {
  try {
  let userInput = this.promptInput.text
  let system = chatAIConfig.dynamicPrompt.note
  let systemMessage = await chatAIUtils.chatController.getNoteVarInfo(noteid, system)
  // MNUtil.copy(systemMessage)
  if (systemMessage === undefined) {
    return
  }
  let question = [{role:"system",content:systemMessage},{role: "user", content: userInput}]
  chatAIUtils.notifyController.askByDynamic(question)
  chatAIUtils.notifyController.currentPrompt = "Dynamic"
  chatAIUtils.notifyController.noteid = chatAIUtils.currentNoteId
    } catch (error) {
    MNUtil.showHUD(error)
  }
}
dynamicController.prototype.animateTo = async function () {
    let studyFrame = MNUtil.studyView.frame
    if (this.lastFrame.x+this.lastFrame.width > studyFrame.width) {
      this.lastFrame.x = studyFrame.width-300
    }
    if (this.lastFrame.y+this.lastFrame.height > studyFrame.height) {
      this.lastFrame.y = studyFrame.height-200
    }
    return new Promise((resolve, reject) => {
      
    this.onAnimate = true
    MNUtil.animate(()=>{
      this.view.frame = this.lastFrame
      this.view.layer.opacity = 1.0

    },0.1).then(()=>{
      this.aiButton.frame = MNUtil.genFrame(0, 0, 40, 40)
      this.closeButton.frame = MNUtil.genFrame(5, 5, 35, 35)
      this.sendButton.frame = MNUtil.genFrame(260, 5, 35, 35)
      this.OCREnhanced.frame = MNUtil.genFrame(260, 160, 35, 35)
      this.visionButton.frame = MNUtil.genFrame(260, 120, 35, 35)
      this.systemButton.frame = MNUtil.genFrame(260, 80, 35, 35)
      this.promptInput.frame = MNUtil.genFrame(45, 5, 210, this.inputHeight)
      this.scrollview.frame = MNUtil.genFrame(0, 40, 300, 160)
      this.onAnimate = false
      resolve()
    })
    })
}
/**
 * @type {UIView}
 */
dynamicController.prototype.view
