/** @return {notificationController} */
const getNotificationController = ()=>self
var notificationController = JSB.defineClass('notificationController : UIViewController <NSURLConnectionDelegate,UIWebViewDelegate>', {
  viewDidLoad: function() {
try {
    let self = getNotificationController()
    self.init()
    self.custom = false;
    self.size = []
    self.onreceive = false
    self.funcResponse = ""
    self.response = ''
    self.dynamic = true;
    self.shouldCopy = false
    self.shouldComment = false
    self.selectedText = '';
    self.searchedText = '';
    self.isLoading = false;
    self.toolbarOn = true;
    self.view.frame = {x:chatAIUtils.getX(),y:chatAIUtils.getY(),width:chatAIUtils.getWidth(),height:120}
    self.lastFrame = self.view.frame;
    // self.currentFrame = self.view.frame
    self.history = []
    self.title = "main"
    self.moveDate = Date.now()
    self.notifyLoc = chatAIConfig.config.notifyLoc
    self.color = [true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true]
    self.view.layer.shadowOffset = {width: 0, height: 0};
    self.view.layer.shadowRadius = 15;
    self.view.layer.shadowOpacity = 0.5;
    self.view.layer.shadowColor = UIColor.colorWithWhiteAlpha(0.5, 1);
    self.view.layer.cornerRadius = 11
    self.view.layer.opacity = 1.0
    self.view.layer.borderColor = MNUtil.hexColorAlpha("#9bb2d6",0.8)
    self.view.layer.borderWidth = 0
    self.view.backgroundColor = MNUtil.hexColorAlpha("#ffffff",0)

    self.notificationView = UIView.new()
    self.notificationView.layer.cornerRadius = 8
    self.notificationView.backgroundColor = MNUtil.hexColorAlpha("#ffffff",0.0)
    self.view.addSubview(self.notificationView)
    self.notiScroll = UIScrollView.new()
    self.notiScroll.layer.cornerRadius = 8
    self.notiScroll.backgroundColor = MNUtil.hexColorAlpha("#ffffff",0.0)
    self.notiScroll.scrollEnabled = true

    self.notificationView.addSubview(self.notiScroll)

    self.createButton("toolbar",undefined,"notificationView")
    self.toolbar.backgroundColor = MNUtil.hexColorAlpha("#727f94",0.0)

    // self.createButton("screenButton","changeScreen:","toolbar")
    self.createButton("screenButton","closeButtonTapped:","toolbar")
    self.screenButton.setImageForState(self.stopImage,0)
    self.screenButton.backgroundColor = MNUtil.hexColorAlpha("#e06c75",0.8)

    self.createButton("bigbangButton","bigbang:","toolbar")
    self.bigbangButton.setImageForState(self.bigbangImage,0)

    self.createButton("copyButton","copy:","toolbar")
    self.copyButton.setImageForState(self.copyImage,0)

    self.createButton("titleButton","setNoteTitle:","toolbar")
    self.titleButton.setImageForState(self.titleImage,0)

    self.createButton("commentButton","setComment:","toolbar")
    self.commentButton.setImageForState(self.commentImage,0)

    self.createButton("promptButton","changePrompts:","toolbar")
    self.promptButton.setTitleForState("关键词",0)
    self.promptButton.titleLabel.font = UIFont.boldSystemFontOfSize(16);

    // self.createButton("locationButton","toggleLocation:","toolbar")
    // self.locationButton.setTitleForState(chatAIConfig.config.notifyLoc?' R ':' L ',0)
    // // self.locationButton.setTitleForState(" R ")
    // self.locationButton.titleLabel.font = UIFont.boldSystemFontOfSize(20);

    self.createButton("childButton","addChildNote:","toolbar")
    self.childButton.setImageForState(self.childImage,0)

    // self.createButton("aiLinkButton","showAILink:","toolbar")
    // self.aiLinkButton.setImageForState(self.aiLinkImage,0)

    self.createButton("excerptButton","setExcerpt:","toolbar")
    self.excerptButton.setImageForState(self.excerptImage,0)

    self.createButton("reloadButton","reAsk:","toolbar")
    self.reloadButton.setImageForState(self.reloadImage,0)

    self.createButton("chatButton","openChatView:","toolbar")
    self.chatButton.setImageForState(self.chatImage,0)

    self.createButton("aiButton")
    self.aiButton.setImageForState(self.aiImage,0)
    self.aiButton.backgroundColor = MNUtil.hexColorAlpha("#ffffff",0.8)

    self.resizeGesture = new UIPanGestureRecognizer(self,"onResizeGesture:")
    self.screenButton.addGestureRecognizer(self.resizeGesture)
    self.resizeGesture.view.hidden = false
    self.resizeGesture.addTargetAction(self,"onResizeGesture:")
    self.setNewResponse()
} catch (error) {
    chatAIUtils.addErrorLog(error, "viewDidLoad")
}
  },
  viewWillAppear: function(animated) {
  },
  viewWillDisappear: function(animated) {
  },
  viewWillLayoutSubviews: function() {
  let self = getNotificationController()
    if (self.onAnimate) {
      // MNUtil.showHUD("message")
      return
    }
    let buttonHeight = 30
    // self.view.frame = self.currentFrame
    var viewFrame = self.view.frame;
    var currentFrame = self.currentFrame
    var height   = viewFrame.height
    self.notifyLoc = chatAIUtils.isIOS()?0:chatAIConfig.config.notifyLoc
    currentFrame.width = chatAIUtils.getWidth()
    currentFrame.x = chatAIUtils.getX()
    currentFrame.y = chatAIUtils.getY()
    self.view.frame = currentFrame
    self.currentFrame = currentFrame

    if (self.onChat) {
      self.setChatLayout()
    }else{
      viewFrame.width = chatAIUtils.getWidth()
      // viewFrame.x = chatAIUtils.getX()
      // viewFrame.y = chatAIUtils.getY()
      // MNUtil.copyJSON(currentFrame)
      // self.view.frame = viewFrame
      // self.currentFrame = viewFrame
      viewFrame.x = 0
      viewFrame.y = 0
      self.notificationView.frame = viewFrame;
      viewFrame.height = height-35
      self.notiScroll.frame = viewFrame
      self.webviewResponse.frame = viewFrame
      // self.toolbar.frame = MNUtil.genFrame(0, height-30, chatAIUtils.getWidth(),buttonHeight)
      self.setLayout()
    }

  },
  closeButtonTapped:async function (params) {
  try {
    

    let self = getNotificationController()
    if (self.connection) {
      self.connection.cancel()
      delete self.connection
    }
    await self.hide()
    self.onChat = false
    chatAIConfig.setSyncStatus(false)
    if (self.chatView) {
      self.chatView.hidden = true
    }
    self.notificationView.hidden = false
    self.webviewResponse.frame = MNUtil.genFrame(0, 0, chatAIUtils.getWidth(), 85)
    // self.sizeHeight = parseInt(await self.runJavaScript(`document.body.scrollHeight`))
    self.setNewResponse()
    // chatAIUtils.clearCurrent()
  } catch (error) {
      chatAIUtils.addErrorLog(error, "closeButtonTapped")
  }
  },
  bigbang:async function () {
    let self = getNotificationController()
    // let text = await self.getWebviewContent()
    let text = await self.getTextForAction()
    if (!self.noteid) {
      MNUtil.postNotification("bigbangText",{text:text})
    }else{
      MNUtil.postNotification("bigbangText",{text:text,noteid:self.noteid,url:chatAIUtils.getUrlByNoteId(self.noteid)})
    }
  },
  addChildNote: async function (button) {
  try {
    let self = getNotificationController()
    let text = await self.getTextForAction(button.round)
    let noteid
    if (self.onChat) {
      noteid = chatAIUtils.currentNoteId ?? (chatAIUtils.getFocusNote() ? chatAIUtils.getFocusNote().noteId : undefined) ?? self.noteid
    }else{
      noteid = self.noteid ?? chatAIUtils.currentNoteId ?? (chatAIUtils.getFocusNote() ? chatAIUtils.getFocusNote().noteId : undefined)
    }
    if (!noteid) {
      MNUtil.showHUD("Unavailable")
      return;
    }
    let config = {excerptText:text,excerptTextMarkdown:true}
    let focusNote = MNNote.new(noteid)
    let childNote = focusNote.createChildNote(config)
    // let childNote = chatAIUtils.createChildNote(noteid, config)
    // MNUtil.showHUD("Add child note")
    await MNUtil.delay(0.5)
    childNote.focusInMindMap()
    // chatAIUtils.focusNoteInMindMapById(childNote.noteId)
  } catch (error) {
      chatAIUtils.addErrorLog(error, "addChildNote")
  }
  },
  copy: async function (button) {
  // MNUtil.showHUD("copy")
  // self.runJavaScript(`editor.setTheme("dark","dark");`)
  try {
    let self = getNotificationController()
    let text = await self.getTextForAction(button.round)
    // let text = await self.getWebviewContent()
    MNUtil.copy(text)
    MNUtil.showHUD("Copy text")
  } catch (error) {
      chatAIUtils.addErrorLog(error, "copy")
  }
  },

  reAsk:async function (button) {
    let self = getNotificationController()
    // MNUtil.copyJSON(self.config)
    if (self.connection) {
      MNUtil.showHUD("On output!")
      return
    }
    if (!self.onChat && chatAIUtils.checkSubscribe(false)) {
      try {
      let selector = 'setChatModelAndReAsk:'
      let modelName = self.currentModel
      let subscriptionModels = chatAIUtils.isActivated()? (chatAIConfig.modelNames("Subscription").map(model=>{return "Subscription: "+model.trim()})):[]
      let customModels = chatAIConfig.getConfig("customKey")?  chatAIConfig.modelNames("Custom").map(model=>{return "Custom: "+model}) : []
      let chatgptModels = chatAIConfig.getConfig("openaiKey") ? chatAIConfig.modelNames("ChatGPT").map(model=>{return "ChatGPT:"+model.trim()}):[]
      let chatglmModels = chatAIConfig.getConfig("apikey") ? chatAIConfig.modelNames("ChatGLM").map(model=>{return "ChatGLM: "+model}) :[]
      let moonshotModels = chatAIConfig.getConfig("moonshotKey") ? chatAIConfig.modelNames("KimiChat").map(model=>{return "KimiChat: "+model}) : []
      let miniMaxModels = chatAIConfig.getConfig("miniMaxKey") ? chatAIConfig.modelNames("Minimax").map(model=>{return "Minimax: "+model}) : []
      let geminiModels = chatAIConfig.getConfig("geminiKey") ? chatAIConfig.modelNames("Gemini").map(model=>{return "Gemini: "+model}) : []
      let claudeModels = chatAIConfig.getConfig("claudeKey") ? chatAIConfig.modelNames("Claude").map(model=>{return "Claude: "+model}) : []
      let deepseekModels = chatAIConfig.getConfig("deepseekKey") ? chatAIConfig.modelNames("Deepseek").map(model=>{return "Deepseek: "+model}) : []
      let qwenModels = chatAIConfig.getConfig("qwenKey") ? chatAIConfig.modelNames("Qwen").map(model=>{return "Qwen: "+model}) : []
      let allModels = ["Default","Built-in"].concat(subscriptionModels).concat(chatglmModels).concat(moonshotModels).concat(miniMaxModels).concat(deepseekModels).concat(qwenModels).concat(chatgptModels).concat(customModels).concat(geminiModels).concat(claudeModels)
      var commandTable = [...new Set(allModels)].map(model=>{
        return {title:model,object:self,selector:selector,param:model,checked:modelName === model}
      })
      if (self.notifyLoc) {
        self.view.popoverController = chatAIUtils.getPopoverAndPresent(button,commandTable,250,0)
      }else{
        self.view.popoverController = chatAIUtils.getPopoverAndPresent(button,commandTable,250,4)
      }
      // self.view.popoverController = MNUtil.getPopoverAndPresent(button,commandTable,250)
      } catch (error) {
        chatAIUtils.addErrorLog(error, "changeChatModel")
      }
    }else{
      try {
      self.notShow = false
      self.called = true
      self.response = ""
      self.preFuncResponse = ''
      if (!self.onChat) {
        if (self.currentPrompt === "Dynamic" || self.currentPrompt === "Vision") {
          self.askByDynamic(self.question,0.99)
        }else{
          self.ask(self.question,self.currentPrompt,0.99)
        }
      }else{
        let last = self.history.pop()
        let question = undefined
        while (last.role !== "user") {
          last = self.history.pop()
        }
        question = last.content
        // if (last.role === "user") {
        //   question = last.content
        //   // MNUtil.showHUD(question)
        // }else{
        //   last = self.history.pop()
        //   // question = self.history.pop().content
        // }
        // let md2html = MNUtil.md2html("I'm thinking...")

        // self["assistant"+self.round].loadHTMLStringBaseURL(chatAIUtils.html(md2html,false,false))
        self["assistant"+self.round].loadFileURLAllowingReadAccessToURL(
          NSURL.fileURLWithPath(chatAIConfig.mainPath + `/veditor_${self.theme}.html`),
          NSURL.fileURLWithPath(chatAIConfig.mainPath + '/')
        );
        self["assistant"+self.round].sizeHeight = 50
        self.setChatLayout()
        // self["assistant"+self.round].frame = MNUtil.genFrame(5,5, self.view.frame.width-10, 50)
        self.continueAsk(question)
      }
      } catch (error) {
        chatAIUtils.addErrorLog(error, "reAsk")
      }
    }

  },
  setNoteTitle: async function(button) {
    let self = getNotificationController()
    let noteid
    if (self.onChat) {
      noteid = chatAIUtils.currentNoteId ?? (chatAIUtils.getFocusNote() ? chatAIUtils.getFocusNote().noteId : undefined) ?? self.noteid
    }else{
      noteid = self.noteid ?? chatAIUtils.currentNoteId ?? (chatAIUtils.getFocusNote() ? chatAIUtils.getFocusNote().noteId : undefined)
    }
    if (!noteid) {
      MNUtil.showHUD("Unavailable")
      return;
    }
    let note = MNUtil.getNoteById(noteid)
    let text = await self.getTextForAction(button.round)
    // let text = await self.getWebviewContent()
    if (button.clickDate && Date.now()-button.clickDate < 500) {
      if (/^".*"$/.test(text)) {
        let length = text.length
        MNUtil.undoGrouping(()=>{
          note.noteTitle = text.slice(1,length-1)
        })
      }
    }else{
      button.clickDate = Date.now()
      MNUtil.undoGrouping(()=>{
        note.noteTitle = text
      })
    }
  },
  setExcerpt: async function (button) {
    let text = await self.getTextForAction(button.round)
    // let text = await self.getWebviewContent()

  try {
    let noteid
    if (self.onChat) {
      noteid = chatAIUtils.currentNoteId ?? (chatAIUtils.getFocusNote() ? chatAIUtils.getFocusNote().noteId : undefined) ?? self.noteid
    }else{
      noteid = self.noteid ?? chatAIUtils.currentNoteId ?? (chatAIUtils.getFocusNote() ? chatAIUtils.getFocusNote().noteId : undefined)
    }
    if (!noteid) {
      MNUtil.showHUD("Unavailable")
      return
    }
    let note = MNNote.new(noteid)
    if (note.excerptPic && !note.textFirst) {
      MNUtil.excuteCommand("EditTextMode")
    }
    MNUtil.undoGrouping(()=>{
      note.excerptText = text.trim()
      if (note.excerptPic && !note.textFirst) {
        MNUtil.delay(0.5).then(()=>{
          MNUtil.excuteCommand("EditTextMode")
        })
      }
    })
  } catch (error) {
      chatAIUtils.addErrorLog(error, "setExcerpt")
  }
  },
  setComment: async function (button) {
    let text = await self.getTextForAction(button.round)
    // let text = await self.getWebviewContent()

  try {
    let noteid
    if (self.onChat) {
      noteid = chatAIUtils.currentNoteId ?? (chatAIUtils.getFocusNote() ? chatAIUtils.getFocusNote().noteId : undefined) ?? self.noteid
    }else{
      noteid = self.noteid ?? chatAIUtils.currentNoteId ?? (chatAIUtils.getFocusNote() ? chatAIUtils.getFocusNote().noteId : undefined)
    }
    if (!noteid) {
      MNUtil.showHUD("Unavailable")
      return
    }
    let note = MNUtil.getNoteById(noteid)
    MNUtil.undoGrouping(()=>{
      try {
        note.appendMarkdownComment(text.trim())
      } catch (error) {
        note.appendTextComment(text.trim())
      }
    })
  } catch (error) {
      chatAIUtils.addErrorLog(error, "setComment")
  }
  },
  showAILink: async function () {
    if (!self.noteid) {
      MNUtil.showHUD("Unavailable")
    }
    let text = await self.getTextForAction()
    // let text = await self.getWebviewContent()
    MNUtil.postNotification("aiLinkOnText",{text:text,noteid:self.noteid})
  },
  changePrompts: function(sender) {
    let self = getNotificationController();
    self.promptButton.setTitleForState(chatAIConfig.prompts[chatAIConfig.currentPrompt].title ,0)
    var commandTable = chatAIConfig.config.promptNames.map(promptName => {
      return {title:chatAIConfig.prompts[promptName].title,object:self,selector:'askWithPrompt:',param:promptName,checked:chatAIConfig.currentPrompt===promptName}
    })

    // switch (chatAIConfig.getConfig("notifyLoc")) {
    switch (self.notifyLoc) {
      case 0:
        self.view.popoverController = MNUtil.getPopoverAndPresent(sender,commandTable,200,4)
        break;
      case 1:
        self.view.popoverController = MNUtil.getPopoverAndPresent(sender,commandTable,200,0)
        break;
      default:
        break;
    }
  },
  changeChatModel:function (button) {
    let self = getNotificationController()
    // MNUtil.copyJSON(self.config)
    if (!chatAIUtils.checkSubscribe(false)) {
      return
    }
    try {
    let selector = 'setChatModel:'
    let modelName = self.currentModel
    let subscriptionModels = chatAIUtils.isActivated()? (chatAIConfig.modelNames("Subscription").map(model=>{return "Subscription: "+model.trim()})):[]
    let customModels = chatAIConfig.getConfig("customKey")?  chatAIConfig.modelNames("Custom").map(model=>{return "Custom: "+model}) : []
    let chatgptModels = chatAIConfig.getConfig("openaiKey") ? chatAIConfig.modelNames("ChatGPT").map(model=>{return "ChatGPT:"+model.trim()}):[]
    let chatglmModels = chatAIConfig.getConfig("apikey") ? chatAIConfig.modelNames("ChatGLM").map(model=>{return "ChatGLM: "+model}) :[]
    let moonshotModels = chatAIConfig.getConfig("moonshotKey") ? chatAIConfig.modelNames("KimiChat").map(model=>{return "KimiChat: "+model}) : []
    let miniMaxModels = chatAIConfig.getConfig("miniMaxKey") ? chatAIConfig.modelNames("Minimax").map(model=>{return "Minimax: "+model}) : []
    let geminiModels = chatAIConfig.getConfig("geminiKey") ? chatAIConfig.modelNames("Gemini").map(model=>{return "Gemini: "+model}) : []
    let claudeModels = chatAIConfig.getConfig("claudeKey") ? chatAIConfig.modelNames("Claude").map(model=>{return "Claude: "+model}) : []
    let deepseekModels = chatAIConfig.getConfig("deepseekKey") ? chatAIConfig.modelNames("Deepseek").map(model=>{return "Deepseek: "+model}) : []
    let qwenModels = chatAIConfig.getConfig("qwenKey") ? chatAIConfig.modelNames("Qwen").map(model=>{return "Qwen: "+model}) : []
    let allModels = ["Default","Built-in"].concat(subscriptionModels).concat(chatglmModels).concat(moonshotModels).concat(miniMaxModels).concat(deepseekModels).concat(qwenModels).concat(chatgptModels).concat(customModels).concat(geminiModels).concat(claudeModels)
    var commandTable = [...new Set(allModels)].map(model=>{
      return {title:model,object:self,selector:selector,param:model,checked:modelName === model}
    })
    self.view.popoverController = chatAIUtils.getPopoverAndPresent(button,commandTable,250,2)
    // self.view.popoverController = MNUtil.getPopoverAndPresent(button,commandTable,250)
    } catch (error) {
      chatAIUtils.addErrorLog(error, "changeChatModel")
    }
  },
  setChatModel:function (chatModel) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    if (!chatAIUtils.checkSubscribe(true)) {
      return
    }
      MNUtil.showHUD("Change model to: "+chatModel)
      self.currentModel = chatModel
      let config
      let modelConfig = chatModel.split(":").map(model=>model.trim())
      if (modelConfig[0] !== "Default") {
        let source = modelConfig[0]
        config = chatAIConfig.getConfigFromSource(source)
        if (modelConfig.length === 2) {
          config.model = modelConfig[1]
        }
      }else{
        config = chatAIConfig.getConfigFromSource()
      }
      self.config = config
  },
  setChatModelAndReAsk:function (chatModel) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    if (!chatAIUtils.checkSubscribe(true)) {
      return
    }
      MNUtil.showHUD("ReAsk with model: "+chatModel)
      self.currentModel = chatModel
      let config
      let modelConfig = chatModel.split(":").map(model=>model.trim())
      if (modelConfig[0] !== "Default") {
        let source = modelConfig[0]
        config = chatAIConfig.getConfigFromSource(source)
        if (modelConfig.length === 2) {
          config.model = modelConfig[1]
        }
      }else{
        config = chatAIConfig.getConfigFromSource()
      }
      self.config = config
try {
      self.notShow = false
      self.called = true
      self.response = ""
      self.preFuncResponse = ''
      if (!self.onChat) {
        if (self.currentPrompt === "Dynamic" || self.currentPrompt === "Vision") {
          self.reAskByDynamic(self.question,0.99)
        }else{
          self.reAsk(self.question,self.currentPrompt,0.99)
        }
      }else{
        let last = self.history.pop()
        let question = undefined
        while (last.role !== "user") {
          last = self.history.pop()
        }
        question = last.content
        self["assistant"+self.round].loadFileURLAllowingReadAccessToURL(
          NSURL.fileURLWithPath(chatAIConfig.mainPath + `/veditor_${self.theme}.html`),
          NSURL.fileURLWithPath(chatAIConfig.mainPath + '/')
        );
        self["assistant"+self.round].sizeHeight = 50
        self.setChatLayout()
        self.continueAsk(question)
      }
      } catch (error) {
        chatAIUtils.addErrorLog(error, "reAsk")
      }
  },
  askWithPrompt: async function (prompt) {
    let self = getNotificationController()
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    self.askWithPrompt(prompt)
  },
  onResizeGesture:function (gesture) {
    // MNUtil.showHUD("message")
    if (self.notifyTimer) {self.notifyTimer.invalidate()}
    let studyFrameHeight = MNUtil.studyView.frame.height
    let maxHeight = studyFrameHeight-chatAIUtils.getY()
    self.custom = false;
    self.dynamic = false;
    let baseframe = gesture.view.frame
    let locationToBrowser = gesture.locationInView(self.view)
    let frame = self.view.frame
    let temX
    let height = locationToBrowser.y+baseframe.height*0.5
    if (height <= 100) {
      height = 100
    }
    if (height >= maxHeight) {
      height = maxHeight
    }
    if (self.notifyLoc === 0) {
      //  Application.sharedInstance().MNUtil.showHUD(`{x:${translation.x},y:${translation.y}}`, self.view.window, 2);
      //  self.view.frame = {x:frame.x,y:frame.y,width:frame.width+translationX,height:frame.height+translationY}
      self.view.frame = {x:chatAIUtils.getX(),y:chatAIUtils.getY(),width:chatAIUtils.getWidth(),height:height}
      self.currentFrame  = self.view.frame
      temX = locationToBrowser.x-frame.width+gesture.view.frame.width*0.5
    }else{
      self.view.frame = {x:MNUtil.studyView.bounds.width-450,y:chatAIUtils.getY(),width:chatAIUtils.getWidth(),height:height}
      self.currentFrame  = self.view.frame
      temX = locationToBrowser.x-gesture.view.frame.width*0.5
    }
    if (gesture.state === 3 && !chatAIUtils.isIOS()) {
      if (self.notifyLoc === 1 && temX < -200) {
        chatAIConfig.config.notifyLoc = 0
        self.show(chatAIConfig.config.notifyLoc,false)
        chatAIConfig.save("MNChatglm_config")
        if (chatAIUtils.chatController.windowLocationButton) {
          chatAIUtils.chatController.windowLocationButton.setTitleForState("Notification: Left",0)
        }
      }
      if (self.notifyLoc === 0 && temX > 200) {
        chatAIConfig.config.notifyLoc = 1
        self.show(chatAIConfig.config.notifyLoc,false)
        chatAIConfig.save("MNChatglm_config")
        if (chatAIUtils.chatController.windowLocationButton) {
          chatAIUtils.chatController.windowLocationButton.setTitleForState("Notification: Right",0)
        }
      }
    }
    if (self.onChat) {
      self.chatView.frame = {x:0,y:0,width:chatAIUtils.getWidth(),height:height}
      self.setChatLayout()
    }
  },
  toggleLocation: async function (params) {
    let self = getNotificationController()
    try {
    switch (chatAIConfig.config.notifyLoc) {
      case 1:
        chatAIConfig.config.notifyLoc = 0
        if (self.onChat) {
          self.chatLocation.setTitleForState("Left",0)
          await self.setChatLayout()
        }else{
          // self.locationButton.setTitleForState(" L ",0)
        }
        if (chatAIUtils.chatController.windowLocationButton) {
          chatAIUtils.chatController.windowLocationButton.setTitleForState("Notification: Left",0)
        }
        break;
      case 0:
        chatAIConfig.config.notifyLoc = 1
        if (self.onChat) {
          self.chatLocation.setTitleForState("Right",0)
          await self.setChatLayout()
        }else{
          // self.locationButton.setTitleForState(" R ",0)
        }
        if (chatAIUtils.chatController.windowLocationButton) {
          chatAIUtils.chatController.windowLocationButton.setTitleForState("Notification: Right",0)
        }
        // self.locationButton.setTitleForState(" R ",0)
        break;
      default:
        break;
    }
    self.show(chatAIConfig.config.notifyLoc)
    chatAIConfig.save('MNChatglm_config')
    } catch (error) {
      chatAIUtils.addErrorLog(error, "toggleLocation")
    }
  },
  openChatView: async function (params) {

    let self = getNotificationController()
    self.openChatView(true)
    return
    if (self.connection) {
      MNUtil.showHUD("Wait...")
      return
    }
    try {
    self.round = 0
    self.heights = {}
    if (self.notifyTimer) {
      self.notifyTimer.invalidate()
    }
    self.notificationView.hidden = true
    self.webviewResponse.hidden = true

    self.onChat = true
    // if (!self.chatView) {
      self.chatView = new UIView(self.view.bounds)
      self.chatView.layer.cornerRadius = 8
      self.view.addSubview(self.chatView)
    // }
    // self.chatView.hidden = false
    // MNUtil.showHUD(self.theme)
    // self.chatView.backgroundColor = MNUtil.hexColorAlpha("#ffffff",0.0)
    // if (!self.chatToolbar) {
      self.chatToolbar = UIView.new()
      self.chatToolbar.layer.cornerRadius = 8
      self.chatToolbar.backgroundColor = MNUtil.hexColorAlpha("#ffffff",0.0)
      self.chatView.addSubview(self.chatToolbar)
    // }
    self.createButton("closeChatButton","closeButtonTapped:","chatToolbar")
    self.closeChatButton.setImageForState(self.stopImage,0)
    self.closeChatButton.backgroundColor = MNUtil.hexColorAlpha("#e06c75",0.8)
    self.resizeGesture0 = new UIPanGestureRecognizer(self,"onResizeGesture:")
    self.closeChatButton.addGestureRecognizer(self.resizeGesture0)
    self.resizeGesture0.view.hidden = false
    self.resizeGesture0.addTargetAction(self,"onResizeGesture:")

    self.createButton("sendButton","sendButtonTapped:","chatView")
    self.sendButton.setImageForState(self.sendImage,0)
    self.sendButton.backgroundColor = MNUtil.hexColorAlpha("#e06c75",0.8)
    self.creatTextView("userInput","chatView")
    self.userInput.editable = true
    self.userInput.layer.borderColor = MNUtil.hexColorAlpha("#9bb2d6",0.8)
    self.userInput.backgroundColor = MNUtil.hexColorAlpha("#e4eeff",0.8)
    self.userInput.scrollEnabled = true
    self.userInput.bounces = true
    self.createButton("chatLocation","toggleLocation:","chatToolbar")
    self.chatLocation.setTitleForState(chatAIConfig.config.notifyLoc?'Right':'Left',0)
    self.chatLocation.titleLabel.font = UIFont.boldSystemFontOfSize(16);
    self.createButton("chatToken","doNothing:","chatToolbar")
    self.createButton("chatModel","doNothing:","chatToolbar")
    self.createButton("reAskButton","reAsk:","chatToolbar")
    self.reAskButton.setImageForState(self.reloadImage,0)
    self.chatToken.hidden = false
    self.chatToken.setTitleForState(self.token[0]+"("+chatAIUtils.sum(self.token)+")",0)
    self.chatToken.titleLabel.font = UIFont.boldSystemFontOfSize(16);
    self.chatModel.hidden = false
    self.chatModel.setTitleForState(self.token[0]+"("+chatAIUtils.sum(self.token)+")",0)
    self.chatModel.titleLabel.font = UIFont.boldSystemFontOfSize(16);
    // if (!self.scrollView) {
      self.scrollView = UIScrollView.new()
      self.scrollView.layer.cornerRadius = 8
    // }
    if (self.theme === "dark") {
      self.scrollView.backgroundColor = MNUtil.hexColorAlpha("#333b41",0.8)
    }else{
      self.scrollView.backgroundColor = MNUtil.hexColorAlpha("#ffffff",0.8)
    }
    // self.scrollView.backgroundColor = MNUtil.hexColorAlpha("#ffffff",0.8)
    self.chatView.addSubview(self.scrollView)
    self.creatButtonsForRound(0)
    var viewFrame = self.view.frame;
    var height   = viewFrame.height
    let studyFrame = MNUtil.studyView.frame
    if (MNUtil.appVersion().type == "iPhoneOS") {
      viewFrame.height = studyFrame.height
    }else{
      viewFrame.height = studyFrame.height-50
    }
    self.view.frame = viewFrame
    self.currentFrame = viewFrame
    self.chatView.frame = MNUtil.genFrame(0, 0, viewFrame.width, viewFrame.height)
    // await MNUtil.delay(0.1)
    self.sizeHeight = self.sizeHeight*1.1+20
    MNUtil.delay(0.4).then(async ()=>{
      // self.setWebviewContent(md2html, false, "assistant0")
      let funcHtml = ""
      if (self.preFuncResponse) {
        funcHtml = `<pre><code class="hljs">${self.preFuncResponse.trim()}</code></pre>`
        self.preFuncResponse = ''
      }
      if (self.lastResponse.trim()) {
        // self.changeTheme(self.theme, "assistant0")
        let sizeHeight = await self.setWebviewContentDev(self.lastResponse, funcHtml,false, "assistant0")
        if (typeof sizeHeight === "number") {
          self.sizeHeight = sizeHeight
        }else{
          chatAIUtils.addErrorLog(error, "openChatView", {sizeHeight:sizeHeight})
        }
      }
      self.sizeHeight = self.sizeHeight+30
      self.setChatLayout()
    })
    self.setChatLayout()
    self.setNewResponse()
    } catch (error) {
      chatAIUtils.addErrorLog(error, "openChatView")
    }
  },
  sendButtonTapped: async function (params) {
    if (self.connection) {
      MNUtil.showHUD("Wait...")
      return
    }
    try {
    let self = getNotificationController()
    let text = self.userInput.text.trim()
    self.prepareContinueAsk(text)
    self.continueAsk(text)
    } catch (error) {
      chatAIUtils.addErrorLog(error, "sendButtonTapped")
    }
  },
  /**
   * 
   * @param {UITextView} textview 
   */
  textViewDidBeginEditing:function (textview) {
    // MNUtil.showHUD("begin")
    // self.notifyTimer.invalidate()
  },
  /**
   * 
   * @param {UITextView} textview 
   */
  textViewDidChange:function (textview) {
    let frame = self.view.frame
    let size = textview.sizeThatFits({width:frame.width-50,height:1000})
    if (size.height < 50) {
      size.height = 50
    }
    if (size.height > 85) {
      size.height = 85
    }
    self.userInput.frame = MNUtil.genFrame(0,frame.height-85, frame.width-50, size.height)
    if (/\n\n$/.test(textview.text) && textview.text.trim()) {
      if (self.connection) {
        MNUtil.showHUD("Wait...")
        return
      }
      let text = textview.text.trim()
      try {
        self.prepareContinueAsk(text)
        self.continueAsk(text)
      } catch (error) {
        MNUtil.showHUD(error)
      }
    }
    
  },
  webViewShouldStartLoadWithRequestNavigationType: function(webView,request,type){
    let requestURL = request.URL().absoluteString()
    // MNUtil.copy(requestURL)
    if (/^nativecopy\:\/\//.test(requestURL)) {
      let text = decodeURIComponent(requestURL.split("content=")[1])
      MNUtil.copy(text)
      return false
    }
    if (/^editorselect\:\/\//.test(requestURL)) {
      let text = decodeURIComponent(requestURL.split("content=")[1])
      MNUtil.copy(text)
      return false
    }
    if (/^editorheight\:\/\//.test(requestURL)) {
      let height = decodeURIComponent(requestURL.split("content=")[1])
      MNUtil.showHUD("height: "+height)
      return false
    }
    if (/^(marginnote\dapp)/.test(requestURL)) {
      let targetNote = MNNote.new(requestURL)
      targetNote.focusInFloatMindMap()
      // MNUtil.openURL(requestURL)
      // Application.sharedInstance().openURL(NSURL.URLWithString(requestURL));
      return false
    }
    if (/^http/.test(requestURL) || /^data\:image\//.test(requestURL)) {
      let beginFrame = self.view.frame
      let endFrame = beginFrame
      let studyFrame = MNUtil.studyView.bounds
      if ((beginFrame.x+beginFrame.width*2) < studyFrame.width) {
        endFrame.x = beginFrame.x+beginFrame.width
        MNUtil.postNotification("openInBrowser", {url:requestURL,beginFrame:beginFrame,endFrame:endFrame})
        return false
      }
      if ((beginFrame.x-beginFrame.width) > 0) {
        endFrame.x = beginFrame.x-beginFrame.width
        MNUtil.postNotification("openInBrowser", {url:requestURL,beginFrame:beginFrame,endFrame:endFrame})
        return false
      }
      MNUtil.postNotification("openInBrowser", {url:requestURL})
      return false
    }
    return true;
  },
  connectionDidReceiveResponse: async function (connection,response) {
    let self = getNotificationController()
    self.setButtonOpacity(0.5)
    // self.response = ""
    self.funcResponse = ""
    self.originalText = ""
    self.notShow = false
    self.size = []
    self.func = undefined
    self.tool = {}
    self.preHeight = 0
    self.autoHide = true
    if (!self.onChat) {
      self.sizeHeight = 0
    }
    self.scrollToBottom = false
    self.first = true
    self.onFinish = false
    // chatAIUtils.copyJSON(self.token)
    self.statusCode = response.statusCode()
    // chatAIUtils.showStatusCodeDescription(self.statusCode.toString())
    // MNUtil.copy("code:"+self.statusCode)
    if (self.onChat) {
      self.setChatLayout()
    }else{
      // self.webviewResponse.loadHTMLStringBaseURL(html("test"))
      self.sizeHeight = await self.getWebviewHeight()
      // self.sizeHeight = parseInt(await self.runJavaScript(`document.body.scrollHeight`))
      self.setNotiLayout()
    }
  },

  connectionDidReceiveData: async function (connection,data) {
    let self = getNotificationController()
    try {
    self.onreceive = true
    // self.size.push(self.textString)
    let textString = MNUtil.data2string(data)
    if (!/^data:\s?\[DONE\]/.test(textString)) {
      self.textString = textString
      // textString = textString.replace(/data:\s?\[DONE\]/,"")
    }
    self.originalText = self.originalText+textString
    // MNUtil.copy(self.originalText)
    switch (self.source) {
      case "Claude":
        self.getResponseForClaude(textString)
        break;
      case "Gemini":
        self.getResponseForGemini(textString)
        break;
      default:
        if (/^data\:/.test(textString) && !/^data\:\s?\[DONE\]/.test(textString)) {
          if (/^data\:\s{"base_resp"\:{"status_code"\:\d\d+/.test(textString)) {
            MNUtil.showHUD(textString)
            return
          }
          // let message = textString.slice(5).trim()
          // if (!MNUtil.isValidJSON(message)) {
          //   chatAIUtils.addErrorLog(message, "connectionDidReceiveData")
          //   // MNUtil.showHUD("Error: "+textString)
          //   return;
          // }
          // MNUtil.copy(textString)
        }
        self.getResponseForChatGPT()
        break;
    }
    } catch (error) {
      if (error.toString() !== "Error: Malformed UTF-8 data") {
        chatAIUtils.addErrorLog(error, "connectionDidReceiveData",self.originalText)
      }
    }
    self.setResponseText(self.preFuncResponse+self.funcResponse).then(()=>{
    // await self.setResponseText(self.preFuncResponse+self.funcResponse)
    if (/data:\s?\[DONE\]/.test(self.textString)) {
      if (!self.onFinish && self.connection && (self.connection === connection)) {
        self.onFinish = true
        // self.beginTime = Date.now()
        self.prepareFinish()
        // MNUtil.showHUD("finish")
        // MNUtil.copy(self.textString)
      }
    }else{
      if (self.onChat) {
        self.setChatLayout()
      }else{
        self.setNotiLayout()
      }
    }
    return
    })
  },
  connectionDidFinishLoading: function (connection) {
  // let self = getNotificationController()
  if (!self.onFinish && self.connection && (self.connection === connection)) {
    self.onFinish = true
    self.prepareFinish()
    // MNUtil.showHUD("finish")
    // MNUtil.copy(self.textString)
  }
  },
  connectionDidFailWithError: function (connection,error) {
    MNUtil.copyJSON(error.userInfo)
    MNUtil.showHUD("Network error")
    self.setButtonOpacity(1.0)
    delete self.connection
  }
});

notificationController.prototype.preCheck = function () {
  if (this.connection) {
    MNUtil.showHUD("on output")
    return false
  }
  if (this.notShow && !this.called) {
    // MNUtil.showHUD("not show")
    return false
  }
  if (chatAIUtils.checkSubscribe(false,false)) {
    chatAIUtils.chatController.usageButton.setTitleForState("Unlimited",0)
    return true
  }
  if (chatAIConfig.config.source === "Built-in") {
    let usage = chatAIConfig.getUsage()
    if (usage.usage >= usage.limit) {
      MNUtil.showHUD("Access limited")
      return false
    }else{
      usage.usage = usage.usage+1
    }
    if (chatAIUtils.chatController.usageButton) {
      chatAIUtils.chatController.usageButton.setTitleForState("Usage: "+usage.usage+"/100",0)
    }
    chatAIConfig.save("MNChatglm_usage")
  }
  return true
}

/** 
 * @this {notificationController} 
 * @param {{key:String,url:String,model:String}} config
 */
notificationController.prototype.baseAsk = async function(
  question,
  config = chatAIConfig.getConfigFromSource(),  
  temperature=0.8
) {
try {
  // chatAIUtils.copyJSON(config)
  this.question = question
  this.history = [].concat(question)
  this.config = config
  this.temperature = temperature
  this.funcIndices = config.func ?? []
  this.actions = config.action ?? []
  this.source = config.source
  switch (config.source) {
    case "ChatGLM":
      this.initRequestForChatGLM(config.key,config.model,temperature,this.funcIndices)
      break;
    case "KimiChat":
    case "Minimax":
    case "Deepseek":
    case "Qwen":
    case "ChatGPT":
    case "Subscription":
    case "Custom":
      this.initRequestForChatGPT(config.key,config.url,config.model,temperature,this.funcIndices)
      break;
    case "Claude":
      this.initRequestForClaude(config.key,config.url,config.model, temperature)
      break;
    case "Gemini":
      this.initRequestForGemini(config.key,config.url,config.model, temperature)
      break;
    case "Built-in":
      //对内置模型而言，只能使用选择好的渠道，不能指定模型
      let keyInfo = chatAIConfig.keys["key"+chatAIConfig.getConfig("tunnel")]
      if (!keyInfo || !keyInfo.keys) {
        MNUtil.showHUD("No apikey for built-in mode!")
        return
      }
      // MNUtil.copyJSON(keyInfo)
      let key = chatAIUtils.getRandomElement(keyInfo.keys)
      if (key === "") {
        MNUtil.showHUD("No apikey for built-in mode!")
        return
      }
      if (keyInfo.useSubscriptionURL) {
        let url = subscriptionConfig.getConfig("url")+ "/v1/chat/completions"
        this.initRequestForChatGPT(key, url,keyInfo.model,temperature,this.funcIndices)
      }else{
        this.initRequestForChatGPT(key, keyInfo.url,keyInfo.model,temperature,this.funcIndices)
      }
    default:
      break;
  }
  chatAIUtils.lastTime = Date.now()
} catch (error) {
  chatAIUtils.addErrorLog(error, "baseAsk")
}
}

/** 
 * @this {notificationController} 
 * @param {String} prompt
 */
notificationController.prototype.askWithPrompt = async function (prompt) {
  try {
    let config = chatAIConfig.getConfigFromPrompt(prompt)
    let question = await chatAIUtils.chatController.getQuestion(prompt)
    if (!question) {
      return
    }
    // copyJSON(config)
    this.baseAsk(question,config)
    this.beginNotification(config.title)
  } catch (error) {
    chatAIUtils.addErrorLog(error, "askWithPrompt")
  }
}
/**
 * 
 * @param {*} question 
 * @param {*} temperature 
 * @param {*} reask 
 * @this {notificationController}
 */
notificationController.prototype.ask = async function(question,promptKey=this.currentPrompt,temperature=0.8) {
try {
  this.dynamic = false
  this.token = []
  this.func = []
  this.preFuncResponse = ""
  let delay = chatAIConfig.config.delay
  if (this.called) {
    delay = 0
  }
  if (!this.preCheck()) {
    return
  }
  await this.delay(delay)
  // MNUtil.showHUD(chatAIConfig.currentTitle)
  // MNUtil.showHUD(chatAIConfig.currentTitle)

  let promptConfig = chatAIConfig.prompts[promptKey]
  if (promptKey) {
    this.currentPrompt = promptKey
    this.currentTitle = promptConfig.title
  }
  await this.beginNotification()
  if ("model" in promptConfig) {
    this.currentModel = promptConfig.model
  }else{
    this.currentModel = "Default"
  }
  let config = chatAIConfig.getConfigFromPrompt(promptKey)
  // MNUtil.copyJSON(config)
  this.baseAsk(question,config,temperature)

} catch (error) {
  chatAIUtils.addErrorLog(error, "ask")
}
  // })
  
};
/**
 * 
 * @param {*} question 
 * @param {*} temperature 
 * @param {*} reask 
 * @this {notificationController}
 */
notificationController.prototype.reAsk = async function(question,promptKey=this.currentPrompt,temperature=0.8) {
try {
  this.dynamic = false
  this.token = []
  this.func = []
  this.preFuncResponse = ""
  let delay = chatAIConfig.config.delay
  if (this.called) {
    delay = 0
  }
  if (!this.preCheck()) {
    return
  }
  await this.delay(delay)
  // MNUtil.showHUD(chatAIConfig.currentTitle)
  // MNUtil.showHUD(chatAIConfig.currentTitle)

  let promptConfig = chatAIConfig.prompts[promptKey]
  if (promptKey) {
    this.currentPrompt = promptKey
    this.currentTitle = promptConfig.title
  }
  await this.beginNotification()
  this.baseAsk(question,this.config,temperature)

} catch (error) {
  chatAIUtils.addErrorLog(error, "ask")
}
  // })
  
};

/**
 * 
 * @param {*} question 
 * @param {*} temperature 
 * @param {*} reask 
 * @this {notificationController}
 */
notificationController.prototype.customAsk = async function(question,noteId = undefined) {
try {
  this.noteid = noteId
  this.token = []
  this.func = []
  this.preFuncResponse = ""
  // this.targetTextview = "textviewResponse"
  if (!this.preCheck()) {
    return
  }
  let currentFrame = this.view.frame
  currentFrame.height = 120
  this.view.frame = currentFrame
  this.currentFrame = currentFrame
  await this.beginNotification("Toolbar")
  this.question = question
  this.baseAsk(question)
} catch (error) {
  chatAIUtils.addErrorLog(error, "customAsk")
}
};

/**
 * 
 * @param {*} question 
 * @param {*} temperature 
 * @param {*} reask 
 * @this {notificationController}
 */
notificationController.prototype.askByDynamic = async function(question,temperature=0.8,reask=false) {
try {
  let config = chatAIConfig.getDynmaicConfig()
  let promptModel = chatAIConfig.getConfig("dynamicModel")
  if (promptModel) {
    this.currentModel = promptModel
  }else{
    this.currentModel = "Default"
  }
  // chatAIUtils.copyJSON(question)
  this.dynamic = true
  this.history = []
  this.token = []
  this.preFuncResponse = ""
  this.actions = config.action
  // this.targetTextview = "textviewResponse"
  if (!this.preCheck()) {
    return
  }
  let currentFrame = this.view.frame
  currentFrame.height = 120
  this.view.frame = currentFrame
  this.currentFrame = currentFrame
  await this.beginNotification("Dynamic")
  this.baseAsk(question,config,undefined)
} catch (error) {
  chatAIUtils.addErrorLog(error, "askByDynamic")
}
};
/**
 * 
 * @param {*} question 
 * @param {*} temperature 
 * @param {*} reask 
 * @this {notificationController}
 */
notificationController.prototype.reAskByDynamic = async function(question,temperature=0.8,reask=false) {
try {
  this.dynamic = true
  this.history = []
  this.token = []
  this.preFuncResponse = ""
  this.actions = config.action
  // this.targetTextview = "textviewResponse"
  if (!this.preCheck()) {
    return
  }
  let currentFrame = this.view.frame
  currentFrame.height = 120
  this.view.frame = currentFrame
  this.currentFrame = currentFrame
  await this.beginNotification("Dynamic")
  this.baseAsk(question,this.config,undefined)
} catch (error) {
  chatAIUtils.addErrorLog(error, "askByDynamic")
}
};
/**
 * 
 * @param {*} question 
 * @param {*} temperature 
 * @param {*} reask 
 * @this {notificationController}
 */
notificationController.prototype.askByVision = async function(question,temperature=0.8,reask=false) {
try {
  let config = chatAIConfig.getDynmaicConfig()
  // chatAIUtils.copyJSON(question)
  this.dynamic = true
  this.history = []
  this.token = []
  this.actions = config.action
  this.preFuncResponse = ""
  // this.targetTextview = "textviewResponse"
  if (!this.preCheck()) {
    return
  }
  let currentFrame = this.view.frame
  currentFrame.height = 120
  this.view.frame = currentFrame
  this.currentFrame = currentFrame
  await this.beginNotification("Vision")
  this.baseAsk(question,config,undefined)
} catch (error) {
  chatAIUtils.addErrorLog(error, "askByVision")
}
};
/**
 * 
 * @param {number} round 
 * @this {notificationController}
 */
notificationController.prototype.creatButtonsForRound = function(round){
  try {
    let backgroundColor = MNUtil.hexColorAlpha("#aeaeae",0.8)
      this["assistant"+round] = this.createWebviewHtmlDev("scrollView")
      this["assistant"+round].first = true
      this["assistant"+round].scrollView.bounces = false
      let viewFrame = this.view.frame
      this["assistant"+round].sizeHeight = 50
      this["assistant"+round].layer.opacity = 0
      this["assistant"+round].frame = MNUtil.genFrame(5,5, viewFrame.width-10, 40)
      MNUtil.delay(0.2).then(()=>{ 
        this.changeTheme(this.theme, "assistant"+round)
        MNUtil.animate(()=>{
          this["assistant"+round].layer.opacity = 0.9
        })
      })
      let copyButtonName = "copyButton"+round
      this.createButton(copyButtonName,"copy:","scrollView")
      this[copyButtonName].setImageForState(this.copyImage,0)
      this[copyButtonName].round = round
      this[copyButtonName].backgroundColor = backgroundColor    
      let titleButtonName = "titleButton"+round
      this.createButton(titleButtonName,"setNoteTitle:","scrollView")
      this[titleButtonName].setImageForState(this.titleImage,0)
      this[titleButtonName].round = round
      this[titleButtonName].backgroundColor = backgroundColor   
      let commentButtonName = "commentButton"+round
      this.createButton(commentButtonName,"setComment:","scrollView")
      this[commentButtonName].setImageForState(this.commentImage,0)
      this[commentButtonName].round = round
      this[commentButtonName].backgroundColor = backgroundColor   
      let excerptButtonName = "excerptButton"+round
      this.createButton(excerptButtonName,"setExcerpt:","scrollView")
      this[excerptButtonName].setImageForState(this.excerptImage,0)
      this[excerptButtonName].round = round
      this[excerptButtonName].backgroundColor = backgroundColor
      let childButtonName = "childButton"+round
      this.createButton(childButtonName,"addChildNote:","scrollView")
      this[childButtonName].setImageForState(this.childImage,0)
      this[childButtonName].round = round
      this[childButtonName].backgroundColor = backgroundColor
  }catch(error){
    chatAIUtils.addErrorLog(error, "creatButtonsForRound")
  }
}
/**
 * 
 * @param {string} text 
 * @this {notificationController}
 */
notificationController.prototype.prepareContinueAsk = function(text){
  try {
    this.round = this.round+1
      // let text = this.userInput.text.trim()
      this.userInput.text = ""
      this.creatTextView("user"+this.round,"scrollView")
      this["user"+this.round].font = UIFont.systemFontOfSize(16);
      this["user"+this.round].text = text
      this["user"+this.round].layer.borderColor = MNUtil.hexColorAlpha("#9bb2d6",0.8)
      this["user"+this.round].backgroundColor = MNUtil.hexColorAlpha("#e4eeff",0.5)

      this["user"+this.round].editable = false

      this.creatButtonsForRound(this.round)

      // this["assistant"+this.round] = this.createWebviewHtmlDev("scrollView")
      // this["assistant"+this.round].first = true
      // this["assistant"+this.round].scrollView.bounces = false
      // let viewFrame = this.view.frame
      // this["assistant"+this.round].sizeHeight = 50
      // this["assistant"+this.round].frame = MNUtil.genFrame(5,5, viewFrame.width-10, 50)
      // let copyButtonName = "copyButton"+this.round
      // this.createButton(copyButtonName,"copy:","scrollView")
      // this[copyButtonName].setImageForState(this.copyImage,0)
      // this[copyButtonName].round = this.round
      // this[copyButtonName].backgroundColor = MNUtil.hexColorAlpha("#aeaeae",0.8)    
      // let titleButtonName = "titleButton"+this.round
      // this.createButton(titleButtonName,"setNoteTitle:","scrollView")
      // this[titleButtonName].setImageForState(this.titleImage,0)
      // this[titleButtonName].round = this.round
      // this[titleButtonName].backgroundColor = MNUtil.hexColorAlpha("#aeaeae",0.8)   
      // let commentButtonName = "commentButton"+this.round
      // this.createButton(commentButtonName,"setComment:","scrollView")
      // this[commentButtonName].setImageForState(this.commentImage,0)
      // this[commentButtonName].round = this.round
      // this[commentButtonName].backgroundColor = MNUtil.hexColorAlpha("#aeaeae",0.8)   
      // let excerptButtonName = "excerptButton"+this.round
      // this.createButton(excerptButtonName,"setExcerpt:","scrollView")
      // this[excerptButtonName].setImageForState(this.excerptImage,0)
      // this[excerptButtonName].round = this.round
      // this[excerptButtonName].backgroundColor = MNUtil.hexColorAlpha("#aeaeae",0.8)
      // let childButtonName = "childButton"+this.round
      // this.createButton(childButtonName,"addChildNote:","scrollView")
      // this[childButtonName].setImageForState(this.childImage,0)
      // this[childButtonName].round = this.round
      // this[childButtonName].backgroundColor = MNUtil.hexColorAlpha("#aeaeae",0.8)
      this.setChatLayout()
  }catch(error){
    chatAIUtils.addErrorLog(error, "prepareContinueAsk")
  
  }
}
/**
 * 
 * @param {*} question 
 * @param {*} temperature 
 * @param {*} reask 
 * @this {notificationController}
 */
notificationController.prototype.continueAsk = function(question,temperature=0.8) {
  let config = chatAIConfig.config
  if (this.notShow && !this.called) {
    // MNUtil.showHUD("not show")
    return
  }
  if (this.connection) {
    MNUtil.showHUD("on output")
    return
  }
  let funcIndices
  if (this.dynamic) {
    funcIndices =  chatAIConfig.config.dynamicFunc
  }else{
    funcIndices =  chatAIConfig.prompts[this.currentPrompt].func ? chatAIConfig.prompts[this.currentPrompt].func : []
  }
  this.question = question
  this.apikey = config.apikey
  this.func = []
  // this.history = this.history.concat(question)
  this.history.push({role: "user", content: question})
  // MNUtil.copyJSON(this.history)
  // MNUtil.copyJSON(this.config)
  this.baseAsk(this.history,this.config)
};

/**
 * 
 * @param {*} question 
 * @param {*} temperature 
 * @param {*} reask 
 * @this {notificationController}
 */
notificationController.prototype.continueAfterToolCall = function(temperature=0.8) {
  try {
    
  let config = this.config
  // let config = chatAIConfig.config
  if (this.notShow && !this.called) {
    // MNUtil.showHUD("not show")
    return
  }
  if (this.connection) {
    MNUtil.showHUD("on output")
    return
  }
  // let funcIndices
  // // config = chatAIConfig.getConfigFromPrompt(this.currentPrompt)
  // if (this.dynamic) {
  //   funcIndices =  chatAIConfig.config.dynamicFunc
  // }else{
  //   funcIndices =  chatAIConfig.prompts[this.currentPrompt].func ? chatAIConfig.prompts[this.currentPrompt].func : []
  // }
  // this.apikey = config.apikey
  // this.func = []
  
  this.baseAsk(this.history,config,temperature)
  } catch (error) {
    chatAIUtils.addErrorLog(error, "continueAfterToolCall")
  }
};
/**
 * @this {notificationController}
 */
notificationController.prototype.prepareFinish = async function () {
  try {
  delete this.connection
  // this.size.push(Date.now())
  this.onFinish = true
  this.scrollToBottom = false
  if (this.statusCode >= 400) {
    let codeDes = chatAIUtils.getStatusCodeDescription(this.statusCode.toString())
    if (chatAIUtils.isValidJSON(this.textString)) {
      MNUtil.showHUD(codeDes+" | "+this.textString)
      MNUtil.copy(codeDes+"\n"+JSON.stringify(JSON.parse(this.textString),null,2)+"\n"+JSON.stringify(this.config))
    }else{
      MNUtil.showHUD(codeDes+" | "+this.textString)
      MNUtil.copy(codeDes+"\n"+this.textString+"\n"+JSON.stringify(this.config))
    }
    // copy(this.textString)
    if (this.onChat) {
      this.setChatLayout()
    }else{
      this.setNotiLayout()
    }
    this.setButtonOpacity(1.0)
    return
  }
  if (/"total_tokens"\:/.test(this.textString)) {
    let res = this.textString.match(/"total_tokens"\:(\d+)/)
    let token = parseInt(res[1])
    if (token == 0) {
      try {
        let resJSON = JSON.parse(this.textString.replace("data:",""))
        if ("base_resp" in resJSON) {
          MNUtil.showHUD(resJSON.base_resp.status_msg)
        }
      } catch (error) {
        
      }
      // MNUtil.copyJSON(resJSON)
    }
    res && this.setToken(token)
  }else{
    this.token.push(0)
  }
    if (!this.func || !this.func.length) {
      this.setButtonOpacity(1.0)
    }
    this.finish()
  } catch (error) {
    chatAIUtils.addErrorLog(error, "prepareFinish")
  }
}
/**
 * @this {notificationController}
 */
notificationController.prototype.finish = async function() {
  // this.connection.cancel()
  // MNUtil.copyJSON(this.size)
  let heightOffset = 0
try {
  this.tool = []
  // MNUtil.copyJSON(this.func)
  if (this.func && this.func.length) {
    //把得到的func执行一遍并将响应添加到this.tool中
    this.funcResponses = this.func.map(func=> this.executeFunctionByAI(func))
    this.funcResponse = this.funcResponses.join("")
    this.history.push({role:"assistant",tool_calls:this.func})
    this.tool.map(tool=>{this.history.push(tool)})
    // chatAIUtils.copyJSON(this.history)
    this.preFuncResponse = this.preFuncResponse+this.funcResponse
    // copy(this.preFuncResponse)
    if (this.func.map(func=>func.function.name).includes("close")) {
      // await this.delay(0.5)
      // MNUtil.showHUD("close")
      await this.hide()
      this.onChat = false
      if (this.chatView) {
        this.chatView.hidden = true
      }
      this.notificationView.hidden = false
      this.webviewResponse.frame = MNUtil.genFrame(0, 0, chatAIUtils.getWidth(), 85)
      // this.sizeHeight = parseInt(await this.runJavaScript(`document.body.scrollHeight`))
    }else{
      this.continueAfterToolCall()
    }
  }else{
    this.history.push({role:"assistant",content:this.response})
    this.funcResponse = ""
    this.lastResponse = this.response.trim()
    // MNUtil.copy(this.lastResponse)
    this.response = ""
    if (chatAIConfig.getConfig("speech") && chatAIConfig.getConfig("speechKey") && this.lastResponse) {
      let responseLength = chatAIUtils.strCode(this.lastResponse)
      if (responseLength >= 500) {
        MNUtil.showHUD("Too long content")
      }else{
        MNUtil.showHUD("Generating Voice...")
        if (!this.onChat) {
          await this.speech(this.lastResponse)
          heightOffset = 10
        }else{
          await this.speech(this.lastResponse,"assistant"+this.round)
          heightOffset = this["assistant"+this.round].sizeHeight*0.1
        }
      }
    }
    if (this.actions.length) {
      this.excuteFinishAction(this.actions,this.lastResponse)
    }
    if (chatAIUtils.dynamicController) {
      MNUtil.studyView.bringSubviewToFront(chatAIUtils.dynamicController.view)
    }
  }
  if (this.onChat) {
    // MNUtil.showHUD("Height:"+this["assistant"+this.round].sizeHeight)
    this.setChatLayout(heightOffset)
  }else{
    // this.runJavaScript(`createAudioElement('audioDiv');`)
    this.sizeHeight = await this.getWebviewHeight()+heightOffset
    
    // MNUtil.copy("text"+this.sizeHeight)
    this.setNotiLayout()
  }
  this.called = false
  this.onFinish = false
} catch (error) {
  chatAIUtils.addErrorLog(error, "finish",this.textString)
  // MNUtil.copy(this.textString)
}
}

notificationController.prototype.init = function () {
  // /**
  //  * @type {chatglmController}
  //  */
  // let ctr = this
  // MNUtil.showHUD("message")
  this.reloadImage = MNUtil.getImage(chatAIConfig.mainPath + `/reload.png`)
  this.stopImage = MNUtil.getImage(chatAIConfig.mainPath + `/stop.png`)
  this.bigbangImage = MNUtil.getImage(chatAIConfig.mainPath + `/bigbang.png`)
  this.copyImage = MNUtil.getImage(chatAIConfig.mainPath + `/copy.png`)
  this.titleImage = MNUtil.getImage(chatAIConfig.mainPath + `/title.png`)
  this.tagImage = MNUtil.getImage(chatAIConfig.mainPath + `/tag.png`)
  this.commentImage = MNUtil.getImage(chatAIConfig.mainPath + `/comment.png`)
  this.aiImage = MNUtil.getImage(chatAIConfig.mainPath + `/ai.png`, 3)
  this.aiLinkImage = MNUtil.getImage(chatAIConfig.mainPath + `/aiLink.png`)
  this.chatImage = MNUtil.getImage(chatAIConfig.mainPath + `/chat.png`)
  this.sendImage = MNUtil.getImage(chatAIConfig.mainPath + `/send.png`)
  this.lockImage = MNUtil.getImage(chatAIConfig.mainPath + `/lock.png`)
  this.unlockImage = MNUtil.getImage(chatAIConfig.mainPath + `/unlock.png`)
  this.excerptImage = MNUtil.getImage(chatAIConfig.mainPath + `/excerpt.png`,2.3)
  this.childImage = MNUtil.getImage(chatAIConfig.mainPath + `/childNote.png`)


}
/**
 * @this {notificationController}
 */
notificationController.prototype.setChatLayout = async function (heightOffset = 0) {
  try {
  let viewFrame = this.chatView.frame
  viewFrame.width = chatAIUtils.getWidth()
    // MNUtil.showHUD("message"+viewFrame.height+"fslkdfj"+MNUtil.studyView.bounds.height)
  if (viewFrame.height > MNUtil.studyView.bounds.height) {
    viewFrame.height = MNUtil.studyView.bounds.height
  }
  this.chatToolbar.frame = MNUtil.genFrame(0, viewFrame.height-30, viewFrame.width, viewFrame.height)
  this.userInput.frame = MNUtil.genFrame(0,viewFrame.height-85, viewFrame.width-50, 50)
  this.sendButton.frame = MNUtil.genFrame(viewFrame.width-45,viewFrame.height-85, 45, 50)
  this.scrollView.frame = MNUtil.genFrame(0, 0, viewFrame.width, viewFrame.height-90)
  let sizeHeight = this.sizeHeight
    this.assistant0.frame = MNUtil.genFrame(5,5, viewFrame.width-10, sizeHeight)
    this.heights.assistant0 = this.assistant0.frame
    if (this.copyButton0) {
      this.copyButton0.frame = MNUtil.genFrame(10,sizeHeight-30, 30, 30)
      this.titleButton0.frame = MNUtil.genFrame(45,sizeHeight-30, 30, 30)
      this.commentButton0.frame = MNUtil.genFrame(80,sizeHeight-30, 30, 30)
      this.excerptButton0.frame = MNUtil.genFrame(115,sizeHeight-30, 30, 30)
      this.childButton0.frame = MNUtil.genFrame(150,sizeHeight-30, 30, 30)
    }
  //   this.assistant0.sizeHeight = sizeHeight
  //   MNUtil.showHUD("frameHeight:"+sizeHeight+";sizeHeight:"+testHeight)
  // }

  // let sizeHeight = await this.getWebviewHeight("assistant0")
  this.notifyLoc = chatAIUtils.isIOS()?0:chatAIConfig.config.notifyLoc

  switch (this.notifyLoc) {
    case 0:
      this.aiButton.frame = MNUtil.genFrame(-45,0,40,40)
      this.closeChatButton.frame = MNUtil.genFrame(viewFrame.width-30, 0, 30, 30)
      this.reAskButton.frame = MNUtil.genFrame(viewFrame.width-65, 0, 30, 30)
      this.chatLocation.frame = MNUtil.genFrame(0,0,55,30)
      this.chatToken.frame = MNUtil.genFrame(60, 0, 100, 30)
      this.chatModel.frame = MNUtil.genFrame(viewFrame.width-100, 0, 30, 30)
      break;
    case 1:
      this.aiButton.frame = MNUtil.genFrame(viewFrame.width+5,0,40,40)
      this.chatLocation.frame = MNUtil.genFrame(viewFrame.width-55,0,55,30)
      this.reAskButton.frame = MNUtil.genFrame(35, 0, 30, 30)
      this.closeChatButton.frame = MNUtil.genFrame(0, 0, 30, 30)
      this.chatToken.frame = MNUtil.genFrame(viewFrame.width-160, 0, 100, 30)
      this.chatModel.frame = MNUtil.genFrame(70, 0, 30, 30)
      break;
    default:
      break;
  }
  let initY = sizeHeight+20
  for (let i = 0; i < this.round; i++) {
    this["assistant"+i].frame = this.heights["assistant"+i]
  }
  if (this["user"+this.round]) {
    let userSize = this["user"+this.round].sizeThatFits({width:viewFrame.width-10,height:1000})
    // MNUtil.showHUD("Usersize:"+JSON.stringify(userSize))
    let assitSize = this["assistant"+this.round].frame.height
    let testHeight = this["assistant"+this.round].sizeHeight
    if (this["assistant"+this.round].first) {
      assitSize = 50
      this["assistant"+this.round].first = false
    }else{
      if (assitSize !== testHeight) {
        assitSize = await this.getWebviewHeight("assistant"+this.round)
        if (assitSize > testHeight) {
          assitSize = testHeight
        }
        assitSize = assitSize+heightOffset
        this["assistant"+this.round].sizeHeight = assitSize
        // MNUtil.showHUD("frameHeight:"+assitSize+";sizeHeight:"+testHeight)
      }
    }
    // MNUtil.showHUD("message"+assitSize)
    // let assitSize = this["assistant"+this.round].sizeThatFits({width:viewFrame.width-10,height:1000})
    // if (this.preRound == this.round && assitSize == this.preHeight) {
    //   // this.show("return")
    //   return
    // }
    let preFrame = this.heights["assistant"+(this.round-1)]
    // let preFrame = this["assistant"+(this.round-1)].frame
    initY = preFrame.y+preFrame.height+5
    if (userSize.width > 350) {
      this["user"+this.round].frame = MNUtil.genFrame(5,initY, viewFrame.width-10, userSize.height)
    }else{
      this["user"+this.round].frame = MNUtil.genFrame(viewFrame.width-userSize.width-10,initY, userSize.width+5, userSize.height)
    }
    initY = initY+userSize.height+5
    this.heights["assistant"+this.round] = MNUtil.genFrame(5,initY, viewFrame.width-10, assitSize+40)
    // this["assistant"+this.round].frame = MNUtil.genFrame(5,initY, viewFrame.width-10, assitSize)
    this["assistant"+this.round].frame = this.heights["assistant"+this.round]
    this['copyButton'+this.round].frame = MNUtil.genFrame(10,initY+assitSize+5, 30, 30)
    this['titleButton'+this.round].frame = MNUtil.genFrame(45,initY+assitSize+5, 30, 30)
    this['commentButton'+this.round].frame = MNUtil.genFrame(80,initY+assitSize+5, 30, 30)
    this['excerptButton'+this.round].frame = MNUtil.genFrame(115,initY+assitSize+5, 30, 30)
    this['childButton'+this.round].frame = MNUtil.genFrame(150,initY+assitSize+5, 30, 30)
    // if (this["assistant"+this.round].frame.y < 100) {
    //   MNUtil.showHUD("message")
    // }
    // MNUtil.copyJSON(this["assistant"+this.round].frame)
    initY = initY+assitSize+5
    this.preHeight = assitSize
  }
  this.preRound = this.round
  this.scrollView.contentSize = {width:chatAIUtils.getWidth(),height:initY+40}
  // this.assistant0.frame = MNUtil.genFrame(5,5, viewFrame.width-10, sizeHeight)
  // MNUtil.showHUD("inity:"+initY)
  if (initY > viewFrame.height-130) {
    this.scrollView.setContentOffsetAnimated({x:0,y:initY-viewFrame.height+130},true)
  }
  } catch (error) {
    chatAIUtils.addErrorLog(error, "setChatLayout")
  }
}

/**
 * @this {notificationController}
 */
notificationController.prototype.setNotiLayout = async function () {
  let sizeHeight = this.sizeHeight
  // MNUtil.showHUD("message"+sizeHeight)
  if (!sizeHeight) {
    // MNUtil.showHUD("Invalid height")
    return
  }
  sizeHeight = Math.max(sizeHeight,this.webviewResponse.frame.height)
      // let size = this.webviewResponse.contentSize
      // MNUtil.copyJSON(size)
  let currentFrame = this.view.frame
  let studyHeight = MNUtil.studyView.frame.height
  if (sizeHeight+35<120) {
    currentFrame.height = 120
      // MNUtil.showHUD('message3:'+sizeHeight)
    // this.size.push({message:'message3',current:currentFrame.height,size:sizeHeight,study:studyHeight})
  }else{
    // if (sizeHeight+35 > currentFrame.height && sizeHeight-currentFrame.height < 100) {
    //   // MNUtil.showHUD("message")
    //   currentFrame.height = sizeHeight+35
    // }else{
    //   // MNUtil.showHUD("diff:"+sizeHeight+":"+currentFrame.height)
    // }
    //超出页面大小，需滚动
    if ((currentFrame.y+sizeHeight+30)>studyHeight) {
      // MNUtil.showHUD('需要滚动')
    // this.size.push({message:'message2',current:currentFrame.height,size:sizeHeight,study:studyHeight})
      this.scrollToBottom = true
      currentFrame.height = studyHeight-currentFrame.y-5
      this.autoHide = false
      this.webviewResponse.frame = MNUtil.genFrame(0, 0, chatAIUtils.getWidth(), currentFrame.height-35)
      // if (this.onreceive) {
      //   MNUtil.copy("receive")
      // }else{
      //   await MNUtil.delay(1)
      //   this.runJavaScript(`document.getElementsByClassName("vditor-reset")[0].scrollTo(0,document.getElementsByClassName("vditor-reset")[0].scrollHeight); `)
      // }
      // this.webviewResponse.contentSize = {width:400,height:sizeHeight+35}
      // this.webviewResponse.frame = genFrame(0, 0, 400, sizeHeight+30)
      // this.notiScroll.contentSize = {width:400,height:sizeHeight}
      // this.notiScroll.setContentOffsetAnimated({x:0,y:sizeHeight-this.notiScroll.frame.height+30},true)
    }else{
      if (sizeHeight+35 > currentFrame.height) {
        currentFrame.height = sizeHeight+35
      }
      // MNUtil.showHUD('message1')
      // this.size.push({message:'message1',current:currentFrame.height,size:sizeHeight,study:studyHeight})
      this.webviewResponse.frame = MNUtil.genFrame(0, 0, chatAIUtils.getWidth(), sizeHeight)
    }
  }
  this.view.frame = currentFrame
  this.currentFrame = currentFrame
}
notificationController.prototype.createButton = function (buttonName,targetAction,superview) {
    this[buttonName] = UIButton.buttonWithType(0);
    this[buttonName].autoresizingMask = (1 << 0 | 1 << 3);
    this[buttonName].setTitleColorForState(UIColor.whiteColor(),0);
    this[buttonName].setTitleColorForState(chatAIConfig.highlightColor, 1);
    this[buttonName].backgroundColor = MNUtil.hexColorAlpha("#9bb2d6",0.8)
    this[buttonName].layer.cornerRadius = 8;
    this[buttonName].layer.masksToBounds = true;
    this[buttonName].titleLabel.font = UIFont.systemFontOfSize(16);

    if (targetAction) {
      this[buttonName].addTargetActionForControlEvents(this, targetAction, 1 << 6);
    }
    if (superview) {
      this[superview].addSubview(this[buttonName])
    }else{
      this.view.addSubview(this[buttonName]);
    }
}
/**
 * @this {notificationController}
 */
notificationController.prototype.creatTextView = function (viewName,superview="view",color="#ffffff",alpha=0.8) {
  this[viewName] = UITextView.new()
  this[viewName].font = UIFont.systemFontOfSize(17);
  this[viewName].layer.cornerRadius = 8
  this[viewName].backgroundColor = MNUtil.hexColorAlpha(color,alpha)
  this[viewName].textColor = UIColor.blackColor()
  this[viewName].delegate = this
  this[viewName].editable = true
  this[viewName].scrollEnabled = false
  this[viewName].bounces = false
  this[viewName].layer.borderWidth = 4

  this[superview].addSubview(this[viewName])
}

notificationController.prototype.hideAllButton = function (frame) {
  this.toolbar.hidden = true
}
notificationController.prototype.showAllButton = function (frame) {
  this.toolbar.hidden = false
}
notificationController.prototype.show = function (notifyLoc,fromOutside = true) {
try {
  let studyFrame = MNUtil.studyView.frame
  this.onAnimate = true
  let height = this.onChat?studyFrame.height-chatAIUtils.getY():this.view.frame.height
  // if (fromOutside) {
  //   height = 120
  // }
  this.notifyLoc = chatAIUtils.isIOS()?0:notifyLoc
  switch (this.notifyLoc) {
    case 0:
      this.currentFrame.x = chatAIUtils.getX()
      if (fromOutside) {
        this.view.frame = {x:-300,y:chatAIUtils.getY(),width:chatAIUtils.getWidth(),height:120}
      }
      break;
    case 1:
      this.currentFrame.x = studyFrame.width-450
      // MNUtil.showHUD("message"+this.currentFrame.x)
      if (fromOutside) {
        this.view.frame = {x:studyFrame.width,y:chatAIUtils.getY(),width:chatAIUtils.getWidth(),height:120}
      }
      break;
    default:
      break;
  }
  this.currentFrame.y = chatAIUtils.getY()
  let preFrame = this.currentFrame
  preFrame.width = chatAIUtils.getWidth()
  preFrame.height = height
  let preOpacity = this.view.layer.opacity
  this.view.layer.opacity = 0.2
  // if (frame) {
  //   this.view.frame = frame
  //   this.currentFrame = frame
  // }
  this.view.hidden = false
  this.setLayout()
  this.hideAllButton()
  MNUtil.animate(()=>{
    this.view.layer.opacity = preOpacity
    this.view.frame = preFrame
    // this.currentFrame = preFrame
  }).then(()=>{
    this.setLayout()
    this.view.layer.borderWidth = 0
    if (this.onChat) {
      this.setChatLayout()
    }else{
      this.showAllButton()
    }
    this.onAnimate = false
  })
} catch (error) {
  chatAIUtils.addErrorLog(error, "show")
}
}
/**
 * @this {notificationController}
 */
notificationController.prototype.hide = async function () {
  let studyFrame = MNUtil.studyView.bounds
  this.onAnimate = true
  this.onChat = false
  if (this.connection) {
    this.connection.cancel()
    delete this.connection
  }
  switch (this.notifyLoc) {
    case 0:
      this.currentFrame = {x:-300,y:chatAIUtils.getY(),width:chatAIUtils.getWidth(),height:120}
      break;
    case 1:
      this.currentFrame = {x:studyFrame.width,y:chatAIUtils.getY(),width:chatAIUtils.getWidth(),height:120}
      break;
    default:
      break;
  }
  let preFrame = this.currentFrame
  let preOpacity = this.view.layer.opacity
  let preCustom = this.custom
  
  this.hideAllButton()
  this.custom = false
  await MNUtil.animate(()=>{
    this.view.layer.opacity = 0.2
    this.view.frame = preFrame
    }
  )
  this.view.hidden = true;
  this.view.layer.opacity = preOpacity      
  this.view.frame = preFrame
  this.onAnimate = false
  // this.currentFrame = preFrame
  this.custom = preCustom
  this.response = ''
  // this.setResponseText('')
  this.setNewResponse()
  return
}

/**
 * @this {notificationController}
 */
notificationController.prototype.setLayout = function () {
try {

  var viewFrame = this.toolbar.bounds;
  var width    = viewFrame.width
  var height   = viewFrame.height
  viewFrame.height = viewFrame.height-30
  this.toolbar.frame = MNUtil.genFrame(0, this.view.frame.height-30, chatAIUtils.getWidth(),30)
  let notifyLoc = chatAIUtils.isIOS()?0:chatAIConfig.config.notifyLoc
  switch (notifyLoc) {
    case 0:
      this.aiButton.frame = MNUtil.genFrame(-45,0,40,40)
      this.screenButton.frame = MNUtil.genFrame(width-30,0,30,30)
      this.bigbangButton.frame = MNUtil.genFrame(width-65,0,30,30)
      this.commentButton.frame = MNUtil.genFrame(width-100,0,30,30)
      this.titleButton.frame = MNUtil.genFrame(width-135,0,30,30)
      this.copyButton.frame = MNUtil.genFrame(width-170,0,30,30)
      this.excerptButton.frame = MNUtil.genFrame(width-205,0,30,30)
      this.childButton.frame = MNUtil.genFrame(width-240,0,30,30) 
      this.reloadButton.frame = MNUtil.genFrame(width-275,0,30,30)
      this.chatButton.frame = MNUtil.genFrame(width-310,0,30,30) 
      this.promptButton.frame = MNUtil.genFrame(0,0,width-315,30)
      break;
    case 1:
      this.aiButton.frame = MNUtil.genFrame(width+5,0,40,40)
      this.screenButton.frame = MNUtil.genFrame(0,0,30,30)
      this.bigbangButton.frame = MNUtil.genFrame(35,0,30,30)
      this.commentButton.frame = MNUtil.genFrame(70,0,30,30)
      this.titleButton.frame = MNUtil.genFrame(105,0,30,30)
      this.copyButton.frame = MNUtil.genFrame(140,0,30,30)
      this.excerptButton.frame = MNUtil.genFrame(175,0,30,30)
      this.reloadButton.frame = MNUtil.genFrame(245,0,30,30)
      this.chatButton.frame = MNUtil.genFrame(viewFrame.width-120,0,30,30) 
      this.childButton.frame = MNUtil.genFrame(210,0,30,30) 
      this.promptButton.frame = MNUtil.genFrame(viewFrame.width-85,0,90,30)
      break;
    default:
      break;
  }
} catch (error) {
  chatAIUtils.addErrorLog(error, "setLayout")
}
}

/** @this {notificationController} */
notificationController.prototype.beginNotification = async function (promptName) {
    chatAIUtils.ensureView(this.view)
    // if (chatAIUtils.forceToRefresh) {
      
    //   chatAIUtils.forceToRefresh = false
    // }
    await MNUtil.delay(0.01)
    this.checkTheme()
    this.setNewResponse()
    MNUtil.delay(0.1).then(()=>{
      this.changeTheme(this.theme)
    })
    await MNUtil.delay(0.01)
    // this.notificationView.hidden = true
    this.webviewResponse.hidden = false
    let currentFrame = this.view.frame
    if (!this.onChat) {
      currentFrame.height = 120
    }
    this.view.frame = currentFrame
    this.currentFrame = currentFrame
    // this.locationButton.setTitleForState(chatAIConfig.config.notifyLoc?' R ':' L ',0)
    try {
    if (promptName) {
      this.promptButton.setTitleForState(promptName ,0)
    }else{
      this.promptButton.setTitleForState(this.currentTitle ,0)
    }
    } catch (error) {
      chatAIUtils.addErrorLog(error, "beginNotification")
    }
    if (this.view.hidden || (!chatAIUtils.isIOS() && this.notifyLoc !== chatAIConfig.config.notifyLoc)) {
      this.show(chatAIConfig.config.notifyLoc)
    }

    MNUtil.studyView.bringSubviewToFront(this.view)
    if (this.notifyTimer) {
      this.notifyTimer.invalidate()
    }
  }

/** @this {notificationController} */
notificationController.prototype.getTextForAction = async function (round) {
  if (this.onChat) {
    return await this.getWebviewContent("assistant"+round)
    // MNUtil.showHUD("round:"+round)
    // let history = this.history.filter(his=>(his.role === "assistant" && !his.tool_calls))
    // return history[round].content
    // return this.reponse
    // return "abc"
  }else{
    return await this.getWebviewContent()
    // let selectedText = await this.runJavaScript("getSelectedTextOrPageText()")
    // if (selectedText.trim() !== "") {
    //   return selectedText.trim()
    // }
    // return this.lastResponse.trim()
  }
}

notificationController.prototype.initRequestForChatGPT = function (apikey,url,model,temperature,funcIndices=[]) {
  if (apikey.trim() === "") {
    MNUtil.showHUD(model+": No apikey!")
    return
  }
  const headers = {
    "Content-Type": "application/json",
    Authorization: "Bearer "+apikey,
    Accept: "text/event-stream"
  }
    // copyJSON(headers)
  let body = {
    "model":model,
    "messages":this.history,
    "temperature":temperature,
    "stream":true
  }
  if (url === "https://api.minimax.chat/v1/text/chatcompletion_v2") {
    if (funcIndices.length) {
      let noteid = this.noteid ?? chatAIUtils.currentNoteId ?? (chatAIUtils.getFocusNote() ? chatAIUtils.getFocusNote().noteId : undefined)
      let tools = chatAIUtils.getFuncByIndexForMinimax(funcIndices,noteid)
      if (tools.length) {
        body.tools = tools
      }
    }
    body.max_tokens = 8000
  }else{
    if (funcIndices.length) {
      let noteid = this.noteid ?? chatAIUtils.currentNoteId ?? (chatAIUtils.getFocusNote() ? chatAIUtils.getFocusNote().noteId : undefined)
      let tools = chatAIUtils.getFuncByIndex(funcIndices,noteid)
      if (tools.length) {
        body.tools = tools
      }
    }
  }
  // chatAIUtils.copyJSON(body)
  // copyJSON(body)

  // MNUtil.copyJSON(body)
  const request = chatAINetwork.initRequest(url, {
      method: "POST",
      headers: headers,
      timeout: 60,
      json: body
    })
  this.currentTime = Date.now()
  this.connection = NSURLConnection.connectionWithRequestDelegate(request,this)
  // MNUtil.showHUD("new connection")
}
notificationController.prototype.initRequestForClaude = function (apikey,url,model,temperature,funcIndices=[]) {
  // if (apikey.trim() === "") {
  //   MNUtil.showHUD("No apikey!")
  //   return
  // }
  try {
    

  const headers = {
    "Content-Type": "application/json",
    "x-api-key":apikey,
    "anthropic-version":"2023-06-01"
  }
  let body = {
    "model":model,
    "max_tokens": 1024,
    "stream":true
  }
  let system = this.history.filter(item => item.role === "system")[0]
  // copyJSON(system)
  if (system) {
    body.system = system.content
    body.messages = this.history.filter(item => item.role !== "system")
  }else{
    body.messages = this.history
  }

  // copyJSON(body)
  const request = chatAINetwork.initRequest(url, {
      method: "POST",
      headers: headers,
      timeout: 60,
      json: body
    })
  this.currentTime = Date.now()
  this.connection = NSURLConnection.connectionWithRequestDelegate(request,this)
    } catch (error) {
      chatAIUtils.addErrorLog(error, "initRequestForClaude")

  }
}
notificationController.prototype.initRequestForGemini = function (apikey,url,model,temperature,funcIndices=[]) {
  // if (apikey.trim() === "") {
  //   MNUtil.showHUD("No apikey!")
  //   return
  // }
  // let fullURL
  // if (model === "gemini-1.5") {
    
  // }
  let fullURL = url+"/v1beta/models/"+model+":streamGenerateContent?key="+apikey
  try {
    

  const headers = {
    "Content-Type": "application/json"
  }
  let body = {
  }
  // let system = this.history.filter(item => item.role === "system")[0]
  // copyJSON(system)
  // if (system) {
  //   body.system = system.content
  //   body.messages = this.history.filter(item => item.role !== "system")
  // }else{
  // let historyWithoutSystem = this.history.filter(item => item.role !== "system")
    // body.contents = this.history
  let system = ""
  let history = []
  this.history.map(his=>{
    if (his.role === "system") {
      system = his.content
      if (model === "gemini-1.5-pro-latest") {
        body.system_instruction = {parts:{text:system}}
        system = ""
      }
      // history.push({role:"system",parts:[{text:his.content}]})
      return
    }
    if (his.role === "user") {
      if (system) {
        history.push({role:"user",parts:[{text:system+"\n"+his.content}]})
        system = ""
      }else{
        history.push({role:"user",parts:[{text:his.content}]})
      }
      return
    }
    if (his.role === "assistant") {
      history.push({role:"model",parts:[{text:his.content}]})
      return
    }
  })
  body.contents = history

  // MNUtil.copyJSON(body)
  const request = chatAINetwork.initRequest(fullURL, {
      method: "POST",
      headers: headers,
      timeout: 60,
      json: body
    })
  this.currentTime = Date.now()
  this.connection = NSURLConnection.connectionWithRequestDelegate(request,this)
    } catch (error) {
      chatAIUtils.addErrorLog(error, "initRequestForGemini")
  }
}

/** 
 * @this {notificationController}
 */
notificationController.prototype.initRequestForChatGLM = function (apikey,model,temperature,funcIndices=[]) {
  if (apikey.trim() === "") {
    MNUtil.showHUD(model+": No apikey!")
    return
  }
  // copy(apikey)
  let final_sign = chatAINetwork.getAuthorization(apikey)    
  const headers = {
    "Content-Type": "application/json",
    Authorization: final_sign
  }
  let body = {
    "model":model,
    "messages":this.history,
    "temperature":temperature,
    "stream":true
  }
  body.tools = [{
    type:"web_search",
    web_search:{enable:false}
  }]
  if (funcIndices.length) {
    let tools = chatAIUtils.getFuncByIndex(funcIndices,this.noteid !== undefined)
    body.tools = body.tools.concat(tools)
  }
  // }else{
  // }

  // MNUtil.copyJSON(body)
  const request = chatAINetwork.initRequest("https://open.bigmodel.cn/api/paas/v4/chat/completions", {
      method: "POST",
      headers: headers,
      timeout: 60,
      json: body
    })
  this.currentTime = Date.now()
  this.connection = NSURLConnection.connectionWithRequestDelegate(request,this)
}

/** 
 * @param {string} response 
 * @this {notificationController}
 */
notificationController.prototype.getResponseForChatGPT = function () {
  try {

    this.resList = chatAIUtils.getResList(this.originalText)
    if (!this.resList.length) {
      return
    }
    // this.resList = resList
    if (chatAIUtils.checkToolCalls(this.resList)) {

      let funcs = []
      this.resList.map(res=>{
        if (res.tool_calls) {
          if (res.tool_calls[0].function.name) {
            funcs.push(res.tool_calls[0])
            // funcs[res.tool_calls[0].index].function.arguments = ""
            // func = res.tool_calls[0]
          }else{
            let index = res.tool_calls[0].index ?? 0
            funcs[index].function.arguments = funcs[index].function.arguments+res.tool_calls[0].function.arguments
          }
          // return delta.tool_calls[0].function.arguments
        }else{
          return ""
        }
      }).join("")
      // MNUtil.copyJSON(funcs)
      this.func = []
      this.funcResponses = funcs.map(func=>{
        // MNUtil.copyJSON(JSON.parse("{\"title\": \"排放变化特征分析\"}{\"title\": \"排放变化特征分析\"}"))
        let arguments = MNUtil.getValidJSON(func.function.arguments.trim())
        func.function.arguments = JSON.stringify(arguments)
        if (arguments) {
          this.func.push(func)
          return this.codifyToolCall(func.function.name, arguments)
        }else{
          func.function.arguments = ""
          this.func.push(func)
          return func.function.name+"()\n"
        }
      })
      // MNUtil.copyJSON(this.funcResponses)
      this.funcResponse = this.funcResponses.join("")
      
    }else{
      this.response = this.resList.map(res=>{
        if (res && res.content) {
          return res.content
        }
        return ""
      }).join("")
    }
    return
  } catch (error) {
    chatAIUtils.addErrorLog(error, "getResponseForChatGPT")
    return
  }
}

/** 
 * @param {string} response 
 * @this {notificationController}
 */
notificationController.prototype.getResponseForGemini = function (response) {
  try {
    // let res = this.originalText.split("data:")
    // res.shift()
    // res.pop()
    if (!MNUtil.isValidJSON(this.originalText) && !MNUtil.isValidJSON(this.originalText+"]")) {
      return
    }
    try {
      this.resList = JSON.parse(this.originalText).map(res=>{
        return res.candidates[0].content.parts[0].text
      })
    } catch (error) {
      this.resList = JSON.parse(this.originalText+"]").map(res=>{
        return res.candidates[0].content.parts[0].text
      })
    }
    this.response = this.resList.join("")
    return
  } catch (error) {
    chatAIUtils.addErrorLog(error, "getResponseForGemini",this.originalText)
    return
  }
}

/** 
 * @param {string} response 
 * @this {notificationController}
 */
notificationController.prototype.getResponseForClaude = function (response) {
  try {
    // let res = this.originalText.split("data:")
    // res.shift()
    // res.pop()

    this.resList = chatAIUtils.parseEvents(this.originalText)
    let response = ""

    this.resList.map(res=>{
      if (res.event === "content_block_start") {
        response = res.data.content_block.text
      }
      if (res.event === "content_block_delta") {
        response = response+res.data.delta.text
      }
    })
    // copy(response)
    this.response = response
    return
  } catch (error) {
    chatAIUtils.addErrorLog(error, "getResponseForClaude",this.originalText)
    return
  }
}
/** 
 * @this {notificationController}
 * 用来格式化调用的函数内容的
 */
notificationController.prototype.codifyToolCall = function (funcName,arguments) {
  switch (funcName) {
    case "multi_tool_use.parallel":
      let preFix = `multi_tool_use(\n`
      let tool_uses = arguments.tool_uses
      let toolMessages = []
      tool_uses.map((tool_use,index)=>{
        switch (tool_use.recipient_name) {
          case "functions.setTitle":
            toolMessages.push("\t"+this.codifyToolCall("setTitle", {title:tool_use.parameters.title.trim()}))
            break;
          case "functions.addComment":
            toolMessages.push("\t"+this.codifyToolCall("addComment", {comment:tool_use.parameters.comment.trim()}))
            break;
          case "functions.addTag":
            toolMessages.push("\t"+this.codifyToolCall("addTag", {tag:tool_use.parameters.tag.trim()}))
            break;
          case "functions.copyMarkdownLink":
            toolMessages.push("\t"+this.codifyToolCall("copyMarkdownLink", {title:tool_use.parameters.title.trim()}))
            break;
          case "functions.copyCardURL":
            toolMessages.push("\t"+this.codifyToolCall("copyCardURL", {}))
            break;
          case "functions.copyText":
            toolMessages.push("\t"+this.codifyToolCall("copyText", {text:tool_use.parameters.text.trim()}))
            break;
          case "functions.addChildNote":
            toolMessages.push("\t"+this.codifyToolCall("addChildNote", {title:tool_use.parameters.title.trim(),content:tool_use.parameters.content.trim()}))
            break;
          case "functions.clearExcerpt":
            toolMessages.push("\t"+this.codifyToolCall("clearExcerpt", {}))
            break;
          case "functions.close":
            toolMessages.push("\t"+this.codifyToolCall("close", {}))
            break;
          case "functions.setExcerpt":
            toolMessages.push("\t"+this.codifyToolCall("setExcerpt", {excerpt:tool_use.parameters.excerpt.trim()}))
            break
          default:
            break;
        }
      })
      return preFix+toolMessages.join("")+")\n"
    case "setTitle":
      if (arguments.title) {
        return `${funcName}("${MNUtil.mergeWhitespace(arguments.title)}")\n`
      }
    case "addComment":
      if (arguments.comment) {
        return `${funcName}("${arguments.comment.trim()}")\n`
      }
    case "addTag":
      if (arguments.tag) {
        return `${funcName}("${MNUtil.mergeWhitespace(arguments.tag)}")\n`
      }
    case "copyMarkdownLink":
      if (arguments.title) {
        return `${funcName}("${MNUtil.mergeWhitespace(arguments.title)}")\n`
      }
    case "copyCardURL":
      return `${funcName}()\n`
    case "copyText":
      if (arguments.text) {
        return `${funcName}("${MNUtil.mergeWhitespace(arguments.text)}")\n`
      }
    case "close":
      return `${funcName}()\n`
    case "clearExcerpt":
      return `${funcName}()\n`
    case "setExcerpt":
      if (arguments.excerpt) {
        return `${funcName}("${arguments.excerpt.trim()}")\n`
      }
    case "addChildNote":
      let pre = `${funcName}(\n`
      if (arguments.title) {
        pre = pre+`"${MNUtil.mergeWhitespace(arguments.title)}"`
        if (arguments.content) {
          pre = pre+",\n"
        }
      }
      if (arguments.content) {
        pre = pre+`"${arguments.content.trim()}"`
      }
      pre = pre+`\n)\n`
      return pre
      return `${funcName}(\n"${MNUtil.mergeWhitespace(arguments.title)}",\n"${MNUtil.mergeWhitespace(arguments.content)}\n")\n`
    default:
      break;
  }
  // copyJSON(arguments)
  return "Error"
}
/** 
 * @this {notificationController}
 * 支持从通知窗口打开（hasContext为true）和直接打开（hasContext为false）
 */
notificationController.prototype.openChatView = async function (hasContext=true) {
    if (this.connection) {
      MNUtil.showHUD("Wait...")
      return
    }
    if (!hasContext) {
      this.token = [0]
      this.history = []
      this.preFuncResponse = ""
      this.config = chatAIConfig.getConfigFromSource()
      this.currentModel = "Default"
    }
    try {
    this.round = 0
    this.heights = {}
    if (this.notifyTimer) {
      this.notifyTimer.invalidate()
    }
    this.notificationView.hidden = true
    this.webviewResponse.hidden = true

    this.onChat = true
    // this.openChatView()
    // if (!this.chatView) {
      this.chatView = new UIView(this.view.bounds)
      this.chatView.layer.cornerRadius = 8
    // }
    this.chatView.hidden = false
    if (this.theme === "dark") {
      this.chatView.backgroundColor = MNUtil.hexColorAlpha("#9f9f9f",0.0)
    }else{
      this.chatView.backgroundColor = MNUtil.hexColorAlpha("#ffffff",0.0)
    }
    // this.chatView.backgroundColor = MNUtil.hexColorAlpha("#ffffff",0.0)
    this.view.addSubview(this.chatView)
    this.chatToolbar = UIView.new()
    this.chatToolbar.layer.cornerRadius = 8
    this.chatToolbar.backgroundColor = MNUtil.hexColorAlpha("#ffffff",0.0)
    this.chatView.addSubview(this.chatToolbar)
    this.createButton("closeChatButton","closeButtonTapped:","chatToolbar")
    this.closeChatButton.setImageForState(this.stopImage,0)
    this.closeChatButton.backgroundColor = MNUtil.hexColorAlpha("#e06c75",0.8)
    this.resizeGesture0 = new UIPanGestureRecognizer(this,"onResizeGesture:")
    this.closeChatButton.addGestureRecognizer(this.resizeGesture0)
    this.resizeGesture0.view.hidden = false
    this.resizeGesture0.addTargetAction(this,"onResizeGesture:")

    this.createButton("sendButton","sendButtonTapped:","chatView")
    this.sendButton.setImageForState(this.sendImage,0)
    this.sendButton.backgroundColor = MNUtil.hexColorAlpha("#e06c75",0.8)
    this.creatTextView("userInput","chatView")
    this.userInput.editable = true
    this.userInput.layer.borderColor = MNUtil.hexColorAlpha("#9bb2d6",0.8)
    this.userInput.backgroundColor = MNUtil.hexColorAlpha("#e4eeff",0.8)
    this.userInput.scrollEnabled = true
    this.userInput.bounces = true
    this.createButton("chatLocation","toggleLocation:","chatToolbar")
    this.chatLocation.setTitleForState(chatAIConfig.config.notifyLoc?'Right':'Left',0)
    this.chatLocation.titleLabel.font = UIFont.boldSystemFontOfSize(16);
    this.createButton("chatToken","doNothing:","chatToolbar")
    this.createButton("reAskButton","reAsk:","chatToolbar")
    this.createButton("chatModel","changeChatModel:","chatToolbar")

    this.reAskButton.setImageForState(this.reloadImage,0)
    this.chatToken.hidden = false

    this.chatToken.setTitleForState(this.token[0]+"("+chatAIUtils.sum(this.token)+")",0)
    this.chatToken.titleLabel.font = UIFont.boldSystemFontOfSize(16);
    this.chatToken.titleLabel.font = UIFont.boldSystemFontOfSize(16);
    this.chatModel.hidden = false
    this.chatModel.setTitleForState("🤖",0)
    this.chatModel.titleLabel.font = UIFont.boldSystemFontOfSize(16);
    this.scrollView = UIScrollView.new()
    this.scrollView.layer.cornerRadius = 8
    if (this.theme === "dark") {
      this.scrollView.backgroundColor = MNUtil.hexColorAlpha("#333b41",0.8)
    }else{
      this.scrollView.backgroundColor = MNUtil.hexColorAlpha("#ffffff",0.8)
    }
    this.chatView.addSubview(this.scrollView)

    if (hasContext) {
      this.creatButtonsForRound(0)
    }else{
      this.assistant0 = this.createWebviewHtmlDev("scrollView")
      this.assistant0.scrollView.bounces = false
      this.assistant0.layer.opacity = 0
      MNUtil.delay(0.2).then(()=>{ 
        this.changeTheme(this.theme, "assistant0")
        MNUtil.animate(()=>{
          this["assistant0"].layer.opacity = 0.9
        })
      })
    }
    var viewFrame = this.view.frame;
    var height   = viewFrame.height
    let studyFrame = MNUtil.studyView.frame
    viewFrame.height = studyFrame.height-chatAIUtils.getY()
    this.view.frame = viewFrame
    this.currentFrame = viewFrame
    this.chatView.frame = MNUtil.genFrame(0, 0, viewFrame.width, viewFrame.height)
    // await MNUtil.delay(0.1)
    if (hasContext) {
      this.sizeHeight = this.sizeHeight*1.1+20
      MNUtil.delay(0.4).then(async ()=>{
        // this.setWebviewContent(md2html, false, "assistant0")
        let funcHtml = ""
        if (this.preFuncResponse) {
          funcHtml = `<pre><code class="hljs">${this.preFuncResponse.trim()}</code></pre>`
          this.preFuncResponse = ''
        }
        if (this.lastResponse.trim()) {
          let sizeHeight = await this.setWebviewContentDev(this.lastResponse, funcHtml,false, "assistant0")
          if (typeof sizeHeight === "number") {
            this.sizeHeight = sizeHeight
          }else{
            chatAIUtils.addErrorLog(error, "openChatView", {sizeHeight:sizeHeight})
          }
        }
        this.sizeHeight = this.sizeHeight+30
        this.setChatLayout()
      })
    }else{
      MNUtil.delay(0.4).then(async ()=>{
        this.setWebviewContentDev("How can I help you?", "",false, "assistant0")
      })
      this.sizeHeight = 40
    }
    this.setChatLayout()
    if (hasContext) {
      this.setNewResponse()
    }
    } catch (error) {
      chatAIUtils.addErrorLog(error, "openChatView")
    }
}
notificationController.prototype.delay = async function (seconds) {
  return new Promise((resolve, reject) => {
    NSTimer.scheduledTimerWithTimeInterval(seconds, false, function () {
      resolve()
    })
  })
}
notificationController.prototype.createTextviewResponse  = function () {
  this.textviewResponse = UITextView.new()
  this.textviewResponse.font = UIFont.systemFontOfSize(16);
  this.textviewResponse.layer.cornerRadius = 8
  this.textviewResponse.backgroundColor = MNUtil.hexColorAlpha("#ffffff",0.8)
  this.textviewResponse.textColor = UIColor.blackColor()
  this.textviewResponse.delegate = this
  this.textviewResponse.contentSize = {width:chatAIUtils.getWidth(),height:120}
  this.textviewResponse.scrollEnabled = false
  this.textviewResponse.text = `Loading...`
}
notificationController.prototype.createWebviewResponse = function () {
  try {
  this.webviewResponse = new UIWebView(this.view.bounds);
  this.webviewResponse.backgroundColor = UIColor.whiteColor();
  this.webviewResponse.scalesPageToFit = false;
  this.webviewResponse.autoresizingMask = (1 << 1 | 1 << 4);
  this.webviewResponse.delegate = this;
  // this.webviewResponse.setValueForKey("Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/13.1.1 Safari/605.1.15","User-Agent")
  this.webviewResponse.scrollView.delegate = this;
  this.webviewResponse.layer.cornerRadius = 8;
  this.webviewResponse.layer.masksToBounds = true;
  this.webviewResponse.layer.borderColor = MNUtil.hexColorAlpha("#9bb2d6",0.8);
  this.webviewResponse.layer.borderWidth = 0
  this.webviewResponse.layer.opacity = 0.9
  this.webviewResponse.scrollView.bounces = false
  this.webviewResponse.loadFileURLAllowingReadAccessToURL(
    NSURL.fileURLWithPath(chatAIConfig.mainPath + `/veditor_${this.theme}.html`),
    NSURL.fileURLWithPath(chatAIConfig.mainPath + '/')
  );
  this.notificationView.addSubview(this.webviewResponse)
    } catch (error) {
    chatAIUtils.addErrorLog(error, "createWebviewResponse")
  }
}
/** 
 * @this {notificationController}
 */
notificationController.prototype.createWebviewHtmlDev = function (superview) {
  try {
  let webview = new UIWebView(this.view.bounds);
  webview.backgroundColor = UIColor.whiteColor();
  webview.scalesPageToFit = false;
  webview.autoresizingMask = (1 << 1 | 1 << 4);
  webview.delegate = this;
  // webview.setValueForKey("Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/13.1.1 Safari/605.1.15","User-Agent")
  webview.scrollView.delegate = this;
  webview.layer.cornerRadius = 8;
  webview.layer.masksToBounds = true;
  webview.layer.borderColor = MNUtil.hexColorAlpha("#9bb2d6",0.8);
  webview.layer.borderWidth = 0
  webview.layer.opacity = 0.9
  // webview.loadFileURLAllowingReadAccessToURL(
  //   NSURL.fileURLWithPath(this.mainPath + '/test.html'),
  //   NSURL.fileURLWithPath(this.mainPath + '/')
  // );
  // let md2html = marked.parse(content)
  // let md2html = MNUtil.md2html(content)
  webview.loadFileURLAllowingReadAccessToURL(
    NSURL.fileURLWithPath(chatAIConfig.mainPath + `/veditor_${this.theme}.html`),
    NSURL.fileURLWithPath(chatAIConfig.mainPath + '/')
  );
  if (superview) {
    this[superview].addSubview(webview)
  }else{
    this.view.addSubview(webview)
  }
  return webview
    } catch (error) {
      chatAIUtils.addErrorLog(error, "createWebviewHtmlDev")
  }
}
/** @this {notificationController} */
notificationController.prototype.runJavaScript = async function(script,webview) {
  // if(!this.webviewResponse || !this.webviewResponse.window)return;
  return new Promise((resolve, reject) => {
    try {
      
    if (webview) {
      // MNUtil.copy(webview)
      this[webview].evaluateJavaScript(script,(result) => {resolve(result)});
    }else{
      this.webviewResponse.evaluateJavaScript(script,(result) => {resolve(result)});
    }
    } catch (error) {
      chatAIUtils.addErrorLog(error, "runJavaScript")
      resolve(0)
    }
  })
};
/** @this {notificationController} */
notificationController.prototype.getWebviewHeight = async function (webview,offset = 25) {
  let sizeHeight = parseInt(await this.runJavaScript(`document.body.scrollHeight`,webview))

  // let funHeight = "0"
  // if (this.funcResponse.trim()) {
  //   funHeight = await this.runJavaScript(`getTop()`,webview)
  // }
  // let height = "0"
  // if (this.response.trim()) {
  //   height = await this.runJavaScript(`document.getElementsByClassName("vditor-reset")[0].scrollHeight`,webview)
    
  // }
  // MNUtil.showHUD("message:"+height+";func:"+funHeight)
  // MNUtil.copy("message:"+height+";func:"+funHeight)
  // return parseInt(height)+parseInt(funHeight)
  // let sizeHeight = parseInt(await this.runJavaScript(`Math.min(document.body.scrollHeight, document.body.offsetHeight, document.documentElement.clientHeight, document.documentElement.scrollHeight, document.documentElement.offsetHeight)`,webview))+35
  return sizeHeight
}
/** @this {notificationController} */
notificationController.prototype.setWebviewContent = async function (content,scrollToBottom = false,webview) {
  let height
  if (scrollToBottom) {
    // MNUtil.copy(content)
    // height = await this.runJavaScript(`document.body.innerHTML = "${MNUtil.escapeString(content)}"; MathJax.typesetPromise().then(() => {window.scrollTo(0,document.body.scrollHeight)});document.body.scrollHeight;`,webview)
    height = await this.runJavaScript(`document.body.innerHTML = decodeURIComponent(\`${encodeURIComponent(content)}\`); MathJax.typesetPromise().then(() => {window.scrollTo(0,document.body.scrollHeight)});document.body.scrollHeight;`,webview)
    // MNUtil.copyJSON(height)
    if (!Object.keys(height).length) {
      return await this.getWebviewHeight(webview) 
    }
    // MNUtil.copy(height)
  }else{
    // MNUtil.copy(content)
    // height = await this.runJavaScript(`document.body.innerHTML = "${MNUtil.escapeString(content)}"; MathJax.typeset();document.body.scrollHeight;`,webview)
    height = await this.runJavaScript(`document.body.innerHTML = decodeURIComponent(\`${encodeURIComponent(content)}\`); MathJax.typeset();document.body.scrollHeight;`,webview)
    // MNUtil.copyJSON(height)
    if (!Object.keys(height).length) {
      return await this.getWebviewHeight(webview) 
    }
    // MNUtil.copy(height)
  }
  return parseInt(height)+25
}
/** @this {notificationController} */
notificationController.prototype.getWebviewContent = async function (webview){
  let  selection = await this.runJavaScript(`editor.getSelection()`,webview)
  // let selection = await this.runJavaScript(`getCurrentSelect()`,webview)
  await this.runJavaScript(`editor.blur();`,webview)
  if (webview) {
    this[webview].endEditing(true)
  }else{
    this.webviewResponse.endEditing(true)
  }
  if (chatAIUtils.isNSNull(selection) || !selection.trim()) {
    let text = await this.runJavaScript(`editor.getValue();`,webview)
    return text
  }else{
  return selection
  // let converted = selection
  //                 .replace(/\*\*\\\*\\\*\*\*/g, "")
  //                 .replace(/\*\*\\\*\*\*/g, "")
  //                 .replace(/######\s######\s/g, "###### ")
  //                 .replace(/#####\s#####\s/g, "##### ")
  //                 .replace(/####\s####\s/g, "#### ")
  //                 .replace(/###\s###\s/g, "### ")
  //                 .replace(/##\s##\s/g, "## ")
  //                 .replace(/#\s#\s/g, "# ")
  //                 .replace(/\*\*\\\$\*\*`/g, "$")
  //                 .replace(/`\\\$/g, "$")
  //   // let converted = selection.replace("**\\$**`","$").replace("`\\$","$")
  //   // MNUtil.copy(selection+":"+converted)
  //   return converted
  }
  // let text = await this.runJavaScript(`getCurrentSelect() ? getCurrentSelect(): editor.getValue();`,webview)
  // // let text = await this.runJavaScript(`getCurrentSelect()`,webview)
  // return text


}
/** @this {notificationController} */
notificationController.prototype.setWebviewContentDev = async function (content,funcResponse="",scrollToBottom = false,webview) {
  let height = 0
  if (scrollToBottom) {
    height = parseInt(await this.runJavaScript(`setValue(\`${encodeURIComponent(funcResponse)}\`,\`${encodeURIComponent(content)}\`,true)`, webview))
  }else{
    height = parseInt(await this.runJavaScript(`setValue(\`${encodeURIComponent(funcResponse)}\`,\`${encodeURIComponent(content)}\`,false)`, webview))
  }
  return height+10
  // let height = "30"
  // let funHeight = "0"
  // if (scrollToBottom) {
  //   // MNUtil.copy(content)
  //   // height = await this.runJavaScript(`document.body.innerHTML = "${MNUtil.escapeString(content)}"; MathJax.typesetPromise().then(() => {window.scrollTo(0,document.body.scrollHeight)});document.body.scrollHeight;`,webview)
  //   if (content.trim()) {
  //     height = await this.runJavaScript(`editor.setValue(decodeURIComponent(\`${encodeURIComponent(content)}\`),true);document.getElementsByClassName("vditor-reset")[0].scrollTo(0,document.getElementsByClassName("vditor-reset")[0].scrollHeight);document.getElementsByClassName("vditor-reset")[0].scrollHeight`,webview)
  //   }
  //   // height = await this.runJavaScript(`document.getElementById("funcResponse").innerHTML=decodeURIComponent(\`${encodeURIComponent(funcResponse)}\`);editor.setValue(decodeURIComponent(\`${encodeURIComponent(content)}\`),true);document.getElementsByClassName("vditor-reset")[0].scrollTo(0,document.getElementsByClassName("vditor-reset")[0].scrollHeight);getTop()`,webview)
  //   // MNUtil.copyJSON(height)
  //   if (!Object.keys(height).length) {
  //     return await this.getWebviewHeight(webview) 
  //   }
  //   // MNUtil.copy(height)
  // }else{
  //   // MNUtil.copy(content)
  //   // height = await this.runJavaScript(`document.body.innerHTML = "${MNUtil.escapeString(content)}"; MathJax.typeset();document.body.scrollHeight;`,webview)
  //   if (content.trim()) {
  //     height = await this.runJavaScript(`editor.setValue(decodeURIComponent(\`${encodeURIComponent(content)}\`),true); document.getElementsByClassName("vditor-reset")[0].scrollHeight`,webview)
  //   }
  //   // MNUtil.copyJSON(height)
  //   if (!Object.keys(height).length) {
  //     return await this.getWebviewHeight(webview) 
  //   }
  //   // MNUtil.copy(height)
  // }

  // if (funcResponse.trim()) {
  //   funHeight = await this.runJavaScript(`document.getElementById("funcResponse").innerHTML=decodeURIComponent(\`${encodeURIComponent(funcResponse)}\`);getTop()`,webview)
  // }
  // // MNUtil.showHUD("message:"+height+";func:"+funHeight)
  // // MNUtil.copy("message:"+height+";func:"+funHeight)
  // return parseInt(height)+parseInt(funHeight)
}

/** 
  *@this {notificationController} 
  *重新加载一遍veditor
  */
notificationController.prototype.setNewResponse = function (webview) {
  if (webview) {
    this[webview].loadFileURLAllowingReadAccessToURL(
      NSURL.fileURLWithPath(chatAIConfig.mainPath + `/veditor_${this.theme}.html`),
      NSURL.fileURLWithPath(chatAIConfig.mainPath + '/')
    );
  }else{
    if (chatAIUtils.forceToRefresh) {
      if (this.webviewResponse) {
        this.webviewResponse.hidden = true
        this.webviewResponse.removeFromSuperview()
      }
      // delete this.webviewResponse
      this.createWebviewResponse()
      this.setNotiLayout()
      // this.webviewResponse.loadFileURLAllowingReadAccessToURL(
      //   NSURL.fileURLWithPath(chatAIConfig.mainPath + `/veditor_${this.theme}.html`),
      //   NSURL.fileURLWithPath(chatAIConfig.mainPath + '/')
      // );
      chatAIUtils.forceToRefresh = false
    }else{
      // this.notificationView.addSubview(this.webviewResponse)
      this.webviewResponse.loadFileURLAllowingReadAccessToURL(
        NSURL.fileURLWithPath(chatAIConfig.mainPath + `/veditor_${this.theme}.html`),
        NSURL.fileURLWithPath(chatAIConfig.mainPath + '/')
      );
    }
  }
}

/** @this {notificationController} */
notificationController.prototype.setResponseText = async function (funcResponse = "") {
  this.response = this.response.trim()
    .replace(/(\\\[)|(\\\])/g, '$$$') // Replace display math mode delimiters
    .replace(/(\\\(\s?)|(\s?\\\))/g, '$') // Replace inline math mode opening delimiter
  // if (this.onResponse) {
  //   MNUtil.showHUD("On response")
  //   return
  // }
  try {
  // let md2html = MNUtil.md2html(this.response)
  if (!this.onChat) {
    // copy(marked.parse(this.response))
    // this.webviewResponse.loadHTMLStringBaseURL(marked.parse(this.response))
    // copy(marked.parse(response))
    // let md2html = marked.parse(response)
    // let convertText = response
    // .replace(/(\\\[)|(\\\])/g, '$$') // Replace display math mode delimiters
    // .replace(/\\\(\s?/g, '$') // Replace inline math mode opening delimiter
    // .replace(/\\\)/g, '$');

    // MNUtil.copy(md2html)
    // md2html = MathJax.typeset([md2html])
    let funcHtml = ""
    if (funcResponse.trim()) {
      funcHtml = `<pre><code>${funcResponse.trim()}</code></pre>`
    }
    // MNUtil.copy(funcHtml)
    // let htmlText = chatAIUtils.html(md2html,this.scrollToBottom)

    // htmlText = htmlText.replace(/<code>/g, "<pre><code>").replace(/<\/code>/g, "</code></pre>")
    // MNUtil.copy(md2html)
    // this.webviewResponse.loadHTMLStringBaseURL(htmlText)
    // copy(response)
    this.onResponse = true
    // let timeBegin = Date.now()
    // MNUtil.copy(response)
    // this.sizeHeight = await this.setWebviewContent(md2html, this.scrollToBottom)
    this.onreceive = false
    this.sizeHeight = await this.setWebviewContentDev(this.response, funcHtml,this.scrollToBottom)
    // if (this.scrollToBottom) {
    //   await this.runJavaScript(`document.body.innerHTML = "${MNUtil.escapeString(htmlText)}"; MathJax.typesetPromise().then(() => {window.scrollTo(0,document.body.scrollHeight)});`)
    // }else{
    //   await this.runJavaScript(`document.body.innerHTML = "${MNUtil.escapeString(htmlText)}"; MathJax.typeset();`)
    // }
    // copy(res)
    // this.sizeHeight = await this.getWebviewHeight()
    // MNUtil.copy("0:"+height+";1:"+this.sizeHeight)
    // MNUtil.copy("time:"+(Date.now()-timeBegin))
    // MNUtil.showHUD("js"+this.sizeHeight)
    // this.sizeHeight = parseInt(await this.runJavaScript(`document.body.scrollHeight`))+35
    this.onResponse = false
    return
    // let scrollview = this.webviewResponse.scrollView.contentSize
  }else{
      
    // let convertText = response
    // .replace(/(\\\[)|(\\\])/g, '$$') // Replace display math mode delimiters
    // .replace(/\\\(\s?/g, '$') // Replace inline math mode opening delimiter
    // .replace(/\\\)/g, '$');
    // let md2html = marked.parse(response)

    // MNUtil.copyJSON(MathJax)
    // md2html = MathJax.typeset([md2html])
    let funcHtml = ""
    if (funcResponse) {
      funcHtml = `<pre><code class="hljs">${funcResponse.trim()}</code></pre>`
    }
    // let htmlText = chatAIUtils.html(md2html,false,false)
    // htmlText = htmlText.replace(/<code>/g, "<pre><code>").replace(/<\/code>/g, "</code></pre>")
    // MNUtil.copy(md2html)
    // this["assistant"+this.round].loadHTMLStringBaseURL(htmlText)
    // await this.runJavaScript(`document.body.innerHTML = "${MNUtil.escapeString(htmlText)}"; MathJax.typeset();`,"assistant"+this.round)
    // await MNUtil.delay(0.1)
    // let sizeHeight = await this.getWebviewHeight("assistant"+this.round)
    // let sizeHeight = await this.setWebviewContent(md2html, false, "assistant"+this.round)
    let sizeHeight = await this.setWebviewContentDev(this.response, funcHtml,this.scrollToBottom,"assistant"+this.round)

    this["assistant"+this.round].sizeHeight = sizeHeight+20
    return
    // this[this.targetTextview].text = this.response
  }
    } catch (error) {
      MNUtil.showHUD("Error in setResponseText: "+error)

    }
}

/**
 * addToolMessage是要给ai看的，codifyToolCall是要给用户看的
 * @param {{index:number,id:string,type:string,function:{name:string,arguments:string}}} func 
 * @returns 
 * @this {notificationController}
 */
notificationController.prototype.executeFunctionByAI = function (func) {
try {
  let note,title,comment
  let funcName = func.function.name
  let arguments = MNUtil.getValidJSON(func.function.arguments)
  let noteid = this.noteid ?? chatAIUtils.currentNoteId ?? (chatAIUtils.getFocusNote() ? chatAIUtils.getFocusNote().noteId : undefined)
  switch (funcName) {
    case "multi_tool_use.parallel":
      this.func = []
      let tool_uses = arguments.tool_uses
      let toolMessages = []
      tool_uses.map((tool_use,index)=>{
        switch (tool_use.recipient_name) {
          case "functions.setTitle":
            if (!noteid) {
              MNUtil.showHUD("Unavailable")
              break
              // this.addToolMessage("Execution failed! There is no card selected",func.id)
              // return "Error in setTitle(): There is no card selected\n"
            }
            let title = tool_use.parameters.title.trim()
            if (!title) {
              MNUtil.showHUD("Empty title")
              break
              // copyJSON(this.func)
              // this.addToolMessage("Execution failed! The title provided is empty!",func.id)
              // return "Error in setTitle(): The title provided is empty!\n"
            }
            this.func.push({type:"function",function:{name:"setTitle",arguments:JSON.stringify({title:title})},id:func.id,index:index})
            note = MNUtil.getNoteById(noteid)
            MNUtil.undoGrouping(()=>{
              note.noteTitle = MNUtil.mergeWhitespace(title.trim())
            })
            toolMessages.push("Title is set")
            // this.addToolMessage("Title is set",func.id)
            break;
          case "functions.addComment":
            if (!noteid) {
              MNUtil.showHUD("Unavailable")
              break
              // this.addToolMessage("Execution failed! There is no card selected",func.id)
              // return "Error in addComment(): There is no card selected\n"
            }
            let comment = tool_use.parameters.comment.trim()
            if (!comment) {
              MNUtil.showHUD("Empty comment")
              break
              // copyJSON(this.func)
              // this.addToolMessage("Execution failed! The comment provided is empty!",func.id)
              // return "Error in addComment(): The comment provided is empty!\n"
            }
            // this.addToolMessage("Comment is added",func.id)
            this.func.push({type:"function",function:{name:"addComment",arguments:JSON.stringify({comment:comment})},id:func.id,index:index})
            note = MNUtil.getNoteById(noteid)
            MNUtil.undoGrouping(()=>{
              try {
                note.appendMarkdownComment(comment.tirm())
              } catch (error) {
                note.appendTextComment(comment.tirm())
              }
            })
            toolMessages.push("Comment is added")
            // this.addToolMessage("Comment is added",func.id)
            break;
          default:
            break;
        }
      
      })
      // MNUtil.copyJSON(tool_uses)
      this.addToolMessage(toolMessages.join("\n"),func.id)
      break;
    case "setTitle":
      // MNUtil.copyJSON(this.func)
      if (!noteid) {
        MNUtil.showHUD("Unavailable")
        this.addToolMessage("Execution failed! There is no card selected",func.id)
        return "Error in setTitle(): There is no card selected\n"
      }
      if (!arguments) {
        MNUtil.showHUD("Empty arguments")
        this.addToolMessage("Execution failed! The arguments provided is empty!",func.id)
        return "Error in setTitle(): Empty arguments!\n"
      }
      if (!arguments.title.trim()) {
        MNUtil.showHUD("Empty title")
        // copyJSON(this.func)
        this.addToolMessage("Execution failed! The title provided is empty!",func.id)
        return "Error in setTitle(): Empty title!\n"
      }
      this.addToolMessage("Title is set",func.id)
      note = MNUtil.getNoteById(noteid)
      MNUtil.undoGrouping(()=>{
        note.noteTitle = MNUtil.mergeWhitespace(arguments.title.trim())
      })
      break;
    case "addComment":
      if (!noteid) {
        MNUtil.showHUD("Unavailable")
        this.addToolMessage("Execution failed! There is no card selected",func.id)
        return "Error in addComment(): There is no card selected\n"
      }
      if (!arguments) {
        MNUtil.showHUD("Empty arguments")
        // copyJSON(this.func)
        this.addToolMessage("Execution failed! The arguments provided is empty!",func.id)
        return "Error in addComment(): Empty arguments!\n"
      }
      if (!arguments.comment.trim()) {
        MNUtil.showHUD("Empty comment")
        // copyJSON(this.func)
        this.addToolMessage("Execution failed! The comment provided is empty!",func.id)
        return "Error in addComment(): Empty comment!\n"
      }
      this.addToolMessage("Comment is added",func.id)
      note = MNNote.new(noteid)
      // note = MNUtil.getNoteById(noteid)
      MNUtil.undoGrouping(()=>{
        try {
          note.appendMarkdownComment(arguments.comment.trim())
        } catch (error) {
          note.appendTextComment(arguments.comment.trim())
        }
        if (MNUtil.mindmapView) {
          note.focusInMindMap(0.5)
        }
      })
      break;
    case "addTag":
      if (!noteid) {
        MNUtil.showHUD("Unavailable")
        this.addToolMessage("Execution failed! There is no card selected",func.id)
        return "Error in addTag(): There is no card selected\n"
      }
      if (!arguments) {
        MNUtil.showHUD("Empty arguments")
        this.addToolMessage("Execution failed! The arguments provided is empty!",func.id)
        return "Error in addTag(): Empty arguments!\n"
      }
      if (!arguments.tag.trim()) {
        MNUtil.showHUD("Empty tag")
        // copyJSON(this.func)
        this.addToolMessage("Execution failed! The tag provided is empty!",func.id)
        return "Error in addTag(): Empty tag!\n"
      }
      this.addToolMessage("Tag is added",func.id)
      note = MNUtil.getNoteById(noteid)
      MNUtil.undoGrouping(()=>{
        note.appendTextComment("#"+MNUtil.mergeWhitespace(arguments.tag.trim()))
      })
      // this.response = this.response+"set title"
      break;
    case "copyCardURL":
      if (!noteid) {
        MNUtil.showHUD("Unavailable")
        this.addToolMessage("Execution failed! There is no card selected",func.id)
        return "Error in copyCardURL(): There is no card selected\n"
      }
      this.addToolMessage("Link is copied",func.id)
      // note = getNoteById(noteid)
      MNUtil.copy(MNNote.new(noteid).noteURL)
      break;
    case "copyMarkdownLink":
      if (!noteid) {
        MNUtil.showHUD("Unavailable")
        this.addToolMessage("Execution failed! There is no card selected",func.id)
        return "` Error in copyMarkdownLink(): There is no card selected `\n\n"
      }
      if (!arguments) {
        MNUtil.showHUD("Empty arguments")
        this.addToolMessage("Execution failed! The arguments provided is empty!",func.id)
        return "Error in copyMarkdownLink(): Empty arguments!\n"
      }
      this.addToolMessage("Markdown Link is copied",func.id)
      note = MNUtil.getNoteById(noteid)
      MNUtil.copy(`[${arguments.title.trim()}](${chatAIUtils.getUrlByNoteId(noteid)})`)
      // this.response = this.response+"set title"
      break;
    case "copyText":
      if (!arguments) {
        MNUtil.showHUD("Empty arguments")
        this.addToolMessage("Execution failed! The arguments provided is empty!",func.id)
        return "Error in copyText(): Empty arguments!\n"
      }
      if (!arguments.text.trim()) {
        MNUtil.showHUD("Empty text")
        this.addToolMessage("Execution failed! The text provided is empty!",func.id)
        return "Error in copyText(): Empty text!\n"
      }
      this.addToolMessage("Pure text is copied",func.id)
      MNUtil.copy(arguments.text.trim())
      // this.response = this.response+"set title"
      break;
    case "close":
      this.addToolMessage("Conversation is ended",func.id)
      // this.response = this.response+"set title"
      break;
    case "clearExcerpt":
      note = MNUtil.getNoteById(noteid)
      MNUtil.undoGrouping(()=>{
        note.excerptText = ""
      }) 
      this.addToolMessage("excerpt is cleared", func.id)
      break;
    case "setExcerpt":
      if (!arguments) {
        MNUtil.showHUD("Empty arguments")
        this.addToolMessage("Execution failed! The arguments provided is empty!",func.id)
        return "Error in setExcerpt(): Empty arguments!\n"
      }
      if (!arguments.excerpt.trim()) {
        MNUtil.showHUD("Empty excerpt")
        this.addToolMessage("Execution failed! The excerpt provided is empty!",func.id)
        return "Error in setExcerpt(): Empty excerpt!\n"
      }
      // note = MNUtil.getNoteById(noteid)
      note = MNNote.new(noteid)
      MNUtil.undoGrouping(()=>{
        note.excerptText = arguments.excerpt.trim()
        if (MNUtil.mindmapView) {
          note.focusInMindMap(0.5)
        }
      }) 
      this.addToolMessage("excerpt is set", func.id)
      break;
    case "addChildNote":
      if (!arguments) {
        MNUtil.showHUD("Empty arguments")
        this.addToolMessage("Execution failed! The arguments provided is empty!",func.id)
        return "Error in addChildNote(): Empty arguments!\n"
      }
      let title = arguments.title
      let config = {markdown:true}
      if (title) {
        config.title = title.trim()
      }
      let content = arguments.content
      if (content) {
        config.content = content.trim()
      }
      note = MNNote.new(noteid)
      // MNNote.createChildNote
      note.createChildNote({title:title,content:content,markdown:true})
      if (MNUtil.mindmapView) {
        note.focusInMindMap(0.5)
      }
      // chatAIUtils.createChildNote(noteid, title, content)
      this.addToolMessage("child note is added",func.id)
      break 
    default:
      break;
  }
  return this.codifyToolCall(funcName,arguments)
  // return undefined
} catch (error) {
  chatAIUtils.addErrorLog(error, "executeFunctionByAI",func)
  return undefined
}
}

notificationController.prototype.setButtonOpacity = function (opacity) {
  if (this.onChat) {
    this.chatToolbar.layer.opacity = opacity
  }else{
    this.toolbar.layer.opacity = opacity
    // this.bigbangButton.layer.opacity = opacity
    // this.commentButton.layer.opacity = opacity
    // this.copyButton.layer.opacity = opacity
    // this.titleButton.layer.opacity = opacity
    // this.locationButton.layer.opacity = opacity
    // this.promptButton.layer.opacity = opacity
    // this.chatButton.layer.opacity = opacity
    // this.reloadButton.layer.opacity = opacity
    // this.aiLinkButton.layer.opacity = opacity
  }
}
/**
 * 
 * @param {string} content 
 */
notificationController.prototype.addToolMessage = function (content,funcId) {
  this.tool.push({"role":"tool","content":content,"tool_call_id":funcId})
}
/** @this {notificationController} */
notificationController.prototype.setToken = function (token) {
    this.token.push(token)
    if (this.onChat) {
        this.chatToken.setTitleForState(""+token+" ("+chatAIUtils.sum(this.token)+")",0)
    }else{
      if (!this.func) {
        if (this.token.length ===1) {
          this.promptButton.setTitleForState(token,0)
        }else{
          this.promptButton.setTitleForState(chatAIUtils.sum(this.token),0)
        }
      }
    }
}
/** @this {notificationController} */
notificationController.prototype.speech = async function(text,webview){
  let encodedText = encodeURIComponent(text)
  let voice = chatAIConfig.getConfig("speechVoice")
  let speed = chatAIConfig.getConfig("speechSpeed")
  let key = chatAIConfig.getConfig("speechKey")
  let group = chatAIConfig.getConfig("miniMaxGroup")
  if (chatAIConfig.getConfig("autoSpeech")) {
    await this.runJavaScript(`speech(\`${encodedText}\`,\`${voice}\`,\`${key}\`,\`${group}\`,${speed},true);`,webview)
  }else{
    await this.runJavaScript(`speech(\`${encodedText}\`,\`${voice}\`,\`${key}\`,\`${group}\`,${speed},false);`,webview)
  }
}
/**
 * @this {notificationController}
 * @param {number[]} actionIndices 
 * @param {string} text 
 */
notificationController.prototype.excuteFinishAction = function (actionIndices,text) {
  // MNUtil.showHUD("excuteFinishAction")
  try {
    

  let shouldClose = false
  let noteid = this.noteid ?? chatAIUtils.currentNoteId ?? (chatAIUtils.getFocusNote() ? chatAIUtils.getFocusNote().noteId : undefined)
  let note = MNNote.new(noteid)
  var actions = ["setTitle","addComment","copyMarkdownLink","copyCardURL","copyText","close","addTag","addChildNote","clearExcerpt","setExcerpt"];
  MNUtil.undoGrouping(()=>{
    actionIndices.forEach(index=>{
      switch (actions[index]) {
        case "setTitle":
          note.noteTitle = MNUtil.mergeWhitespace(text)
          MNUtil.showHUD("Title is set")
          break;
        case "addComment":
          if (text.trim()) {
            note.appendMarkdownComment(text.trim())
            MNUtil.showHUD("Comment is added")
          }else{
            MNUtil.showHUD("Empty content!")
          }
          break;
        case "addTag":
          note.appendTextComment("#"+MNUtil.mergeWhitespace(text))
          MNUtil.showHUD("Tag is added")
          break
        case "copyCardURL":
          MNUtil.copy(note.noteURL)
          MNUtil.showHUD("Link is copied")
          break;
        case "copyMarkdownLink":
          MNUtil.copy(`[${text}](${note.noteURL})`)
          MNUtil.showHUD("Markdown Link is copied")
          break;
        case "copyText":
          MNUtil.copy(text)
          MNUtil.showHUD("Content is copied")
          break;
        case "clearExcerpt":
          note.excerptText = ""
          MNUtil.showHUD("clear excerpt")
          break;
        case "close":
          shouldClose = true;
          break;
        case "setExcerpt":
          note.excerptText = text
          MNUtil.showHUD("excerpt is set")
          break;
        case "addChildNote":
          note.createChildNote({content:text,markdown:true})
          MNUtil.showHUD("child note is added")
          break;
        default:
          break;
      }
    })
  
  })
  MNUtil.delay(0.5).then(()=>{
    if (shouldClose) {
      this.hide()
    }
  })
  } catch (error) {
    chatAIUtils.addErrorLog(error, "excuteFinishAction")
  }
}
/**
 * @this {notificationController}
 */
notificationController.prototype.checkTheme = function(refresh = false){
  if (!chatAIConfig.getConfig("autoTheme") || !chatAIUtils.isSubscribed(false)) {
    this.theme = "light"
    return
  }
  if (MNUtil.app.currentTheme === "Dark") {
    if (refresh && this.theme !== "dark") {
      this.refreshTheme("dark")
    }
    this.theme = "dark"
  }else{
    if (refresh && this.theme === "dark") {
      this.refreshTheme("light")
    }
    this.theme = "light"
  }
}
/**
 * @this {notificationController}
 */
notificationController.prototype.refreshTheme = function (theme) {
  if (this.webviewResponse) {
    // MNUtil.showHUD(theme)
    this.changeTheme(theme)
  }
  if (this.onChat) {
    this.webviewResponse.hidden = true
    if (theme === "dark") {
      this.scrollView.backgroundColor = MNUtil.hexColorAlpha("#333b41",0.8)
    }else{
      this.scrollView.backgroundColor = MNUtil.hexColorAlpha("#ffffff",0.8)
    }
  }
  let round = 0
  while (this["assistant"+round]) {
    this.changeTheme(theme,"assistant"+round)
    round = round+1
  }
  return
}
/**
 * @this {notificationController}
 */
notificationController.prototype.changeTheme = function (theme,webview) {
  if (!chatAIConfig.getConfig("autoTheme") || !chatAIUtils.isSubscribed(false)) {
    return
  }
  if (webview) {
    switch (theme) {
      case "dark":
        this.runJavaScript(`editor.setTheme("dark","dark");document.body.style.backgroundColor = "#24292E";`,webview)
        // this.theme = "dark"
        break;
      case "light":
        this.runJavaScript(`editor.setTheme("light","light");document.body.style.backgroundColor = "#ffffff";`,webview)
        // this.theme = "light"
        break;
      default:
        break;
    }
  }else{
    switch (theme) {
      case "dark":
        this.runJavaScript(`editor.setTheme("dark","dark");document.body.style.backgroundColor = "#24292E";`)
        // this.theme = "dark"
        break;
      case "light":
        this.runJavaScript(`editor.setTheme("light","light");document.body.style.backgroundColor = "#ffffff";`)
        // this.theme = "light"
        break;
      default:
        break;
    }
  }
  }
/**
 * @type {UIView}
 */
notificationController.prototype.view
/**
 * @type {notificationController}
 */
notificationController.prototype.addonController