


// 定义一个类
class chatAIUtils {
  // 构造器方法，用于初始化新创建的对象
  constructor(name) {
    this.name = name;
  }
  static errorLog = []
  /**
   * @type {{version:String,type:String}}
   * @static
   */
  static version
  static currentNoteId
  static currentSelection = ""
  static onPopupMenuOnNoteTime = 0
  static onPopupMenuOnSelectionTime = 0
  static currentPrompt
  /**
   * @type {Boolean}
   * @static
   */
  static OCREnhancedMode
  /**
   * @type {Boolean}
   * @static
   */
  static visionMode
  static noSystemMode
  static lastTime
  /**
   * @type {chatglmController}
   * @static
   */
  static chatController
  /**
   * @type {notificationController}
   * @static
   */
  static notifyController
  /**
   * @type {dynamicController}
   * @static
   */
  static dynamicController
  static init(){
    this.OCREnhancedMode = false
    this.app = Application.sharedInstance()
    this.data = Database.sharedInstance()
    this.focusWindow = this.app.focusWindow
    this.version = this.appVersion()
  }
  static async checkMNUtil(alert = false,delay = 0.01){
    if (typeof MNUtil === 'undefined') {//如果MNUtil未被加载，则执行一次延时，然后再检测一次
      //仅在MNUtil未被完全加载时执行delay
      await chatAIUtils.delay(delay)
      if (typeof MNUtil === 'undefined') {
        if (alert) {
          chatAIUtils.showHUD("MN ChatAI: Please install 'MN Utils' first!",5)
        }
        return false
      }
    }
    return true
  }
  static showHUD(message,duration=2) {
    this.app.showHUD(message,this.focusWindow,2)
  }

  static appVersion() {
    let info = {}
    let version = parseFloat(this,this.app.appVersion)
    if (version >= 4) {
      info.version = "marginnote4"
    }else{
      info.version = "marginnote3"
    }
    switch (this.app.osType) {
      case 0:
        info.type = "iPadOS"
        break;
      case 1:
        info.type = "iPhoneOS"
        break;
      case 2:
        info.type = "macOS"
        break;
      default:
        break;
    }
    return info
  }
  static  getNoteColors() {
    return ["#ffffb4","#ccfdc4","#b4d1fb","#f3aebe","#ffff54","#75fb4c","#55bbf9","#ea3323","#ef8733","#377e47","#173dac","#be3223","#ffffff","#dadada","#b4b4b4","#bd9fdc"]
  }
  static getNoteById(noteid) {
    let note = this.data.getNoteById(noteid)
    return note
  }
  static getNoteBookById(notebookId) {
    let notebook = this.data.getNotebookById(notebookId)
    return notebook
  }
  static getUrlByNoteId(noteid) {
    let ver = this.appVersion()
    return ver.version+'app://note/'+noteid
  }
  /**
   * 注意这里的code需要是字符串
   * @param {string} code 
   * @returns {string}
   */
  static getStatusCodeDescription(code){
  try {
    

  // if (typeof code === "number") {
  //   code = toString(code)
  // }
      let des = {
        "400": "Bad Request",
        "401": "Unauthorized",
        "402": "Payment Required",
        "403": "Forbidden",
        "404": "Not Found",
        "405": "Method Not Allowed",
        "406": "Not Acceptable",
        "407": "Proxy Authentication Required",
        "408": "Request Timeout",
        "409": "Conflict",
        "410": "Gone",
        "411": "Length Required",
        "412": "Precondition Failed",
        "413": "Payload Too Large",
        "414": "URI Too Long",
        "415": "Unsupported Media Type",
        "416": "Range Not Satisfiable",
        "417": "Expectation Failed",
        "418": "I'm a teapot",
        "421": "Misdirected Request",
        "422": "Unprocessable Entity",
        "423": "Locked",
        "424": "Failed Dependency",
        "425": "Too Early",
        "426": "Upgrade Required",
        "428": "Precondition Required",
        "429": "Too Many Requests",
        "431": "Request Header Fields Too Large",
        "451": "Unavailable For Legal Reasons",
        "500": "Internal Server Error",
        "501": "Not Implemented",
        "502": "Bad Gateway",
        "503": "Service Unavailable",
        "504": "Gateway Timeout",
        "505": "HTTP Version Not Supported",
        "506": "Variant Also Negotiates",
        "507": "Insufficient Storage",
        "508": "Loop Detected",
        "510": "Not Extended",
        "511": "Network Authentication Required"
      }
      if (code in des) {
    return (code+": "+des[code])
      }
      return undefined
    } catch (error) {
      MNUtil.copy(error.toString())
    }
  }
  /**
   * 
   * @param {String} url 
   * @returns {String}
   */
  static getNoteIdByURL(url) {
    let targetNoteId = url.trim()
    if (/^marginnote\dapp:\/\/note\//.test(targetNoteId)) {
      targetNoteId = targetNoteId.slice(22)
    }
    return targetNoteId
  }
  static clipboardText() {
    return UIPasteboard.generalPasteboard().string
  }
  static copy(text) {
    UIPasteboard.generalPasteboard().string = text
  }
  static copyJSON(object) {
    UIPasteboard.generalPasteboard().string = JSON.stringify(object,null,2)
  }
  /**
   * 
   * @param {NSData} imageData 
   */
  static copyImage(imageData) {
    UIPasteboard.generalPasteboard().setDataForPasteboardType(imageData,"public.png")
  }
  static studyController() {
    return this.app.studyController(this.focusWindow)
  }
  static studyView() {
    return this.app.studyController(this.focusWindow).view
  }

  static currentDocController() {
    return this.studyController().readerController.currentDocumentController
  }
  static currentNotebook() {
    let notebookId = this.studyController().notebookController.notebookId
    return this.getNoteBookById(notebookId)
  }
  static undoGrouping(notebookId,f){
    UndoManager.sharedInstance().undoGrouping(
      String(Date.now()),
      notebookId,
      f
    )
    this.app.refreshAfterDBChanged(notebookId)
  }
  /**
   * 
   * @param {{title:String,content:String,markdown:Boolean,color:Number}} config 
   * @returns 
   */
  static creatNote(config) {
    try {

      let notebook = this.currentNotebook()
      let title = config.title ?? ""
    let note = Note.createWithTitleNotebookDocument(title, notebook,this.currentDocController().document)
      if (config.content) {
        if (config.markdown) {
          note.appendMarkdownComment(config.content)
      }else{
          note.appendTextComment(config.content)
        }
      }
      if (config.color !== undefined) {
        note.colorIndex = config.color
      }
      return note
    } catch (error) {
      this.showHUD(error)
      return undefined
    }
  }
  /**
   * 
   * @param {MbBookNote} parent 
   * @param {MbBookNote} targetNote 
   */
  static addChildNote(parent,targetNote,colorInheritance=false) {
    this.undoGrouping(parent.notebookId, ()=>{
      if (colorInheritance) {
        targetNote.colorIndex = parent.colorIndex
      }
      parent.addChild(targetNote)
    })
  }
  /**
   * 
   * @param {MbBookNote|String} parent 
   * @param {{title:String,content:String,markdown:Boolean,color:Number}} config 
   * @returns {MbBookNote}
   */
  static createChildNote(parent,config) {
    let parentNote = (typeof parent === "string")?this.getNoteById(parent):parent
    let child
    this.undoGrouping(parentNote.notebookId, ()=>{
      child = this.creatNote(config)
      parentNote.addChild(child)
    })
    return child
  }
  /**
   * 
   * @param {MbBookNote} brother 
   * @param {MbBookNote} targetNote 
   */
  static addBrotherNote(brother,targetNote,colorInheritance=false) {
    if (!brother.parentNote) {
      this.showHUD("No parent note!")
      return
    }
    let parent = brother.parentNote
    this.undoGrouping(parent.notebookId, ()=>{
      if (colorInheritance) {
        targetNote.colorIndex = brother.colorIndex
      }
      parent.addChild(targetNote)
    })
  }
  /**
   * 
   * @param {MbBookNote} brother 
   * @param {{title:String,content:String,markdown:Boolean,color:Number}} config 
   */
  static createBrotherNote(brother,config) {
    if (!brother.parentNote) {
      this.showHUD("No parent note!")
      return
    }
    let parent = brother.parentNote
    this.undoGrouping(parent.notebookId, ()=>{
      let child = this.creatNote(config)
      parent.addChild(child)
    })
  }
  static getSplitLine() {
    let study = this.studyController()
    let studyFrame = study.view.bounds
    let readerFrame = study.readerController.view.frame
    let hidden = study.readerController.view.hidden//true代表脑图全屏
    let rightMode = study.rightMapMode
    let fullWindow = readerFrame.width == studyFrame.width
    if (hidden || fullWindow) {
      return undefined
    }
    if (rightMode) {
      let splitLine = readerFrame.x+readerFrame.width
      return splitLine
    }else{
      let splitLine = readerFrame.x
      return splitLine
    }
  }
  static hexColorAlpha(hex,alpha) {
    let color = UIColor.colorWithHexString(hex)
    return alpha!==undefined?color.colorWithAlphaComponent(alpha):color
  }
  static genFrame(x,y,width,height) {
    return {x:x,y:y,width:width,height:height}
  }
  static getImage(path,scale=2) {
    return UIImage.imageWithDataScale(NSData.dataWithContentsOfFile(path), scale)
  }

  static getFocusNote() {
    let notebookController = this.studyController().notebookController
    // copy("text:"+!notebookController.view.hidden)
    if (!notebookController.view.hidden && notebookController.mindmapView && notebookController.focusNote) {
      return notebookController.focusNote
    }else{
      return (this.currentDocController().focusNote ?? this.currentDocController().lastFocusNote)
    }
  }

  static getFocusNotes() {
    let notebookController = this.studyController().notebookController
    // copy("test:"+(!notebookController.view.hidden && notebookController.mindmapView.selViewLst.length))
    if (!notebookController.view.hidden && notebookController.mindmapView && notebookController.mindmapView.selViewLst.length) {
      let selViewLst = notebookController.mindmapView.selViewLst
      // let focusNotes = 
      return selViewLst.map(tem=>{
        return tem.note.note
      })
    }else if(this.currentDocController().focusNote){
      return [this.currentDocController().focusNote]
    }else{
      //如果两个上面两个都没有，那就可能是小窗里打开的
      return [notebookController.focusNote]
    }
  }

  static cloneNote(noteid) {
    let targetNote = this.getNoteById(noteid)
    if (!targetNote) {
      this.showHUD("Note not exists!")
      return undefined
    }
    let note = this.data.cloneNotesToTopic([targetNote], targetNote.notebookId)
    return note[0]
  }

  static cloneAndMerge(currentNote,targetNoteId) {
    let clonedNoteId = this.cloneNote(targetNoteId)
    currentNote.merge(this.getNoteById(clonedNoteId))
  }

  static postNotification(name,userInfo) {
    NSNotificationCenter.defaultCenter().postNotificationNameObjectUserInfo(name, this.focusWindow, userInfo)
  }

  static moveElement(arr, element, direction) {
      // 获取元素的索引
    var index = arr.indexOf(element);
    if (index === -1) {
      this.showHUD('Element not found in array');
      return;
    }
    switch (direction) {
      case 'up':
        if (index === 0) {
          this.showHUD('Element is already at the top');
          return;
        }
              // 交换元素位置
        [arr[index], arr[index - 1]] = [arr[index - 1], arr[index]];
        break;
      case 'down':
        if (index === arr.length - 1) {
          this.showHUD('Element is already at the bottom');
          return;
        }
              // 交换元素位置
        [arr[index], arr[index + 1]] = [arr[index + 1], arr[index]];
        break;
      case 'top':
              // 移除元素
        arr.splice(index, 1);
              // 添加到顶部
        arr.unshift(element);
        break;
      default:
        this.showHUD('Invalid direction');
    }
  }

  static getVarInfo(text) {
    let config = {}
    let hasClipboardText = text.includes("{{clipboardText}}")
    let hasSelectionText = text.includes("{{selectionText}}")
    if (hasClipboardText) {
      config.clipboardText = this.clipboardText()
    }
    if (hasSelectionText) {
      config.selectionText = this.currentDocController().selectionText
    }
    return config
  }
  /**
   * 
   * @param {string} text 
   * @param {string} userInput 
   * @returns 
   */
  static checkVariableForNote(text,userInput){//提前写好要退化到的变量
    let OCR_Enabled = chatAIUtils.OCREnhancedMode
    let hasUserInput = text.includes("{{userInput}}")
    let hasCards = text.includes("{{cards}}")
    let hasCardsOCR = text.includes("{{cardsOCR}}")
    let replaceVarConfig = {}
    if (OCR_Enabled) {
      replaceVarConfig.context = `{{textOCR}}`

      replaceVarConfig.card = `{{cardOCR}}`
      replaceVarConfig.parentCard = `{{parentCardOCR}}`
      replaceVarConfig.cards = `{{cardsOCR}}`

      if (hasUserInput && !userInput) {
        replaceVarConfig.userInput = `{{textOCR}}`

      }
      if (hasCards || hasCardsOCR) {
        if (MNNote.getFocusNotes().length === 1) {
          replaceVarConfig.cards = `{{cardOCR}}`
          replaceVarConfig.cardsOCR = `{{cardOCR}}`
        }
      }
    }else{
      if (hasUserInput && !userInput) {
        replaceVarConfig.userInput = `{{context}}`
      }
      if (hasCards || hasCardsOCR) {
        if (MNNote.getFocusNotes().length === 1) {
          replaceVarConfig.cards = `{{card}}`
          replaceVarConfig.cardsOCR = `{{carsdOCR}}`
        }
      }
    }
    return this.replacVar(text, replaceVarConfig)
  }

  static checkVariableForText(text,userInput){
    let OCR_Enabled = chatAIUtils.OCREnhancedMode
    let hasUserInput = text.includes("{{userInput}}")
    let replaceVarConfig = {}

    if (OCR_Enabled) {
      replaceVarConfig.context = `{{textOCR}}`
      replaceVarConfig.card = `{{textOCR}}`
      replaceVarConfig.parentCard = `{{textOCR}}`
      replaceVarConfig.cards = `{{textOCR}}`
      if (hasUserInput && !userInput) {
        replaceVarConfig.userInput = `{{textOCR}}`
      }
    }else{
      replaceVarConfig.card = `{{context}}`
      replaceVarConfig.cards = `{{context}}`
      replaceVarConfig.parentCard = `{{context}}`
      if (hasUserInput && !userInput) {
        replaceVarConfig.userInput = `{{context}}`
      }
    }
    replaceVarConfig.cardOCR = `{{textOCR}}`
    replaceVarConfig.cardsOCR = `{{textOCR}}`
    replaceVarConfig.parentCardOCR = `{{textOCR}}`
    return this.replacVar(text, replaceVarConfig)
  }
  static replacVar(text,varInfo) {
    let vars = Object.keys(varInfo)
    let original = text
    for (let i = 0; i < vars.length; i++) {
      const variable = vars[i];
      const variableText = varInfo[variable]
      const regex = new RegExp(`{{${variable}}}`, 'g');
      original = original.replace(regex,variableText)
    }
    // copy(original)
    return original
  }

  static detectAndReplace(text,element=undefined) {
    let config = this.getVarInfo(text)
    if (element !== undefined) {
      config.element = element
    }
    return this.replacVar(text,config)
  }

  static checkHeight(height){
    if (height > 400) {
      return 400
    }else if(height < 80){
      return 80
    }else{
      return height
    }
  }
  static addObserver(observer,selector,name){
    NSNotificationCenter.defaultCenter().addObserverSelectorName(observer, selector, name);
  }
  static removeObserver(observer,name){
    NSNotificationCenter.defaultCenter().removeObserverName(observer, name);
  }
  static studyMode(){
    return this.studyController().studyMode
  }
  static openURL(url){
    this.app.openURL(NSURL.URLWithString(url));
  }
  static ensureChatAIController(){
    if (!this.chatController) {
      this.chatController = chatglmController.new();
      MNUtil.studyView.addSubview(this.chatController.view)
      this.chatController.view.hidden = true;
    }else{
      this.ensureView(this.chatController.view)
    }
  }
  static initChatAIController(){
    this.chatController = chatglmController.new();
    MNUtil.studyView.addSubview(this.chatController.view)
  }
  static ensureNotifyController(){
    if (!this.notifyController) {
      this.notifyController = notificationController.new();
      MNUtil.studyView.addSubview(this.notifyController.view)
      this.notifyController.view.hidden = true
      this.notifyController.view.frame = {x:50,y:50,width:400,height:120}
      this.notifyController.currentFrame = {x:50,y:50,width:400,height:120}
    }else
      this.ensureView(this.notifyController.view)
      // if (this.forceToRefresh) {
      //   this.notifyController.setNewResponse()
      // // MNUtil.showHUD("message")

      //   MNUtil.showHUD("Force to refresh")
      // //   if (this.notifyController.webviewResponse) {
      // //     this.notifyController.webviewResponse.hidden = true
      // //     this.notifyController.webviewResponse.removeFromSuperview()
      // //   }
      // //   // delete this.webviewResponse
      // //   this.notifyController.createWebviewResponse()
      // //   this.notifyController.setNotiLayout()
      // //   this.forceToRefresh = false
      // }
    
  }
  static initNotifyController(){
    this.notifyController = notificationController.new();
    MNUtil.studyView.addSubview(this.notifyController.view)
  }
  static initDynamicController(){
    this.dynamicController = dynamicController.new();
    MNUtil.studyView.addSubview(this.dynamicController.view)
  }
  static isIOS(){
    //把宽度过低的情况也当做是iOS模式
    return (MNUtil.studyView.bounds.width < 500)
  }
  static getWidth(){
    if (this.isIOS()) {
      return MNUtil.studyView.bounds.width
    }else{
      return 400
    }
  }
  static getY(){
    if (MNUtil.appVersion().type == "iPhoneOS") {
      return 0
    }else{
      return 50
    }
  }
  static getX(){
    let notifyLoc = chatAIUtils.isIOS()?0:chatAIConfig.config.notifyLoc
    switch (notifyLoc) {
      case 0:
        if (this.isIOS()) {
          return 0
        }else{
          return 50
        }
      case 1:
        if (this.isIOS()) {
          return MNUtil.studyView.bounds.width-450
        }else{
          return MNUtil.studyView.bounds.width-450
        }
      default:
        break;
    }
    return 0

  }
  /**
   * 
   * @param {MbBookNote|MNNote} note 
   */
  static async getTextForSearch(note,OCR_enabled=false) {
    let order = chatAIConfig.getConfig("searchOrder")
    let text
    for (let index = 0; index < order.length; index++) {
      const element = order[index];
      switch (element) {
        case 1:
          if (note.noteTitle && note.noteTitle !== "") {
            text = note.noteTitle
          }
          break;
        case 2:
          if (OCR_enabled && note.excerptPic && !note.textFirst) {
            let image = MNUtil.getMediaByHash(note.excerptPic.paint)
            text = await chatAINetwork.getTextOCR(image)
            // text = ""
          }else if (this.noteHasExcerptText(note)) {
            text = note.excerptText
          }

          //如果都不满足，此时text依然为undefined
          break;
        case 3:
          let commentText
          let commentImage = undefined
          //用find主要是保证得到想要的元素之后就会直接返回，而不是继续执行
          //但是find处理不了异步的情况
          let comment = note.comments.find(comment=>{
            switch (comment.type) {
              case "TextNote":
                if (/^marginnote\dapp:\/\//.test(comment.text)) {
                  return false
                }else{
                  commentText = comment.text
                  return true
                }
              case "HtmlNote":
                commentText = comment.text
                return true
              case "LinkNote":
                if (comment.q_hpic && !note.textFirst) {
                  if (OCR_enabled) {
                    commentImage = MNUtil.getMediaByHash(comment.q_hpic.paint)
                    // commentText = await chatAINetwork.getTextOCR(commentImage)
                    return true
                  }else{
                    return false
                  }
                }else{
                  commentText = comment.q_htext
                  return true
                }
              case "PaintNote":
                if (OCR_enabled && comment.paint) {
                  commentImage = MNUtil.getMediaByHash(comment.paint)
                  // commentText = await chatAINetwork.getTextOCR(commentImage)
                  return true
                }
                return false
              default:
                return false
            }
          })
          if (commentImage) {
            MNUtil.showHUD("should OCR")
            commentText = await chatAINetwork.getTextOCR(commentImage)
            // MNUtil.copy(commentText)
          }
          if (commentText && commentText.length) {
            text = commentText
          }
          break;
        default:
          break;
      }
      if (text) {
        return text
      }
    }
    return undefined
  }
  static getToday() {
    // 创建一个新的Date对象，默认情况下它会包含当前日期和时间
    const today = new Date();

    // 获取日
    const day = today.getDate();
    return day
  }
  static switchColor(on123){
    let color = on123 ? "#457bd3" : "#9bb2d6"
    return this.hexColorAlpha(color,0.8)
  }
  static countWords(str) {
    const chinese = Array.from(str)
      .filter(ch => /[\u4e00-\u9fa5]/.test(ch))
      .length
    
    const english = Array.from(str)
      .map(ch => /[a-zA-Z0-9\s]/.test(ch) ? ch : ' ')
      .join('').split(/\s+/).filter(s => s)
      .length

    return chinese + english
  }
  static animate(func,time = 0.2) {
    UIView.animateWithDurationAnimationsCompletion(time,func)
  }

  static animateWithCompletion(func,funcWhenCompleted,time = 0.2) {
    UIView.animateWithDurationAnimationsCompletion(time,func,funcWhenCompleted)
  }
  static checkSender(sender,window){
    return this.app.checkNotifySenderInWindow(sender, window)
  }
  static getFileName(fullPath) {
      // 找到最后一个'/'的位置
    let lastSlashIndex = fullPath.lastIndexOf('/');

      // 从最后一个'/'之后截取字符串，得到文件名
    let fileName = fullPath.substring(lastSlashIndex + 1);

    return fileName;
  }
  static isfileExists(path) {
    return NSFileManager.defaultManager().fileExistsAtPath(path)
  }
  static getCurrentFile() {
    let docFile = this.currentDocController().document
    // copy(docFile.pathFile)
    let fullPath
    if (docFile.fullPathFileName) {
      fullPath = docFile.fullPathFileName
    }else{
      let folder = this.app.documentPath
      fullPath = folder+"/"+docFile.pathFile
      if (docFile.pathFile.startsWith("$$$MNDOCLINK$$$")) {
        let fileName = this.getFileName(docFile.pathFile)
        fullPath = this.app.tempPath + fileName
        // fullPath = docFile.pathFile.replace("$$$MNDOCLINK$$$", "/Users/linlifei/")
      }
    }

    if (!this.isfileExists(fullPath)) {
      MNUtil.showHUD("Invalid file: "+docFile.pathFile)
      return undefined
    }
    // copy(fullPath)
    let fileName = this.getFileName(fullPath)
    return{
      name:fileName,
      path:fullPath,
      md5:docFile.docMd5
    }
  }
  static getNoteFileName(noteId) {
    let note = MNUtil.getNoteById(noteId)
    let docFile = MNUtil.getDocById(note.docMd5)
    if (!docFile) {
      MNUtil.showHUD("No file")
      return undefined
    }
    return MNUtil.getFileName(docFile.pathFile)
  }
  static getNoteFile(noteId) {
    let note = MNUtil.getNoteById(noteId)
    let docFile = MNUtil.getDocById(note.docMd5)
    if (!docFile) {
      MNUtil.showHUD("No file")
      return undefined
    }
    let fullPath
    if (docFile.fullPathFileName) {
      fullPath = docFile.fullPathFileName
    }else{
      let folder = MNUtil.documentFolder
      let fullPath = folder+"/"+docFile.pathFile
      if (docFile.pathFile.startsWith("$$$MNDOCLINK$$$")) {
        let fileName = this.getFileName(docFile.pathFile)
        fullPath = Application.sharedInstance().tempPath + fileName
        // fullPath = docFile.pathFile.replace("$$$MNDOCLINK$$$", "/Users/linlifei/")
      }
    }
    if (!MNUtil.isfileExists(fullPath)) {
      MNUtil.showHUD("Invalid file: "+docFile.pathFile)
      return undefined
    }
    // copy(fullPath)
    let fileName = this.getFileName(fullPath)
    return{
      name:fileName,
      path:fullPath,
      md5:docFile.docMd5
    }
  }
  static isValidJSON(jsonString){
    try{
      var json = JSON.parse(jsonString);
      if (json && typeof json === "object") {
        return true;
      }
    }
    catch(e){
      return false;
    }
    return false;
  }
  static noteHasExcerptText(note) {
    //摘要文本必须存在并且不为空
    //考虑到可能存在图片摘要，因此要么图片摘要不存在，要么图片摘要已被转为文本
    return note.excerptText && note.excerptText !== "" && (!note.excerptPic || note.textFirst)
  }
  static strCode(str) {  //获取字符串的字节数
    var count = 0;  //初始化字节数递加变量并获取字符串参数的字符个数
    var cn = [8211, 8212, 8216, 8217, 8220, 8221, 8230, 12289, 12290, 12296, 12297, 12298, 12299, 12300, 12301, 12302, 12303, 12304, 12305, 12308, 12309, 65281, 65288, 65289, 65292, 65294, 65306, 65307, 65311]
    var half = [32, 33, 34, 35, 36, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 58, 59, 60, 61, 62, 63, 64, 91, 92, 93, 94, 95, 96, 123, 124, 125, 126,105,108,8211]
    if (str) {  //如果存在字符串，则执行
      let len = str.length;
        for (var i = 0; i < len; i++) {  //遍历字符串，枚举每个字符
        let charCode = str.charCodeAt(i)
            if (charCode>=65 && charCode<=90) {
              count += 1.5;  //大写
        } else if (half.includes(charCode)) {
              count +=0.45
        } else if (cn.includes(charCode)) {
              count +=0.8
            }else if (charCode > 255) {  //字符编码大于255，说明是双字节字符(即是中文)
                count += 2;  //则累加2个
            }else{
                count++;  //否则递加一次
            }
        }
        return count;  //返回字节数
    } else {
        return 0;  //如果参数为空，则返回0个
    }
  }
  static getRandomElement(arr) {
    if (arr.length === 1) {
      return arr[0]
    }
    if (arr && arr.length) {
      const randomIndex = Math.floor(Math.random() * arr.length);
      return arr[randomIndex];
    }
    return ""; // 或者抛出一个错误，如果数组为空或者未定义
  }
  static focusNoteInMindMapById(noteId){
    this.studyController().focusNoteInMindMapById(noteId)
  }
  static async delay (seconds) {
    return new Promise((resolve, reject) => {
      NSTimer.scheduledTimerWithTimeInterval(seconds, false, function () {
        resolve()
      })
    })
  }
  static getFile(path) {
    return NSData.dataWithContentsOfFile(path)
  }
  static clearCurrent(){
    this.currentNoteId = undefined
    this.currentSelection = undefined
  }
  static refreshCurrent(){
    this.currentSelection = this.currentDocController().selectionText
    let focusNote = this.getFocusNote()
    if (focusNote) {
      this.currentNoteId = focusNote.noteId
    }else{
      this.currentNoteId = undefined
    }
  }
  static getPopoverAndPresent(sender,commandTable,width=100,position=2) {
    var menuController = MenuController.new();
    menuController.commandTable = commandTable
    menuController.rowHeight = 35;
    menuController.preferredContentSize = {
      width: width,
      height: menuController.rowHeight * menuController.commandTable.length
    };
    //左 0
    //下 1，3
    //上 2
    //右 4
    var popoverController = new UIPopoverController(menuController);
    var r = sender.convertRectToView(sender.bounds,MNUtil.studyView);
    popoverController.presentPopoverFromRect(r, MNUtil.studyView, position, true);
    return popoverController
  }
  static isActivated(msg = false){
    if (typeof subscriptionConfig !== 'undefined') {
      return subscriptionConfig.getConfig("activated")
    }else{
      if (msg) {
        this.showHUD("Set your API key or install 'MN Subscrption'")
      }
      return false
    }
    
  }
  static isSubscribed(msg = true){
    if (typeof subscriptionConfig !== 'undefined') {
      return subscriptionConfig.isSubscribed()
    }else{
      if (msg) {
        this.showHUD("Please install 'MN Subscription' first!")
      }
      return false
    }
  }
  /**
   * 
   * @returns {Boolean}
   */
  static checkSubscribe(count = true, toast = true){
    // return true
    if (typeof subscriptionConfig !== 'undefined') {
      let res = subscriptionConfig.checkSubscribed(count)
      return res
    }else{
      if (toast) {
        this.showHUD("Please install 'MN Subscription' first!")
      }
      return false
    }
  }
  /**
   * 
   * @param {MbBookNote} note
   * @returns {String[]}
   */
  static extractTagsFromNote(note) {
    // 用于存储所有标签的数组
    const tags = [];

    // 检查 note 是否有 comments 属性，且其为数组
    if (note.comments && Array.isArray(note.comments)) {
      // 遍历 comments 数组
      note.comments.forEach(comment => {
        // 检查评论的类型是否为 "TextNote"
        if (comment.type === "TextNote" && typeof comment.text === "string") {
          // 使用正则表达式查找所有标签（格式为 #tagname）
          const tagMatches = comment.text.match(/#[\w\u4e00-\u9fff]+/g);
          if (tagMatches) {
            // 将找到的标签添加到 tags 数组中
            tags.push(...tagMatches);
          }
        }
      });
    }

    // 返回去重后的标签数组
    return [...new Set(tags)];
  }
  /**
   * 
   * @param {*} arr1 
   * @param {*} arr2 
   * @returns {String[]}
   */
  static findCommonElements(arr1, arr2) {
    // 使用 filter() 方法和 includes() 方法找出相同的元素
    const commonElements = arr1.filter(element => arr2.includes(element));
    return commonElements;
  }
  static findKeyByTitle(obj, titleValue) {
    for (let key in obj) {
      if (obj.hasOwnProperty(key)) {
        if (obj[key].title === titleValue) {
          return key;
        }
      }
    }
    return undefined; // 没有找到对应的 key
  }
  static getFuncForAI(funcName) {
    let args = {}
    switch (funcName) {
      case "setTitle":
        args.title = this.genArgument("string", "title that should be set for this card, pure text only")
        return this.genStructure(funcName, args,
          "this function is used to set title for a card"
        )
      case "addComment":
        args.comment = this.genArgument("string", "comment that should be added for this card, pure text only")
        return this.genStructure(funcName, args,
          "this function is used to add a comment for a card"
        )
      case "addTag":
        args.tag = this.genArgument("string", "tag that should be added for this card, single word only, no hyphen is allowed")
        return this.genStructure(funcName, args,
          "this function is used to add a tag for a card"
        )
      case "addChildNote":
        args.title = this.genArgument("string", "title for child note, optional")
        args.content = this.genArgument("string", "content for child note, optional")
        return this.genStructure(funcName, args,
          "this function is used to add a child note for a card"
        )
      case "clearExcerpt":
        return this.genStructure(funcName, args,
          "this function is used to clear the card excerpt, do not pass any argument"
        )
      case "setExcerpt":
        args.excerpt = this.genArgument("string", "excerpt text to be set")
        return this.genStructure(funcName, args,
          "this function is used to set the card excerpt text"
        )
      case "copyMarkdownLink":
        args.title = this.genArgument("string", "title for markdown link")
        return this.genStructure(funcName, args,
          "this function can copy the card link in mardown format, just specify the title for this link"
        )
      case "copyCardURL":
        return this.genStructure(funcName, args,
          "this function can directly copy the card url, do not pass any argument"
        )
      case "copyText":
        args.text = this.genArgument("string", "pure text that need to be copied")
        return this.genStructure(funcName, args,
          "this function can copy any pure text, but not card link"
        )
      case "close":
        return this.genStructure(funcName, args,
          "this function is used to end the coversation, do not pass any argument"
        )
      default:
        break;
    }
  }
  static getFuncByIndex(indices,isNote = true) {
    let func = ["setTitle","addComment","copyMarkdownLink","copyCardURL","copyText","close","addTag","addChildNote","clearExcerpt","setExcerpt"]
    let disableForSelection = [true,true,true,true,false,false,true,true,true,true]
    if (isNote) {
      let funcStructures = indices.map(ind=>this.getFuncForAI(func[ind]))
      return funcStructures
    }else{
      let funcStructures = indices.filter(ind=>!disableForSelection[ind]).map(ind=>this.getFuncForAI(func[ind]))
      return funcStructures
    }
  }

  static genArgument(type,description) {
    return{ "type": type, "description": description }
  }
  static genStructure(name,args,description) {
    let funcStructure = {
      "name":name,
      "description":description,
      "parameters": {
        "type": "object",
        "properties": args,
        "required": Object.keys(args),
      }
    }
    return {"type":"function","function":funcStructure}
  }

  static getFuncForAIForMinimax(funcName) {
    let args = {}
    switch (funcName) {
      case "setTitle":
        args.title = this.genArgument("string", "title that should be set for this card, pure text only")
        return this.genStructureForMinimax(funcName, args,
          "this function is used to set title for a card"
        )
      case "addComment":
        args.comment = this.genArgument("string", "comment that should be added for this card, pure text only")
        return this.genStructureForMinimax(funcName, args,
          "this function is used to add a comment for a card"
        )
      case "addTag":
        args.tag = this.genArgument("string", "tag that should be added for this card, single word only, no hyphen is allowed")
        return this.genStructureForMinimax(funcName, args,
          "this function is used to add a tag for a card"
        )
      case "addChildNote":
        args.title = this.genArgument("string", "title for child note, optional")
        args.content = this.genArgument("string", "content for child note, optional")
        return this.genStructureForMinimax(funcName, args,
          "this function is used to add a child note for a card"
        )
      case "clearExcerpt":
        return this.genStructureForMinimax(funcName, args,
          "this function is used to clear the card excerpt, do not pass any argument"
        )
      case "setExcerpt":
        args.excerpt = this.genArgument("string", "excerpt text to be set")
        return this.genStructureForMinimax(funcName, args,
          "this function is used to set the card excerpt text"
        )
      case "copyMarkdownLink":
        args.title = this.genArgument("string", "title for markdown link")
        return this.genStructureForMinimax(funcName, args,
          "this function can copy the card link in mardown format, just specify the title for this link"
        )
      case "copyCardURL":
        return this.genStructureForMinimax(funcName, args,
          "this function can directly copy the card url, do not pass any argument"
        )
      case "copyText":
        args.text = this.genArgument("string", "pure text that need to be copied")
        return this.genStructureForMinimax(funcName, args,
          "this function can copy any pure text, but not card link"
        )
      case "close":
        return this.genStructureForMinimax(funcName, args,
          "this function is used to end the coversation, do not pass any argument"
        )
      default:
        break;
    }
  }
  static getFuncByIndexForMinimax(indices,isNote = true) {
    let func = ["setTitle","addComment","copyMarkdownLink","copyCardURL","copyText","close","addTag","addChildNote","clearExcerpt","setExcerpt"]
    let disableForSelection = [true,true,true,true,false,false,true,true,true,true]
    if (isNote) {
      let funcStructures = indices.map(ind=>this.getFuncForAIForMinimax(func[ind]))
      return funcStructures
    }else{
      let funcStructures = indices.filter(ind=>!disableForSelection[ind]).map(ind=>this.getFuncForAI(func[ind]))
      return funcStructures
    }
  }
  static genStructureForMinimax(name,args,description) {
    let parameters = {
      "type": "object",
      "properties": args,
      "required": Object.keys(args),
    }
    let funcStructure = {
      "name":name,
      "description":description,
      "parameters": JSON.stringify(parameters)
    }
    return {"type":"function","function":funcStructure}
  }
  /**
   * 
   * @param {Array} resList 
   */
  static checkToolCalls(resList) {
    // MNUtil.copyJSON(resList)
    try {
      
    return resList.some(res=>{
        if (res && res.tool_calls) {
          return true
        }
        return false
      })
    } catch (error) {
      MNUtil.showHUD("Error in checkToolCalls: "+error)
      return false
    }
  }
  /**
   * 
   * @param {String} rawText 
   * @returns {{event:String,data:String}[]}
   */
  static parseEvents(rawText) {
    const lines = rawText.split('\n\n');
    // return lines
    const events = lines.map(line => {
      // 假设每行文本都是以 "event: " 开头，后面跟着事件类型，然后是数据
      const parts = line.split('\n');
      // const eventType = parts[0].split(': ')[1].trim();
      // const eventData = JSON.parse(parts.slice(1).join('\n'));
      let event = parts[0].split(':')[1]
      if (event) {
        let data = parts[1].slice(5)
        return {
          event: event.trim(),
          data: JSON.parse(data)
        };
      }else{
        return {
          event: ""
        };
      }
    });
    return events;
  }
  static getResList(originalText) {
    try {
      
      let res = originalText.split("data:")
    // copy(originalText)
      res.shift()
      if (res.length > 1) {
        res.pop()
      }
      if (JSON.parse(res[0]).choices.length === 0) {
        res.shift()
      }
    // MNUtil.copyJSON(res)
    let resList = res.map(r=>MNUtil.getValidJSON(r).choices[0].delta)
      return resList
    } catch (error) {
      
      // MNUtil.showHUD("Error in getResList: "+)
      // MNUtil.copy(error)
      return []
    }
  }
  static html(string) {
    return `<!doctype html>
  <html>
  <head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0,minimum-scale=1.0, maximum-scale=1.0, user-scalable=no">
    <title>Marked.js</title>
    <style>
  p {
    max-width: 385px;
    margin-top: 0;
  }
  pre {
    background-color: #343541;
    color: white;
    border-radius: 5px;
    max-width: 400px;
    overflow-x: scroll;
    margin-top: 0;
    margin-bottom: 5px;
  }
  img {
    max-width: 385px;
  }
.code-header {
  display: flex;
  justify-content: space-between;
  align-items: center;
  padding: 5px;
}
.code-header button {
  margin-left: auto; /* 这将推动按钮到容器的右边 */
}
pre code.hljs {
  display: block;
  overflow-x: auto;
  padding: 1em
}
code.hljs {
  padding: 3px 5px
}
/*!
  Theme: GitHub Dark
  Description: Dark theme as seen on github.com
  Author: github.com
  Maintainer: @Hirse
  Updated: 2021-05-15

  Outdated base version: https://github.com/primer/github-syntax-dark
  Current colors taken from GitHub's CSS
*/
.hljs {
  color: #c9d1d9;
  background: #000000
}
.hljs-doctag,
.hljs-keyword,
.hljs-meta .hljs-keyword,
.hljs-template-tag,
.hljs-template-variable,
.hljs-type,
.hljs-variable.language_ {
  /* prettylights-syntax-keyword */
  color: #ff7b72
}
.hljs-title,
.hljs-title.class_,
.hljs-title.class_.inherited__,
.hljs-title.function_ {
  /* prettylights-syntax-entity */
  color: #d2a8ff
}
.hljs-attr,
.hljs-attribute,
.hljs-literal,
.hljs-meta,
.hljs-number,
.hljs-operator,
.hljs-variable,
.hljs-selector-attr,
.hljs-selector-class,
.hljs-selector-id {
  /* prettylights-syntax-constant */
  color: #79c0ff
}
.hljs-regexp,
.hljs-string,
.hljs-meta .hljs-string {
  /* prettylights-syntax-string */
  color: #a5d6ff
}
.hljs-built_in,
.hljs-symbol {
  /* prettylights-syntax-variable */
  color: #ffa657
}
.hljs-comment,
.hljs-code,
.hljs-formula {
  /* prettylights-syntax-comment */
  color: #8b949e
}
.hljs-name,
.hljs-quote,
.hljs-selector-tag,
.hljs-selector-pseudo {
  /* prettylights-syntax-entity-tag */
  color: #7ee787
}
.hljs-subst {
  /* prettylights-syntax-storage-modifier-import */
  color: #c9d1d9
}
.hljs-section {
  /* prettylights-syntax-markup-heading */
  color: #1f6feb;
  font-weight: bold
}
.hljs-bullet {
  /* prettylights-syntax-markup-list */
  color: #f2cc60
}
.hljs-emphasis {
  /* prettylights-syntax-markup-italic */
  color: #c9d1d9;
  font-style: italic
}
.hljs-strong {
  /* prettylights-syntax-markup-bold */
  color: #c9d1d9;
  font-weight: bold
}
.hljs-addition {
  /* prettylights-syntax-markup-inserted */
  color: #aff5b4;
  background-color: #033a16
}
.hljs-deletion {
  /* prettylights-syntax-markup-deleted */
  color: #ffdcd7;
  background-color: #67060c
}
.hljs-char.escape_,
.hljs-link,
.hljs-params,
.hljs-property,
.hljs-punctuation,
.hljs-tag {
  /* purposely ignored */
}
  </style>
  </head>
  <body contenteditable="true">${string}<script>
  // window.scrollTo(0,document.body.scrollHeight);

      MathJax = {
          tex: {
              inlineMath: [ ['$','$'], ["\\(","\\)"] ]
          }
      };
      var originalBodyContent = ""
      var isBodyEdited = false;
      document.addEventListener('input', function () {
        isBodyEdited = true;
      });
      function getSelectedTextOrPageText() {
          var selectedText = window.getSelection().toString();
          if (selectedText && selectedText.trim() !== '') {
              return selectedText;
          } else if (isBodyEdited){
              var body = document.body;
              var pageText = body.innerText || body.textContent;
              return pageText.trim();
          } else {
            return ""
          }
      }
      function copyToClipboard(uuid) {
        // 获取代码块的文本内容
        var code = document.getElementById(uuid).innerText;
        // 创建临时的textarea来选择文本
        var dummy = document.createElement('textarea');
        // 将代码块的文本内容赋值到textarea
        dummy.value = code;
        document.body.appendChild(dummy);
        // 选择textarea中的内容
        dummy.select();
        // 执行复制命令
        document.execCommand('copy');
        // 移除临时创建的textarea
        document.body.removeChild(dummy);
      }
  </script>
  <script id="MathJax-script" async src="https://cdn.jsdelivr.net/npm/mathjax@3/es5/tex-chtml.js"></script>
  </body>
  </html>`
  }
  static sum(array) {
    let sum = 0
    for (let i = 0; i < array.length; i++) {
      sum = sum+array[i]
    }
    return sum
  }
  static getTranslation(gesture){
    let locationToMN = gesture.locationInView(MNUtil.studyView)
    if (!gesture.moveDate) {
      gesture.moveDate = 0
    }
    if ((Date.now() - gesture.moveDate) > 100) {
      let translation = gesture.translationInView(MNUtil.studyView)
      let location2Button = gesture.locationInView(gesture.view)
      // if (gesture.state !== 3 && Math.abs(translation.y)<20 && Math.abs(translation.x)<20) {
      if (gesture.state === 1) {
        gesture.location2Button = {x:location2Button.x-translation.x,y:location2Button.y-translation.y}
        // MNUtil.showHUD(JSON.stringify(gesture.location2Button))
      }
    }
    // MNUtil.showHUD(JSON.stringify(locationToMN))
    if (locationToMN.x <= 0) {
      locationToMN.x = 0
    }
    if (locationToMN.x > MNUtil.studyView.frame.width) {
      locationToMN.x = MNUtil.studyView.frame.width
    }
    gesture.moveDate = Date.now()
    // let location = {x:locationToMN.x - self.locationToButton.x-gesture.view.frame.x,y:locationToMN.y -self.locationToButton.y-gesture.view.frame.y}
    let location = {x:locationToMN.x - gesture.location2Button.x,y:locationToMN.y -gesture.location2Button.y}
    if (location.y <= 0) {
      location.y = 0
    }
    if (location.y>=MNUtil.studyView.frame.height-15) {
      location.y = MNUtil.studyView.frame.height-15
    }
    return location
  }
  static getNewLoc(gesture){
    let locationToMN = gesture.locationInView(MNUtil.studyView)
    if (!gesture.moveDate) {
      gesture.moveDate = 0
    }
    if ((Date.now() - gesture.moveDate) > 100) {
      let translation = gesture.translationInView(MNUtil.studyView)
      let locationToBrowser = gesture.locationInView(gesture.view.superview)
      // if (gesture.state !== 3 && Math.abs(translation.y)<20 && Math.abs(translation.x)<20) {
      if (gesture.state === 1) {
        gesture.locationToBrowser = {x:locationToBrowser.x-translation.x,y:locationToBrowser.y-translation.y}
        // MNUtil.showHUD(JSON.stringify(gesture.locationToBrowser))
      }
    }
    // MNUtil.showHUD(JSON.stringify(locationToMN))
    if (locationToMN.x <= 0) {
      locationToMN.x = 0
    }
    if (locationToMN.x > MNUtil.studyView.frame.width) {
      locationToMN.x = MNUtil.studyView.frame.width
    }
    gesture.moveDate = Date.now()
    // let location = {x:locationToMN.x - self.locationToButton.x-gesture.view.frame.x,y:locationToMN.y -self.locationToButton.y-gesture.view.frame.y}
    let location = {x:locationToMN.x - gesture.locationToBrowser.x,y:locationToMN.y -gesture.locationToBrowser.y}
    if (location.y <= 0) {
      location.y = 0
    }
    if (location.y>=MNUtil.studyView.frame.height-15) {
      location.y = MNUtil.studyView.frame.height-15
    }
    return location
  }
  /**
   * 
   * @param {string} fullPath 
   * @returns {string}
   */
  static getExtensionFolder(fullPath) {
      // 找到最后一个'/'的位置
      let lastSlashIndex = fullPath.lastIndexOf('/');
      // 从最后一个'/'之后截取字符串，得到文件名
      let fileName = fullPath.substring(0,lastSlashIndex);
      return fileName;
  }
  static checkMNUtilsFolder(fullPath){
    let extensionFolder = this.getExtensionFolder(fullPath)
    let folderExist = NSFileManager.defaultManager().fileExistsAtPath(extensionFolder+"/marginnote.extension.mnutils/main.js")
    if (!folderExist) {
      this.showHUD("MN ChatAI: Please install 'MN Utils' first!",5)
    }
    return folderExist
  }
  static checkCouldAsk(){
      if (this.notifyController.view.hidden) {
        //如果界面都隐藏了，那肯定可以启动
        this.notifyController.onChat = false
        return true
      }
        //如果请求还没结束，或者在聊天模式，则不允许发起对话
      if (this.notifyController.onChat) {
        MNUtil.showHUD("on chat mode")
        return false
      }
      if (this.notifyController.connection) {
        MNUtil.showHUD("on output")
        return false
      }
      return true
  }
  /**
   * 
   * @param {UIView} view 
   */
  static ensureView(view){
    if (!MNUtil.isDescendantOfStudyView(view)) {
      view.hidden = true
      MNUtil.studyView.addSubview(view)
      this.forceToRefresh = true
    }
  }
  static isNSNull(obj){
    return (obj === NSNull.new())
  }
  static genUserMessage(context,imageData){
    let compression = chatAIConfig.getConfig("imageCompression")
    if (imageData) {
      if (compression) {
        let compressedImageData = UIImage.imageWithData(imageData).jpegData(0.0)
        return {
          role: "user", 
          content: [
            {
              "type": "text",
              "text": context
            },
            {
              "type": "image_url",
              "image_url": {
                "url" : "data:image/jpeg;base64,"+compressedImageData.base64Encoding()
              }
            }
          ]
        }
      }
      return {
        role: "user", 
        content: [
          {
            "type": "text",
            "text": context
          },
          {
            "type": "image_url",
            "image_url": {
              "url" : "data:image/png;base64,"+imageData.base64Encoding()
            }
          }
        ]
      }
    }else{
      MNUtil.showHUD("No image found")
      return {role: "user", content: context}
    }
  }
  static addErrorLog(error,source,info){
    MNUtil.showHUD("MN ChatAI Error ("+source+"): "+error)
    if (info) {
      this.errorLog.push({error:error.toString(),source:source,info:info,time:(new Date(Date.now())).toString()})
    }else{
      this.errorLog.push({error:error.toString(),source:source,time:(new Date(Date.now())).toString()})
    }
    MNUtil.copyJSON(this.errorLog)
  }
  static checkLogo(){
    if (typeof MNUtil === 'undefined') return false
    if (typeof toolbarConfig !== 'undefined' && toolbarConfig.addonLogos && ("MNChatAI" in toolbarConfig.addonLogos) && !toolbarConfig.addonLogos["MNChatAI"]) {
        return false
    }
    return true
  }
  static extractJSONFromMarkdown(markdown) {
    // 使用正则表达式匹配被```JSON```包裹的内容
    const regex = /```JSON([\s\S]*?)```/g;
    const matches = regex.exec(markdown);
    
    // 提取匹配结果中的JSON字符串部分，并去掉多余的空格和换行符
    if (matches && matches[1]) {
        const jsonString = matches[1].trim();
        return jsonString;
    } else {
        return undefined;
    }
  }
  static async delay (seconds) {
    return new Promise((resolve, reject) => {
      NSTimer.scheduledTimerWithTimeInterval(seconds, false, function () {
        resolve()
      })
    })
  }
    /**
   * 
   * @param {string} title 
   * @param {string} subTitle 
   * @param {string[]} items 
   * @returns {Promise<{input:string,button:number}>}
   */
  static input(title,subTitle,items) {
    return new Promise((resolve, reject) => {
      UIAlertView.showWithTitleMessageStyleCancelButtonTitleOtherButtonTitlesTapBlock(
        title,subTitle,3,items[0],items.slice(1),
        (alert, buttonIndex) => {
          let res = {input:alert.textFieldAtIndex(0).text,button:buttonIndex}
          resolve(res)
        }
      )
    })
  }
}

class chatAIConfig {
  // 构造器方法，用于初始化新创建的对象
  constructor(name) {
    this.name = name;
  }
  // static defaultAction
  static isFirst = true
  static his = []
  static currentPrompt
  /** @type {Number[]} */
  static currentFunc
  /** @type {Number[]} */
  static currentAction
  /** @type {String} */
  static currentTitle
  /** @type {String} */
  static mainPath
  static action = []
  static defaultPrompts = {
      Translate:                      {title: "翻译",context:"请翻译下面这段话：{{context}}"},
      Keyword:                        {title: "关键词",context:"请为下面这段话提取关键词：{{context}}"},
      Title:                          {title: "标题",context:"请为下面这段话生成标题：{{context}}"}
  }
  static defaultConfig = {
    searchOrder: [2,1,3],
    autoAction: false,
    onSelection: true,
    onNote: true,
    onNewExcerpt: true,
    delay: 0,
    ignoreShortText: false,
    notifyLoc: 0,
    toolbar: true,
    model: 0,
    chatglmModel:0,
    promptNames: Object.keys(this.defaultPrompts),
    currentPrompt: Object.keys(this.defaultPrompts)[0],
    apikey: "",
    modelOnReAsk: -1,
    source: 'Built-in',
    url: "https://api.openai.com",
    openaiKey: "",
    tunnel:0,
    moonshotKey : "",
    moonshotModel : 0,
    customKey : "",
    customModel : "",
    customUrl : "",
    customModelIndex : 0,
    claudeKey : "",
    claudeUrl : "https://api.anthropic.com",
    claudeModel : 0,
    geminiKey : "",
    geminiUrl : 'https://generativelanguage.googleapis.com',
    geminiModel : 0,
    miniMaxKey: "",
    miniMaxUrl: "https://api.minimax.chat/v1/text/chatcompletion_v2",
    miniMaxModel: 0,
    miniMaxGroup:"1827907340364431485",
    deepseekKey:"",
    deepseekUrl:"https://api.deepseek.com/chat/completions",
    deepseekModel:0,
    qwenKey:"",
    qwenUrl:"https://dashscope.aliyuncs.com/compatible-mode/v1/chat/completions",
    qwenModel:0,
    dynamic:true,
    dynamicFunc : [],
    dynamicModel : "Default",
    dynamicAction: [],
    colorConfig: [1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],
    syncNoteId: "",
    simpleTexKey:"",
    autoExport:false,
    autoImport:false,
    lastSyncTime:0,
    modifiedTime:0,
    speech:false,
    speechSpeed:1.0,
    autoSpeech:false,
    speechVoice:"male-qn-qingse",
    speechKey:"eyJhbGciOiJSUzI1NiIsInR5cCI6IkpXVCJ9.eyJHcm91cE5hbWUiOiLmnpfnq4vpo54iLCJVc2VyTmFtZSI6Iuael-eri-mjniIsIkFjY291bnQiOiIiLCJTdWJqZWN0SUQiOiIxODI3OTA3MzQwMzY4NjI1Nzg5IiwiUGhvbmUiOiIxMzAxNTk5MjA4NSIsIkdyb3VwSUQiOiIxODI3OTA3MzQwMzY0NDMxNDg1IiwiUGFnZU5hbWUiOiIiLCJNYWlsIjoiIiwiQ3JlYXRlVGltZSI6IjIwMjQtMDktMDEgMTk6MzI6NTYiLCJpc3MiOiJtaW5pbWF4In0.Z7XNgcL2Y6qspWYJJMo0QinzWJp1C9-iTkeZk-2-ouqbkGvnmdh2xfIj-5jB-KMG4rqTjShExBifBlkUMMZgHeCVTmUyz6KNPKAzVvkfkMOjjbD7gElmFgO_0zHtL3pc8q6iAUGxrSmtBY1feIK9CpbQKzTI6xLYEU6d8keAv4zV14eey9L5UT5WwpNJ9vZG0367XuoOyGYnICfwIlSC5qg74NdtREq7t0vgh6NQ6BtWRWhdM-Q06rNPA5H5I8Km5RD8DmCm05aspkxMq_SsNyco9HrpEIKLSvBrLW7TVB4XG324fpUa-xdfvX_rFm7SRBy9sHbC7EtWhR6pUBSeEQ",
    imageCompression:true,
    syncSource:"MNNote",
    r2file:"",
    r2password:"",
    InfiFile:"",
    InfiPassword:"",
    webdavFile:"",
    webdavFolder:"",
    webdavUser:"",
    webdavPassword:"",
    subscriptionModel:0,
    autoTheme:false
  }
  static defaultDynamicPrompt = {
    "note":"list below is the structure of a card:\n{{card}}",
    "text":"{{context}}"
  }
  static default_usage = {
    usage: 0,
    limit: 100,
    day: 0
  }
  static init(){
    this.config = this.getByDefault('MNChatglm_config',this.defaultConfig)
    this.prompts = this.getByDefault('MNChatglm_prompts', this.defaultPrompts)
    // MNUtil.copyJSON(this.prompts)
    this.knowledge = this.getByDefault('MNChatglm_knowledge',"")
    this.keys = this.getByDefault('MNChatglm_builtInKeys', {})
    // this.keys = {}
    this.fileId = this.getByDefault("MNChatglm_fileId", {})
    this.default_usage = {limit:100,day:chatAIUtils.getToday(),usage:0}
    this.usage = this.getByDefault('MNChatglm_usage',this.default_usage)
    this.dynamicPrompt = this.getByDefault("MNChatglm_dynamicPrompt", this.defaultDynamicPrompt)
    this.currentPrompt = this.getConfig("currentPrompt")
    // MNUtil.copyJSON({prompts:this.prompts,config:this.config})
    let currentPrompt = this.prompts[this.currentPrompt]
    if (!currentPrompt) {
      let promptNames = Object.keys(this.prompts)
      this.currentPrompt = promptNames[0]
    }
    this.currentFunc = this.prompts[this.currentPrompt].func ?? []
    this.currentAction = this.prompts[this.currentPrompt].action ?? []
    this.currentModel = this.prompts[this.currentPrompt].model ?? "Default"
    this.currentTitle = this.prompts[this.currentPrompt].title
    this.defaultModel = this.getDefaultModel()
    this.highlightColor = UIColor.blendedColor(
      UIColor.colorWithHexString("#2c4d81").colorWithAlphaComponent(0.8),
      chatAIUtils.app.defaultTextColor,
      0.8
    );
    // MNUtil.copy(this.config.r2password)
  }
  static async getTunnels(){
    if (!Object.keys(this.keys).length) {
      MNUtil.showHUD("Refreshing built-in keys...")
      let keys = await chatAINetwork.fetchKeys()
      if (keys) {
        this.keys = keys 
        this.save('MNChatglm_builtInKeys')
        if (keys.message) {
          // copyJSON(keys)
          MNUtil.showHUD(keys.message)
        }else{
          MNUtil.showHUD("error")
          return ['Tunnel 1️⃣: ','Tunnel 2️⃣: ','Tunnel 3️⃣: ','Tunnel 4️⃣: ']

        }
        // chatAIUtils.chatController.refreshButton.setTitleForState(`Refresh (1️⃣: ${keys.key0.keys.length}, 2️⃣: ${keys.key1.keys.length}, 3️⃣: ${keys.key2.keys.length}, 4️⃣: ${keys.key3.keys.length})`,0)
      }else{
        MNUtil.showHUD("error")
        return ['Tunnel 1️⃣: ','Tunnel 2️⃣: ','Tunnel 3️⃣: ','Tunnel 4️⃣: ']
      }
    }
    return ['Tunnel 1️⃣: '+this.keys["key0"].model,'Tunnel 2️⃣: '+this.keys["key1"].model,'Tunnel 3️⃣: '+this.keys["key2"].model,'Tunnel 4️⃣: '+this.keys["key3"].model]
  
  }
  static copy(obj){
    return JSON.parse(JSON.stringify(obj))
  }
  static getConfig(key){
    if (this.config[key] !== undefined) {
      return this.config[key]
    }else{
      return this.defaultConfig[key]
    }
  }
  static getAllConfig(){
    let config = {config:this.config,prompts:this.prompts,knowledge:this.knowledge,dynamicPrompt:this.dynamicPrompt}
    return config
  }
  static deepEqual(obj1, obj2) {
    if (obj1 === obj2) return true;

    if (typeof obj1 !== 'object' || obj1 === null ||
        typeof obj2 !== 'object' || obj2 === null) {
        return false;
    }

    let keys1 = Object.keys(obj1);
    let keys2 = Object.keys(obj2);

    if (keys1.length !== keys2.length) return false;

    for (let key of keys1) {
        if (!keys2.includes(key)) {
            return false;
        }
        if (["modifiedTime","lastSyncTime"].includes(key)) {
          return true
        }
        if (!this.deepEqual(obj1[key], obj2[key])) {
          return false;
        }
    }
    return true;
  }
  static setSyncStatus(onSync,success = false){
  try {
    this.onSync = onSync
    if (chatAIUtils.chatController) {
      if (onSync) {
        MNButton.setColor(chatAIUtils.chatController.moveButton, "#e06c75",0.5)
      }else{
        if (success) {
          MNButton.setColor(chatAIUtils.chatController.moveButton, "#30d36c",0.5)
          MNUtil.delay(1).then(()=>{
            MNButton.setColor(chatAIUtils.chatController.moveButton, "#3a81fb",0.5)
          })
        }else{
          MNButton.setColor(chatAIUtils.chatController.moveButton, "#3a81fb",0.5)
        }
      }
    }
  } catch (error) {
    MNUtil.showHUD(error)
  }
  }
  static isSameConfigWithLocal(config,alert = true){
  try {
    // MNUtil.copyJSON({remote:config,local:this.getAllConfig()})
    let same = this.deepEqual(config, this.getAllConfig())
    if (same && alert) {
      MNUtil.showHUD("Same config")
    }
    return same
  } catch (error) {
    return false
  }
  }
  // static currentFunc(){
  //   let currentFunc = this.prompts[this.currentPrompt].func ?? []
  //   return currentFunc
  // }
  /**
   * 
   * @param {MbBookNote} note
   */
  static expandesConfig(note,config,orderedKeys=undefined,exclude=undefined) {
    let keys
    if (orderedKeys) {
      keys = orderedKeys
    }else{
      keys = Object.keys(config)
    }
    keys.forEach((key)=>{
      let subConfig = config[key]
      if (typeof subConfig === "object") {
        let child = chatAIUtils.createChildNote(note,key)
        this.expandesConfig(child, subConfig,undefined,exclude)
      }else{
        if (exclude) {
          if (key !== exclude) {
            chatAIUtils.createChildNote(note,key,config[key])
          }
        }else{
          chatAIUtils.createChildNote(note,key,config[key])
        }
      }
    })
  }
  static getDefaultActionKeys() {
    let actions = this.getActions()
    return Object.keys(actions)
  }
  static save(key,ignoreExport = false,synchronize = true) {
      switch (key) {
        case "MNChatglm_builtInKeys":
          NSUserDefaults.standardUserDefaults().setObjectForKey(this.keys,'MNChatglm_builtInKeys')
          break;
        case "MNChatglm_config":
          NSUserDefaults.standardUserDefaults().setObjectForKey(this.config,"MNChatglm_config")
          this.config.modifiedTime = Date.now()
          if (!ignoreExport && chatAIUtils.isSubscribed(false) && this.getConfig("autoExport")) {
            this.export(false)
          }
          break;
        case "MNChatglm_prompts":
          NSUserDefaults.standardUserDefaults().setObjectForKey(this.prompts,"MNChatglm_prompts")
          this.config.modifiedTime = Date.now()
          if (!ignoreExport && chatAIUtils.isSubscribed(false) && this.getConfig("autoExport")) {
            this.export(false)
          }
          break;
        case "MNChatglm_fileId":
          NSUserDefaults.standardUserDefaults().setObjectForKey(this.fileId,"MNChatglm_fileId")
          break;
        case "MNChatglm_knowledge":
          NSUserDefaults.standardUserDefaults().setObjectForKey(this.knowledge,"MNChatglm_knowledge")
          this.config.modifiedTime = Date.now()
          if (!ignoreExport && chatAIUtils.isSubscribed(false) && this.getConfig("autoExport")) {
            this.export(false)
          }
          break;
        case "MNChatglm_dynamicPrompt":
          NSUserDefaults.standardUserDefaults().setObjectForKey(this.dynamicPrompt,"MNChatglm_dynamicPrompt")
          this.config.modifiedTime = Date.now()
          if (!ignoreExport && chatAIUtils.isSubscribed(false) && this.getConfig("autoExport")) {
            this.export(false)
          }
          break;
        case "MNChatglm_usage":
          NSUserDefaults.standardUserDefaults().setObjectForKey(this.usage,"MNChatglm_usage")
          break;
        default:
          MNUtil.showHUD("Not supported")
          break;
      }
    if (synchronize) {
      NSUserDefaults.standardUserDefaults().synchronize()
    }
  }
  static getSyncSourceString(){
    switch (this.getConfig("syncSource")) {
      case "MNNote":
        return "MNNote"
      case "CFR2":
        return "Cloudflare R2"
      case "Infi":
        return "InfiniCloud"
      case "Webdav":
        return "Webdav"
      default:
        break;
    }
    return undefined
  }
   static async checkR2Password(){
    if (!this.getConfig("r2password")) {
      let res = await MNUtil.input("Passward for Config","设置云端配置文件加密密码",["Cancel","Confirm"])
      if (!res.button) {
        MNUtil.showHUD("User Cancel")
        return false
      }
      if (res.input && res.input.trim()) {
        this.config.r2password = res.input
        this.save("MNChatglm_config",true)
        return true
      }else{
        return false
      }
    }
    return true
  }
   static async checkInfiPassword(){
    if (!this.getConfig("InfiPassword")) {
      let res = await MNUtil.input("Passward for Config","设置云端配置文件加密密码",["Cancel","Confirm"])
      if (!res.button) {
        MNUtil.showHUD("User Cancel")
        return false
      }
      if (res.input && res.input.trim()) {
        this.config.InfiPassword = res.input
        this.save("MNChatglm_config",true)
        return true
      }else{
        return false
      }
    }
    return true
  }
  static async checkWebdavAccount(force = false){
    // MNUtil.copyJSON(this.config)
    let shouldSave = false
    if (force || !this.getConfig("webdavFolder")) {
      let res = await MNUtil.input("Folder for Webdav","输入webdav文件夹",["Cancel","Confirm"])
      if (!res.button) {
        MNUtil.showHUD("User Cancel")
        return false
      }
      if (res.input && res.input.trim()) {
        this.config.webdavFolder = res.input
      }else{
        return false
      }
      shouldSave = true
    }
    if (force || !this.getConfig("webdavUser")) {
      let res = await MNUtil.input("UserName for Webdav","输入webdav用户名",["Cancel","Confirm"])
      if (!res.button) {
        MNUtil.showHUD("User Cancel")
        return false
      }
      if (res.input && res.input.trim()) {
        this.config.webdavUser = res.input
      }else{
        return false
      }
      shouldSave = true
    }
    if (force || !this.getConfig("webdavPassword")) {
      let res = await MNUtil.input("Passward for Webdav","输入webdav密码",["Cancel","Confirm"])
      if (!res.button) {
        MNUtil.showHUD("User Cancel")
        return false
      }
      if (res.input && res.input.trim()) {
        this.config.webdavPassword = res.input
      }else{
        return false
      }
      shouldSave = true
    }
    if (shouldSave) {
      MNUtil.showHUD("Save Webdav account...")
      this.save("MNChatglm_config",true)
    }
    return true
  }
  static async export(alert = true){
    if (!chatAIUtils.checkSubscribe(true)) {
      return false
    }
    // MNUtil.copyJSON(this.getAllConfig())
    // return
    if (this.onSync) {
      MNUtil.showHUD("onSync")
      return
    }
    this.setSyncStatus(true)
    let syncSource = this.getConfig("syncSource")
    let remoteConfig
    switch (syncSource) {
      case "MNNote":
        let noteId = this.getConfig("syncNoteId")
        let lastSyncTime = this.getConfig("lastSyncTime") ?? 0
        let modifiedTime = this.getConfig("modifiedTime") ?? 0
        let latestTime = Math.max(lastSyncTime,modifiedTime)
        let focusNote = MNUtil.getNoteById(noteId)
        if (!focusNote) {
          focusNote = MNNote.getFocusNote()
        }
        let modifiedDate = Date.parse(focusNote.modifiedDate ?? focusNote.createDate)
        let confirm = false
        // MNUtil.copy(modifiedDate)
        // MNUtil.copyJSON(focusNote.modifiedDate)
        if (latestTime > modifiedDate) {
          // MNUtil.showHUD("should sync")
          confirm = true
        }else{
          // MNUtil.showHUD("should comfirm")
          if (alert) {
            confirm = await MNUtil.confirm("Newer config from note!\n卡片配置较新！","Overwrite?\n是否覆盖？")
          }
        }
        if (!confirm) {
          this.setSyncStatus(false)
          return false
        }
        this.config.lastSyncTime = Date.now()+5
        this.config.modifiedTime = this.config.lastSyncTime
        this.config.syncNoteId = focusNote.noteId
        chatAIUtils.chatController.configNoteIdInput.text = focusNote.noteId
        let config = this.getAllConfig()
        MNUtil.undoGrouping(()=>{
          focusNote.excerptText = "```JSON\n"+JSON.stringify(config,null,2)+"\n```"
          focusNote.noteTitle = "MN ChatAI Config"
          focusNote.note.excerptTextMarkdown = true
        })
        this.setSyncStatus(false,true)
        return true
      case "CFR2":
        this.setSyncStatus(true)
        if (!this.getConfig("r2file")) {
          let fileName = NSUUID.UUID().UUIDString()
          this.config.r2file = fileName
          chatAIUtils.chatController.configNoteIdInput.text = fileName
        }
        let hasPassword = await this.checkR2Password()
        if (!hasPassword) {
          this.setSyncStatus(false)
          return false
        }
        if (alert) {
          MNUtil.showHUD("Checking remote config...")
        }
        remoteConfig = await chatAIConfig.readEncryptedConfigFromR2(chatAIConfig.config.r2file, chatAIConfig.config.r2password)
        // MNUtil.copyJSON(remoteConfig)
        if (!remoteConfig || chatAIConfig.isSameConfigWithLocal(remoteConfig,alert)) {
          this.setSyncStatus(false)
          return false
        }
        if (remoteConfig && remoteConfig.config && remoteConfig.config.modifiedTime > this.config.modifiedTime) {
          if (alert) {
            let confirm = await MNUtil.confirm("Newer config from R2!\nR2配置较新！","Overwrite remote config?\n是否覆盖远程配置？")
            if (!confirm) {
              this.setSyncStatus(false)
              return false
            }
          }else{
            this.setSyncStatus(false)
            return false
          }
        }
        this.config.lastSyncTime = Date.now()+5
        this.config.modifiedTime = this.config.lastSyncTime
        if (alert) {
          MNUtil.showHUD("Uploading...")
        }
        await chatAIConfig.uploadConfigWithEncryptionFromR2(this.config.r2file, this.config.r2password, alert)
        // MNUtil.copyJSON(this.config)
        this.setSyncStatus(false,true)
        return true
      case "Infi":
        this.setSyncStatus(true)
        if (!this.getConfig("InfiFile")) {
          let fileName = NSUUID.UUID().UUIDString()
          this.config.InfiFile = fileName
          chatAIUtils.chatController.configNoteIdInput.text = fileName
        }
        let hasInfiPassword = await this.checkInfiPassword()
        if (!hasInfiPassword) {
          this.setSyncStatus(false)
          return false
        }
        if (alert) {
          MNUtil.showHUD("Checking remote config...")
        }
        remoteConfig = await chatAIConfig.readEncryptedConfigFromInfi(chatAIConfig.config.InfiFile, chatAIConfig.config.InfiPassword)
        // MNUtil.copyJSON(remoteConfig)
        if (!remoteConfig || chatAIConfig.isSameConfigWithLocal(remoteConfig,alert)) {
          this.setSyncStatus(false)
          return false
        }
        if (remoteConfig && remoteConfig.config && remoteConfig.config.modifiedTime > this.config.modifiedTime) {
          if (alert) {
            let confirm = await MNUtil.confirm("Newer config from InfiniCloud!\nInfiniCloud配置较新！","Overwrite remote config?\n是否覆盖远程配置？")
            if (!confirm) {
              this.setSyncStatus(false)
              return false
            }
          }else{
            this.setSyncStatus(false)
            return false
          }
        }
        this.config.lastSyncTime = Date.now()+5
        this.config.modifiedTime = this.config.lastSyncTime
        if (alert) {
          MNUtil.showHUD("Uploading...")
        }
        await chatAIConfig.uploadConfigWithEncryptionToInfi(this.config.InfiFile, this.config.InfiPassword, alert)
        // MNUtil.copyJSON(this.config)
        this.setSyncStatus(false,true)
        return true
      case "Webdav":
      try {
        
        this.setSyncStatus(true)
        let hasWebdavAccount = await this.checkWebdavAccount()
        if (!hasWebdavAccount) {
          this.setSyncStatus(false)
          return false
        }
        if (!this.getConfig("webdavFile")) {
          let fileName = NSUUID.UUID().UUIDString()
          this.config.webdavFile = fileName
          chatAIUtils.chatController.configNoteIdInput.text = fileName
        }
        if (alert) {
          MNUtil.showHUD("Checking remote config...")
        }
        let authorization = {
          user:this.getConfig("webdavUser"),
          password:this.getConfig("webdavPassword")
        }
        remoteConfig = await chatAIConfig.readConfigFromWebdav(chatAIConfig.config.webdavFile+".json",authorization)
        // MNUtil.copyJSON(remoteConfig)
        if (!remoteConfig || chatAIConfig.isSameConfigWithLocal(remoteConfig,alert)) {
          this.setSyncStatus(false)
          return false
        }
        if (!Object.keys(remoteConfig).length || ("statusCode" in remoteConfig && (remoteConfig.statusCode >= 400 && remoteConfig.statusCode != 404 ))) {
          // chatAIUtils.addErrorLog(error, "export",remoteConfig.statusCode)
          MNUtil.showHUD("Error when export.readConfigFromWebdav: "+remoteConfig.statusCode)
          // MNUtil.copyJSON(remoteConfig)
          this.setSyncStatus(false)
          return false
        }
        if (remoteConfig && remoteConfig.config && remoteConfig.config.modifiedTime > this.config.modifiedTime) {
          if (alert) {
            let confirm = await MNUtil.confirm("Newer config from Webdav!\nWebdav配置较新！","Overwrite remote config?\n是否覆盖远程配置？")
            if (!confirm) {
              this.setSyncStatus(false)
              return false
            }
          }else{
            this.setSyncStatus(false)
            return false
          }
        }

        this.config.lastSyncTime = Date.now()+5
        this.config.modifiedTime = this.config.lastSyncTime
        if (alert) {
          MNUtil.showHUD("Uploading...")
        }
        let res = await chatAIConfig.uploadConfigToWebdav(this.config.webdavFile+".json", authorization)
        if (typeof res === "object" && "statusCode" in res && res.statusCode >= 400) {
          MNUtil.showHUD("Error when export.uploadConfigToWebdav: "+res.statusCode)
          MNUtil.copyJSON(res)
          this.setSyncStatus(false)
          return false
        }
        // MNUtil.copyJSON(this.config)
        this.setSyncStatus(false)
        return true
      } catch (error) {
        MNUtil.showHUD(error)
        this.setSyncStatus(false,true)
        return true
      }
      break;
    }
    // chatAIConfig.his.push("export")
    // MNUtil.showHUD("his: "+chatAIConfig.his.length)
    // MNUtil.copyJSON(chatAIConfig.his)
    // MNUtil.showHUD("export")


    // MNUtil.copyJSON(config)
  }
  static async import(alert = true){
    // chatAIConfig.his.push("import")
    // MNUtil.showHUD("his: "+chatAIConfig.his.length)
    // MNUtil.copyJSON(chatAIConfig.his)
    if (!chatAIUtils.checkSubscribe(true)) {
      return false
    }
    if (this.onSync) {
      if (alert) {
        MNUtil.showHUD("onSync")
      }
      return false
    }
    let syncSource = this.getConfig("syncSource")
    let config
    let lastSyncTime
    let modifiedTime
    let latestTime
    let modifiedDate
    this.setSyncStatus(true)
    switch (syncSource) {
      case "MNNote":
      let noteId = this.config.syncNoteId
      lastSyncTime = this.config.lastSyncTime ?? 0
      modifiedTime = this.config.modifiedTime ?? 0
      latestTime = Math.max(lastSyncTime,modifiedTime)
      let focusNote = MNUtil.getNoteById(noteId)
      if (!focusNote) {
        focusNote = chatAIUtils.getFocusNote()
      }
      chatAIUtils.chatController.configNoteIdInput.text = focusNote.noteId
      if (focusNote.noteTitle !== "MN ChatAI Config") {
        MNUtil.showHUD("Invalid note title!")
        this.setSyncStatus(false)
        return false
      }
      modifiedDate = Date.parse(focusNote.modifiedDate)
      let confirm = false
      // MNUtil.copy(modifiedDate)
      // MNUtil.copyJSON(focusNote.modifiedDate)
      if (latestTime < modifiedDate) {
        // MNUtil.showHUD("should sync")
        confirm = true
      }else{
        // MNUtil.showHUD("should comfirm")
        if (alert) {
          confirm = await MNUtil.confirm("Older config from note!\n卡片配置较旧！","Overwrite?\n是否覆盖？")
        }
      }
      if (!confirm) {
        this.setSyncStatus(false)
        return false
      }
      let contentToParse = focusNote.excerptText
      if (/```JSON/.test(contentToParse)) {
        contentToParse = chatAIUtils.extractJSONFromMarkdown(contentToParse)
      }
      config = JSON.parse(contentToParse)
      break;
    case "CFR2":
      if (!chatAIConfig.getConfig("r2file")) {
        MNUtil.showHUD("No Config file")
        this.setSyncStatus(false)
        return false
      }

      let hasPassword = await this.checkR2Password()
      if (!hasPassword) {
        this.setSyncStatus(false)
        return false
      }
      try {
      if (alert) {
        MNUtil.showHUD("Downloading...")
      }
        // let authorization = {
        //   user:this.getConfig("webdavUser"),
        //   password:this.getConfig("webdavPassword")
        // }
      // let res = await chatAIConfig.readConfigFromWebdav(chatAIConfig.config.webdavFile+".json",authorization)
      config = await chatAIConfig.readEncryptedConfigFromR2(chatAIConfig.config.r2file, chatAIConfig.config.r2password)
      if (!config || chatAIConfig.isSameConfigWithLocal(config,alert)) {
        this.setSyncStatus(false)
        return false
      }
      // config = await chatAIConfig.readEncryptedConfigFromR2("https://dav.jianguoyun.com/dav/code/619F5AB4-196D-4960-802B-19CFC8F080E8.json", chatAIConfig.config.r2password)
      // return false
      lastSyncTime = this.config.lastSyncTime ?? 0
      modifiedTime = this.config.modifiedTime ?? 0
      latestTime = Math.max(lastSyncTime,modifiedTime)
      // MNUtil.copyJSON(config)
      modifiedDate = Math.max(config.config["lastSyncTime"],config.config["modifiedTime"])
      let confirm = true
      if (latestTime > modifiedDate) {
        if (alert) {
          confirm = await MNUtil.confirm("Older config from R2!\nR2配置较旧！","Overwrite?\n是否覆盖？")
        }
      }
      if (!confirm) {
        this.setSyncStatus(false)
        return false
      }
      } catch (error) {
        MNUtil.showHUD(error)
        this.setSyncStatus(false)
        return false
      }
      break;
    case "Infi":
      if (!chatAIConfig.getConfig("InfiFile")) {
        MNUtil.showHUD("No Config file")
        this.setSyncStatus(false)
        return false
      }

      let hasInfiPassword = await this.checkInfiPassword()
      if (!hasInfiPassword) {
        this.setSyncStatus(false)
        return false
      }
      try {
      if (alert) {
        MNUtil.showHUD("Downloading...")
      }
        // let authorization = {
        //   user:this.getConfig("webdavUser"),
        //   password:this.getConfig("webdavPassword")
        // }
      // let res = await chatAIConfig.readConfigFromWebdav(chatAIConfig.config.webdavFile+".json",authorization)
      config = await chatAIConfig.readEncryptedConfigFromInfi(chatAIConfig.config.InfiFile, chatAIConfig.config.InfiPassword)
      if (!config || chatAIConfig.isSameConfigWithLocal(config,alert)) {
        this.setSyncStatus(false)
        return false
      }
      // config = await chatAIConfig.readEncryptedConfigFromR2("https://dav.jianguoyun.com/dav/code/619F5AB4-196D-4960-802B-19CFC8F080E8.json", chatAIConfig.config.r2password)
      // return false
      lastSyncTime = this.config.lastSyncTime ?? 0
      modifiedTime = this.config.modifiedTime ?? 0
      latestTime = Math.max(lastSyncTime,modifiedTime)
      // MNUtil.copyJSON(config)
      modifiedDate = Math.max(config.config["lastSyncTime"],config.config["modifiedTime"])
      let confirm = true
      if (latestTime > modifiedDate) {
        if (alert) {
          confirm = await MNUtil.confirm("Older config from InfiniCloud!\nInfiniCloud配置较旧！","Overwrite local config?\n是否覆盖本地配置？")
        }
      }
      if (!confirm) {
        this.setSyncStatus(false)
        return false
      }
      } catch (error) {
        MNUtil.showHUD(error)
        this.setSyncStatus(false)
        return false
      }
      break;
    case "Webdav":
      if (!chatAIConfig.getConfig("webdavFile")) {
        MNUtil.showHUD("No Config file")
        this.setSyncStatus(false)
        return false
      }
      let hasAccount = await this.checkWebdavAccount()
      if (!hasAccount) {
        this.setSyncStatus(false)
        return false
      }
      try {
      if (alert) {
        MNUtil.showHUD("Downloading...")
      }
      let authorization = {
        user:this.getConfig("webdavUser"),
        password:this.getConfig("webdavPassword")
      }
      config = await chatAIConfig.readConfigFromWebdav(chatAIConfig.config.webdavFile+".json",authorization)
      if (!config || chatAIConfig.isSameConfigWithLocal(config,alert)) {
        this.setSyncStatus(false)
        return false
      }
      // MNUtil.copyJSON(config)
      lastSyncTime = this.config.lastSyncTime ?? 0
      modifiedTime = this.config.modifiedTime ?? 0
      latestTime = Math.max(lastSyncTime,modifiedTime)
      if (!Object.keys(config).length || ("statusCode" in config && config.statusCode >= 400)) {
        MNUtil.showHUD("Error when import: "+config.statusCode)
        MNUtil.copyJSON(config)
        this.setSyncStatus(false)
        return false
      }
      // MNUtil.copyJSON(config)
      modifiedDate = Math.max(config.config["lastSyncTime"],config.config["modifiedTime"])
      let confirm = true
      if (latestTime > modifiedDate) {
        if (alert) {
          confirm = await MNUtil.confirm("Older config from Webdav!\nWebdav配置较旧！","Overwrite local config?\n是否覆盖本地配置？")
        }
      }
      if (!confirm) {
        this.setSyncStatus(false)
        return false
      }
      } catch (error) {
        MNUtil.showHUD(error)
        this.setSyncStatus(false)
        return false
      }
      break;
    }
    if ("config" in config && "prompts" in config && "knowledge" in config && "dynamicPrompt" in config) {
      this.config = config.config
      this.config.lastSyncTime = Date.now()
      // this.config.modifiedTime = modifiedDate
      // let prompts = {}
      // this.config.promptNames.map(promptName=>{
      //   prompts[promptName] = config[promptName]
      // })
      this.prompts = config.prompts
      // MNUtil.copyJSON(prompts)
      this.knowledge = config.knowledge
      this.dynamicPrompt = config.dynamicPrompt
      this.currentPrompt = this.config.currentPrompt
      if (chatAIUtils.chatController) {
        chatAIUtils.chatController.lastLength = this.config.promptNames.length
        chatAIUtils.chatController.refreshView("autoActionView")
        chatAIUtils.chatController.refreshView("syncView")
        chatAIUtils.chatController.refreshView("configView")
        chatAIUtils.chatController.refreshView("modelView")
        chatAIUtils.chatController.refreshView("advanceView")
      }
      this.save("MNChatglm_dynamicPrompt",true)
      this.save("MNChatglm_knowledge",true)
      this.save("MNChatglm_prompts",true)
      this.save("MNChatglm_config",true)
      this.setSyncStatus(false,true)
      if (alert) {
        MNUtil.showHUD("Import success!")
      }
      return true
    }else{
      MNUtil.showHUD("Invalid config in note!")
      this.setSyncStatus(false)
      return false
    }
  }
 static async syncForMNNote(){
 try {

    if (!chatAIUtils.checkSubscribe(true)) {
      return false
    }
    let noteId = this.config.syncNoteId
    let lastSyncTime = this.config.lastSyncTime ?? 0
    let modifiedTime = this.config.modifiedTime ?? 0
    let latestTime = Math.max(lastSyncTime,modifiedTime)
    let focusNote = MNUtil.getNoteById(noteId)
    if (!focusNote) {
      focusNote = chatAIUtils.getFocusNote()
    }
    let isVaildNoteConfig = false
    let noteConfig
    let modifiedDate = Date.parse(focusNote.modifiedDate ?? focusNote.createDate)
    if (focusNote.noteTitle === "MN ChatAI Config") {
      let contentToParse = focusNote.excerptText
      if (/```JSON/.test(contentToParse)) {
        contentToParse = chatAIUtils.extractJSONFromMarkdown(contentToParse)
      }
      noteConfig = JSON.parse(contentToParse)
      isVaildNoteConfig = ("config" in noteConfig && "prompts" in noteConfig && "knowledge" in noteConfig && "dynamicPrompt" in noteConfig)
      
    }
    if (latestTime < modifiedDate && isVaildNoteConfig) {
      this.setSyncStatus(true)
      // MNUtil.showHUD("should import")
      this.config = noteConfig.config
      this.config.lastSyncTime = Date.now()
      this.prompts = noteConfig.prompts
      this.knowledge = noteConfig.knowledge
      this.dynamicPrompt = noteConfig.dynamicPrompt
      chatAIUtils.chatController.refreshView("autoActionView")
      chatAIUtils.chatController.refreshView("syncView")
      chatAIUtils.chatController.refreshView("configView")
      chatAIUtils.chatController.refreshView("modelView")
      chatAIUtils.chatController.refreshView("advanceView")
      this.save("MNChatglm_dynamicPrompt",true)
      this.save("MNChatglm_knowledge",true)
      this.save("MNChatglm_prompts",true)
      this.save("MNChatglm_config",true)
      MNUtil.showHUD("Sync Success (import)!")
      this.setSyncStatus(false,true)
      return true
    }else{
      this.setSyncStatus(true)
      // MNUtil.showHUD("should export")
      this.config.lastSyncTime = Date.now()+5
      this.config.syncNoteId = focusNote.noteId
      let config = {config:this.config,prompts:this.prompts,knowledge:this.knowledge,dynamicPrompt:this.dynamicPrompt}
      MNUtil.undoGrouping(()=>{
        focusNote.excerptText = "```JSON\n"+JSON.stringify(config,null,2)+"\n```"
        focusNote.noteTitle = "MN ChatAI Config"
      })
      chatAIUtils.chatController.refreshView("syncView")
      MNUtil.showHUD("Sync Success (export)!")
      this.setSyncStatus(false,true)
      return true
    }
 } catch (error) {
  MNUtil.showHUD(error)
 }
 }
 static async syncForCFR2(){
 try {

    if (!chatAIUtils.checkSubscribe(true)) {
      return false
    }
    this.setSyncStatus(true)
    let lastSyncTime = this.config.lastSyncTime ?? 0
    let modifiedTime = this.config.modifiedTime ?? 0
    let latestTime = Math.max(lastSyncTime,modifiedTime)
    let isVaildNoteConfig = false
    let modifiedDate = 0
    let R2Config
    if (this.getConfig("r2file")) {
      let hasPassword = await this.checkR2Password()
      if (!hasPassword) {
        this.setSyncStatus(false)
        return false
      }
      MNUtil.showHUD("Checking remote config...")
      R2Config = await this.readEncryptedConfigFromR2(this.config.r2file, chatAIConfig.config.r2password)
      if (!R2Config ||chatAIConfig.isSameConfigWithLocal(R2Config)) {
        this.setSyncStatus(false)
        return false
      }
      modifiedDate = Math.max(R2Config.config["lastSyncTime"],R2Config.config["modifiedTime"])
      isVaildNoteConfig = ("config" in R2Config && "prompts" in R2Config && "knowledge" in R2Config && "dynamicPrompt" in R2Config)
    }
    if (R2Config && R2Config.config && latestTime < modifiedDate && isVaildNoteConfig) {
      // MNUtil.showHUD("should import")
      this.config = R2Config.config
      this.config.lastSyncTime = Date.now()
      this.prompts = R2Config.prompts
      this.knowledge = R2Config.knowledge
      this.dynamicPrompt = R2Config.dynamicPrompt
      chatAIUtils.chatController.refreshView("autoActionView")
      chatAIUtils.chatController.refreshView("syncView")
      chatAIUtils.chatController.refreshView("configView")
      chatAIUtils.chatController.refreshView("modelView")
      chatAIUtils.chatController.refreshView("advanceView")
      this.save("MNChatglm_dynamicPrompt",true)
      this.save("MNChatglm_knowledge",true)
      this.save("MNChatglm_prompts",true)
      this.save("MNChatglm_config",true)
      MNUtil.showHUD("Sync Success (import)!")
      this.setSyncStatus(false,true)
      return true
    }else{
      if (!this.getConfig("r2file")) {
        let fileName = NSUUID.UUID().UUIDString()
        this.config.r2file = fileName
        chatAIUtils.chatController.configNoteIdInput.text = fileName
      }

      this.config.lastSyncTime = Date.now()+5
      this.config.modifiedTime = this.config.lastSyncTime
      
      MNUtil.showHUD("Uploading...")
      await this.uploadConfigWithEncryptionFromR2(this.config.r2file, this.config.r2password)
      // MNUtil.copyJSON(this.config)
      MNUtil.showHUD("Sync Success (export)!")
      this.setSyncStatus(false,true)
      return true
    }
 } catch (error) {
  this.setSyncStatus(false)
  MNUtil.showHUD(error)
 }
 }
 static async syncForInfi(){
 try {

    if (!chatAIUtils.checkSubscribe(true)) {
      return false
    }
    this.setSyncStatus(true)
    let lastSyncTime = this.config.lastSyncTime ?? 0
    let modifiedTime = this.config.modifiedTime ?? 0
    let latestTime = Math.max(lastSyncTime,modifiedTime)
    let isVaildNoteConfig = false
    let modifiedDate = 0
    let InfiConfig
    if (this.getConfig("InfiFile")) {
      let hasPassword = await this.checkInfiPassword()
      if (!hasPassword) {
        this.setSyncStatus(false)
        return false
      }
      MNUtil.showHUD("Checking remote config...")
      InfiConfig = await this.readEncryptedConfigFromInfi(this.config.InfiFile, chatAIConfig.config.InfiPassword)
      if (!InfiConfig ||chatAIConfig.isSameConfigWithLocal(InfiConfig)) {
        this.setSyncStatus(false)
        return false
      }
      modifiedDate = Math.max(InfiConfig.config["lastSyncTime"],InfiConfig.config["modifiedTime"])
      isVaildNoteConfig = ("config" in InfiConfig && "prompts" in InfiConfig && "knowledge" in InfiConfig && "dynamicPrompt" in InfiConfig)
    }
    if (InfiConfig && InfiConfig.config && latestTime < modifiedDate && isVaildNoteConfig) {
      // MNUtil.showHUD("should import")
      this.config = InfiConfig.config
      this.config.lastSyncTime = Date.now()
      this.prompts = InfiConfig.prompts
      this.knowledge = InfiConfig.knowledge
      this.dynamicPrompt = InfiConfig.dynamicPrompt
      chatAIUtils.chatController.refreshView("autoActionView")
      chatAIUtils.chatController.refreshView("syncView")
      chatAIUtils.chatController.refreshView("configView")
      chatAIUtils.chatController.refreshView("modelView")
      chatAIUtils.chatController.refreshView("advanceView")
      this.save("MNChatglm_dynamicPrompt",true)
      this.save("MNChatglm_knowledge",true)
      this.save("MNChatglm_prompts",true)
      this.save("MNChatglm_config",true)
      MNUtil.showHUD("Sync Success (import)!")
      this.setSyncStatus(false,true)
      return true
    }else{
      if (!this.getConfig("InfiFile")) {
        let fileName = NSUUID.UUID().UUIDString()
        this.config.InfiFile = fileName
        chatAIUtils.chatController.configNoteIdInput.text = fileName
      }

      this.config.lastSyncTime = Date.now()+5
      this.config.modifiedTime = this.config.lastSyncTime
      
      MNUtil.showHUD("Uploading...")
      await this.uploadConfigWithEncryptionToInfi(this.config.InfiFile, this.config.InfiPassword)
      // MNUtil.copyJSON(this.config)
      MNUtil.showHUD("Sync Success (export)!")
      this.setSyncStatus(false,true)
      return true
    }
 } catch (error) {
  this.setSyncStatus(false)
  MNUtil.showHUD(error)
 }
 }
  static async syncForWebdav(){
 try {

    if (!chatAIUtils.checkSubscribe(true)) {
      return false
    }
    this.setSyncStatus(true)
    let lastSyncTime = this.config.lastSyncTime ?? 0
    let modifiedTime = this.config.modifiedTime ?? 0
    let latestTime = Math.max(lastSyncTime,modifiedTime)
    let isVaildNoteConfig = false
    let modifiedDate = 0
    let remoteConfig
    let authorization
    if (this.getConfig("webdavFile")) {
      let hasAccount = await this.checkWebdavAccount()
      if (!hasAccount) {
        this.setSyncStatus(false)
        return false
      }
      MNUtil.showHUD("Checking remote config...")
      authorization = {
        user:this.getConfig("webdavUser"),
        password:this.getConfig("webdavPassword")
      }
      remoteConfig = await chatAIConfig.readConfigFromWebdav(chatAIConfig.config.webdavFile+".json",authorization)
      if (!remoteConfig || this.isSameConfigWithLocal(remoteConfig)) {
        this.setSyncStatus(false)
        return false
      }
      if (!Object.keys(remoteConfig).length || ("statusCode" in remoteConfig && remoteConfig.statusCode >= 400)) {
        MNUtil.showHUD("Error when Sync.readConfigFromWebdav: "+remoteConfig.statusCode)
        MNUtil.copyJSON(remoteConfig)
        this.setSyncStatus(false)
        return false
      }
      if (remoteConfig) {
        modifiedDate = Math.max(remoteConfig.config["lastSyncTime"],remoteConfig.config["modifiedTime"])
        isVaildNoteConfig = ("config" in remoteConfig && "prompts" in remoteConfig && "knowledge" in remoteConfig && "dynamicPrompt" in remoteConfig)
      }
    }
    if (remoteConfig && remoteConfig.config && latestTime < modifiedDate && isVaildNoteConfig) {
      // MNUtil.showHUD("should import")
      this.config = remoteConfig.config
      this.config.lastSyncTime = Date.now()
      this.prompts = remoteConfig.prompts
      this.knowledge = remoteConfig.knowledge
      this.dynamicPrompt = remoteConfig.dynamicPrompt
      chatAIUtils.chatController.refreshView("autoActionView")
      chatAIUtils.chatController.refreshView("syncView")
      chatAIUtils.chatController.refreshView("configView")
      chatAIUtils.chatController.refreshView("modelView")
      chatAIUtils.chatController.refreshView("advanceView")
      this.save("MNChatglm_dynamicPrompt",true)
      this.save("MNChatglm_knowledge",true)
      this.save("MNChatglm_prompts",true)
      this.save("MNChatglm_config",true)
      MNUtil.showHUD("Sync Success (import)!")
      this.setSyncStatus(false,true)
      return true
    }else{
      if (!this.getConfig("webdavFile")) {
        let fileName = NSUUID.UUID().UUIDString()
        this.config.webdavFile = fileName
        chatAIUtils.chatController.configNoteIdInput.text = fileName
      }

      this.config.lastSyncTime = Date.now()+5
      this.config.modifiedTime = this.config.lastSyncTime
      
      MNUtil.showHUD("Uploading...")
      let res = await this.uploadConfigToWebdav(this.config.webdavFile+".json", authorization)
      if (typeof res === "object" && "statusCode" in res && res.statusCode >= 400) {
        MNUtil.showHUD("Error when export.uploadConfigToWebdav: "+res.statusCode)
        MNUtil.copyJSON(res)
        this.setSyncStatus(false)
        return false
      }
      // MNUtil.copyJSON(this.config)
      MNUtil.showHUD("Sync Success (export)!")
      this.setSyncStatus(false,true)
      return true
    }
 } catch (error) {
  MNUtil.showHUD(error)
  this.setSyncStatus(false)
 }
 }
  static get(key) {
    return NSUserDefaults.standardUserDefaults().objectForKey(key)
  }

  static getByDefault(key,defaultValue) {
    let value = NSUserDefaults.standardUserDefaults().objectForKey(key)
    if (value === undefined) {
      NSUserDefaults.standardUserDefaults().setObjectForKey(defaultValue,key)
      return defaultValue
    }
    return value
  }

  static remove(key) {
    NSUserDefaults.standardUserDefaults().removeObjectForKey(key)
  }
  static reset(){
    // const defaultPrompts = this.defaultPrompts
    this.prompts = this.copy(this.defaultPrompts)
    this.config.promptNames = Object.keys(this.prompts)
    this.config.dynamic = false
    this.dynamicPrompt = this.defaultDynamicPrompt
    this.setCurrentPrompt(this.config.promptNames[0])
    this.save('MNChatglm_config')
    this.save('MNChatglm_prompts')
    this.save("MNChatglm_dynamicPrompt")
  }
  static setCurrentPrompt(prompt){
    this.currentPrompt = prompt//是promptKey
    this.config.currentPrompt = prompt
    this.currentFunc = this.prompts[this.currentPrompt].func ?? []
    this.currentAction = this.prompts[this.currentPrompt].action ?? []
    this.currentModel = this.prompts[this.currentPrompt].model ?? "Default"
    this.currentTitle = this.prompts[this.currentPrompt].title
    NSUserDefaults.standardUserDefaults().setObjectForKey(this.config,"MNChatglm_config")
  }
  static getUsage() {
    let today = chatAIUtils.getToday()
    this.usage.limit = 100
    if (today !== this.usage.day) {
      this.usage.usage = 0
      this.usage.day = today
    }
    return this.usage
  }
  static modelNames(source){
    let models
    let additionalModels = []
    switch (source) {
      case "ChatGLM":
        return ["glm-4-plus","glm-4-0520","glm-4","glm-4v-plus","glm-4v","glm-4-air","glm-4-airx","glm-4-long","glm-4-flash"]
      case "Gemini":
        return ["gemini-pro","gemini-1.5-pro-latest","gemini-1.5-flash-latest"]
      case "ChatGPT":
        models = ["gpt-4o-mini","gpt-4o","gpt-4-turbo","gpt-4","gpt-3.5-turbo","gpt-3.5-turbo-0125"]
        if (this.config.customModel.trim()) {
          additionalModels = this.config.customModel.split(",").map(model=>model.trim()).filter(model=>!models.includes(model))
        }
        return models.concat(additionalModels)
      case "Subscription":
        models = ["gpt-4o-mini","gpt-4o","gpt-4-turbo"]
        if (this.config.customModel.trim()) {
          additionalModels = this.config.customModel.split(",").map(model=>model.trim()).filter(model=>!models.includes(model))
        }
        return models.concat(additionalModels)
      case "KimiChat":
        return ["moonshot-v1-8k","moonshot-v1-32k","moonshot-v1-128k"]
      case "Claude":
        return ["claude-3-haiku-20240307","claude-3-sonnet-20240229","claude-3-opus-20240229","claude-3-5-sonnet-20240620"]
      case "Minimax":
        return ["abab6.5-chat","abab6.5s-chat","abab6.5t-chat","abab6.5g-chat","abab5.5-chat","abab5.5s-chat"]
      case "Deepseek":
        return ["deepseek-chat","deepseek-coder"]
      case "Qwen":
        return ["qwen-long","qwen-turbo","qwen-plus","qwen-max","qwen-max-0428","qwen-max-0403","qwen-max-0107","qwen-max-longcontext"]
      // case "01.AI":
      //   return
      case "Custom":
        return this.config.customModel.split(",").map(model=>model.trim())
      default:
        break;
    }
  }
  static saveApiKey(apikey,url){
    MNUtil.showHUD("Save APIKey for "+this.config.source)
    switch (this.config.source) {
      case "ChatGLM":
        this.config.apikey = apikey
        break;
      case "Claude":
        this.config.claudeKey = apikey
        break;
      case "Gemini":
        this.config.geminiKey = apikey
        break;
      case "ChatGPT":
        this.config.openaiKey = apikey
        if (url) {
          this.config.url = url
        }
        break;
      case "KimiChat":
        this.config.moonshotKey = apikey
        break;
      case "Minimax":
        this.config.miniMaxKey = apikey
        break
      case "Deepseek":
        this.config.deepseekKey = apikey
        break
      case "Qwen":
        this.config.qwenKey = apikey
        break
      case "Custom":
        this.config.customKey = apikey
        if (url) {
          this.config.customUrl = url
        }
        break
      default:
        break;
    }
    NSUserDefaults.standardUserDefaults().setObjectForKey(this.config,"MNChatglm_config")
    if (chatAIUtils.isSubscribed(false) && this.getConfig("autoExport")) {
      this.export(false)
    }
  }
  static getDefaultModel(source = this.config.source){
    let models = this.modelNames(source)
    switch (source) {
      case "ChatGLM":
        return models[this.getConfig("chatglmModel")]
      case "Claude":
        return models[this.getConfig("claudeModel")]
      case "Gemini":
        return models[this.getConfig("geminiModel")]
      case "ChatGPT":
        return models[this.getConfig("model")]
      case "KimiChat":
        return models[this.getConfig("moonshotModel")]
      case "Minimax":
        return models[this.getConfig("miniMaxModel")]
      case "Deepseek":
        return models[this.getConfig("deepseekModel")]
      case "Qwen":
        return models[this.getConfig("qwenModel")]
      case "Custom":
        return models[this.getConfig("customModelIndex")]
      case "Subscription":
        return models[this.getConfig("subscriptionModel")]
      default:
        break;
    }
  }
  static getConfigFromSource(source = this.config.source){
    let models = this.modelNames(source)
    let config = {source:source}
    config.model = this.getDefaultModel(source)
    switch (source) {
      case "ChatGLM":
        config.key = this.getConfig("apikey")
        config.url = "https://open.bigmodel.cn/api/paas/v4/chat/completions"
        // config.model = models[this.getConfig("chatglmModel")]
        return config
      case "Claude":
        config.key = this.getConfig("claudeKey")
        config.url = this.getConfig("claudeUrl")+"/v1/messages"
        // config.model = models[this.getConfig("claudeModel")]
        return config
      case "Gemini":
        config.key = this.getConfig("geminiKey")
        config.url = this.getConfig("geminiUrl")
        // config.model = models[this.getConfig("geminiModel")]
        return config
      case "ChatGPT":
        config.key = this.getConfig("openaiKey")
        config.url = this.getConfig("url")+`/v1/chat/completions`
        // config.model = models[this.getConfig("model")]
        return config
      case "KimiChat":
        config.key = this.getConfig("moonshotKey")
        config.url = "https://api.moonshot.cn/v1/chat/completions"
        // config.model = models[this.getConfig("moonshotModel")]
        return config
      case "Minimax":
        config.key = this.getConfig("miniMaxKey")
        config.url = "https://api.minimax.chat/v1/text/chatcompletion_v2"
        // config.model = models[this.getConfig("miniMaxModel")]
        return config
      case "Deepseek":
        config.key = this.getConfig("deepseekKey")
        config.url = "https://api.deepseek.com/chat/completions"
        // config.model = models[this.getConfig("deepseekModel")]
        return config
      case "Qwen":
        config.key = this.getConfig("qwenKey")
        config.url = "https://dashscope.aliyuncs.com/compatible-mode/v1/chat/completions"
        // config.model = models[this.getConfig("qwenModel")]
        return config
      case "Custom":
        config.key = this.getConfig("customKey")
        config.url = this.getConfig("customUrl")
        // config.model = models[this.getConfig("customModelIndex")]
        return config
      case "Subscription":
        config.key = subscriptionConfig.config.apikey 
        config.url = subscriptionConfig.config.url + "/v1/chat/completions"
        // config.model = models[this.getConfig("subscriptionModel")]
        return config
      case "Built-in":
        config.key = ""
        return config
      default:
        break;
    }
  }
  static getConfigFromPrompt(prompt = this.currentPrompt){
    let promptConfig = this.prompts[prompt]
    // MNUtil.copyJSON(promptConfig)
    let promptModel = promptConfig.model
    let config
    if (promptModel) {
      let modelConfig = promptModel.split(":").map(model=>model.trim())
      if (modelConfig[0] !== "Default") {
        let source = modelConfig[0]
        config = this.getConfigFromSource(source)
        if (modelConfig.length === 2) {
          config.model = modelConfig[1]
        }
      }else{
        config = this.getConfigFromSource()
      }
    }else{
      config = this.getConfigFromSource()
    }
    config.title = promptConfig.title
    if (promptConfig.func) {
      config.func = promptConfig.func
    }
    if (promptConfig.action) {
      config.action = promptConfig.action
    }
    return config
  }
  static getDynmaicConfig(){
    // let promptConfig = this.dynamicPrompt
    let promptModel = this.getConfig("dynamicModel")
    let dynamicFunc = this.getConfig("dynamicFunc")
    let dynamicAction = this.getConfig("dynamicAction")
    let config
    let modelConfig = promptModel.split(":").map(model=>model.trim())
    if (modelConfig[0] !== "Default") {
      let source = modelConfig[0]
      config = this.getConfigFromSource(source)
      if (modelConfig.length === 2) {
        config.model = modelConfig[1]
      }
    }else{
      config = this.getConfigFromSource()
    }
    config.title = "Dynamic"
    if (dynamicFunc.length) {
      config.func = dynamicFunc
    }
    if (dynamicAction.length){
      config.action = dynamicAction
    }
    return config
  }
  /**
   * 
   * @param {NSData} fileData 
   * @param {UIView} filename 
   */
  static exportFile(fileData,filename) {
    fileData.writeToFileAtomically(chatAIUtils.app.tempPath+"/"+filename, false)
    let UTI = "public.sqlite"
    chatAIUtils.app.saveFileWithUti(chatAIUtils.app.tempPath+"/"+filename, UTI)
    let tem = NSData.dataWithContentsOfFile(chatAIUtils.app.dbPath+"/vector.sqlite")
    tem.writeToFileAtomically(chatAIUtils.app.dbPath+"/export.sqlite", false)
  }
  static getOrderText() {
    let order = this.getConfig("searchOrder")
    if (order[0] == 4) {
      return 'Order: (Title) + (Excerpt → Comment)'
    }
    let orderNumber = `${order[0]}${order[1]}${order[2]}`
    switch (orderNumber) {
      case "123":
        return 'Order: Title → Excerpt → Comment'
      case "132":
        return 'Order: Title → Comment → Excerpt'
      case "213":
        return 'Order: Excerpt → Title → Comment'
      case "231":
        return 'Order: Excerpt → Comment → Title'
      case "312":
        return 'Order: Comment → Title → Excerpt'
      case "321":
        return 'Order: Comment → Excerpt → Title'
      default:
        return "123";
    }
  }
  static async readEncryptedConfigFromR2(fileName,key){
  try {
    let url = "https://file.feliks.top/"+fileName+"?timestamp="+Date.now()
    // let res = await chatAINetwork.fetch(url)
    // let text = this.data2string(res)
    // return text
    // const headers = {
    //   "Cache-Control": "no-cache"
    // };
    let text = await MNUtil.readTextFromUrlAsync(url)
    // MNUtil.copyJSON(text)
    if (typeof text === "object" && "statusCode" in text) {
      return text
    }
    if (!text) {
      this.setSyncStatus(false)
      return undefined
    }
    let decodedText = MNUtil.xorEncryptDecrypt(text, key)
    // MNUtil.copy(decodedText)
    if (MNUtil.isValidJSON(decodedText)) {
      let config = JSON.parse(decodedText)
      return config
    }
    return undefined
  } catch (error) {
    MNUtil.copy(error.toString())
    return undefined
  }
  }
  static async uploadConfigWithEncryptionFromR2(fileName,key,alert = true){
    let text = JSON.stringify(this.getAllConfig())
    let encodedText = MNUtil.xorEncryptDecrypt(text, key)
    await chatAINetwork.uploadFileToR2(encodedText, fileName,alert)
  }
  static async readEncryptedConfigFromInfi(fileName,key){
  try {
    let url = "https://futtsu.teracloud.jp/dav/mnconfig/"+fileName
    let Authorization = {
      user:"Feliks15145",
      password:"Eeq3dnRy8bV86Zna"
    }
    // let res = await chatAINetwork.fetch(url)
    // let text = this.data2string(res)
    // return text
    // const headers = {
    //   "Cache-Control": "no-cache"
    // };
    // let text = await MNUtil.readTextFromUrlAsync(url)
    let text = await chatAINetwork.readWebDAVFile(url,Authorization.user,Authorization.password)
    // if (MNUtil.isValidJSON(text)) {
    //   let config = JSON.parse(text)
    //   return config
    // }
    // return text

    // let text = await this.readConfigFromWebdav(url,Authorization)
    // MNUtil.copyJSON(text)
    if (typeof text === "object" && "statusCode" in text) {
      return text
    }
    if (!text) {
      this.setSyncStatus(false)
      return undefined
    }
    let decodedText = MNUtil.xorEncryptDecrypt(text, key)
    // MNUtil.copy(decodedText)
    if (MNUtil.isValidJSON(decodedText)) {
      let config = JSON.parse(decodedText)
      return config
    }
    return undefined
  } catch (error) {
    MNUtil.copy(error.toString())
    return undefined
  }
  }
  static async uploadConfigWithEncryptionToInfi(fileName,key,alert = true){
    let text = JSON.stringify(this.getAllConfig())
    let encodedText = MNUtil.xorEncryptDecrypt(text, key)
    let url = "https://futtsu.teracloud.jp/dav/mnconfig/"+fileName
    let Authorization = {
      user:"Feliks15145",
      password:"Eeq3dnRy8bV86Zna"
    }
    let res = await chatAINetwork.uploadWebDAVFile(url, Authorization.user, Authorization.password, encodedText)
    // await this.uploadConfigToWebdav(encodedText, fileName,Authorization)
  }
  /**
   * 
   * @param {string} fileName
   * @param {{user:string,password:string}} authorization 
   * @returns 
   */
  static async readConfigFromWebdav(fileName,authorization){
    let url = this.getConfig("webdavFolder")+fileName
    // MNUtil.copyJSON({url:url,user:authorization.user,password:authorization.password})
    // let url = "https://file.feliks.top/565DE95F-ADE9-4CE6-9395-68FFFD4F6708"
    let text = await chatAINetwork.readWebDAVFile(url,authorization.user,authorization.password)
    // chatAINetwork.uploadWebDAVFile(url, username, password, fileContent)
    // let text = await MNUtil.readTextFromUrlAsync(url)
    // let decodedText = MNUtil.xorEncryptDecrypt(text, key)
    if (MNUtil.isValidJSON(text)) {
      let config = JSON.parse(text)
      return config
    }
    return text
  }
  /**
   * 
   * @param {string} fileName
   * @param {{user:string,password:string}} authorization 
   * @returns 
   */
  static async uploadConfigToWebdav(fileName,authorization){
    let url = this.getConfig("webdavFolder")+fileName
    let text = JSON.stringify(this.getAllConfig())
    // let encodedText = MNUtil.xorEncryptDecrypt(text, key)
    let res = await chatAINetwork.uploadWebDAVFile(url, authorization.user, authorization.password, text)
    // MNUtil.copy(res)
    // await chatAINetwork.uploadFileToR2(encodedText, fileName)
    if (MNUtil.isValidJSON(res)) {
      let response = JSON.parse(res)
      return response
    }
    return res
  }
}

class chatAINetwork {
  constructor(name) {
    this.name = name;
  }
  static requestWithURL(url){
    return NSMutableURLRequest.requestWithURL(NSURL.URLWithString(url))
  }
  static genNSURL(url) {
    return NSURL.URLWithString(url)
  }
  static async sendRequest(request){
    const queue = NSOperationQueue.mainQueue()
    return new Promise((resolve, reject) => {
      NSURLConnection.sendAsynchronousRequestQueueCompletionHandler(
        request,
        queue,
        (res, data, err) => {
          if (err.localizedDescription){
            MNUtil.showHUD(err.localizedDescription)
            let error = {error:err.localizedDescription}
            resolve(error)
          }
          if (res.statusCode() === 200) {
            // MNUtil.showHUD("OCR success")
          }else{
            resolve({error:res.statusCode()})
            // MNUtil.showHUD("Error in OCR")
          }
          const result = NSJSONSerialization.JSONObjectWithDataOptions(
            data,
            1<<0
          )
          if (NSJSONSerialization.isValidJSONObject(result)){
            resolve(result)
          }
          resolve(result)
        }
      )
  })
  }
  static async fetch (url,options = {}){
    // MNUtil.copy(url)
    const request = this.initRequest(url, options)
    const res = await this.sendRequest(request)
    return res
  }
/**
 * 
 * @param {*} url 
 * @param {*} options 
 * @param {NSData} imageData 
 * @returns 
 */
static initOCRRequest (url,options,imageData) {
  const request = NSMutableURLRequest.requestWithURL(this.genNSURL(url))
  // try {
  request.setHTTPMethod("Post")
  request.httpShouldHandleCookies = false
  // request.setCachePolicy(4)
  // request.setTimeoutInterval(options.timeout ?? 10)
  let boundary = "------------------------PN7UsJiL7Z78DgpbkjKEWE"//NSUUID.UUID().UUIDString()

  const headers = {
    "User-Agent": "curl/8.4.0",
    "Accept-Encoding":"*",
    "Accept-Language":"*",
    "Connection":"close",
    "Content-Type": "multipart/form-data; boundary="+boundary,
    Accept: "*/*"
  }
  request.setAllHTTPHeaderFields({
    ...headers,
    ...(options.headers ?? {})
  })

  
  let body = NSMutableData.new()
  let filePart = NSData.dataWithStringEncoding(`--${boundary}\r\nContent-Disposition: form-data; name="file"; filename="Snipaste_2024-02-18_00-32-59.png"\r\nContent-Type: image/png\r\n\r\n`, 4)
  body.appendData(filePart)
  body.appendData(imageData)
  
  let endBoundary = NSData.dataWithStringEncoding(`\r\n--${boundary}--\r\n`, 4)
  body.appendData(endBoundary)
  // copy(body.base64Encoding())
  request.setHTTPBody(body)
  return request
}

static initFileRequest (url,options,purpose,fileName,fileData) {
  const request = NSMutableURLRequest.requestWithURL(this.genNSURL(url))
  try {
  request.setHTTPMethod("Post")
  request.setTimeoutInterval(options.timeout ?? 10)
  let boundary = NSUUID.UUID().UUIDString()

  const headers = {
    "User-Agent":
      "Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/13.1.1 Safari/605.1.15",
    "Content-Type": "multipart/form-data; boundary="+boundary,
    Accept: "application/json"
  }
  request.setAllHTTPHeaderFields({
    ...headers,
    ...(options.headers ?? {})
  })
  let body = NSMutableData.new()
  let purposeData = NSData.dataWithStringEncoding(purpose, "utf8")
  let purposePart = NSData.dataWithStringEncoding(`
--${boundary}
Content-Disposition: form-data; name="purpose"

`, "utf8")
  let filePart = NSData.dataWithStringEncoding(`
--${boundary}
Content-Disposition: form-data; name="file"; filename="${fileName}"
Content-Type: application/pdf

`, "utf8")
  body.appendData(purposePart)
  body.appendData(purposeData)
  body.appendData(filePart)
  body.appendData(fileData)
  let endBoundary = NSData.dataWithStringEncoding(`--${boundary}--`, "utf8")
  body.appendData(endBoundary)
  request.setHTTPBody(body)
  return request
    } catch (error) {
    MNUtil.showHUD("Error in initFileRequest: "+error)
    return request
  }
}
  /**
   * @param {NSData} image 
   * @returns 
   */
  static async getTextOCR (image) {
    if (typeof ocrNetwork === 'undefined') {
      MNUtil.showHUD("Install 'MN OCR' first")
      return undefined
    }
    try {
      let res = await ocrNetwork.OCR(image)
      MNUtil.copy(res)
      return res
    } catch (error) {
      chatAIUtils.addErrorLog(error, "getTextOCR",)
      return undefined
    }
  }
//备用，使用服务器而不是R2
  static async fetchKeys0 (authorization,string) {
  const headers = {
    "Content-Type": "application/json",
    Authorization: "Bearer sk-gSrzDAH7TBrRCcOaCaFe8f159cAa4a57B7DaCd929f647a0d"
  }

  let body = {
    "model":"share",
    "messages":[{"role": "user", "content": "mnaddon"}]
  }
  let url = subscriptionConfig.getConfig("url")+ "/v1/chat/completions"
  let options = {
      method: "POST",
      headers: headers,
      timeout: 60,
      json: body
    }
  try {
    const res = await this.fetch(url,options)
    return res;
  } catch (error) {
    MNUtil.showHUD(error)

    return undefined
  }
  }
  static async fetchKeys (authorization,string) {
  let url = `https://file.feliks.top/sharedKeys.json?timestamp=`+Date.now()
  try {
    const res = await this.fetch(url,
      {
        method: "Get",
        timeout: 60
      }
    )
    return res;
  } catch (error) {
    MNUtil.showHUD(error)

    return undefined
  }
  }

  static initRequest(url,options) {
    const request = this.requestWithURL(url)
    request.setHTTPMethod(options.method ?? "GET")
    request.setTimeoutInterval(options.timeout ?? 10)
    const headers = {
      "User-Agent":
        "Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/13.1.1 Safari/605.1.15",
      "Content-Type": "application/json",
      Accept: "application/json"
    }
    request.setAllHTTPHeaderFields({
      ...headers,
      ...(options.headers ?? {})
    })
    if (options.search) {
      request.setURL(
        this.genNSURL(
          `${url.trim()}?${Object.entries(options.search).reduce((acc, cur) => {
            const [key, value] = cur
            return `${acc ? acc + "&" : ""}${key}=${encodeURIComponent(value)}`
          }, "")}`
        )
      )
    } else if (options.body) {
      request.setHTTPBody(NSData.dataWithStringEncoding(options.body, 4))
    } else if (options.form) {
      request.setHTTPBody(
        NSData.dataWithStringEncoding(
          Object.entries(options.form).reduce((acc, cur) => {
            const [key, value] = cur
            return `${acc ? acc + "&" : ""}${key}=${encodeURIComponent(value)}`
          }, ""),
          4
        )
      )
    } else if (options.json) {
      request.setHTTPBody(
        NSJSONSerialization.dataWithJSONObjectOptions(
          options.json,
          1
        )
      )
    }
    return request
  }
  static async getUsage(authorization,string) {
    let url = chatAIConfig.config.url
    let urlSubscription = url+'/v1/dashboard/billing/subscription'
    let urlUsage = url+"/v1/dashboard/billing/usage"

    let key = chatAIConfig.config.openaiKey
    if (key.trim() === "") {
      MNUtil.showHUD("no api key")
      return
    }
    let headers = {
        'Authorization': 'Bearer '+key,
        "Content-Type": "application/json"
    }
    let usage = {}
    const res = await this.fetch(urlUsage,
      {
        method: "GET",
        timeout: 60,
        headers: headers
      }
    )
    usage.usage = res.total_usage
    const total = await this.fetch(urlSubscription,
      {
        method: "GET",
        timeout: 60,
        headers: headers
      }
    )
    usage.total = total.hard_limit_usd
    return usage;
  }
/**
 * 
 * @param {*} fullPath 
 * @returns {Promise<{object:String,status:String,id:String,purpose:String,bytes:Number,filename:String}>}
 */
  static async upload(fullPath,key) {
  let fileData = chatAIUtils.getFile(fullPath)
  // let fileSizeWithMB = fileData.length()/1048576
  if (fileData.length() >= 104857600) {
    MNUtil.showHUD("Too large file!")
    return {}
  }
  // copy("length:"+fileSizeWithMB+"MB")
  // showHUD("length:"+fileData.length())
  // let fileName = (fullPath)
  let fileName = `doc_${Date.now()}.pdf`
  const headers = {
    Authorization: "Bearer "+key
  }
  let url = "https://api.moonshot.cn/v1/files"
  // copyJSON(body)
  // showHUD(fileName)
  const request = this.initFileRequest(url, {
      headers: headers,
      timeout: 60
    },
    "file-extract",
    fileName,
    fileData)
  let res = await this.sendRequest(request)
  return res
//   const queue = NSOperationQueue.mainQueue()

//   return new Promise((resolve, reject) => {
    
//   NSURLConnection.sendAsynchronousRequestQueueCompletionHandler(
//     request,
//     queue,
//     (res, data, err) => {
//       if (err.localizedDescription){
//         showHUD(err.localizedDescription)
//         reject()
//       }
//       // if (data.length() === 0) resolve({})
//       const result = NSJSONSerialization.JSONObjectWithDataOptions(
//         data,
//         1<<0
//       )
//       if (NSJSONSerialization.isValidJSONObject(result)){
//         // showHUD(result)
//         // copyJSON(result)
//         resolve(result)
//       }
//       resolve(result)
//       // showHUD(result)
//     }
//   )
//   })
}
  static getAuthorization(apikey) {
    let header = JSON.stringify({"alg":"HS256","sign_type":"SIGN"})
    let payload =JSON.stringify({
      "api_key": apikey.split(".")[0],
      "exp": Date.now()+60000,
      "timestamp": Date.now()
    });
    let secretSalt = apikey.split(".")[1];
    let before_sign = this.base64UrlEncode(CryptoJS.enc.Utf8.parse(header)) + '.' + this.base64UrlEncode(CryptoJS.enc.Utf8.parse(payload));

    let  signature =CryptoJS.HmacSHA256(before_sign, secretSalt);
     signature = this.base64UrlEncode(signature);

    let final_sign = before_sign + '.' + signature;
    return final_sign
  }
   //和普通base64加密不一样
  static base64UrlEncode(str) {
     var encodedSource = CryptoJS.enc.Base64.stringify(str);
     var reg = new RegExp('/', 'g');
     encodedSource = encodedSource.replace(/=+$/,'').replace(/\+/g,'-').replace(reg,'_');
     return encodedSource;
  }
  static async uploadFileToR2(text, fileName, msg = true) {
    try {
      
    let textData = NSData.dataWithStringEncoding(text,4)
    let bucketName = 'test'
    var accessKeyId = 'a4dd38e9a43edd92e7c0a29d90fceb38';
    var secretAccessKey = 'c7f0d5fdf94a12e203762c1b536f49fd1accb9c9ea7bb0e4810e856bb27ac9e7';
    var endpointUrl = 'https://45485acd4578c553e0570e10e95105ef.r2.cloudflarestorage.com';
    var region = 'auto';
    var service = 's3';
    var urlString = endpointUrl + '/' + bucketName + '/' + fileName;
    let url = MNUtil.genNSURL(urlString);
    var request = NSMutableURLRequest.requestWithURL(url);
    request.setHTTPMethod('PUT');
    // 设置认证头
    var date = new Date();
    var amzDate = date.toISOString().replace(/[:-]|\.\d{3}/g, '');
    // amzDate = '20240614T154746Z'
    var shortDate = amzDate.substr(0, 8);
    var scope = shortDate + '/' + region + '/' + service + '/aws4_request';
    var host = '45485acd4578c553e0570e10e95105ef.r2.cloudflarestorage.com'
    // var payloadHash = CryptoJS.SHA256(imageData).toString(CryptoJS.enc.Hex);
    // payloadHash = 'e3b0c44298fc1c149afbf4c8996fb92427ae41e4649b934ca495991b7852b855'
    var payloadHash = 'UNSIGNED-PAYLOAD'
    var canonicalUri = '/' + bucketName + '/' + fileName;
    var canonicalRequest = 'PUT\n' + canonicalUri + '\n\n' +
        'host:' + host + '\n' +
        'x-amz-content-sha256:'+payloadHash+'\n' +
        'x-amz-date:' + amzDate + '\n\n' +
        'host;x-amz-content-sha256;x-amz-date\n' +
        payloadHash;

    var hashedCanonicalRequest = CryptoJS.SHA256(canonicalRequest).toString(CryptoJS.enc.Hex);

    var stringToSign = 'AWS4-HMAC-SHA256\n' + amzDate + '\n' + scope + '\n' + hashedCanonicalRequest;
    var dateKey = CryptoJS.HmacSHA256(shortDate, 'AWS4' + secretAccessKey);
    var dateRegionKey = CryptoJS.HmacSHA256(region, dateKey);
    var dateRegionServiceKey = CryptoJS.HmacSHA256(service, dateRegionKey);
    var signingKey = CryptoJS.HmacSHA256('aws4_request', dateRegionServiceKey);
    var signature = CryptoJS.HmacSHA256(stringToSign, signingKey).toString(CryptoJS.enc.Hex);

    var authorizationHeader = 'AWS4-HMAC-SHA256 Credential=' + accessKeyId + '/' + scope + ', SignedHeaders=host;x-amz-content-sha256;x-amz-date, Signature=' + signature;

    const headers = {
        "Accept-Encoding":"identity",
        "Authorization": authorizationHeader,
        'X-Amz-Content-SHA256': payloadHash,
        'Host': host,
        "X-Amz-Date": amzDate
    };
    request.setAllHTTPHeaderFields(headers);
    request.setHTTPBody(textData);
    let res = await this.sendRequest(request)
    if (res && "error" in res) {
      
    }else{
      if (msg) {
        MNUtil.showHUD("Upload success!")
      }
    }
    // MNUtil.copyJSON(res)
    return res
    } catch (error) {
      MNUtil.showHUD(error)
    }
}
static btoa(str) {
    // Encode the string to a WordArray
    const wordArray = CryptoJS.enc.Utf8.parse(str);
    // Convert the WordArray to Base64
    const base64 = CryptoJS.enc.Base64.stringify(wordArray);
    return base64;
}
static async readWebDAVFile(url, username, password) {
    const headers = {
      Authorization:'Basic ' + chatAINetwork.btoa(username + ':' + password),
      "Cache-Control": "no-cache"
      };
        const response = await MNConnection.fetch(url, {
            method: 'GET',
            headers: headers
        });
    try {
        // if ("statusCode" in response) {
        //   MNUtil.copyJSON(response)
        // }
        // MNUtil
        if (!response.base64Encoding) {
          return response
        }
        let text = MNUtil.data2string(response)
        return text
        // MNUtil.copy(text)

        // if (!response.ok) {
        //     throw new Error('Network response was not ok: ' + response.statusText);
        // }

        // const text = await response.text();
        // return text;
    } catch (error) {
      MNUtil.copy(error)
      MNUtil.showHUD(error)
      return response
    }
}
static async uploadWebDAVFile(url, username, password, fileContent) {
    const headers = {
      Authorization:'Basic ' + chatAINetwork.btoa(username + ':' + password),
      "Content-Type":'application/octet-stream'
    };

    try {
        const response = await MNConnection.fetch(url, {
            method: 'PUT',
            headers: headers,
            body: fileContent
        });
        if (!response.base64Encoding) {
          return response
        }
        let text = MNUtil.data2string(response)
        return text
    } catch (error) {
      MNUtil.showHUD(error)
    }
}
}
