/** @return {chatglmController} */
const getChatglmController = ()=>self
var chatglmController = JSB.defineClass('chatglmController : UIViewController', {
  viewDidLoad: function() {
    try {
    let self = getChatglmController()
    self.init()
    self.view.frame = {x:50,y:50,width:chatAIUtils.getWidth(),height:450}
    self.lastFrame = self.view.frame;
    self.currentFrame = self.view.frame
    self.moveDate = Date.now()
    self.onNewExcerpt = chatAIConfig.config.onNewExcerpt
    self.notifyLoc = chatAIConfig.config.notifyLoc
    //通过id获取文件内容
    self.fileContent = {}

    if (!chatAIConfig.config.delay) {
      chatAIConfig.config.delay = 0
    }
    if (chatAIConfig.config.ignoreShortText == undefined) {
      chatAIConfig.config.ignoreShortText = false
    }


    if (!self.settingView) {
      self.createSettingView()
    }else{
    }
    self.settingViewLayout()
      self.setButtonText(chatAIConfig.config.promptNames,chatAIConfig.currentPrompt)
      self.setTextview(chatAIConfig.currentPrompt)
      self.settingView.hidden = false

    self.createButton("moveButton","moveButtonTapped:")
    self.moveButton.clickDate = 0
    MNButton.setColor(self.moveButton, "#3a81fb",0.5)

    self.moveGesture = new UIPanGestureRecognizer(self,"onMoveGesture:")
    self.moveButton.addGestureRecognizer(self.moveGesture)
    self.moveGesture.view.hidden = false
    // self.moveGesture.addTargetAction(self,"onMoveGesture:")

    self.resizeGesture = new UIPanGestureRecognizer(self,"onResizeGesture:")
    self.promptSaveButton.addGestureRecognizer(self.resizeGesture)
    self.resizeGesture.view.hidden = false
    // self.resizeGesture.addTargetAction(self,"onResizeGesture:")
    // self.settingController.view.hidden = false
    } catch (error) {
      chatAIUtils.addErrorLog(error, "viewDidLoad")
      // MNUtil.copy(error)

    }
  },
  viewWillAppear: function(animated) {
  },
  viewWillDisappear: function(animated) {
  },
  viewWillLayoutSubviews: function() {
  try {
    let self = getChatglmController()
    // let buttonHeight = 25
    // self.view.frame = self.currentFrame
    var viewFrame = self.view.bounds;
    var width    = viewFrame.width
    var height   = viewFrame.height
    self.moveButton.frame = {  x: width*0.5-75,  y: 0,  width: 150,  height: 16,};
    height = height-36
    self.settingViewLayout()
    self.refreshLayout()
  } catch (error) {
    chatAIUtils.addErrorLog(error, "viewWillLayoutSubviews")
  }

  },
  moveButtonTapped: async function (button) {
    // if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    var commandTable = [
      {title:'Manual Sync',object:self,selector:'syncConfig:',param:[1,2,3]},
      {title:'Chat Mode',object:self,selector:'openChatView:',param:[1,3,2]},
    ];
    // self.view.popoverController = MNUtil.getPopoverAndPresent(sender,commandTable,250)
    self.view.popoverController = chatAIUtils.getPopoverAndPresent(button,commandTable,150,1)
    return
    if ((Date.now() - button.clickDate)<500) {
      MNUtil.showHUD("Manual sync")
      let success
      let syncSource = chatAIConfig.getConfig("syncSource")
      switch (syncSource) {
        case "MNNote":
          success = await chatAIConfig.syncForMNNote()
          break;
        case "CFR2":
          success = await chatAIConfig.syncForCFR2()
          break;
        case "Webdav":
          success = await chatAIConfig.syncForWebdav()
          break;
      }
      if (success) {
        let dateObj = new Date(chatAIConfig.getConfig("lastSyncTime"))
        MNButton.setTitle(self.syncTimeButton, "Last Sync Time: "+dateObj.toLocaleString())
        // MNUtil.showHUD("Sync Success!")
      }
      return
    }
    button.clickDate = Date.now()
  },
  openChatView: function (params) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    chatAIUtils.notifyController.preFuncResponse = ""
    chatAIUtils.notifyController.onChat = true
    chatAIUtils.notifyController.openChatView(false)
    chatAIUtils.notifyController.beginNotification("Chat")
  },
  changeSearchOrder: function(sender) {
    // if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    var commandTable = [
      {title:'Title → Excerpt → Comment',object:self,selector:'setSearchOrder:',param:[1,2,3],checked:chatAIConfig.config.searchOrder ==[1,2,3]},
      {title:'Title → Comment → Excerpt',object:self,selector:'setSearchOrder:',param:[1,3,2],checked:chatAIConfig.config.searchOrder==[1,3,2]},
      {title:'Excerpt → Title → Comment',object:self,selector:'setSearchOrder:',param:[2,1,3],checked:chatAIConfig.config.searchOrder==[2,1,3]},
      {title:'Excerpt → Comment → Title',object:self,selector:'setSearchOrder:',param:[2,3,1],checked:chatAIConfig.config.searchOrder==[2,3,1]},
      {title:'Comment → Title → Excerpt',object:self,selector:'setSearchOrder:',param:[3,1,2],checked:chatAIConfig.config.searchOrder==[3,1,2]},
      {title:'Comment → Excerpt → Title',object:self,selector:'setSearchOrder:',param:[3,2,1],checked:chatAIConfig.config.searchOrder==[3,2,1]},
    ];
    // self.view.popoverController = MNUtil.getPopoverAndPresent(sender,commandTable,250)
    self.view.popoverController = chatAIUtils.getPopoverAndPresent(sender,commandTable,250,1)
  },
  setSearchOrder:function (order) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    chatAIConfig.config.searchOrder = order
    self.orderButton.setTitleForState(chatAIConfig.getOrderText(),0)
    chatAIConfig.save("MNChatglm_config")
  },
  changeSyncSource: function (sender) {
    let self = getChatglmController()
    let syncSource = chatAIConfig.getConfig("syncSource")
    var commandTable = [
        {title:'MNNote',object:self,selector:'setSyncSource:',param:'MNNote',checked:syncSource =='MNNote'},
        {title:'Cloudflare R2',object:self,selector:'setSyncSource:',param:'CFR2',checked:syncSource =='CFR2'},
        {title:'InfiniCloud',object:self,selector:'setSyncSource:',param:'Infi',checked:syncSource =='Infi'},
        {title:'Webdav',object:self,selector:'setSyncSource:',param:'Webdav',checked:syncSource =='Webdav'}
    ]
    self.popover(sender, commandTable,200,1)
    // self.view.popoverController = chatAIUtils.getPopoverAndPresent(sender,commandTable,200,1)
  },
  setSyncSource: async function (source) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    let currentSource = chatAIConfig.getConfig("syncSource")
    if (currentSource === source) {
      return
    }
    chatAIConfig.setSyncStatus(false)
    let file
    switch (source) {
      case "CFR2":
        file = chatAIConfig.getConfig("r2file") ?? ""
        MNButton.setTitle(self.exportConfigButton, "Export to R2")
        MNButton.setTitle(self.importConfigButton, "Import from R2")
        MNButton.setTitle(self.focusConfigNoteButton, "Copy")
        self.configNoteIdInput.text = file
        // self.focusConfigNoteButton.hidden = true
        break;
      case "Infi":
        file = chatAIConfig.getConfig("InfiFile") ?? ""
        MNButton.setTitle(self.exportConfigButton, "Export to Infini")
        MNButton.setTitle(self.importConfigButton, "Import from Infini")
        MNButton.setTitle(self.focusConfigNoteButton, "Copy")
        self.configNoteIdInput.text = file
        // self.focusConfigNoteButton.hidden = true
        break;
      case "Webdav":
        file = chatAIConfig.getConfig("webdavFile") ?? ""
        MNButton.setTitle(self.exportConfigButton, "Export to Webdav")
        MNButton.setTitle(self.importConfigButton, "Import from Webdav")
        MNButton.setTitle(self.focusConfigNoteButton, "Copy")
        self.configNoteIdInput.text = file
        // self.focusConfigNoteButton.hidden = true
        break;
      case "MNNote":
        self.configNoteIdInput.text = chatAIConfig.getConfig("syncNoteId")
        self.focusConfigNoteButton.hidden = false
        MNButton.setTitle(self.exportConfigButton, "Export to Note")
        MNButton.setTitle(self.importConfigButton, "Import from Note")
        MNButton.setTitle(self.focusConfigNoteButton, "Focus")
        break;
      default:
        break;
    }
    chatAIConfig.config.syncSource = source
    MNButton.setTitle(self.syncSourceButton, "Source: "+chatAIConfig.getSyncSourceString(),undefined,true)
    // self.syncSourceButton.setTitleForState("Source: "+chatAIConfig.getSyncSourceString(),0)
    // self.syncSourceButton.setTitleForState("Source: "+chatAIConfig.getSyncSourceString(),1)
    chatAIConfig.save("MNChatglm_config",true)
  },
  changeSource: function(sender) {
    // if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    let source = chatAIConfig.config.source
    var commandTable
    if (chatAIUtils.isActivated()) {
      commandTable = [
        {title:'Built-in',object:self,selector:'setSource:',param:'Built-in',checked:source =='Built-in'},
        {title:'Subscription',object:self,selector:'setSource:',param:'Subscription',checked:source =='Subscription'},
        {title:'ChatGPT',object:self,selector:'setSource:',param:'ChatGPT',checked:source =='ChatGPT'},
        {title:'ChatGLM',object:self,selector:'setSource:',param:'ChatGLM',checked:source =='ChatGLM'},
        {title:'KimiChat',object:self,selector:'setSource:',param:'KimiChat',checked:source =='KimiChat'},
        {title:'Minimax',object:self,selector:'setSource:',param:'Minimax',checked:source =='Minimax'},
        {title:'Deepseek',object:self,selector:'setSource:',param:'Deepseek',checked:source =='Deepseek'},
        {title:'Qwen',object:self,selector:'setSource:',param:'Qwen',checked:source =='Qwen'},
        {title:'Claude',object:self,selector:'setSource:',param:'Claude',checked:source =='Claude'},
        {title:'Gemini',object:self,selector:'setSource:',param:'Gemini',checked:source =='Gemini'},
        {title:'Custom',object:self,selector:'setSource:',param:'Custom',checked:source =='Custom'},
      ];
    }else{
      commandTable = [
        {title:'Built-in',object:self,selector:'setSource:',param:'Built-in',checked:source =='Built-in'},
        {title:'ChatGPT',object:self,selector:'setSource:',param:'ChatGPT',checked:source =='ChatGPT'},
        {title:'ChatGLM',object:self,selector:'setSource:',param:'ChatGLM',checked:source =='ChatGLM'},
        {title:'KimiChat',object:self,selector:'setSource:',param:'KimiChat',checked:source =='KimiChat'},
        {title:'Minimax',object:self,selector:'setSource:',param:'Minimax',checked:source =='Minimax'},
        {title:'Deepseek',object:self,selector:'setSource:',param:'Deepseek',checked:source =='Deepseek'},
        {title:'Qwen',object:self,selector:'setSource:',param:'Qwen',checked:source =='Qwen'},
        {title:'Claude',object:self,selector:'setSource:',param:'Claude',checked:source =='Claude'},
        {title:'Gemini',object:self,selector:'setSource:',param:'Gemini',checked:source =='Gemini'},
        {title:'Custom',object:self,selector:'setSource:',param:'Custom',checked:source =='Custom'},
      ];
    }
    self.view.popoverController = chatAIUtils.getPopoverAndPresent(sender,commandTable,200,1)
    // self.view.popoverController = MNUtil.getPopoverAndPresent(sender,commandTable,150)
  },
  setSource: function(param) {
  let self = getChatglmController()
  try {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    let source = chatAIConfig.config.source
    if (param === source) {
      return
    }
    // let viewFrame = self.view.bounds
    // let width = viewFrame.width
    chatAIConfig.config.source = param
    self.sourceButton.setTitleForState("Source: "+chatAIConfig.config.source,0)
    self.setModel(chatAIConfig.config.source)
    self.setModelButton(chatAIConfig.config.source)
    chatAIConfig.save("MNChatglm_config")
  } catch (error) {
    chatAIUtils.addErrorLog(error, "setSource")
  }
  },
  setSourceByButton: function (button) {
    let allSources = ['Built-in','Subscription','ChatGPT','ChatGLM','KimiChat','Minimax','Deepseek','Qwen','Claude','Gemini','Custom']
    let buttonSource = allSources[button.sourceIndex]
    // MNUtil.copy(buttonSource)
    let self = getChatglmController()
    try {
      let source = chatAIConfig.config.source
      if (buttonSource === source) {
        return
      }
      // let viewFrame = self.view.bounds
      // let width = viewFrame.width
      chatAIConfig.config.source = buttonSource
      self.sourceButton.setTitleForState("Source: "+chatAIConfig.config.source,0)
      self.setModel(chatAIConfig.config.source)
      self.setModelButton(chatAIConfig.config.source)
      let sourceIndex = button.sourceIndex
      for (let i = 0; i < allSources.length; i++) {
        let buttonName = "scrollSourceButton"+i
        if (i === sourceIndex) {
          MNButton.setConfig(self[buttonName], {color:"#2c70de"})
        }else{
          MNButton.setConfig(self[buttonName], {color:"#9bb2d6"})
        }
        self[buttonName].titleLabel.font = UIFont.boldSystemFontOfSize(17)
      }
      chatAIConfig.save("MNChatglm_config")
    } catch (error) {
      chatAIUtils.addErrorLog(error, "setSourceByButton")
    }
  },
  changeModel: function(sender) {
    let self = getChatglmController()
  try {
    
    var commandTable
    let source = chatAIConfig.config.source
    let config = chatAIConfig.config
    let modelNames = chatAIConfig.modelNames(source)
    let position = 2
    switch (source) {
      case "ChatGLM":
        commandTable = modelNames.map((model,index)=>{
          return {title:model,object:self,selector:'setModel:',param:index,checked: chatAIConfig.getConfig("kechatglmModely") == index}
        })
        break;
      case "Claude":
        commandTable = modelNames.map((model,index)=>{
          return {title:model,object:self,selector:'setModel:',param:index,checked:chatAIConfig.getConfig("claudeModel") == index}
        })
        break;
      case "Gemini":
        commandTable = modelNames.map((model,index)=>{
          return { title:model,object:self,selector:'setModel:',param:index,checked:chatAIConfig.getConfig("geminiModel") == index}
        })
        break;
      case "ChatGPT":
        position = 4
        commandTable = modelNames.map((model,index)=>{
          return { title:model,object:self,selector:'setModel:',param:index,checked:chatAIConfig.getConfig("model") == index}
        })
        break
      case "KimiChat":
        commandTable = modelNames.map((model,index)=>{
          return { title:model,object:self,selector:'setModel:',param:index,checked:chatAIConfig.getConfig("moonshotModel") == index}
        })
        break;
      case "Minimax":
        commandTable = modelNames.map((model,index)=>{
          return { title:model,object:self,selector:'setModel:',param:index,checked:chatAIConfig.getConfig("miniMaxModel") == index}
        })
        break;
      case "Deepseek":
        commandTable = modelNames.map((model,index)=>{
          return { title:model,object:self,selector:'setModel:',param:index,checked:chatAIConfig.getConfig("deepseekModel") == index}
        })
        break;
      case "Qwen":
        commandTable = modelNames.map((model,index)=>{
          return { title:model,object:self,selector:'setModel:',param:index,checked:chatAIConfig.getConfig("qwenModel") == index}
        })
        break;
      case "Custom":
        commandTable = modelNames.map((model,index)=>{
          return {title:model.trim(),object:self,selector:'setModel:',param:index,checked:chatAIConfig.getConfig("customModelIndex") == index}
        })
        break
      case "Subscription":
        position = 4
        commandTable = modelNames.map((model,index)=>{
          return {title:model.trim(),object:self,selector:'setModel:',param:index,checked:chatAIConfig.getConfig("subscriptionModel") == index}
        })
        break
      default:
        break;
    }
    self.view.popoverController = MNUtil.getPopoverAndPresent(sender,commandTable,250,position)
    // self.view.popoverController = chatAIUtils.getPopoverAndPresent(sender,commandTable,250,4)

  } catch (error) {
    showHUD(error)
  }
  },
  setModel: function (modelIndex) {
    let self = getChatglmController()
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    // chatAIConfig.config.model = params
    switch (chatAIConfig.config.source) {
      case "ChatGLM":
        chatAIConfig.config.chatglmModel = modelIndex
        break;
      case "Claude":
        chatAIConfig.config.claudeModel = modelIndex
        break;
      case "ChatGPT":
        chatAIConfig.config.model = modelIndex
        break;
      case "KimiChat":
        chatAIConfig.config.moonshotModel = modelIndex
        break;
      case "Minimax":
        chatAIConfig.config.miniMaxModel = modelIndex
        break;
      case "Custom":
        chatAIConfig.config.customModelIndex = modelIndex
        break;
      case "Gemini":
        chatAIConfig.config.geminiModel = modelIndex
        break;
      case "Deepseek":
        chatAIConfig.config.deepseekModel = modelIndex
        break;
      case "Qwen":
        chatAIConfig.config.qwenModel = modelIndex
        break;
      default:
        break;
    }
    chatAIConfig.defaultModel = chatAIConfig.getDefaultModel()
    MNUtil.showHUD("modelindex: "+chatAIConfig.defaultModel)

    self.setModel(chatAIConfig.config.source)
    // self.setModelButton(chatAIConfig.config.source)
    chatAIConfig.save("MNChatglm_config")
  },
  saveCustomModels: function (params) {
    chatAIConfig.config.customModel = self.customModelInput.text
    chatAIConfig.save("MNChatglm_config")
    MNUtil.showHUD("Save model")
  },
  changeFunc: function (button) {
    let self = getChatglmController()
    try {
      if (!chatAIUtils.checkSubscribe(false)) {
        return
      }
      let currentFunc 
      let selector
      if (self.contextButton.currentTitle === "Text") {
        // MNUtil.showHUD("dynamicFunc")
        currentFunc = chatAIConfig.getConfig("dynamicFunc")
        selector = 'setDynamicFunc:'
      }else{
        currentFunc = chatAIConfig.currentFunc
        selector = 'setFunc:'
      }
    var commandTable = [
          {title:"Set Title",object:self,selector:selector,param:0,checked:currentFunc.includes(0)},
          {title:"Add Comment",object:self,selector:selector,param:1,checked:currentFunc.includes(1)},
          {title:"Add Tag",object:self,selector:selector,param:6,checked:currentFunc.includes(6)},
          {title:"Add Child Note",object:self,selector:selector,param:7,checked:currentFunc.includes(7)},
          {title:"Copy MD Link",object:self,selector:selector,param:2,checked:currentFunc.includes(2)},
          {title:"Copy Card URL",object:self,selector:selector,param:3,checked:currentFunc.includes(3)},
          {title:"Copy Text",object:self,selector:selector,param:4,checked:currentFunc.includes(4)},
          {title:"Clear Excerpt",object:self,selector:selector,param:8,checked:currentFunc.includes(8)},
          {title:"Set Excerpt",object:self,selector:selector,param:9,checked:currentFunc.includes(9)},
          {title:"Close",object:self,selector:selector,param:5,checked:currentFunc.includes(5)},
          {title:"None",object:self,selector:selector,param:-1,checked:currentFunc.length === 0},
          {title:"All",object:self,selector:selector,param:100,checked:currentFunc.length === 10},
        ];
    self.view.popoverController = chatAIUtils.getPopoverAndPresent(button,commandTable,250,0)
    
    // self.view.popoverController = MNUtil.getPopoverAndPresent(button,commandTable,250)
    } catch (error) {
      showHUD(error)
    }
  },
  setFunc(param) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
try {
    if (!chatAIUtils.checkSubscribe()) {
      return
    }
    let currentFunc = chatAIConfig.currentFunc
    switch (param) {
      case -1:
        currentFunc = []
        break;
      case 100:
        currentFunc = [0,1,2,3,4,5,6,7,8,9]//增加函数后要在这里加一条，不然显示不出来
        break
      default:
        if (currentFunc.includes(param)) {
          currentFunc = currentFunc.filter(func=> func!==param)
        }else{
          currentFunc.push(param)
        }
        currentFunc.sort(function(a, b) {
          return a - b;
        });
        break;
    }
    // chatAIUtils.copyJSON(currentFunc)
    chatAIConfig.currentFunc = currentFunc
    chatAIConfig.prompts[chatAIConfig.currentPrompt].func = currentFunc
    chatAIConfig.save("MNChatglm_prompts")
} catch (error) {
  MNUtil.showHUD(error)
}
  },
  setDynamicFunc(param) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    if (!chatAIUtils.checkSubscribe()) {
      return
    }
try {
    let currentFunc = chatAIConfig.config.dynamicFunc ? chatAIConfig.config.dynamicFunc : []
    switch (param) {
      case -1://None
        currentFunc = []
        break;
      case 100://All
        currentFunc = [0,1,2,3,4,5,6,7,8,9]//增加函数后要在这里加一条，不然显示不出来
        break
      default:
        if (currentFunc.includes(param)) {
          //已经选中了则去除选中状态
          currentFunc = currentFunc.filter(func=> func!==param)
        }else{
          //未选中则增加
          currentFunc.push(param)
        }
        //排序
        currentFunc.sort(function(a, b) {
          return a - b;
        });
        break;
    }
    chatAIConfig.config.dynamicFunc = currentFunc
    chatAIConfig.save("MNChatglm_config")
} catch (error) {
  MNUtil.showHUD(error)
}

  },
  changePromptModel:function (button) {
    let self = getChatglmController()
    if (!chatAIUtils.checkSubscribe(false)) {
      return
    }
    try {
    let selector = 'setPromptModel:'
    let modelName = chatAIConfig.currentModel
    // MNUtil.showHUD(self.contextButton.currentTitle)
    if (self.contextButton.currentTitle === "Text") {
      // MNUtil.showHUD("dynamicFunc")
      modelName = chatAIConfig.getConfig("dynamicModel")
      selector = 'setDynamicModel:'
    }
    let subscriptionModels = chatAIUtils.isActivated()? (chatAIConfig.modelNames("Subscription").map(model=>{return "Subscription: "+model.trim()})):[]
    let customModels = chatAIConfig.getConfig("customKey")?  chatAIConfig.modelNames("Custom").map(model=>{return "Custom: "+model}) : []
    let chatgptModels = chatAIConfig.getConfig("openaiKey") ? chatAIConfig.modelNames("ChatGPT").map(model=>{return "ChatGPT:"+model.trim()}):[]
    let chatglmModels = chatAIConfig.getConfig("apikey") ? chatAIConfig.modelNames("ChatGLM").map(model=>{return "ChatGLM: "+model}) :[]
    let moonshotModels = chatAIConfig.getConfig("moonshotKey") ? chatAIConfig.modelNames("KimiChat").map(model=>{return "KimiChat: "+model}) : []
    let miniMaxModels = chatAIConfig.getConfig("miniMaxKey") ? chatAIConfig.modelNames("Minimax").map(model=>{return "Minimax: "+model}) : []
    let geminiModels = chatAIConfig.getConfig("geminiKey") ? chatAIConfig.modelNames("Gemini").map(model=>{return "Gemini: "+model}) : []
    let claudeModels = chatAIConfig.getConfig("claudeKey") ? chatAIConfig.modelNames("Claude").map(model=>{return "Claude: "+model}) : []
    let deepseekModels = chatAIConfig.getConfig("deepseekKey") ? chatAIConfig.modelNames("Deepseek").map(model=>{return "Deepseek: "+model}) : []
    let qwenModels = chatAIConfig.getConfig("qwenKey") ? chatAIConfig.modelNames("Qwen").map(model=>{return "Qwen: "+model}) : []
    let allModels = ["Default","Built-in"].concat(subscriptionModels).concat(chatglmModels).concat(moonshotModels).concat(miniMaxModels).concat(deepseekModels).concat(qwenModels).concat(chatgptModels).concat(customModels).concat(geminiModels).concat(claudeModels)
    var commandTable = [...new Set(allModels)].map(model=>{
      return {title:model,object:self,selector:selector,param:model,checked:modelName === model}
    })
    self.view.popoverController = chatAIUtils.getPopoverAndPresent(button,commandTable,250,0)
    // self.view.popoverController = MNUtil.getPopoverAndPresent(button,commandTable,250)
    } catch (error) {
      MNUtil.showHUD(error)
    }
  },
  setPromptModel: function (model) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    if (!chatAIUtils.checkSubscribe(false)) {
      return
    }
    // let config = model.split(":")
    let promptName = chatAIConfig.prompts[chatAIConfig.currentPrompt].title
    chatAIConfig.prompts[chatAIConfig.currentPrompt].model = model
    chatAIConfig.setCurrentPrompt(chatAIConfig.currentPrompt)
    chatAIConfig.save("MNChatglm_prompts")
    MNUtil.showHUD("Set model for "+promptName+": ["+model+"]")
  },
  setDynamicModel: function (model) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    chatAIConfig.config.dynamicModel = model
    chatAIConfig.save("MNChatglm_config")
    MNUtil.showHUD("Set model for Dynamic: ["+model+"]")
  },
  changeActions: function (button) {
    let self = getChatglmController()
    if (!chatAIUtils.checkSubscribe(false)) {
      return
    }
    let currentAction
    let selector
    if (self.contextButton.currentTitle === "Text") {
      // MNUtil.showHUD("dynamicFunc")
      currentAction = chatAIConfig.getConfig("dynamicAction")
      selector = 'setDynamicAction:'
    }else{
      currentAction = chatAIConfig.currentAction ?? []
      selector = 'setAction:'
    }
    var commandTable = [
          {title:"Set Title",object:self,selector:selector,param:0,checked:currentAction.includes(0)},
          {title:"Add Comment",object:self,selector:selector,param:1,checked:currentAction.includes(1)},
          {title:"Add Tag",object:self,selector:selector,param:6,checked:currentAction.includes(6)},
          {title:"Add Child Note",object:self,selector:selector,param:7,checked:currentAction.includes(7)},
          {title:"Copy MD Link",object:self,selector:selector,param:2,checked:currentAction.includes(2)},
          {title:"Copy Card URL",object:self,selector:selector,param:3,checked:currentAction.includes(3)},
          {title:"Copy Text",object:self,selector:selector,param:4,checked:currentAction.includes(4)},
          {title:"Clear Excerpt",object:self,selector:selector,param:8,checked:currentAction.includes(8)},
          {title:"Set Excerpt",object:self,selector:selector,param:9,checked:currentAction.includes(9)},
          {title:"Close",object:self,selector:selector,param:5,checked:currentAction.includes(5)},
          {title:"None",object:self,selector:selector,param:-1,checked:currentAction.length === 0},
          {title:"All",object:self,selector:selector,param:100,checked:currentAction.length === 10},
        ];
    self.view.popoverController = chatAIUtils.getPopoverAndPresent(button,commandTable,250,0)
  },
  setAction(param) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
try {
    if (!chatAIUtils.checkSubscribe()) {
      return
    }
    let currentAction = chatAIConfig.currentAction
    switch (param) {
      case -1:
        currentAction = []
        break;
      case 100:
        currentAction = [0,1,2,3,4,5,6,7,8,9]//增加函数后要在这里加一条，不然显示不出来
        break
      default:
        if (currentAction.includes(param)) {
          currentAction = currentAction.filter(func=> func!==param)
        }else{
          currentAction.push(param)
        }
        currentAction.sort(function(a, b) {
          return a - b;
        });
        break;
    }
    // chatAIUtils.copyJSON(currentAction)
    chatAIConfig.currentAction = currentAction
    chatAIConfig.prompts[chatAIConfig.currentPrompt].action = currentAction
    chatAIConfig.save("MNChatglm_prompts")
} catch (error) {
  MNUtil.showHUD(error)
}
  },
  setDynamicAction(param) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    if (!chatAIUtils.checkSubscribe()) {
      return
    }
try {
    let currentAction = chatAIConfig.config.dynamicAction ? chatAIConfig.config.dynamicAction : []
    switch (param) {
      case -1://None
        currentAction = []
        break;
      case 100://All
        currentAction = [0,1,2,3,4,5,6,7,8,9]//增加函数后要在这里加一条，不然显示不出来
        break
      default:
        if (currentAction.includes(param)) {
          //已经选中了则去除选中状态
          currentAction = currentAction.filter(func=> func!==param)
        }else{
          //未选中则增加
          currentAction.push(param)
        }
        //排序
        currentAction.sort(function(a, b) {
          return a - b;
        });
        break;
    }
    chatAIConfig.config.dynamicAction = currentAction
    chatAIConfig.save("MNChatglm_config")
} catch (error) {
  MNUtil.showHUD(error)
}

  },
  changeOpacityTo:function (opacity) {
    self.view.layer.opacity = opacity
  },
  openSettingView:function () {
    let self = getChatglmController()
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    // self.settingController.view.hidden = false
    if (!self.settingView) {
      self.createSettingView()
    }else{
    }
    self.settingViewLayout()
    
    try {
      self.setButtonText(chatAIConfig.promptNames,chatAIConfig.currentPrompt)
      self.setTextview(chatAIConfig.currentPrompt)
      self.settingView.hidden = false
    } catch (error) {
      showHUD(error)
      
    }

    // self.view.addSubview(self.tabView)
  },
  resetConfig: async function (button) {
  try {
    let confirm = await MNUtil.confirm("Reset All Prompts?", "重置所有prompt？")
    if (confirm) {
      let self = getChatglmController()
      chatAIConfig.reset()
      self.setButtonText(chatAIConfig.config.promptNames,chatAIConfig.currentPrompt)
      self.setTextview(chatAIConfig.currentPrompt)
      if (chatAIConfig.config.dynamic) {
        self.dynamicButton.backgroundColor = MNUtil.hexColorAlpha("#fd3700",0.8)
        self.dynamicButton.setTitleForState("Dynamic ✅",0)
      }else{
        self.dynamicButton.setTitleForState("Dynamic ❌",0)
        self.dynamicButton.backgroundColor = MNUtil.hexColorAlpha("#ff9375",0.8)
      }
    }
  } catch (error) {
    chatAIUtils.addErrorLog(error, "resetConfig")
  }
  },

  toggleWindowLocation: function () {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    switch (chatAIConfig.config.notifyLoc) {
      case 1:
        chatAIConfig.config.notifyLoc = 0
        self.windowLocationButton.setTitleForState("Notification: Left",0)
        // chatAIUtils.notifyController.locationButton.setTitleForState("Left",0)
        break;
      case 0:
        chatAIConfig.config.notifyLoc = 1
        self.windowLocationButton.setTitleForState("Notification: Right",0)
        // chatAIUtils.notifyController.locationButton.setTitleForState("Right",0)
        break;
      default:
        break;
    }
    // chatAIUtils.notifyController.config = chatAIConfig.config
    chatAIConfig.save("MNChatglm_config")
  },
  toggleAutoTheme: function(){
    if (!chatAIUtils.checkSubscribe(true,true)) {
      return
    }
    chatAIConfig.config.autoTheme = !chatAIConfig.getConfig("autoTheme")
    MNButton.setTitle(self.autoThemeButton, "Auto Theme: "+(chatAIConfig.getConfig("autoTheme")?"✅":"❌"))
    chatAIConfig.save("MNChatglm_config")
    if (chatAIConfig.config.autoTheme) {
      chatAIUtils.notifyController.checkTheme(true)
    }
  },
  closeButtonTapped: function() {
    if (chatAIUtils.addonBar) {
      self.hide(chatAIUtils.addonBar.frame)
    }else{
      self.hide()
    }
    self.searchedText = ""
  },
  onMoveGesture:function (gesture) {
    // let locationToMN = gesture.locationInView(MNUtil.studyView)
    //     MNUtil.showHUD("message")
    // if ((Date.now() - self.moveDate) > 100) {
    //   let translation = gesture.translationInView(MNUtil.studyView)
    //   let locationToBrowser = gesture.locationInView(self.view)
    //   let locationToButton = gesture.locationInView(gesture.view)
    //   let buttonFrame = self.moveButton.frame
    //   let newY = locationToButton.y-translation.y 
    //   let newX = locationToButton.x-translation.x
    //   if (gesture.state !== 3 && (newY<buttonFrame.height+5 && newY>-5 && newX<buttonFrame.width+5 && newX>-5 && Math.abs(translation.y)<20 && Math.abs(translation.x)<20)) {
    //     gesture.locationToBrowser = {x:locationToBrowser.x-translation.x,y:locationToBrowser.y-translation.y}
    //     // MNUtil.showHUD(JSON.stringify(gesture.locationToBrowser))
    //     // self.locationToButton = {x:newX,y:newY}
    //   }else{
    //     // MNUtil.showHUD("message")
    //   }
    // }
    // self.moveDate = Date.now()
    // let location = {x:locationToMN.x - self.locationToButton.x-gesture.view.frame.x,y:locationToMN.y -self.locationToButton.y-gesture.view.frame.y}
    // let location = {x:locationToMN.x - gesture.locationToBrowser.x,y:locationToMN.y -gesture.locationToBrowser.y}
    let location = chatAIUtils.getNewLoc(gesture)
    let frame = self.view.frame
    self.view.frame = MNUtil.genFrame(location.x,location.y,frame.width,frame.height)
    self.currentFrame  = self.view.frame
    self.custom = false;
    if (gesture.state === 3) {
      MNUtil.studyView.bringSubviewToFront(self.view)
    }
  },
  onResizeGesture:function (gesture) {
  try {
    

    // self.custom = false;
    // self.customMode = "none"
    // if (!gesture.moveDate) {
    //   gesture.moveDate = 0
    // }
    // if ((Date.now() - gesture.moveDate) > 100) {

    // }
    let baseframe = gesture.view.frame
    // let locationToBrowser = gesture.locationInView(self.view)
    // let locationToButton = gesture.locationInView(gesture.view)
    let frame = self.view.frame
    // let width = locationToBrowser.x+(baseframe.width-locationToButton.x)
    // let height = locationToBrowser.y+(baseframe.height-locationToButton.y)
    // MNUtil.copyJSON({locationToBrowser:locationToBrowser,locationToButton:locationToButton})
    // MNUtil.showHUD(JSON.stringify(locationToButton))

    // let locationToBrowser = gesture.locationInView(self.view)
    // let translation = gesture.translationInView(MNUtil.studyView)
    let translation = chatAIUtils.getTranslation(gesture)
    let width = translation.x-frame.x+baseframe.width
    let height = translation.y-frame.y+baseframe.height+15
    if (width <= 330) {
      width = 330
    }
    if (height <= 465) {
      height = 465
    }

    // if (translation) {
    //   MNUtil.showHUD(JSON.stringify(translation))
      // let newFrame = {x:frame.x,y:frame.y,width:frame.width+translation.x,height:frame.height+translation.y}
      // self.view.frame = newFrame
      self.view.frame = {x:frame.x,y:frame.y,width:width,height:height}
      self.currentFrame  = self.view.frame
    // }
    if (gesture.state === 3) {
      MNUtil.studyView.bringSubviewToFront(self.view)
    }
  } catch (error) {
    MNUtil.showHUD(error)
  }
  },
  onResizeGesture0:function (gesture) {
    self.custom = false;
    self.customMode = "none"
    let baseframe = gesture.view.frame
    let locationToBrowser = gesture.locationInView(self.view)
    let frame = self.view.frame
    let width = locationToBrowser.x+baseframe.width*0.5
    let height = self.view.frame.height
    if (width <= 330) {
      width = 330
    }
    //  self.view.frame = {x:frame.x,y:frame.y,width:frame.width+translationX,height:frame.height+translationY}
    self.view.frame = {x:frame.x,y:frame.y,width:width,height:height}
    self.currentFrame  = self.view.frame
    if (gesture.state === 3) {
      MNUtil.studyView.bringSubviewToFront(self.view)
    }
  },
  modelTabTapped: function (params) {
    self.switchView("modelView")
  },
  triggerButtonTapped: function (params) {
    self.switchView("autoActionView")
  },
  advancedButtonTapped: function (params) {
    self.switchView("advanceView")
    if (chatAIConfig.config.source === "Built-in") {
      if (chatAIUtils.checkSubscribe(false,false)) {
        self.usageButton.setTitleForState("Unlimited",0)
      }else{
        let usage  = chatAIConfig.usage
        self.usageButton.setTitleForState("Usage: "+usage.usage+"/100",0)
      }
    }
  },
  syncConfigTapped: function (params) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    self.switchView("syncView")
  },
  configButtonTapped: function (params) {
    self.switchView("configView")

  },
  configSystemTapped: function (params) {
    self.SystemButton.backgroundColor = MNUtil.hexColorAlpha("#457bd3",0.8)
    self.contextButton.backgroundColor = MNUtil.hexColorAlpha("#9bb2d6",0.8)
    self.contextInput.hidden = true
    self.systemInput.hidden = false
  },
  configContextTapped: function (params) {
    self.SystemButton.backgroundColor = MNUtil.hexColorAlpha("#9bb2d6",0.8)
    self.contextButton.backgroundColor = MNUtil.hexColorAlpha("#457bd3",0.8)
    self.contextInput.hidden = false
    self.systemInput.hidden = true
  },
  promptSaveTapped: function (button) {
  // try {
  //     chatAIConfig.save("MNChatglm_prompts")
  //   // chatAIConfig.export(false)
  // } catch (error) {
  //   MNUtil.showHUD(error)
  // }
  // return
    try {
    let self = getChatglmController()
    if (self.contextButton.currentTitle === "Text") {
      chatAIConfig.dynamicPrompt.text = self.contextInput.text
      chatAIConfig.dynamicPrompt.note = self.systemInput.text
      chatAIConfig.save("MNChatglm_dynamicPrompt")
      MNUtil.showHUD("Save Dynamic prompt")
      return
    }
    // return
    let clickDate = Date.now()
    if (button.clickDate && clickDate-button.clickDate<500) {
      if (MNUtil.studyMode === 3) {
        let focuseNote = MNNote.getFocusNote()
        chatAIUtils.currentNoteId = focuseNote.noteId
      }
      chatAIUtils.notifyController.noteid = chatAIUtils.currentNoteId
      chatAIUtils.notifyController.text = chatAIUtils.currentSelection
      if (chatAIUtils.checkCouldAsk()) {
        self.ask()
      }
    }else{
      button.clickDate = Date.now()
      // chatAIConfig.export(false)
      // let noteId = chatAIConfig.config.syncNoteId
      // let focusNote = MNUtil.getNoteById(noteId)
      // MNUtil.copy(focusNote.noteId)
      // // let noteId0 = focusNote.noteId
      let oldConfig = chatAIConfig.prompts[chatAIConfig.currentPrompt]
      let oldJson = JSON.stringify(oldConfig)
      let config = oldConfig
      config.title = self.titleInput.text ?? ""
      config.context = self.contextInput.text ?? ""
      config.system = self.systemInput.text ?? ""
      if (oldJson === JSON.stringify(config)) {
        return
      }
      chatAIConfig.prompts[chatAIConfig.currentPrompt] = config
      self.setButtonText(chatAIConfig.config.promptNames,chatAIConfig.currentPrompt)
      MNUtil.delay(0.1).then(()=>{
        chatAIConfig.save("MNChatglm_prompts",false,false)
        MNUtil.showHUD("Save prompt: "+chatAIConfig.prompts[chatAIConfig.currentPrompt].title)
      })
    }
    } catch (error) {
      MNUtil.showHUD(error)
    }
  },
  saveKnowledgeButtonTapped: function (params) {
    try {
      chatAIConfig.knowledge = self.knowledgeInput.text
      chatAIConfig.save("MNChatglm_knowledge")
      showHUD("Save knowledge")
    } catch (error) {
      showHUD(error);
    }
  },
  changeTunnel: async function(sender) {
    let self = getChatglmController()
    let tunnels = await chatAIConfig.getTunnels()
    var commandTable = tunnels.map((tunnel,index)=>{
      return {title:tunnel,object:self,selector:'setTunnel:',param:index,checked:chatAIConfig.config.tunnel ==index}
    })
    self.popover(sender, commandTable,250)
    // self.view.popoverController = MNUtil.getPopoverAndPresent(sender,commandTable,150)
  },
  setTunnel: async function name(param) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    let tunnels = await chatAIConfig.getTunnels()
    chatAIConfig.config.tunnel = param
    self.tunnelButton.setTitleForState(tunnels[param],0)
    chatAIConfig.save("MNChatglm_config")

  },
  refreshUsage: async function (button) {
    if (button.builtIn) {
      if (chatAIUtils.checkSubscribe(false,false)) {
        self.usageButton.setTitleForState("Unlimited",0)
      }else{
        let usage  = chatAIConfig.usage
        self.usageButton.setTitleForState("Usage: "+usage.usage+"/100",0)
      }
    }else{
      let self = getChatglmController()
      MNUtil.showHUD("Fetching usage")
      let usage  = await chatAINetwork.getUsage()
      self.customUsage.setTitleForState(`Usage: ${(usage.usage/100.).toFixed(2)} / ${usage.total.toFixed(2)}`,0) 
    }
  },
  configAddTapped: function (params) {
    let self = getChatglmController()
    if (Object.keys(chatAIConfig.prompts).length >= 10 && !chatAIUtils.checkSubscribe()) {
      return
    }
    // MNUtil.showHUD("message"+Object.keys(chatAIConfig.prompts).length)
    self.titleInput.text = "New prompt"
    self.contextInput.text = "input your prompt"
    self.systemInput.text = ""
    let i = 0
    while (chatAIConfig.prompts["customEngine"+i]) {
      i = i+1
    }
    let prompts = chatAIConfig.prompts
    let config = {title:self.titleInput.text,context:self.contextInput.text}
    prompts["customEngine"+i] = config
    chatAIConfig.prompts = prompts
    chatAIConfig.config.promptNames = chatAIConfig.config.promptNames.concat(("customEngine"+i))
    self.setButtonText(chatAIConfig.config.promptNames,"customEngine"+i)
    chatAIConfig.setCurrentPrompt("customEngine"+i)
    self.refreshLayout()
    chatAIConfig.save("MNChatglm_prompts")
  },
  addVariable: function (sender) {
    let vars = ['{{card}}','{{cardOCR}}','{{cards}}','{{cardsOCR}}','{{parentCard}}','{{parentCardOCR}}','{{context}}','{{textOCR}}','{{userInput}}','{{knowledge}}','{{noteDocInfo}}','{{currentDocInfo}}','{{noteDocAttach}}','{{currentDocAttach}}','{{noteDocName}}','{{currentDocName}}','{{selectionText}}','{{clipboardText}}']
    var commandTable = vars.map(variable=>{
      return {title:variable,object:self,selector:'insert:',param:variable}
    })
    self.view.popoverController = chatAIUtils.getPopoverAndPresent(sender,commandTable,200,4)
    // let self = getChatglmController()
    // let range = self.contextInput.selectedRange
    // let pre = self.contextInput.text.slice(0,range.location)
    // let post = self.contextInput.text.slice(range.location)
    // self.contextInput.text = pre+"{{context}}"+post
    // copyJSON(range)
  },
  insert: function (variable) {
    let self = getChatglmController()
    if (!self.contextInput.hidden) {
      let range = self.contextInput.selectedRange
      let pre = self.contextInput.text.slice(0,range.location)
      let post = self.contextInput.text.slice(range.location+range.length)
      self.contextInput.text = pre+variable+post
    }
    if (!self.systemInput.hidden) {
      let range = self.systemInput.selectedRange
      let pre = self.systemInput.text.slice(0,range.location)
      let post = self.systemInput.text.slice(range.location+range.length)
      self.systemInput.text = pre+variable+post
    }
  },
  configDeleteTapped: async function (button) {
    if (Object.keys(chatAIConfig.prompts).length === 1) {
      MNUtil.showHUD("You can not clear all prompts!")
      return
    }
    let confirm = await MNUtil.confirm("Delete this prompt?", "删除这个prompt？")
    if (confirm) {
      delete chatAIConfig.prompts[chatAIConfig.currentPrompt]
      chatAIConfig.config.promptNames = chatAIConfig.config.promptNames.filter(item=>item !== chatAIConfig.config.currentPrompt)
      chatAIConfig.setCurrentPrompt(chatAIConfig.config.promptNames[0])
      self.setButtonText(chatAIConfig.config.promptNames,chatAIConfig.currentPrompt)
      self.refreshLayout()
      chatAIConfig.save("MNChatglm_config")
      chatAIConfig.save("MNChatglm_prompts")
    }
  },
  pasteApiKey:function (params) {
    let apikey = UIPasteboard.generalPasteboard().string.trim()
    self.apiKeyInput.text = apikey
    chatAIConfig.saveApiKey(apikey)
  },
  importFromSubscription:function (params) {
    try {
    if (chatAIUtils.checkSubscribe(false)) {
      let apikey = subscriptionConfig.config.apikey
      if (!apikey.trim()) {
        MNUtil.showHUD("Empty key!")
        return
      }
      self.apiKeyInput.text = apikey
      if (subscriptionConfig.config.url) {
        self.URLInput.text = subscriptionConfig.config.url
        chatAIConfig.saveApiKey(apikey,subscriptionConfig.config.url)
      }else{
        self.URLInput.text = "https://api.feliks.top"
        chatAIConfig.saveApiKey(apikey,"https://api.feliks.top")
      }
      // MNUtil.showHUD("Import success!")
      // chatAIConfig.save('MNChatglm_config')
    }

    } catch (error) {
      MNUtil.showHUD(error)
    }
  },
  toggleImageCompressionButton: function (params) {
    chatAIConfig.config.imageCompression = !chatAIConfig.getConfig("imageCompression")
    MNButton.setTitle(self.imageCompressionButton, "Image Compression for vision mode: "+(chatAIConfig.getConfig("imageCompression")?"✅":"❌"))
  },
  saveApiKey:function (params) {
    chatAIConfig.saveApiKey(self.apiKeyInput.text)
  },
  pasteURL:function (params) {
    let URL = chatAIUtils.clipboardText().trim()
    self.URLInput.text = URL
    if (chatAIConfig.config.source === "Custom") {
      chatAIConfig.config.customUrl = URL
    }else{
      chatAIConfig.config.url = URL
    }
    MNUtil.showHUD("Save url")
    chatAIConfig.save('MNChatglm_config')
  },
  saveURL:function (params) {
    try {
      
    if (chatAIConfig.config.source === "Custom") {
      chatAIConfig.config.customUrl = self.URLInput.text.trim()
    }else{
      chatAIConfig.config.url = self.URLInput.text.trim()
    }
    MNUtil.showHUD("Save url")
    chatAIConfig.save('MNChatglm_config')
    } catch (error) {
      MNUtil.showHUD(error)
    }
  },
  saveConfig: async function (params) {
    switch (chatAIConfig.config.source) {
      case "Built-in":
        MNUtil.showHUD("Refreshing...")
        let keys = await chatAINetwork.fetchKeys0()
        if (keys) {
          chatAIConfig.keys = keys 
          if (keys.message) {
            MNUtil.showHUD(keys.message)
            chatAIConfig.save('MNChatglm_builtInKeys')
            self.refreshView("modelView")
            // self.refreshButton.setTitleForState(`1️⃣: ${keys.key0.keys.length}, 2️⃣: ${keys.key1.keys.length}, 3️⃣: ${keys.key2.keys.length}, 4️⃣: ${keys.key3.keys.length}`,0)
            return
          }
        }
        MNUtil.showHUD("error")
        return;
      case "ChatGLM":
        chatAIConfig.config.apikey = self.apiKeyInput.text.trim()
        break;
      case "Claude":
        chatAIConfig.config.claudeKey = self.apiKeyInput.text.trim()
        break;
      case "Gemini":
        chatAIConfig.config.geminiKey = self.apiKeyInput.text.trim()
        break;
      case "ChatGPT":
        chatAIConfig.config.openaiKey = self.apiKeyInput.text.trim()
        chatAIConfig.config.url = self.URLInput.text.trim()
        chatAIConfig.config.customModel = self.customModelInput.text
        break;
      case "KimiChat":
        chatAIConfig.config.moonshotKey = self.apiKeyInput.text.trim()
        break;
      case "Minimax":
        chatAIConfig.config.miniMaxKey = self.apiKeyInput.text.trim()
        break
      case "Custom":
        chatAIConfig.config.customKey = self.apiKeyInput.text.trim()
        chatAIConfig.config.customUrl = self.URLInput.text.trim()
        chatAIConfig.config.customModel = self.customModelInput.text
        break
      case "Subscription":
        chatAIConfig.config.customModel = self.customModelInput.text
        break;
      default:
        break;
    }
    chatAIConfig.save('MNChatglm_config')
    MNUtil.showHUD("Save Config for ["+chatAIConfig.config.source+"]")
  },
  toggleSelected: async function (button) {
  try {
    let self = getChatglmController()

    button.isSelected = true//!button.isSelected
    self.titleInput.backgroundColor = MNUtil.hexColorAlpha("#9bb2d6",0.8)
    self.promptSaveButton.backgroundColor = MNUtil.hexColorAlpha("#e06c75",0.8)
    let clickDate = Date.now()
    if (button.clickDate && clickDate-button.clickDate<300) { 
      //触发双击
      let oldConfig = chatAIConfig.prompts[chatAIConfig.currentPrompt]
      let oldJson = JSON.stringify(oldConfig)
      let config = oldConfig
      config.title = self.titleInput.text ?? ""
      config.context = self.contextInput.text ?? ""
      config.system = self.systemInput.text ?? ""
      if (oldJson !== JSON.stringify(config)) {
        chatAIConfig.prompts[chatAIConfig.currentPrompt] = config
        self.setButtonText(chatAIConfig.config.promptNames,chatAIConfig.currentPrompt)
        chatAIUtils.notifyController.noteid = chatAIUtils.currentNoteId
        chatAIUtils.notifyController.text = chatAIUtils.currentSelection
        chatAIUtils.notifyController.currentPrompt = chatAIConfig.currentPrompt
        MNUtil.delay(0.1).then(()=>{
          chatAIConfig.save("MNChatglm_prompts",false,false)
        })
      }
      if (chatAIUtils.currentSelection === "") {
        MNUtil.showHUD("no text/card selected")
        return
      }
      if (chatAIUtils.checkCouldAsk()) {
        self.ask()
      }
      return
    }else{
      button.clickDate = clickDate
    }
    if (chatAIConfig.currentPrompt === button.id) {
      return
    }
    let title = button.id
    chatAIConfig.setCurrentPrompt(title)
    self.words.forEach((entryName,index)=>{
      if (entryName !== title) {
        self["nameButton"+index].isSelected = false
        self["nameButton"+index].backgroundColor = MNUtil.hexColorAlpha("#9bb2d6",0.8);
      }
    })
    // MNUtil.copyJSON(self.hiddens)
    button.backgroundColor = chatAIUtils.switchColor(button.isSelected)
    if (button.isSelected) {
      self.setTextview(title)
    }
    self.SystemButton.setTitleForState("System",0)
    self.contextButton.setTitleForState("User",0)
    self.visionButton.hidden = false
    chatAIConfig.save('MNChatglm_config')
  } catch (error) {
    MNUtil.showHUD(error)
  }
  },
  toggleAutoAction:function () {
  try {
    chatAIConfig.config.autoAction = !chatAIConfig.config.autoAction
    chatAIConfig.save('MNChatglm_config')
    self.refreshView("autoActionView")
    return
    // self.autoActionButton.backgroundColor = chatAIUtils.switchColor(chatAIConfig.config.autoAction)
    // let title = chatAIConfig.config.autoAction ? "Enable trigger: ✅" : "Enable trigger: ❌"
    // self.autoActionButton.setTitleForState(title)
    // self.onSelectionButton.hidden = !chatAIConfig.config.autoAction
    // self.onNewExcerptButton.hidden = !chatAIConfig.config.autoAction
    // self.newExcerptTagDetection.hidden = !chatAIConfig.config.autoAction
    // self.onNoteButton.hidden = !chatAIConfig.config.autoAction
    // self.ignoreButton.hidden = !chatAIConfig.config.autoAction
    // self.delayButton.hidden = !chatAIConfig.config.autoAction

    // for (let index = 0; index < 32; index++) {
    //   self["ColorButton"+index].hidden = !chatAIConfig.config.autoAction
    // }
    // MNUtil.refreshAddonCommands()
      } catch (error) {
    chatAIUtils.show(error)
  }
  },
  toggleOnSelection:function () {
    chatAIConfig.config.onSelection = !chatAIConfig.config.onSelection
    chatAIConfig.save('MNChatglm_config')
    self.onSelectionButton.backgroundColor = chatAIUtils.switchColor(chatAIConfig.config.onSelection)
    if (chatAIConfig.config.onSelection) {
      // self.onSelectionButton.backgroundColor = MNUtil.hexColorAlpha("#457bd3",.8)
      self.onSelectionButton.setTitleForState("On Selection: ✅")
    }else{
      // self.onSelectionButton.backgroundColor = MNUtil.hexColorAlpha("#9bb2d6",0.8)
      self.onSelectionButton.setTitleForState("On Selection: ❌")
    }
  },
  toggleOnNote:function () {
    chatAIConfig.config.onNote = !chatAIConfig.config.onNote
    chatAIConfig.save("MNChatglm_config")

    if (chatAIConfig.config.onNote) {
      self.onNoteButton.backgroundColor = MNUtil.hexColorAlpha("#457bd3",0.8)
      self.onNoteButton.setTitleForState("On Note: ✅")
    }else{
      self.onNoteButton.backgroundColor = MNUtil.hexColorAlpha("#9bb2d6",0.8)
      self.onNoteButton.setTitleForState("On Note: ❌")
    }
  },
  toggleOnNewExcerpt:function () {
    chatAIConfig.config.onNewExcerpt = !chatAIConfig.config.onNewExcerpt
    chatAIConfig.save('MNChatglm_config')
    if (chatAIConfig.config.onNewExcerpt) {
      self.onNewExcerptButton.backgroundColor = MNUtil.hexColorAlpha("#457bd3",0.8)
      self.onNewExcerptButton.setTitleForState("On New Excerpt: ✅")
    }else{
      self.onNewExcerptButton.backgroundColor = MNUtil.hexColorAlpha("#9bb2d6",0.8)
      self.onNewExcerptButton.setTitleForState("On New Excerpt: ❌")
    }
  },
  toggleNewExcerptTagDetection:function () {
    if (!chatAIConfig.getConfig("newExcerptTagDetection") && !chatAIUtils.checkSubscribe()) {
      return
    }
    chatAIConfig.config.newExcerptTagDetection = !chatAIConfig.config.newExcerptTagDetection
    chatAIConfig.save('MNChatglm_config')
    if (chatAIConfig.config.newExcerptTagDetection) {
      self.newExcerptTagDetection.backgroundColor = MNUtil.hexColorAlpha("#457bd3",0.8)
      self.newExcerptTagDetection.setTitleForState("Tag detection: ✅")
    }else{
      self.newExcerptTagDetection.backgroundColor = MNUtil.hexColorAlpha("#9bb2d6",0.8)
      self.newExcerptTagDetection.setTitleForState("Tag detection: ❌")
    }
  },
  toggleAutoSpeech:function (params) {
    chatAIConfig.config.autoSpeech = !chatAIConfig.getConfig("autoSpeech")
    MNButton.setConfig(self.autoSpeechButton, {
      opacity: 1.0,
      color:(chatAIConfig.getConfig("autoSpeech")?"#457bd3":"#9bb2d6"),
      alpha:0.8,
      title:"Auto Speech "+(chatAIConfig.getConfig("autoSpeech")?"✅":"❌")
    })
    chatAIConfig.save("MNChatglm_config")
  },
  toggleSpeech:function (params) {
    chatAIConfig.config.speech = !chatAIConfig.getConfig("speech")
    MNButton.setConfig(self.speechButton, {opacity: 1.0,color:(chatAIConfig.getConfig("speech")?"#457bd3":"#9bb2d6"),alpha:0.8,title:"Speech "+(chatAIConfig.getConfig("speech")?"✅":"❌")})
    MNButton.setConfig(self.speechVoiceButton, {opacity: 1.0,color:(chatAIConfig.getConfig("speech")?"#457bd3":"#9bb2d6"),alpha:0.8,title:"Speech Voice "+chatAIConfig.getConfig("speechVoice")})
    MNButton.setConfig(self.speechSpeedButton, {opacity: 1.0,color:(chatAIConfig.getConfig("speech")?"#457bd3":"#9bb2d6"),alpha:0.8,title:"Speech Speed: "+chatAIConfig.getConfig("speechSpeed")})
    chatAIConfig.save("MNChatglm_config")
  },
  changeSpeechVoice:function (sender) {
  try {
    let voices = ["male-qn-qingse","male-qn-jingying","male-qn-badao","male-qn-daxuesheng","female-shaonv","female-yujie","female-chengshu","female-tianmei","presenter_male","presenter_female","audiobook_male_1","audiobook_male_2","audiobook_female_1","audiobook_female_2","male-qn-qingse-jingpin","male-qn-jingying-jingpin","male-qn-badao-jingpin","male-qn-daxuesheng-jingpin","female-shaonv-jingpin","female-yujie-jingpin","female-chengshu-jingpin","female-tianmei-jingpin"]
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    var commandTable = voices.map(voice=>{
      return {title:voice,object:self,selector:'changeVoiceTo:',param:voice,checked:chatAIConfig.getConfig("speechVoice") == voice}
    }) 
    self.view.popoverController = MNUtil.getPopoverAndPresent(sender,commandTable,200)
  } catch (error) {
    MNUtil.showHUD(error)
  }
  },
  changeVoiceTo: function (voice) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    chatAIConfig.config.speechVoice = voice
    MNButton.setConfig(self.speechVoiceButton, {opacity: 1.0,color:(chatAIConfig.getConfig("speech")?"#457bd3":"#9bb2d6"),alpha:0.8,title:"Speech Voice: "+chatAIConfig.getConfig("speechVoice")})
    chatAIConfig.save("MNChatglm_config")
  },
  changeSpeechSpeed:function (sender) {
  try {
    let speeds = [0.5,0.75,1,1.25,1.5,1.75,2.0]
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    var commandTable = speeds.map(speed=>{
      return {title:"Speed: "+speed,object:self,selector:'changeSpeedTo:',param:speed}
    }) 
    self.view.popoverController = MNUtil.getPopoverAndPresent(sender,commandTable,200)
  } catch (error) {
    MNUtil.showHUD(error)
  }
  },
  changeSpeedTo: function (speed) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    chatAIConfig.config.speechSpeed = speed
    MNButton.setConfig(self.speechSpeedButton, {opacity: 1.0,color:(chatAIConfig.getConfig("speech")?"#457bd3":"#9bb2d6"),alpha:0.8,title:"Speech Speed: "+chatAIConfig.getConfig("speechSpeed")})
    chatAIConfig.save("MNChatglm_config")
  },
  changeDelay: function(sender) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    var commandTable = [
      {title:'2.0s',object:self,selector:'changeDelayTo:',param:2.0},
      {title:'1.5s',object:self,selector:'changeDelayTo:',param:1.5},
      {title:'1.0s',object:self,selector:'changeDelayTo:',param:1.0},
      {title:'0.5s',object:self,selector:'changeDelayTo:',param:0.5}
    ];
    self.view.popoverController = MNUtil.getPopoverAndPresent(sender,commandTable,100)
  },
  changeDelayTo: function(delay) {
    chatAIConfig.config.delay = delay
    self.delayButton.setTitleForState("Delay: "+delay+"s")
    chatAIConfig.save("MNChatglm_config")
    MNUtil.showHUD("Set delay to "+delay+"s")
  },
  toggleColorConfig: function (button) {
    if (chatAIConfig.config.colorConfig[button.index]) {
      chatAIConfig.config.colorConfig[button.index] = 0
      button.setTitleForState("✖️",0)
    }else{
      chatAIConfig.config.colorConfig[button.index] = 1
      button.setTitleForState("✓",0)
    }
    chatAIConfig.save("MNChatglm_config")

  },
  toggleDynamic: function () {
    let self = getChatglmController()
    try {
    if (self.contextButton.currentTitle === "User") {
      self.contextButton.setTitleForState("Text",0)
      self.SystemButton.setTitleForState("Note",0)
      self.titleInput.text = "Dynamic"
      self.titleInput.backgroundColor = MNUtil.hexColorAlpha("#ff9375",0.8)
      self.promptSaveButton.backgroundColor = MNUtil.hexColorAlpha("#ff9375",0.8)
      // copyJSON(chatAIConfig.dynamicPrompt)
      self.systemInput.text = chatAIConfig.dynamicPrompt.note
      self.contextInput.text = chatAIConfig.dynamicPrompt.text
    }else{
      if (chatAIConfig.config.dynamic) {
        chatAIConfig.config.dynamic = false
        self.dynamicButton.setTitleForState("Dynamic ❌",0)
        self.dynamicButton.backgroundColor = MNUtil.hexColorAlpha("#ff9375",0.8)
      }else{
        self.dynamicButton.backgroundColor = MNUtil.hexColorAlpha("#fd3700",0.8)
        self.dynamicButton.setTitleForState("Dynamic ✅",0)
        chatAIConfig.config.dynamic = true
      }
      chatAIConfig.save('MNChatglm_config')
    }
    self.visionButton.hidden = true
    // self.setButtonText(chatAIConfig.config.promptNames)
    // if (self.systemInput.hidden) {
    //   self.contextButton.backgroundColor = MNUtil.hexColorAlpha("#fd3700",0.8)
    //   self.SystemButton.backgroundColor = MNUtil.hexColorAlpha("#ff9375",0.8)
    // }else{
    //   self.SystemButton.backgroundColor = MNUtil.hexColorAlpha("#fd3700",0.8)
    //   self.contextButton.backgroundColor = MNUtil.hexColorAlpha("#ff9375",0.8)
    // }
    // self.SystemButton.hidden = false
    } catch (error) {
      MNUtil.showHUD(error)
    }
  },
  toggleIgnoreShortText:function (button) {
    chatAIConfig.config.ignoreShortText = !chatAIConfig.config.ignoreShortText
    button.setTitleForState("Ignore short text: "+(chatAIConfig.config.ignoreShortText?"✅":"🚫"))
    if (chatAIConfig.config.ignoreShortText) {
      self.ignoreButton.backgroundColor = MNUtil.hexColorAlpha("#457bd3",0.8)
    }else{
      self.ignoreButton.backgroundColor = MNUtil.hexColorAlpha("#9bb2d6",0.8)
    }
    chatAIConfig.save("MNChatglm_config")

  },
  exportConfig:async function (params) {
    let success = await chatAIConfig.export()
    if (success) {
      // self.configNoteIdInput.text = chatAIConfig.config.syncNoteId
      // chatAIConfig.save("MNChatglm_config",true)
      MNUtil.showHUD("Export Success!")
      let dateObj = new Date(chatAIConfig.getConfig("lastSyncTime"))
      MNButton.setTitle(self.syncTimeButton, "Last Sync Time: "+dateObj.toLocaleString())
    }

  },
  importConfig:async function (params) {
    let success = await chatAIConfig.import()
    if (success) {
      MNUtil.showHUD("Import Success!")
    }
  },
  syncConfig: async function (params) {
    let success
    let syncSource = chatAIConfig.getConfig("syncSource")
    switch (syncSource) {
      case "MNNote":
        success = await chatAIConfig.syncForMNNote()
        break;
      case "CFR2":
        success = await chatAIConfig.syncForCFR2()
        break;
      case "Infi":
        success = await chatAIConfig.syncForInfi()
        break;
      case "Webdav":
        success = await chatAIConfig.syncForWebdav()
        break;
    }
    if (success) {
      let dateObj = new Date(chatAIConfig.getConfig("lastSyncTime"))
      MNButton.setTitle(self.syncTimeButton, "Last Sync Time: "+dateObj.toLocaleString())
      // MNUtil.showHUD("Sync Success!")
    }
  },
  toggleAutoExport: function (params) {
  try {
    if (!chatAIUtils.isSubscribed()) {
      MNUtil.showHUD("Not subscribed")
      return
    }
    chatAIConfig.config.autoExport = !chatAIConfig.getConfig("autoExport")
    MNButton.setTitle(self.autoExportButton, "Auto Export: "+(chatAIConfig.getConfig("autoExport")?"✅":"❌"))
    chatAIConfig.save("MNChatglm_config")
  } catch (error) {
    MNUtil.showHUD(error)
  }
  },
  toggleAutoImport: function (params) {
    if (!chatAIUtils.isSubscribed()) {
      MNUtil.showHUD("Not subscribed")
      return
    }
    chatAIConfig.config.autoImport = !chatAIConfig.getConfig("autoImport")
    MNButton.setTitle(self.autoImportButton, "Auto Import: "+(chatAIConfig.getConfig("autoImport")?"✅":"❌"))
    chatAIConfig.save("MNChatglm_config")
  },
  pasteConfigNoteId:async function (params) {
  try {
    let file
    let res
    let syncSource = chatAIConfig.getConfig("syncSource")
    switch (syncSource) {
      case "MNNote":
        let noteId = MNUtil.clipboardText
        let note = MNNote.new(noteId)//MNUtil.getNoteById(noteId)
        if (note) {
          self.configNoteIdInput.text = note.noteId
          chatAIConfig.config.syncNoteId = note.noteId
          chatAIConfig.save("MNChatglm_config")
          MNUtil.showHUD("Save Config NoteId")
        }else{
          MNUtil.showHUD("Note not exist!")
        }
        break;
      case "CFR2":
        file = MNUtil.clipboardText
        self.configNoteIdInput.text = file
        chatAIConfig.config.r2file = file
        res = await MNUtil.input("Passward for Config","输入云端配置文件加密密码",["Cancel","Confirm"])
        if (res.button) {
          chatAIConfig.config.r2password = res.input
        }
        chatAIConfig.save("MNChatglm_config")
        break;
      case "Infi":
        file = MNUtil.clipboardText
        self.configNoteIdInput.text = file
        chatAIConfig.config.InfiFile = file
        res = await MNUtil.input("Passward for Config","输入云端配置文件加密密码",["Cancel","Confirm"])
        if (res.button) {
          chatAIConfig.config.InfiPassword = res.input
        }
        chatAIConfig.save("MNChatglm_config")
        break;
      case "Webdav":
        file = MNUtil.clipboardText
        self.configNoteIdInput.text = file
        chatAIConfig.config.webdavFile = file
        chatAIConfig.checkWebdavAccount(true)
        // res = await MNUtil.input("Folder for Webdav","输入webdav文件夹",["Cancel","Confirm"])
        // if (res.button) {
        //   chatAIConfig.config.webdavFolder = res.input
        // }
        // res = await MNUtil.input("UserName for Webdav","输入webdav用户名",["Cancel","Confirm"])
        // if (!res.button) {
        //   chatAIConfig.config.webdavUser = res.input
        // }
        // res = await MNUtil.input("Passward for Webdav","输入webdav密码",["Cancel","Confirm"])
        // if (!res.button) {
        //   chatAIConfig.config.webdavPassword = res.input
        // }
        chatAIConfig.save("MNChatglm_config",true)
      default:
        break;
    }
  } catch (error) {
    MNUtil.showHUD(error)
  }
  },
  clearConfigNoteId:function (params) {
    self.configNoteIdInput.text = ""
    let syncSource = chatAIConfig.getConfig("syncSource")
    switch (syncSource) {
      case "MNNote":
        chatAIConfig.config.syncNoteId = ""
        chatAIConfig.save("MNChatglm_config",true)
        MNUtil.showHUD("Clear Config NoteId")
        break;
      case "CFR2":
        chatAIConfig.config.r2file = ""
        chatAIConfig.config.r2password = ""
        chatAIConfig.save("MNChatglm_config",true)
        MNUtil.showHUD("Clear Config File")
        break;
      case "Infi":
        chatAIConfig.config.InfiFile = ""
        chatAIConfig.config.InfiPassword = ""
        chatAIConfig.save("MNChatglm_config",true)
        MNUtil.showHUD("Clear Config File")
        break;
      case "Webdav":
        chatAIConfig.config.webdavFile = ""
        chatAIConfig.save("MNChatglm_config",true)
        MNUtil.showHUD("Clear Config File")
        break;
    }
  },
  toggleVisionMode: function (params) {
    if (!chatAIUtils.checkSubscribe(true)) {
      return
    }
    let prompt = chatAIConfig.currentPrompt
    let vision = chatAIConfig.prompts[prompt].vision
    if (vision) {
      chatAIConfig.prompts[prompt].vision = false
      self.visionButton.backgroundColor = MNUtil.hexColorAlpha("#c0bfbf",0.8)
    }else{
      chatAIConfig.prompts[prompt].vision = true
      self.visionButton.backgroundColor = MNUtil.hexColorAlpha("#e06c75",0.8)
    }
    chatAIConfig.save("MNChatglm_prompts")
  },
  focusConfigNoteId:function (params) {
  try {
    let syncSource = chatAIConfig.getConfig("syncSource")
    switch (syncSource) {
      case "MNNote":
        let noteId = chatAIConfig.config.syncNoteId
        let note = MNNote.new(noteId)
        if (note) {
          note.focusInFloatMindMap()
        }else{
          MNUtil.showHUD("Note not exist!")
        }
        break;
      case "CFR2":
        MNUtil.copy(chatAIConfig.config.r2file)
        break;
      case "Infi":
        MNUtil.copy(chatAIConfig.config.InfiFile)
        break;
      case "Webdav":
        MNUtil.copy(chatAIConfig.config.webdavFile)
        break;
      default:
        break;
    }
  } catch (error) {
    MNUtil.showHUD("Error in focusConfigNoteId: "+error)
  }
  }
});
chatglmController.prototype.init = function () {
  // /**
  //  * @type {chatglmController}
  //  */
  // let ctr = this
  this.reloadImage = MNUtil.getImage(chatAIConfig.mainPath + `/reload.png`)
  this.stopImage = MNUtil.getImage(chatAIConfig.mainPath + `/stop.png`)
  this.settingImage = MNUtil.getImage(chatAIConfig.mainPath + `/setting.png`)
  this.visionImage = MNUtil.getImage(chatAIConfig.mainPath + `/vision.png`,1.5)
  this.searchedText = '';
  this.view.layer.shadowOffset = {width: 0, height: 0};
  this.view.layer.shadowRadius = 15;
  this.view.layer.shadowOpacity = 0.5;
  this.view.layer.shadowColor = UIColor.colorWithWhiteAlpha(0.5, 1);
  this.view.layer.cornerRadius = 11
  this.view.layer.opacity = 1.0
  this.view.layer.borderColor = MNUtil.hexColorAlpha("#9bb2d6",0.8)
  this.view.layer.borderWidth = 0
  this.highlightColor = UIColor.blendedColor( MNUtil.hexColorAlpha("#2c4d81",0.8),
    chatAIUtils.app.defaultTextColor,
    0.8
  );
}

/**
 * @this {chatglmController}
 */
chatglmController.prototype.getQuestion = async function(promptKey = chatAIConfig.currentPrompt,userInput) {
try {
  //因为dynamicController可能还没有被创建，所以要加个判断
  if (chatAIUtils.currentNoteId) {
    let question = await this.getQuestionOnNote(chatAIUtils.currentNoteId,promptKey,userInput)
    return question
  }else{
    let question = await this.getQuestionOnText(promptKey,userInput)
    return question
  }
} catch (error) {
  chatAIUtils.addErrorLog(error, "getQuestion")
  return undefined
}
};

/**
 * @this {chatglmController}
 */
chatglmController.prototype.getNoteVarInfo = async function(noteid,text,userInput) {
  let replaceText= chatAIUtils.checkVariableForNote(text, userInput)
  let config = {}
  let hasContext = replaceText.includes("{{context}}")
  let hasUserInput = replaceText.includes("{{userInput}}")
  let hasOCR = replaceText.includes("{{textOCR}}")
  let hasCard = replaceText.includes("{{card}}")
  let hasCardOCR = replaceText.includes("{{cardOCR}}")
  let hasCards = replaceText.includes("{{cards}}")
  let hasCardsOCR = replaceText.includes("{{cardsOCR}}")
  let hasParentCard = replaceText.includes("{{parentCard}}")
  let hasParentCardOCR = replaceText.includes("{{parentCardOCR}}")
  let hasKnowledge = replaceText.includes("{{knowledge}}")
  let note = MNUtil.getNoteById(noteid)
  let contextVar = ""
    if (hasContext) {
      contextVar = await chatAIUtils.getTextForSearch(note)
      if (!contextVar) {
        MNUtil.showHUD("No text in note/card!")
        return undefined
      }
      config.context = contextVar
    }

    if (hasCard) {
      let cardStructure = await this.genCardStructure(chatAIUtils.currentNoteId)
      let stringified = this.stringifyCardStructure(cardStructure)
      if (stringified) {
        config.card = stringified
      }else{
        return undefined
      }
    }
    if (hasCardOCR) {
      let cardStructure = await this.genCardStructure(chatAIUtils.currentNoteId,true)
      let stringified = this.stringifyCardStructure(cardStructure)
      if (stringified) {
        config.cardOCR = stringified
      }else{
        return undefined
      }
      // // copyJSON(cardStructure)
      // if (!Object.keys(cardStructure).length) {
      //   MNUtil.showHUD("No text in note/card!")
      //   return undefined
      // }
      // let cardStructureString = JSON.stringify(cardStructure,null,2)
      // config.cardOCR = cardStructureString
    }
    if (hasParentCard) {
      let parentNoteId = MNNote.new(chatAIUtils.currentNoteId).parentNote.noteId
      let cardStructure = await this.genCardStructure(parentNoteId)
      let stringified = this.stringifyCardStructure(cardStructure)
      if (stringified) {
        config.parentCard = stringified
      }else{
        return undefined
      }
      // // copyJSON(cardStructure)
      // if (!Object.keys(cardStructure).length) {
      //   MNUtil.showHUD("No text in note/card!")
      //   return undefined
      // }
      // let cardStructureString = JSON.stringify(cardStructure,null,2)
      // config.parentCard = cardStructureString
    }
    if (hasParentCardOCR) {
      let parentNoteId = MNNote.new(chatAIUtils.currentNoteId).parentNote.noteId
      let cardStructure = await this.genCardStructure(parentNoteId,true)
      let stringified = this.stringifyCardStructure(cardStructure)
      if (stringified) {
        config.parentCardOCR = stringified
      }else{
        return undefined
      }
      // // copyJSON(cardStructure)
      // if (!Object.keys(cardStructure).length) {
      //   MNUtil.showHUD("No text in note/card!")
      //   return undefined
      // }
      // let cardStructureString = JSON.stringify(cardStructure,null,2)
      // config.parentCardOCR = cardStructureString
    }
    if (hasCards) {
      let focusNotes = MNNote.getFocusNotes()
      let cardStructures = []
      for (let i = 0; i < focusNotes.length; i++) {
        const note = focusNotes[i];
        cardStructures.push(await this.genCardStructure(note.noteId))
      }
      config.cards = JSON.stringify(cardStructures,null,2)
    }
    if (hasCardsOCR) {
      let focusNotes = MNNote.getFocusNotes()
      let cardStructures = []
      for (let i = 0; i < focusNotes.length; i++) {
        const note = focusNotes[i];
        cardStructures.push(await this.genCardStructure(note.noteId,true))
      }
      config.cardsOCR = JSON.stringify(cardStructures,null,2)
    }
    if (hasOCR) {
      contextVar = await chatAIUtils.getTextForSearch(note,true)
      config.textOCR = contextVar
    }
  if (text.includes("{{currentDocInfo}}")) {
    let currentFile = chatAIUtils.getCurrentFile()
    if (!currentFile) {
      return undefined
    }
    config.currentDocInfo = await this.getFileContent(currentFile)
  }
  if (text.includes("{{noteDocInfo}}")) {
    let currentFile = chatAIUtils.getNoteFile(noteid)
    if (!currentFile) {
      currentFile = chatAIUtils.getCurrentFile()
    }
    if (!currentFile) {
      MNUtil.showHUD("No doc for this note")
      return undefined
    }
    config.noteDocInfo = await this.getFileContent(currentFile)
    // copy(fileContent)
  }
  if (text.includes("{{currentDocAttach}}")) {
    let content = editorUtils.getAttachContentByMD5(MNUtil.currentDocmd5)
    if (!content) {
      MNUtil.showHUD("Attach is empty or not exist")
      return undefined
    }
    config.currentDocAttach = content
  }
  if (text.includes("{{noteDocAttach}}")) {
    let note = MNUtil.getNoteById(noteid)
    let content = editorUtils.getAttachContentByMD5(note.docMd5)
    if (!content) {
      MNUtil.showHUD("Attach is empty or not exist")
      return undefined
    }
    config.noteDocAttach = content
  }
  if (hasKnowledge) {
    config.knowledge = chatAIConfig.knowledge
  }
  if (text.includes("{{clipboardText}}")) {
    config.clipboardText = MNUtil.clipboardText
  }
  if (text.includes("{{selectionText}}")) {
    config.selectionText = MNUtil.selectionText
  }
  if (text.includes("{{currentDocName}}")) {
    config.currentDocName = MNUtil.getFileName(MNUtil.currentDocController.document.pathFile)
  }
  if (text.includes("{{noteDocName}}")) {
    config.noteDocName = chatAIUtils.getNoteFileName(noteid)
  }
  if (hasUserInput) {
    config.userInput = userInput
  }
  let prompt = chatAIUtils.replacVar(replaceText, config)
  // MNUtil.copyJSON(replacedText)
  return prompt
}

/**
 * @this {chatglmController}
 */
chatglmController.prototype.getTextVarInfo = async function(text,userInput) {
  try {
  let replaceText= chatAIUtils.checkVariableForText(text, userInput)
  let config = {}
  let image = undefined
  let fileContent = undefined
  let hasOCR = replaceText.includes("{{textOCR}}")
  let hasContext = replaceText.includes("{{context}}")
  let hasCurrentDocInfo = replaceText.includes("{{currentDocInfo}}")
  let hasNoteDocInfo = replaceText.includes("{{noteDocInfo}}")
  let hasUserInput = replaceText.includes("{{userInput}}")
  let selectedText = MNUtil.selectionText
  if (hasOCR) {
    image = MNUtil.getDocImage()
    selectedText = await chatAINetwork.getTextOCR(image)
    config.textOCR = selectedText
  }
  if (hasContext) {
    config.context = selectedText
  }

  if (hasCurrentDocInfo || hasNoteDocInfo) {
    let currentFile = chatAIUtils.getCurrentFile()
    if (!currentFile) {
      return undefined
    }
    fileContent = await this.getFileContent(currentFile)
    // copy(fileContent)
    if (hasCurrentDocInfo) {
      config.currentDocInfo = fileContent
    }
    if (hasNoteDocInfo) {
      config.noteDocInfo = fileContent
    }
  }
  if (text.includes("{{clipboardText}}")) {
    config.clipboardText = MNUtil.clipboardText
  }
  if (text.includes("{{selectionText}}")) {
    config.selectionText = MNUtil.selectionText
  }
  if (text.includes("{{currentDocName}}")) {
    config.currentDocName = MNUtil.getFileName(MNUtil.currentDocController.document.pathFile)
  }
  if (text.includes("{{noteDocName}}")) {
    config.noteDocName = MNUtil.getFileName(MNUtil.currentDocController.document.pathFile)
  }
  if (text.includes("{{currentDocAttach}}")) {
    if (typeof editorUtils === 'undefined') {
      MNUtil.showHUD("Please install 'MN Editor' first!")
      return undefined
    }
    let content = editorUtils.getAttachContentByMD5(MNUtil.currentDocmd5)
    if (!content) {
      MNUtil.showHUD("Attach is empty or not exist")
      return undefined
    }
    config.currentDocAttach = content
  }
  if (text.includes("{{noteDocAttach}}")) {
    if (typeof editorUtils === 'undefined') {
      MNUtil.showHUD("Please install 'MN Editor' first!")
      return undefined
    }
    let content = editorUtils.getAttachContentByMD5(MNUtil.currentDocmd5)
    if (!content) {
      MNUtil.showHUD("Attach is empty or not exist")
      return undefined
    }
    config.noteDocAttach = content
  }
  if (hasUserInput) {
    config.userInput = userInput
  }
  return chatAIUtils.replacVar(replaceText, config)
    } catch (error) {
    MNUtil.showHUD(error)
  }

}

/**
 * @this {chatglmController}
 */
chatglmController.prototype.getQuestionOnNote = async function(noteid,prompt = chatAIConfig.currentPrompt,userInput) {
  try {
  let vision = chatAIConfig.prompts[prompt].vision
  let context = chatAIConfig.prompts[prompt].context
  let system = chatAIConfig.prompts[prompt].system
  let contextMessage
  let systemMessage
  let question
  contextMessage = await this.getNoteVarInfo(noteid,context,userInput)
  if (system) {
    systemMessage = await this.getNoteVarInfo(noteid,system,userInput)
    if (chatAIUtils.visionMode || vision) {
      let imageData = MNNote.getImageFromNote(MNNote.new(noteid))
      question = [{role:"system",content:systemMessage},chatAIUtils.genUserMessage(contextMessage, imageData)]
    }else{
      question = [{role:"system",content:systemMessage},{role: "user", content: contextMessage}]
    }
    return question
  }
  if (chatAIUtils.visionMode || vision) {
    let imageData = MNNote.getImageFromNote(MNNote.new(noteid))
    question = [chatAIUtils.genUserMessage(contextMessage, imageData)]
  }else{
    question = [{role: "user", content: contextMessage}]
  }
  return question
    } catch (error) {
    showHUD(error)
  }
}

/**
 * @this {chatglmController}
 */
chatglmController.prototype.getQuestionOnText = async function(prompt = chatAIConfig.currentPrompt,userInput) {

  try {
  let vision = chatAIConfig.prompts[prompt].vision
  let context = chatAIConfig.prompts[prompt].context
  let system = chatAIConfig.prompts[prompt].system
  let contextMessage = await this.getTextVarInfo(context,userInput)
  let question
  
  if (system) {
    let systemMessage = await this.getTextVarInfo(system,userInput)
    if (chatAIUtils.visionMode  || vision) {
      let imageData = MNUtil.getDocImage()
      question = [{role:"system",content:systemMessage},chatAIUtils.genUserMessage(contextMessage, imageData)]
    }else{
      question = [{role:"system",content:systemMessage},{role: "user", content: contextMessage}]
    }
    return question
  }
  if (chatAIUtils.visionMode || vision) {
    let imageData = MNUtil.getDocImage()
    question = [chatAIUtils.genUserMessage(contextMessage, imageData)]
  }else{
    question = [{role: "user", content: contextMessage}]
  }
  return question
    } catch (error) {
    MNUtil.showHUD(error)
  }

}
chatglmController.prototype.changeButtonOpacity = function(opacity) {
    this.moveButton.layer.opacity = opacity
    this.closeButton.layer.opacity = opacity
}
chatglmController.prototype.setButtonLayout = function (button,targetAction) {
    button.autoresizingMask = (1 << 0 | 1 << 3);
    button.setTitleColorForState(UIColor.whiteColor(),0);
    button.setTitleColorForState(this.highlightColor, 1);
    button.backgroundColor = MNUtil.hexColorAlpha("#9bb2d6",0.8);
    button.layer.cornerRadius = 8;
    button.layer.masksToBounds = true;
    if (targetAction) {
      button.addTargetActionForControlEvents(this, targetAction, 1 << 6);
    }
    this.view.addSubview(button);
}


chatglmController.prototype.createButton = function (buttonName,targetAction,superview) {
    this[buttonName] = UIButton.buttonWithType(0);
    this[buttonName].autoresizingMask = (1 << 0 | 1 << 3);
    this[buttonName].setTitleColorForState(UIColor.whiteColor(),0);
    this[buttonName].setTitleColorForState(this.highlightColor, 1);
    this[buttonName].backgroundColor = MNUtil.hexColorAlpha("#9bb2d6",0.8)
    this[buttonName].layer.cornerRadius = 8;
    this[buttonName].layer.masksToBounds = true;
    this[buttonName].titleLabel.font = UIFont.systemFontOfSize(16);

    if (targetAction) {
      this[buttonName].addTargetActionForControlEvents(this, targetAction, 1 << 6);
    }
    if (superview) {
      this[superview].addSubview(this[buttonName])
    }else{
      this.view.addSubview(this[buttonName]);
    }
}
/**
 * @this {chatglmController}
 */
chatglmController.prototype.settingViewLayout = function (){
    let viewFrame = this.view.bounds
    let width = viewFrame.width+10
    let height = viewFrame.height
    this.settingView.frame = MNUtil.genFrame(-5, 55, width, height-65)
    this.configView.frame = MNUtil.genFrame(0,0,width,height-65)
    this.modelView.frame = MNUtil.genFrame(0,0,width,height-65)
    this.autoActionView.frame = MNUtil.genFrame(0,0,width,height-65)
    this.advanceView.frame = MNUtil.genFrame(0,0,width,height-65)
    this.syncView.frame = MNUtil.genFrame(0,0,width,height-65)
    // advanceView
    if (width<700) {
      this.orderButton.frame = MNUtil.genFrame(5,5,width-10,35)
      this.knowledgeInput.frame = {x:5,y:190,width:width-10,height:height-300}
      this.saveKnowledgeButton.frame = {x:5,y:height-105,width:width-10,height:35}
      this.speechButton.frame = MNUtil.genFrame(5,45,95,35)
      this.autoSpeechButton.frame = MNUtil.genFrame(105,45,130,35)
      this.speechSpeedButton.frame = MNUtil.genFrame(240,45,width-245,35)
      this.speechVoiceButton.frame = MNUtil.genFrame(5,85,width-10,35)
      this.windowLocationButton.frame = MNUtil.genFrame(10+(width-15)*0.5,125,(width-15)*0.5,35)
      this.autoThemeButton.frame = MNUtil.genFrame(5,125,(width-15)*0.5,35)
      // configView
      this.scrollview.frame = {x:5,y:5,width:width-10,height:150}
      this.scrollview.contentSize = {width:width-10,height:height};

      this.contextInput.frame = {x:5,y:200,width:width-90,height:height-270}
      this.systemInput.frame = {x:5,y:200,width:width-90,height:height-270}
      this.titleInput.frame = {x:5,y:160,width:width-130,height:35}
      this.visionButton.frame = MNUtil.genFrame(width-120, 160, 35, 35)
      this.promptModel.frame = {x:width-80,y:160,width:75,height:35}
      this.contextButton.frame = {x:width-80,y:200,width:75,height:35}
      this.promptSaveButton.frame = {x:width-80,y:height-105,width:75,height:35}
      this.addVarButton.frame = {x:width-120,y:height-105,width:30,height:30}

      this.configReset.frame = {x:width-40,y:50,width:30,height:30}
      this.deleteButton.frame = {x:width-40,y:85,width:30,height:30}
      this.newEntryButton.frame = {x:width-40,y:120,width:30,height:30}

      this.SystemButton.frame = {x:width-80,y:240,width:75,height:35}
      this.funcButton.frame = {x:width-80,y:280,width:75,height:35}
      this.actionButton.frame = {x:width-80,y:320,width:75,height:35}

    }else{
      this.orderButton.frame = MNUtil.genFrame(5,5,350,35)
      this.knowledgeInput.frame = {x:360,y:5,width:width-365,height:height-115}
      this.saveKnowledgeButton.frame = {x:360,y:height-105,width:width-365,height:35}
      this.speechButton.frame = MNUtil.genFrame(5,45,95,35)
      this.autoSpeechButton.frame = MNUtil.genFrame(105,45,130,35)
      this.speechSpeedButton.frame = MNUtil.genFrame(240,45,115,35)
      this.speechVoiceButton.frame = MNUtil.genFrame(5,85,350,35)
      this.windowLocationButton.frame = MNUtil.genFrame(180,125,175,35)
      this.autoThemeButton.frame = MNUtil.genFrame(5,125,170,35)
      // configView
      this.scrollview.frame = {x:5,y:5,width:350,height:height-75}
      this.scrollview.contentSize = {width:350,height:height};
  
      this.titleInput.frame = {x:360,y:5,width:width-485,height:35}
      this.visionButton.frame = MNUtil.genFrame(width-120, 5, 35, 35)
      this.contextInput.frame = {x:360,y:45,width:width-445,height:height-115}
      this.systemInput.frame = {x:360,y:45,width:width-445,height:height-115}
      this.promptModel.frame = {x:width-80,y:5,width:75,height:35}
      this.contextButton.frame = {x:width-80,y:45,width:75,height:35}
      this.SystemButton.frame = {x:width-80,y:85,width:75,height:35}
      this.promptSaveButton.frame = {x:width-80,y:height-105,width:75,height:35}
      this.addVarButton.frame = {x:width-120,y:height-105,width:30,height:30}

      this.configReset.frame = {x:320,y:height-175,width:30,height:30}
      this.deleteButton.frame = {x:320,y:height-140,width:30,height:30}
      this.newEntryButton.frame = {x:320,y:height-105,width:30,height:30}
  
      this.funcButton.frame = {x:width-80,y:125,width:75,height:35}
      this.actionButton.frame = {x:width-80,y:165,width:75,height:35}
    }
    let realWidth = (width > 500)?width-150:width
    let realX = (width > 500)?155:5
    // modelView
    if (width < 500) {
      this.modelScrollview.hidden = true
    }else{
      this.modelScrollview.hidden = false
      let allSources = 11
      let initY = 5
      for (let i = 0; i < allSources; i++) {
        let buttonName = "scrollSourceButton"+i
        this[buttonName].frame = MNUtil.genFrame(5, initY, 135, 35)
        initY = initY+40
        // this.createButton(buttonName,"changeSource:","modelScrollview")
        // MNButton.setConfig(this[buttonName], {opacity:1.0,color:"#2c70de",alpha:0.8})
        // this[buttonName].titleLabel.font = UIFont.boldSystemFontOfSize(17)
      }
    }
    this.modelScrollview.frame = MNUtil.genFrame(5, 5, 145, height-75)
    this.sourceButton.frame = MNUtil.genFrame(realX,5,realWidth-100,35)
    this.saveConfigButton.frame = MNUtil.genFrame(width-90,5,85,35)
    this.apiKeyInput.frame = MNUtil.genFrame(realX,50,realWidth-10,75)
    this.pasteApiKeyButton.frame = MNUtil.genFrame(width-95,90,85,30)
    this.URLInput.frame = MNUtil.genFrame(realX,130,realWidth-10,40)
    this.pasteURLButton.frame = MNUtil.genFrame(width-95,135,85,30)
    this.setModel(chatAIConfig.config.source)
    this.tunnelButton.frame = MNUtil.genFrame(realX,50,(realWidth-10),40)
    this.usageButton.frame = MNUtil.genFrame(realX,95,(realWidth-10),40)

    // autoView
    this.autoActionButton.frame = MNUtil.genFrame(5,5,width-100,35)
    this.delayButton.frame = MNUtil.genFrame(width-90,5,85,35)
    this.onSelectionButton.frame = MNUtil.genFrame(5,50,width-10,35)
    this.onNewExcerptButton.frame = MNUtil.genFrame(5,95,width-170,35)
    this.newExcerptTagDetection.frame = MNUtil.genFrame(width-160,95,155,35)
    this.onNoteButton.frame = MNUtil.genFrame(5,230,(width-10),35)
    this.ignoreButton.frame = MNUtil.genFrame(5,360,(width-10),35)


    // syncView
    this.syncSourceButton.frame = MNUtil.genFrame(5, 5, width-10, 35)
    this.configNoteIdInput.frame = MNUtil.genFrame(5,50,width-10,60)
    this.syncTimeButton.frame = MNUtil.genFrame(5,115,width-10,35)
    this.exportConfigButton.frame = MNUtil.genFrame(5,155,(width-15)*0.5,35)
    this.importConfigButton.frame = MNUtil.genFrame(10+(width-15)*0.5,155,(width-15)*0.5,35)
    this.autoExportButton.frame = MNUtil.genFrame(5,195,(width-15)*0.5,35)
    this.autoImportButton.frame = MNUtil.genFrame(10+(width-15)*0.5,195,(width-15)*0.5,35)
    this.pasteConfigNoteButton.frame = MNUtil.genFrame(width-70,80,60,25)
    this.clearConfigNoteButton.frame = MNUtil.genFrame(width-135,80,60,25)
    this.focusConfigNoteButton.frame = MNUtil.genFrame(width-200,80,60,25)

    let initX = 5
    let initY = 135

    for (let index = 0; index < 32; index++) {
      if (index == 8) {
        initX = 5
        initY = 175
      }
      if (index == 16) {
        initX = 5
        initY = 270
      }
      if (index == 24) {
        initX = 5
        initY = 310
      }
      this["ColorButton"+index].frame = MNUtil.genFrame(initX,initY,37,37)
      // this["ColorButton"+index].setTitleForState(chatAIConfig.config.colorConfig[index]?"✓":"✖️",0)
      this["ColorButton"+index].setTitleForState(chatAIConfig.getConfig("colorConfig")[index]?"✓":"✖️",0)
      initX = initX+40.5
    }


    let settingFrame = this.settingView.bounds
    settingFrame.x = 0
    settingFrame.y = 15
    settingFrame.height = 40
    settingFrame.width = settingFrame.width
    this.tabView.frame = settingFrame
    settingFrame.width = 75
    settingFrame.y = 5
    settingFrame.x = 0
    settingFrame.height = 30
    this.configButton.frame = settingFrame
    settingFrame.x = 80
    settingFrame.width = 65
    this.modelTab.frame = settingFrame
    settingFrame.x = 150
    settingFrame.width = 75
    this.triggerButton.frame = settingFrame
    settingFrame.x = 230
    settingFrame.width = 65
    this.syncConfig.frame = settingFrame
    settingFrame.x = 300
    settingFrame.width = 55
    this.advancedButton.hidden = this.view.bounds.width < 360
    this.advancedButton.frame = settingFrame

    settingFrame.x = this.tabView.frame.width - 40
    settingFrame.width = 30
    this.closeButton.frame = settingFrame

}
/**
 * @this {chatglmController}
 */
chatglmController.prototype.createSettingView = function (){
try {
  
  //创建各分页
  let targetView = "settingView"
  let boldFont = UIFont.boldSystemFontOfSize(16)
  this.creatView(targetView,"view","#f1f6ff",0.9)
  this.settingView.hidden = true
  this.creatView("tabView","view","#ffffff",0.0)
  this.creatView("configView",targetView,"#9bb2d6",0)

  this.creatView("modelView",targetView,"#9bb2d6",0)
  this.modelView.hidden = true

  this.creatView("autoActionView",targetView,"#9bb2d6",0)
  this.autoActionView.hidden = true

  this.creatView("advanceView",targetView,"#9bb2d6",0)
  this.advanceView.hidden = true

  this.creatView("syncView",targetView,"#9bb2d6",0)
  this.syncView.hidden = true

  targetView = "tabView"
  //创建切换按钮
  let buttonColor = "#ffffff"
  let radius = 10
  this.createButton("configButton","configButtonTapped:",targetView)
  this.configButton.layer.cornerRadius = radius;
  MNButton.setConfig(this.configButton, 
    {color:"#457bd3",alpha:0.9,opacity:1.0,title:"Prompt",font:17,bold:true}
  )

  this.createButton("modelTab","modelTabTapped:",targetView)
  this.modelTab.layer.cornerRadius = radius;
  MNButton.setConfig(this.modelTab, 
    {color:"#9bb2d6",alpha:0.9,opacity:1.0,title:"Model",font:17,bold:true}
  )

  this.createButton("triggerButton","triggerButtonTapped:",targetView)
  this.triggerButton.layer.cornerRadius = radius;
  MNButton.setConfig(this.triggerButton, 
    {color:"#9bb2d6",alpha:0.9,opacity:1.0,title:"Trigger",font:17,bold:true}
  )

  this.createButton("syncConfig","syncConfigTapped:",targetView)
  this.syncConfig.layer.cornerRadius = radius;
  MNButton.setConfig(this.syncConfig, 
    {color:"#9bb2d6",alpha:0.9,opacity:1.0,title:"Sync",font:17,bold:true}
  )

  this.createButton("advancedButton","advancedButtonTapped:",targetView)
  this.advancedButton.layer.cornerRadius = radius;
  MNButton.setConfig(this.advancedButton, 
    {color:"#9bb2d6",alpha:0.9,opacity:1.0,title:"More",font:17,bold:true}
  )

  this.createButton("closeButton","closeButtonTapped:",targetView)
  this.closeButton.layer.cornerRadius = radius;
  MNButton.setImage(this.closeButton, this.stopImage)
  MNButton.setColor(this.closeButton, "#e06c75")
  // this.closeButton.setTitleForState('✖️', 0);
  // this.closeButton.titleLabel.font = UIFont.systemFontOfSize(10);
  try {
    
  this.resizeGesture0 = new UIPanGestureRecognizer(this,"onResizeGesture0:")
  this.closeButton.addGestureRecognizer(this.resizeGesture0)
  this.resizeGesture0.view.hidden = false
  } catch (error) {
    chatAIUtils.addErrorLog(error, "createSettingView")
  }
  //创建各分页下的按钮



  //advanceView
  targetView = "advanceView"
  this.createButton("windowLocationButton","toggleWindowLocation:",targetView)
  MNButton.setConfig(this.windowLocationButton, {opacity:1.0,color:"#457bd3",alpha:0.8})

  this.createButton("autoThemeButton","toggleAutoTheme:",targetView)
  MNButton.setConfig(this.autoThemeButton, {opacity:1.0,color:"#457bd3",alpha:0.8})

  this.createButton("orderButton","changeSearchOrder:",targetView)
  MNButton.setConfig(this.orderButton, {opacity: 1.0,color: "#457bd3", alpha: 0.8})
  
  this.creatTextView("knowledgeInput",targetView)

  this.createButton("saveKnowledgeButton","saveKnowledgeButtonTapped:","advanceView")
  MNButton.setConfig(this.saveKnowledgeButton, {opacity: 1.0,color:"#e06c75",alpha:0.8,title:"Save Knowledge"})

  this.createButton("speechButton","toggleSpeech:","advanceView")
  MNButton.setConfig(this.speechButton, {opacity: 1.0,color:(chatAIConfig.getConfig("speech")?"#457bd3":"#9bb2d6"),alpha:0.8,title:"Speech "+(chatAIConfig.getConfig("speech")?"✅":"❌")})

  this.createButton("autoSpeechButton","toggleAutoSpeech:","advanceView")
  MNButton.setConfig(this.autoSpeechButton, {opacity: 1.0,color:(chatAIConfig.getConfig("autoSpeech")?"#457bd3":"#9bb2d6"),alpha:0.8,title:"Auto Speech "+(chatAIConfig.getConfig("autoSpeech")?"✅":"❌")})

  this.createButton("speechVoiceButton","changeSpeechVoice:","advanceView")
  MNButton.setConfig(this.speechVoiceButton, {opacity: 1.0,color:(chatAIConfig.getConfig("speech")?"#457bd3":"#9bb2d6"),alpha:0.8,title:"Speech Voice: "+chatAIConfig.getConfig("speechVoice")})

  this.createButton("speechSpeedButton","changeSpeechSpeed:","advanceView")
  MNButton.setConfig(this.speechSpeedButton, {opacity: 1.0,color:(chatAIConfig.getConfig("speech")?"#457bd3":"#9bb2d6"),alpha:0.8,title:"Speech Speed: "+chatAIConfig.getConfig("speechSpeed")})

  this.refreshView(targetView)


  //autoActionView

  targetView = "autoActionView"

  this.createButton("autoActionButton","toggleAutoAction:",targetView)
  // this.autoActionButton.titleLabel.font = UIFont.boldSystemFontOfSize(17)
  this.createButton("onSelectionButton","toggleOnSelection:",targetView)
  this.createButton("onNoteButton","toggleOnNote:",targetView)
  this.createButton("onNewExcerptButton","toggleOnNewExcerpt:",targetView)
  this.createButton("newExcerptTagDetection","toggleNewExcerptTagDetection:",targetView)
  this.createButton("ignoreButton","toggleIgnoreShortText:",targetView)
  this.createButton("delayButton","changeDelay:",targetView)
  let color = ["#ffffb4","#ccfdc4","#b4d1fb","#f3aebe","#ffff54","#75fb4c","#55bbf9","#ea3323","#ef8733","#377e47","#173dac","#be3223","#ffffff","#dadada","#b4b4b4","#bd9fdc"]
  for (let index = 0; index < 32; index++) {
    this["ColorButton"+index]   = UIButton.buttonWithType(0);
    this["ColorButton"+index].index = index
    this["ColorButton"+index].hidden = !chatAIConfig.getConfig("autoAction")
    if (index > 15) {
      this.setColorButtonLayout(this["ColorButton"+index],"toggleColorConfig:",color[index-16])
    }else{
      this.setColorButtonLayout(this["ColorButton"+index],"toggleColorConfig:",color[index])
    }
  }
  this.refreshView(targetView)

  this.autoActionButton.layer.opacity = 1.0

  //modelView

  targetView = "modelView"
  this.modelScrollview = UIScrollView.new()
  this.modelView.addSubview(this.modelScrollview)
  this.modelScrollview.hidden = false
  this.modelScrollview.delegate = this
  this.modelScrollview.bounces = true
  this.modelScrollview.alwaysBounceVertical = true
  this.modelScrollview.layer.cornerRadius = 8
  this.modelScrollview.backgroundColor = MNUtil.hexColorAlpha("#c0bfbf",0.8)

  let allSources = ['Built-in','Subscription','ChatGPT','ChatGLM','KimiChat','Minimax','Deepseek','Qwen','Claude','Gemini','Custom']
  let sourceIndex = allSources.indexOf(chatAIConfig.config.source)
  this.modelScrollview.contentSize = {width:145,height:11*40}
  for (let i = 0; i < allSources.length; i++) {
    let buttonName = "scrollSourceButton"+i
    this.createButton(buttonName,"setSourceByButton:","modelScrollview")
    this[buttonName].sourceIndex = i
    if (i === sourceIndex) {
      MNButton.setConfig(this[buttonName], {opacity:0.9,color:"#2c70de",alpha:0.8,title:allSources[i],bold:true})
    }else{
      MNButton.setConfig(this[buttonName], {opacity:0.8,color:"#9bb2d6",alpha:0.8,title:allSources[i],bold:true})
    }
    this[buttonName].titleLabel.font = UIFont.boldSystemFontOfSize(17)
  }

  this.createButton("sourceButton","changeSource:",targetView)
  MNButton.setConfig(this.sourceButton, {opacity:1.0,color:"#2c70de",alpha:0.8})
  this.sourceButton.titleLabel.font = UIFont.boldSystemFontOfSize(17)

  this.createButton("tunnelButton","changeTunnel:",targetView)
  MNButton.setConfig(this.tunnelButton, {opacity:1.0,color:"#457bd3",alpha:0.8})

  this.createButton("usageButton","refreshUsage:",targetView)
  this.usageButton.builtIn = true
  MNButton.setConfig(this.usageButton, {opacity:1.0,color:"#457bd3",alpha:0.8})

  
  // this.createButton("saveCustomModels","saveCustomModels:","modelView")
  // MNButton.setTitle(this.saveCustomModels, "Save")
  this.creatTextView("customModelInput","modelView")
  // MNButton.setColor(this.saveCustomModels, "#457bd3",0.8)
  
  this.createButton("modelButton","changeModel:","modelView")
  MNButton.setColor(this.modelButton, "#457bd3",0.8)

  this.createButton("importSubscriptionButton","importFromSubscription:","modelView")
  MNButton.setTitle(this.importSubscriptionButton, "Import from subscription")
  MNButton.setColor(this.importSubscriptionButton, "#457bd3",0.8)

  this.createButton("imageCompressionButton","toggleImageCompressionButton:","modelView")
  MNButton.setTitle(this.imageCompressionButton, "Image Compression for vision mode: "+(chatAIConfig.getConfig("imageCompression")?"✅":"❌"))
  MNButton.setColor(this.imageCompressionButton, "#457bd3",0.8)

  this.createButton("customUsage","refreshUsage:","modelView")
  this.customUsage.builtIn = false
  MNButton.setConfig(this.customUsage, {title:"Usage:",color:"#457bd3",alpha:0.8})

  this.creatTextView("apiKeyInput","modelView")
  this.apiKeyInput.bounces = true
  this.apiKeyInput.editable = true

  this.createButton("pasteApiKeyButton","pasteApiKey:","modelView")
  MNButton.setConfig(this.pasteApiKeyButton, {opacity:1.0,color:"#9bb2d6",title:"Paste key"})

  // this.createButton("saveApiKeyButton","saveApiKey:","modelView")
  // MNButton.setConfig(this.saveApiKeyButton, {opacity:1.0,color:"#9bb2d6",title:"Save"})

  this.creatTextView("URLInput","modelView")

  this.createButton("pasteURLButton","pasteURL:","modelView")
  MNButton.setConfig(this.pasteURLButton, {opacity:1.0,color:"#9bb2d6",title:"Paste url"})

  // this.createButton("saveURLButton","saveURL:","modelView")
  // MNButton.setConfig(this.saveURLButton, {opacity:1.0,color:"#9bb2d6",title:"Save"})

  this.createButton("saveConfigButton","saveConfig:","modelView")
  MNButton.setConfig(this.saveConfigButton, {opacity:0.8,color:"#e06c75",title:"Save",bold:true})

  this.refreshView(targetView)

  //configView
  targetView = "configView"
  this.scrollview = UIScrollView.new()
  this.configView.addSubview(this.scrollview)
  this.scrollview.hidden = false
  this.scrollview.delegate = this
  this.scrollview.bounces = true
  this.scrollview.alwaysBounceVertical = true
  this.scrollview.layer.cornerRadius = 8
  this.scrollview.backgroundColor = MNUtil.hexColorAlpha("#b3bbc0",0.7)
  this.creatTextView("contextInput","configView")
  this.creatTextView("systemInput","configView")
  this.systemInput.hidden = true

  this.creatTextView("titleInput","configView","#9bb2d6")
  this.createButton("dynamicButton","toggleDynamic:","scrollview")



  // let entries           = NSUserDefaults.standardUserDefaults().objectForKey('MNBrowser_entries');
  // copyJSON(chatAIConfig.prompts)
  // copy(text)
  this.titleInput.contentInset = {top: 0,left: 0,bottom: 0,right: 0}
  this.titleInput.textContainerInset = {top: 0,left: 0,bottom: 0,right: 0}

  this.createButton("visionButton","toggleVisionMode:","configView")
  this.visionButton.setImageForState(this.visionImage,0)
  this.visionButton.backgroundColor =  MNUtil.hexColorAlpha("#c0bfbf",0.8)

  this.createButton("funcButton","changeFunc:","configView")
  MNButton.setConfig(this.funcButton, {opacity:1.0,title:"Tools"})

  this.createButton("promptModel","changePromptModel:","configView")
  MNButton.setConfig(this.promptModel, {opacity:1.0,title:"Model"})

  this.createButton("configReset","resetConfig:","configView")
  MNButton.setConfig(this.configReset, {opacity:0.8,title:"🔄",color:"#ffffff",alpha:0.8})

  this.createButton("deleteButton","configDeleteTapped:","configView")
  MNButton.setConfig(this.deleteButton, {opacity:0.8,title:"🗑",color:"#ffffff",alpha:0.8})

  this.createButton("newEntryButton","configAddTapped:","configView")
  MNButton.setConfig(this.newEntryButton, {opacity:0.8,title:"➕",color:"#ffffff",alpha:0.8})

  this.createButton("promptSaveButton","promptSaveTapped:","configView")
  MNButton.setConfig(this.promptSaveButton, {opacity:0.8,title:"Save",bold:true,color:"#e06c75",alpha:0.8})



  this.createButton("addVarButton","addVariable:","configView")
  MNButton.setConfig(this.addVarButton, {opacity:1.0,title:"➕"})

  this.createButton("contextButton","configContextTapped:","configView")
  MNButton.setConfig(this.contextButton, {opacity:1.0,title:"User",color:"#457bd3",alpha:0.8})

  this.createButton("SystemButton","configSystemTapped:","configView")
  MNButton.setConfig(this.SystemButton, {opacity:1.0,title:"System",color:"#9bb2d6",alpha:0.8})

  this.createButton("actionButton","changeActions:","configView")
  MNButton.setConfig(this.actionButton, {opacity:1.0,title:"Action",color:"#9bb2d6",alpha:0.8})
  this.refreshView(targetView)

  //syncView
  targetView = "syncView"
  this.createButton("syncSourceButton","changeSyncSource:",targetView)
  MNButton.setConfig(this.syncSourceButton, {title:"Source: "+chatAIConfig.getSyncSourceString(),color:"#457bd3",font:17,alpha:0.8,bold:true})


  this.creatTextView("configNoteIdInput",targetView)
  this.configNoteIdInput.editable = false
  this.createButton("syncTimeButton","syncConfig:",targetView)
  MNButton.setConfig(this.syncTimeButton, {color:"#457bd3",alpha:0.8})
  
  this.createButton("exportConfigButton","exportConfig:",targetView)
  MNButton.setConfig(this.exportConfigButton, {title:"Export To Note",color:"#457bd3",alpha:0.8})

  this.createButton("importConfigButton","importConfig:",targetView)
  MNButton.setConfig(this.importConfigButton, {title:"Import From Note",color:"#457bd3",alpha:0.8})

  this.createButton("autoExportButton","toggleAutoExport:",targetView)
  MNButton.setConfig(this.autoExportButton, {color:"#457bd3",alpha:0.8})

  this.createButton("autoImportButton","toggleAutoImport:",targetView)
  MNButton.setConfig(this.autoImportButton, {color:"#457bd3",alpha:0.8})

  this.createButton("pasteConfigNoteButton","pasteConfigNoteId:",targetView)
  MNButton.setConfig(this.pasteConfigNoteButton, {title:"Paste",color:"#9bb2d6",alpha:0.8})

  this.createButton("clearConfigNoteButton","clearConfigNoteId:",targetView)
  MNButton.setConfig(this.clearConfigNoteButton, {title:"Clear",color:"#9bb2d6",alpha:0.8})

  this.createButton("focusConfigNoteButton","focusConfigNoteId:",targetView)
  MNButton.setConfig(this.focusConfigNoteButton, {title:"Focus",color:"#9bb2d6",alpha:0.8})

  this.refreshView(targetView)  


} catch (error) {
  MNUtil.showHUD(error)

}
}

/**
 * @this {chatglmController}
 * @param {string[]} names
 */
chatglmController.prototype.setButtonText = function (names,highlight) {
try {
  
    this.words = names
    // MNUtil.showHUD("count:"+names.length)
    names.map((word,index)=>{
      if (!(word in chatAIConfig.prompts)) {
        return
      }
      let buttonName = "nameButton"+index
      if (!this[buttonName]) {
        this.createButton(buttonName,"toggleSelected:","scrollview")
        // this[buttonName].index = index
        // MNUtil.showHUD("Create "+buttonName)
        this[buttonName].titleLabel.font = UIFont.systemFontOfSize(16);
      }
      this[buttonName].hidden = false
      this[buttonName].setTitleForState(chatAIConfig.prompts[word].title,0) 
      this[buttonName].id = word

      this[buttonName].isSelected = (word === highlight)
      MNButton.setColor(this[buttonName], (word === highlight) ? "#457bd3" : "#9bb2d6",0.8)
    })
    this.refreshLayout()
} catch (error) {
  MNUtil.showHUD(error)
}
}
/**
 * @this {chatglmController}
 */
chatglmController.prototype.setTextview = function (name) {
      // let entries           =  NSUserDefaults.standardUserDefaults().objectForKey('MNBrowser_entries');
      let text  = chatAIConfig.prompts[name]
      this.titleInput.text= text.title
      this.contextInput.text = text.context?text.context:""
      if (!text.system) {
        text.system = ""
      }
      this.systemInput.text = text.system
      if (text.vision) {
        this.visionButton.backgroundColor = MNUtil.hexColorAlpha("#e06c75",0.8)
      }else{
        this.visionButton.backgroundColor = MNUtil.hexColorAlpha("#c0bfbf",0.8)
      }
}
/**
 * @this {chatglmController}
 */
chatglmController.prototype.refreshLayout = function () {
  if (!this.settingView) {return}
  this.dynamicButton.frame = MNUtil.genFrame(10,10,110,30)
  if (!this.configView.hidden) {
    var viewFrame = this.scrollview.bounds;
    var xLeft     = 0
    let initX = 130
    let initY = 10
    let initL = 0
    this.locs = [];
    // MNUtil.copyJSON(this.words)
    // MNUtil.showHUD("words count:"+this.words.length)
    this.words.map((word,index)=>{
      if (!(word in chatAIConfig.prompts)) {
        return
      }
      let title = chatAIConfig.prompts[word].title
      let width = chatAIUtils.strCode(title.replaceAll(" ",""))*9+15
      if (xLeft+initX+width > viewFrame.width-10) {
        initX = 10
        initY = initY+40
        initL = initL+1
      }
      this["nameButton"+index].frame = {  x: xLeft+initX,  y: initY,  width: width,  height: 30,};
      this.locs.push({
        x:xLeft+initX,
        y:initY,
        l:initL,
        i:index
      })
      initX = initX+width+10
    })
    // MNUtil.copyJSON(this.locs)
    if (this.lastLength && this.lastLength>this.words.length) {
      for (let index = this.words.length; index < this.lastLength; index++) {
        // MNUtil.showHUD("Hidden:"+"nameButton"+index)
        this["nameButton"+index].hidden = true
      }
    }
    this.lastLength = this.words.length
    this.scrollview.contentSize= {width:viewFrame.width,height:initY+40}
  
  }
}

chatglmController.prototype.hideAllButton = function (frame) {
  // if (condition) {
    
  // }
  // this.moveButton.hidden = true
}
chatglmController.prototype.showAllButton = function (frame) {
  // this.moveButton.hidden = false
}
/**
 * @this {chatglmController}
 */
chatglmController.prototype.show = function (frame) {
try {
  MNUtil.studyView.bringSubviewToFront(this.view)
  MNUtil.studyView.bringSubviewToFront(chatAIUtils.addonBar)
  let preFrame = this.currentFrame
  let preOpacity = this.view.layer.opacity
  this.view.layer.opacity = 0.2
  // this.settingView.hidden = true
  // if (frame) {
  //   this.view.frame = frame
  //   this.currentFrame = frame
  // }
  this.view.hidden = false
  this.hideAllButton()

  MNUtil.animate(()=>{
    this.view.layer.opacity = preOpacity
    // this.view.frame = preFrame
    // this.currentFrame = preFrame
  }).then(()=>{
    try {
    this.view.layer.borderWidth = 0
    this.view.layer.opacity = 1.0
    // MNUtil.copy("123")
    this.showAllButton()
    this.settingView.hidden = false
    } catch (error) {
      MNUtil.showHUD(error)
    }
    // chatAIUtils.copyJSON(this.view.frame)
  })
  if (chatAIUtils.isSubscribed(false) && chatAIConfig.getConfig("autoImport")) {
    chatAIConfig.import(false)
  }

} catch (error) {
  chatAIUtils.addErrorLog(error, "show")
}
}
chatglmController.prototype.hide = function (frame) {
  MNUtil.studyView.bringSubviewToFront(chatAIUtils.addonBar)
  let preFrame = this.view.frame
  let preOpacity = this.view.layer.opacity
  let preCustom = this.custom
  this.hideAllButton()
  this.custom = false
  MNUtil.animate(()=>{
    this.view.layer.opacity = 0.2
  }).then(()=>{
    this.view.hidden = true;
    this.view.layer.opacity = preOpacity      
    this.view.frame = preFrame
    this.currentFrame = preFrame
    this.custom = preCustom
  })
}

chatglmController.prototype.creatView = function (viewName,superview="view",color="#9bb2d6",alpha=0.8) {
  this[viewName] = UIView.new()
  this[viewName].backgroundColor = MNUtil.hexColorAlpha(color,alpha)
  this[viewName].layer.cornerRadius = 12
  this[superview].addSubview(this[viewName])
}

chatglmController.prototype.creatTextView = function (viewName,superview="view",color="#b3bbc0",alpha=0.7) {
  this[viewName] = UITextView.new()
  this[viewName].font = UIFont.systemFontOfSize(15);
  this[viewName].layer.cornerRadius = 8
  this[viewName].backgroundColor = MNUtil.hexColorAlpha(color,alpha)
  this[viewName].textColor = UIColor.blackColor()
  this[viewName].delegate = this
  this[viewName].bounces = true
  this[superview].addSubview(this[viewName])
}

/**
 * 
 * @param {UIButton} button 
 * @param {*} targetAction 
 * @param {*} color 
 */
chatglmController.prototype.setColorButtonLayout = function (button,targetAction,color) {
    button.autoresizingMask = (1 << 0 | 1 << 3);
    button.setTitleColorForState(UIColor.blackColor(),0);
    button.setTitleColorForState(this.highlightColor, 1);
    button.backgroundColor = UIColor.colorWithHexString(color).colorWithAlphaComponent(0.8);
    button.layer.cornerRadius = 10;
    button.layer.masksToBounds = true;
    button.layer.borderWidth = 2
    if (targetAction) {
      button.addTargetActionForControlEvents(this, targetAction, 1 << 6);
    }
    this.autoActionView.addSubview(button);
}

/**
 * @this {chatglmController}
 */
chatglmController.prototype.fetch = async function (url,options = {}){
  return new Promise((resolve, reject) => {
    // UIApplication.sharedApplication().networkActivityIndicatorVisible = true
    const queue = NSOperationQueue.mainQueue()
    const request = chatAINetwork.initRequest(url, options)
    NSURLConnection.sendAsynchronousRequestQueueCompletionHandler(
      request,
      queue,
      (res, data, err) => {
        if (err.localizedDescription) reject(err.localizedDescription)
        // if (data.length() === 0) resolve({})
        const result = NSJSONSerialization.JSONObjectWithDataOptions(
          data,
          1<<0
        )
        if (NSJSONSerialization.isValidJSONObject(result)) resolve(result)
        resolve(result)
      }
    )
  })
}

/**
 * @this {chatglmController}
 */
chatglmController.prototype.genCardStructure = async function (noteid,OCR_enabled=false) {
  let hasImage = false
  let cardStructure = {}
  let note = MNUtil.getNoteById(noteid)
  if (note.noteTitle && note.noteTitle !== "") {
    cardStructure.title = note.noteTitle
  }
  if (note.excerptPic && !note.textFirst) {
    hasImage = true
  }
  if (OCR_enabled && note.excerptPic && !note.textFirst) {
    cardStructure.excerpt = await chatAINetwork.getTextOCR(MNUtil.getMediaByHash(note.excerptPic.paint))
    // hasImage = true
  }else if (chatAIUtils.noteHasExcerptText(note)){
    cardStructure.excerpt = note.excerptText
  }
  if (note.comments.length) {
    let comments = []
    for (let i = 0; i < note.comments.length; i++) {
      const comment = note.comments[i];
      switch (comment.type) {
        case "TextNote":
          if (/^marginnote\dapp:\/\//.test(comment.text)) {
          }else{
            comments.push(comment.text)
          }
          break
        case "HtmlNote":
          comments.push(comment.text)
          break
        case "LinkNote":
          if (OCR_enabled && comment.q_hpic && !note.textFirst) {
            comments.push(await chatAINetwork.getTextOCR(MNUtil.getMediaByHash(comment.q_hpic.paint)))
          }else{
            comments.push(comment.q_htext)
          }
          break
        case "PaintNote":
          if (comment.paint) {
            hasImage = true
          }
          if (OCR_enabled && comment.paint){
            comments.push(await chatAINetwork.getTextOCR(MNUtil.getMediaByHash(comment.paint)))
          }
          break
        default:
          break
      }
    }
    if (comments.length === 1) {
      cardStructure.comment = comments[0]
    }else{
      cardStructure.comments = comments
    }
  }
  // MNUtil.copy("length:"+Object.keys(cardStructure).length)
  let keys = Object.keys(cardStructure)
  switch (keys.length) {
    case 0:
      if (hasImage) {
        return "{{image}}"
      }
      return cardStructure
    case 1:
      // 只有一个键时，不需要返回整个结构
      return cardStructure[keys[0]]
    default:
      return cardStructure
  }
  return cardStructure
}
/**
 * @this {chatglmController}
 */
chatglmController.prototype.stringifyCardStructure = function(cardStructure){
  switch (typeof cardStructure) {
    case "string":
      return cardStructure
    case "object":
      if (!Object.keys(cardStructure).length) {
        MNUtil.showHUD("No text in note/card!")
        return undefined
      }
      return JSON.stringify(cardStructure,null,2)
    default:
      return undefined
  }
}
/**
 * @this {chatglmController}
 * @param {{name:String,path:String,md5:String}} fileObject
 */
chatglmController.prototype.getFileContent = async function (fileObject){

  let file_id = await this.getFileId(fileObject)
  if (!file_id) {
    return undefined
  }
  if (this.fileContent[file_id]) {
    return JSON.stringify(this.fileContent[file_id],null,2)
  }
  MNUtil.showHUD("Get file content: "+fileObject.name)
  let key = chatAIConfig.config.moonshotKey
  if (!key) {
    MNUtil.showHUD("No Moonshot ApiKey!")
    return undefined
  }
  let url = `https://api.moonshot.cn/v1/files/${file_id}/content`
  let headers = {
      Authorization: "Bearer "+key,
      "Content-Type": "application/json"
  }
  try {
    const res = await this.fetch(url,
      {
        method: "Get",
        timeout: 60,
        headers: headers
      }
    )
    
    // res.file_type = "application/pdf"
    res.filename = fileObject.name
    this.fileContent[file_id] = res
    // copyJSON(res)
    return JSON.stringify(res,null,2);
  } catch (error) {
    // showHUD(error)
    // copy(error)
    return undefined
  }
}

/**
 * @this {chatglmController}
 * @param {{name:String,path:String,md5:String}} fileObject
 */
chatglmController.prototype.getFileId = async function (fileObject){
  let fileMd5 = fileObject.md5
  if (chatAIConfig.fileId[fileMd5]) {
    return chatAIConfig.fileId[fileMd5]
  }
  let key = chatAIConfig.config.moonshotKey
  if (!key) {
    MNUtil.showHUD("No Moonshot ApiKey!")
    return undefined
  }
  MNUtil.showHUD("Upload file: "+fileObject.name)
  let fileId = (await chatAINetwork.upload(fileObject.path,key)).id
  if (!fileId) {
    return undefined
  }
  chatAIConfig.fileId[fileMd5] = fileId
  chatAIConfig.save("MNChatglm_fileId")
  return fileId
}

/**
 * @this {chatglmController}
 */
chatglmController.prototype.ask = async function (promptKey = chatAIConfig.currentPrompt){
    // showHUD(promptKey)
  try {
    let question = await this.getQuestion(promptKey)
    if (!question) {
      return
    }
    chatAIUtils.notifyController.ask(question,promptKey)
    return question
  } catch (error) {
    MNUtil.showHUD("Error in ask: "+error)
  }
}
/**
 * @this {chatglmController}
 */
chatglmController.prototype.setModel = function (source) {
  let modelNames = chatAIConfig.modelNames(source)
  switch (source) {
    case "ChatGLM":
      this.modelButton.setTitleForState(modelNames[chatAIConfig.getConfig("chatglmModel")],0)
      break;
    case "Claude":
      this.modelButton.setTitleForState(modelNames[chatAIConfig.getConfig("claudeModel")],0)
      break;
    case "Gemini":
      this.modelButton.setTitleForState(modelNames[chatAIConfig.getConfig("geminiModel")],0)
      break;
    case "ChatGPT":
      this.modelButton.setTitleForState(modelNames[chatAIConfig.config.model],0) 
      break;
    case "Subscription":
      this.modelButton.setTitleForState(modelNames[chatAIConfig.getConfig("subscriptionModel")],0) 
      break;
    case "KimiChat":
      this.modelButton.setTitleForState(modelNames[chatAIConfig.getConfig("moonshotModel")],0) 
      break;
    case "Minimax":
      this.modelButton.setTitleForState(modelNames[chatAIConfig.getConfig("miniMaxModel")],0) 
      break;
    case "Deepseek":
      this.modelButton.setTitleForState(modelNames[chatAIConfig.getConfig("deepseekModel")],0) 
      break;
    case "Qwen":
      this.modelButton.setTitleForState(modelNames[chatAIConfig.getConfig("qwenModel")],0) 
      break;
    case "Custom":
      if (chatAIConfig.config.customModel && chatAIConfig.config.customModel.trim() === "") {
        this.modelButton.setTitleForState("No model",0) 
      }else{
        this.modelButton.setTitleForState(modelNames[chatAIConfig.getConfig("customModelIndex")],0) 
      }
      break;
    default:
      break;
  }
  let viewFrame = this.view.bounds
  let width = viewFrame.width+10
  let realWidth = (width > 500)?width-150:width
  let realX = (width > 500)?155:5
  this.imageCompressionButton.frame = MNUtil.genFrame(realX, viewFrame.height-105, realWidth-10, 35)
  switch (source) {
    case "ChatGLM":
    case "Claude":
    case "Gemini":
    case "KimiChat":
    case "Minimax":
    case "Qwen":
    case "Deepseek":
      this.modelButton.frame = MNUtil.genFrame(realX,130,realWidth-10,35)
      break;
    case "ChatGPT":
      this.customUsage.frame = MNUtil.genFrame(realX+195,175,realWidth-205,35)
      this.modelButton.frame = MNUtil.genFrame(realX,175,190,35)
      // this.saveCustomModels.frame = MNUtil.genFrame(width-80,230,70,50)
      this.customModelInput.frame = MNUtil.genFrame(realX, 215, realWidth-10, 65)
      if (chatAIConfig.config.customModel) {
        this.customModelInput.text = chatAIConfig.config.customModel
      }else{
        this.customModelInput.text = "Custom model"
      }
      this.importSubscriptionButton.frame = MNUtil.genFrame(realX, 285, realWidth-10, 35)
      break;
    case "Subscription":
      this.customUsage.frame = MNUtil.genFrame(realX+195,50,realWidth-205,35)
      this.modelButton.frame = MNUtil.genFrame(realX,50,190,35)
      this.customModelInput.frame = MNUtil.genFrame(realX, 90, realWidth-10, 70)
      if (chatAIConfig.config.customModel) {
        this.customModelInput.text = chatAIConfig.config.customModel
      }else{
        this.customModelInput.text = "Custom model"
      }
      break;
    case "Custom":
      this.modelButton.frame = MNUtil.genFrame(realX,175,realWidth-10,35)
      // this.saveCustomModels.frame = MNUtil.genFrame(width-80,230,70,50)
      this.customModelInput.frame = MNUtil.genFrame(realX, 215, realWidth-10, 70)
      if (chatAIConfig.config.customModel) {
        this.customModelInput.text = chatAIConfig.config.customModel
      }else{
        this.customModelInput.text = "Custom model"
      }
      break;
    default:
      break;    
  }

}

/**
 * @this {chatglmController}
 */
chatglmController.prototype.switchView = function (targetView) {
  let allViews = ["configView", "syncView", "advanceView", "modelView", "autoActionView"]
  let allButtons = ["configButton","syncConfig", "advancedButton", "modelTab", "triggerButton"]
  allViews.forEach((k,index) => {
    let isTargetView = k === targetView
    this[k].hidden = !isTargetView
    this[allButtons[index]].backgroundColor = MNUtil.hexColorAlpha(isTargetView?"#457bd3":"#9bb2d6",0.8)
  })
  self.refreshView(targetView)
}

/**
 * @this {chatglmController}
 */
chatglmController.prototype.refreshView = function (targetView) {
try {
  switch (targetView) {
    case "advanceView":
      this.knowledgeInput.text = chatAIConfig.knowledge
      let locInd = chatAIConfig.config.notifyLoc
      let locNames = ["Left","Right"]
      MNButton.setTitle(this.windowLocationButton, "Notification: "+locNames[locInd])
      MNButton.setTitle(this.autoThemeButton, "Auto Theme: "+(chatAIConfig.getConfig("autoTheme")?"✅":"❌"))
      MNButton.setTitle(this.orderButton, chatAIConfig.getOrderText())
      break;
    case "modelView":
      this.sourceButton.setTitleForState("Source: "+chatAIConfig.getConfig("source"),0)
      chatAIConfig.getTunnels().then((tunnels)=>{
        this.tunnelButton.setTitleForState(tunnels[chatAIConfig.getConfig("tunnel")],0)
      })
      // let tunnels = ['Tunnel1️⃣: '+chatAIConfig.keys["key0"].model,'Tunnel2️⃣: '+chatAIConfig.keys["key1"].model,'Tunnel3️⃣: '+chatAIConfig.keys["key2"].model,'Tunnel4️⃣: '+chatAIConfig.keys["key3"].model]
      if (chatAIUtils.checkSubscribe(false,false)) {
        this.usageButton.setTitleForState("Unlimited",0)
      }else{
        let usage  = chatAIConfig.usage
        this.usageButton.setTitleForState("Usage: "+usage.usage+"/100",0)
      }
      this.setModel(chatAIConfig.config.source)
      this.setModelButton(chatAIConfig.config.source)
      break;
    case "configView":
      if (chatAIConfig.getConfig("dynamic")) {
        MNButton.setConfig(this.dynamicButton, {opacity:1.0,color:"#fd3700",alpha:0.8,title:"Dynamic ✅"})
      }else{
        MNButton.setConfig(this.dynamicButton, {opacity:1.0,color:"#ff9375",alpha:0.8,title:"Dynamic ❌"})
      }
      let text  = chatAIConfig.prompts[chatAIConfig.currentPrompt]
      if (!text) {
        chatAIConfig.setCurrentPrompt(chatAIConfig.config.promptNames[0])
        text  = chatAIConfig.prompts[chatAIConfig.currentPrompt]
      }
      this.contextInput.text = text.context?text.context:""
      this.titleInput.text = text.title
      // MNUtil.copyJSON(chatAIConfig.config)
      this.setButtonText(chatAIConfig.config.promptNames,chatAIConfig.currentPrompt)
      this.setTextview(chatAIConfig.currentPrompt)
      break;
    case "syncView":
      let syncSource = chatAIConfig.getConfig("syncSource")
      switch (syncSource) {
        case "MNNote":
          MNButton.setTitle(this.focusConfigNoteButton, "Focus")
          MNButton.setTitle(this.exportConfigButton, "Export to Note")
          MNButton.setTitle(this.importConfigButton, "Import from Note")
          // this.focusConfigNoteButton.hidden = syncSource === "MNNote"
          this.configNoteIdInput.text = chatAIConfig.getConfig("syncNoteId")
          break;
        case "CFR2":
          MNButton.setTitle(this.focusConfigNoteButton, "Copy")
          MNButton.setTitle(this.exportConfigButton, "Export to R2")
          MNButton.setTitle(this.importConfigButton, "Import from R2")
          // this.focusConfigNoteButton.hidden = syncSource === "CFR2"
          this.configNoteIdInput.text = chatAIConfig.getConfig("r2file")
          break;
        case "Infi":
          MNButton.setTitle(this.focusConfigNoteButton, "Copy")
          MNButton.setTitle(this.exportConfigButton, "Export to Infi")
          MNButton.setTitle(this.importConfigButton, "Import from Infi")
          // this.focusConfigNoteButton.hidden = syncSource === "CFR2"
          this.configNoteIdInput.text = chatAIConfig.getConfig("InfiFile")
          break;
        case "Webdav":
          MNButton.setTitle(this.focusConfigNoteButton, "Copy")
          MNButton.setTitle(this.exportConfigButton, "Export to Webdav")
          MNButton.setTitle(this.importConfigButton, "Import from Webdav")
          // this.focusConfigNoteButton.hidden = syncSource === "CFR2"
          this.configNoteIdInput.text = chatAIConfig.getConfig("webdavFile")
          break;
        default:
          break;
      }
      MNButton.setTitle(this.autoExportButton, "Auto Export: "+(chatAIUtils.isSubscribed(false) && chatAIConfig.getConfig("autoExport")?"✅":"❌"))
      MNButton.setTitle(this.autoImportButton, "Auto Import: "+(chatAIUtils.isSubscribed(false) && chatAIConfig.getConfig("autoImport")?"✅":"❌"))
      let dateObj = new Date(chatAIConfig.getConfig("lastSyncTime"))
      MNButton.setTitle(this.syncTimeButton, "Last Sync Time: "+dateObj.toLocaleString())
      break;
    case "autoActionView":
      MNButton.setTitle(this.ignoreButton, "Ignore short text: "+(chatAIConfig.getConfig("ignoreShortText")?"✅":"🚫"))
      if (chatAIConfig.getConfig("ignoreShortText")) {
        MNButton.setColor(this.ignoreButton, "#457bd3", 0.8)
      }else{
        MNButton.setColor(this.ignoreButton, "#9bb2d6", 0.8)
      }
      let autoAction = chatAIConfig.getConfig("autoAction")
      MNButton.setTitle(this.delayButton, "Delay: "+chatAIConfig.config.delay+"s")
      MNButton.setColor(this.delayButton, "#457bd3",0.8)
      MNButton.setColor(this.autoActionButton, autoAction?"#457bd3":"#9bb2d6", 0.8)
      MNButton.setTitle(this.autoActionButton, autoAction?"Enable trigger: ✅":"Enable trigger: ❌",17,true)
      this.onSelectionButton.hidden = !autoAction
      this.onNewExcerptButton.hidden = !autoAction
      this.newExcerptTagDetection.hidden = !autoAction
      this.onNoteButton.hidden = !autoAction
      this.ignoreButton.hidden = !autoAction
      this.delayButton.hidden = false
      let onSelection = chatAIConfig.config.onSelection
      MNButton.setColor(this.onSelectionButton, onSelection?"#457bd3":"#9bb2d6", 0.8)
      MNButton.setTitle(this.onSelectionButton, onSelection?"On Selection: ✅":"On Selection: ❌")
      let onNote = chatAIConfig.config.onNote
      MNButton.setColor(this.onNoteButton, onNote?"#457bd3":"#9bb2d6", 0.8)
      MNButton.setTitle(this.onNoteButton, onNote?"On Note: ✅":"On Note: ❌")
      let onNewExcerpt = chatAIConfig.config.onNewExcerpt
      MNButton.setColor(this.onNewExcerptButton, onNewExcerpt?"#457bd3":"#9bb2d6", 0.8)
      MNButton.setTitle(this.onNewExcerptButton, onNewExcerpt?"On New Excerpt: ✅":"On New Excerpt: ❌")
      let newExcerptTagDetection = chatAIConfig.config.newExcerptTagDetection
      MNButton.setColor(this.newExcerptTagDetection, newExcerptTagDetection?"#457bd3":"#9bb2d6", 0.8)
      MNButton.setTitle(this.newExcerptTagDetection, newExcerptTagDetection?"Tag detection: ✅":"Tag detection: ❌")
      for (let index = 0; index < 32; index++) {
        this["ColorButton"+index].hidden = !chatAIConfig.config.autoAction
      }
      MNUtil.refreshAddonCommands()
      break;
    default:
      break;
  }
} catch (error) {
  MNUtil.showHUD("Error in refreshView: "+error)
}
}
/**
 * @this {chatglmController}
 */
chatglmController.prototype.setModelButton = function (source) {
  if (source == "ChatGPT") {
    this.URLInput.hidden = false
    this.pasteURLButton.hidden = false
    // this.saveURLButton.hidden = false
    // this.saveCustomModels.hidden = false
    this.customModelInput.hidden = false
    this.customUsage.hidden = false
    if (typeof subscriptionConfig === 'undefined') {
      this.importSubscriptionButton.hidden = true
    }else{
      this.importSubscriptionButton.hidden = !chatAIUtils.checkSubscribe(false)
    }
  }else{
    this.URLInput.hidden = true
    this.pasteURLButton.hidden = true
    // this.saveURLButton.hidden = true
    // this.saveCustomModels.hidden = true
    this.customModelInput.hidden = true
    this.customUsage.hidden = true
    this.importSubscriptionButton.hidden = true
  }
  if (source == "Built-in") {
    MNButton.setConfig(this.saveConfigButton, {title:"Refresh",bold:true})
    this.apiKeyInput.hidden = true
    this.pasteApiKeyButton.hidden = true
    // this.saveApiKeyButton.hidden = true
    this.modelButton.hidden = true
    this.tunnelButton.hidden = false
    // this.refreshButton.hidden = false
    this.usageButton.hidden = false
  }else{
    MNButton.setConfig(this.saveConfigButton, {title:"Save",bold:true})
    this.apiKeyInput.hidden = false
    this.pasteApiKeyButton.hidden = false
    // this.saveApiKeyButton.hidden = false
    this.modelButton.hidden = false
    this.tunnelButton.hidden = true
    // this.refreshButton.hidden = true
    this.usageButton.hidden = true
  }
  let config = chatAIConfig.getConfigFromSource(source)
  this.apiKeyInput.text = config.key
  switch (source) {
      case "ChatGPT":
        let URL = chatAIConfig.config.url
        if (URL === "") {
          URL = `https://api.openai.com`
        }
        this.URLInput.text = URL
        break;
      case "Built-in":
        if (chatAIUtils.checkSubscribe(false,false)) {
          this.usageButton.setTitleForState("Unlimited",0)
        }else{
          let usage  = chatAIConfig.usage
          this.usageButton.setTitleForState("Usage: "+usage.usage+"/100",0)
        }
        break;
      case "Custom":
        this.URLInput.text = chatAIConfig.config.customUrl ?? ""
        this.usageButton.hidden = true
        this.pasteURLButton.hidden = false
        // this.saveURLButton.hidden = false
        this.URLInput.hidden = false
        this.customModelInput.hidden = false
        // this.saveCustomModels.hidden = false
        break;
      case "Subscription":
        this.apiKeyInput.hidden = true
        this.customUsage.hidden = false
        this.usageButton.hidden = true
        this.pasteURLButton.hidden = true
        // this.saveURLButton.hidden = false
        this.customModelInput.hidden = false
        this.pasteApiKeyButton.hidden = true
        // this.saveCustomModels.hidden = false
        break;
      default:
        break;
    }
}
chatglmController.prototype.popover = function(sender,commandTable,width=200,direction=2){
  this.view.popoverController = chatAIUtils.getPopoverAndPresent(sender,commandTable,width,direction)
}
/** @type {UITextView} */
chatglmController.prototype.contextInput